Ext.define('webtsm.Support', {singleton:true, mixins:['BpcCommon.mixin.BpcModuleUtilsMixin'], cache:{types:{}, attributetypes:{}}, logEventNames:{edit:'webtsmEditTimeSeriesValues', create:'webtsmCreateTimeSeries', editTimeSeries:'webtsmEditTimeSeries', deleteTimeSeries:'webtsmDeleteTimeSeries'}, intervals:{provider:{hakom:[{'ID':0, 'Name':'No'}, {'ID':1, 'Name':'Second', type:Ext.Date.SECOND}, {'ID':2, 'Name':'Minute', type:Ext.Date.MINUTE}, {'ID':3, 'Name':'Hour', type:Ext.Date.HOUR}, {'ID':4, 'Name':'Day', 
type:Ext.Date.DAY}, {'ID':5, 'Name':'Week'}, {'ID':6, 'Name':'Month'}, {'ID':7, 'Name':'Quarter'}, {'ID':8, 'Name':'Year', type:Ext.Date.MINUTE}, {'ID':9, 'Name':'Total'}, {'ID':10, 'Name':'Millisecond', type:Ext.Date.MILLI}]}}, legacy:{legacyIntervals:{no:' ', milliseconds:'MS', second:'S', minute:'N', hour:'H', day:'D', week:'W', month:'M', quarter:'Q', year:'E'}, legacyTypes:{begin:'A', end:'E', spontaneous:'S', linearspline:'L'}}, keys:{icons:{infoIcon:'fa-info-circle', addToBucket:'fa-plus-square', 
'delete':'fa-trash', clone:'fa-clone', cancel:'fa-ban', timeseriesData:'fa-database', remove:'fa-times', close:'fa-times', users:'fa-user', groups:'fa-users', listMode:'fa-list-alt', viewMode:'fa-eye', edit:'fa-edit', add:'fa-plus', save:'fa-save', plus:'fa-plus', list:'fa-list', check:'fa-check', gear:'fa-gear', search:'fa-search', download:'fa-download', aggregations:'fa-microchip', attributeTypes:'fa-archive', timeseriesTypes:'fa-dot-circle', settings:'fa-cog', expand:'fa-expand', filter:'fa-filter', 
refresh:'fa-sync', lineChart:'fa-line-chart', barChart:'fa-bar-chart', times:'fa-times', gears:'fa-gears', calendar:'fa-calendar', timeseries:'chart-line', chartArea:'chart-area', warning:'fa-exclamation-triangle'}, settings:{}}, defaultDelimiter:',', icon:function(className) {
  return this.getBpcIconCls(className);
}, getBpcIconCls:function(fontAwesomeName) {
  return BpcCommon.util.Icons.getBpcIconCls(fontAwesomeName);
}, getEmptyInfoContainer:function(title, iconCls, infoText) {
  title = title === void 0 ? '' : title;
  iconCls = iconCls === void 0 ? '' : iconCls;
  infoText = infoText === void 0 ? 'Keine Daten geladen' : infoText;
  title = this.TR(title);
  infoText = this.TR(infoText);
  var html = '\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center; align-items: center;"\x3e';
  var header = '\x3ch2\x3e' + title + '\x3c/h2\x3e\x3cbr/\x3e';
  var info = webtsm.Support.getSpanForIconCls(webtsm.ConfigKeys.icons.chartArea, '#e4e4e4', 72) + '\x3cbr\x3e' + infoText;
  html += header;
  html += info;
  html += '\x3c/div\x3e';
  return Ext.create({xtype:'container', html:html});
}, canEdit:function() {
  return BpcCommon.Api.hasUserAnyRight(['WEBTSM_administrator', 'WEBTSM_editor', 'webtsm_edit', 'webtsm_admin']);
}, bpc:{removeReplaceStateFromUrl:function(newState) {
  var hash = window.location.hash, hashes = hash ? hash.split('//') : [], navPart = undefined, state = undefined;
  if (hashes.length) {
    if (hashes.length === 1) {
      return;
    } else if (hashes.length > 1) {
      hashes.map(function(hash) {
        if (hash.startsWith('#')) {
          navPart = hash;
        } else {
          state = hash;
        }
      });
      if (navPart) {
        if (newState) {
          navPart += '//' + Ext.Object.toQueryString(newState, true);
        }
        window.location.hash = navPart;
      }
    }
  }
}}, instanceExists:function(moduleIdToMatch) {
  var instancesStore = BpcCommon.Api.getModuleInstances('webtsm');
  if (instancesStore) {
    var instanceModels = instancesStore.getData().getRange() || [];
    if (instanceModels) {
      instanceModels = instanceModels.filter(function(r) {
        return Ext.isDefined(r) && r.get('moduleId') === moduleIdToMatch;
      });
      return instanceModels.length > 0;
    }
  }
  return false;
}, sortWrapper:function(key, lowercase, trim) {
  return function(a, b) {
    try {
      var compareLeft = a[key];
      var compareRight = b[key];
      if (compareLeft && compareRight) {
        if (lowercase) {
          compareLeft = compareLeft.toLowerCase();
          compareRight = compareRight.toLowerCase();
        }
        if (trim) {
          compareLeft = compareLeft.trim();
          compareRight = compareRight.trim();
        }
        if (compareLeft < compareRight) {
          return -1;
        }
        if (compareLeft > compareRight) {
          return 1;
        }
      }
      return 0;
    } catch (e) {
      return 0;
    }
  };
}, stylesLoaded:false, frontEndPath:'bpc-fe-webtsm/', constructor:function() {
  var $jscomp$this = this;
  if (!this.stylesLoaded) {
    this.loadScript(this.frontEndPath + 'resources/webtsm.css').then(function(value) {
      $jscomp$this.stylesLoaded = true;
    });
  }
  this.loadScript(this.frontEndPath + 'resources/dateparser.js');
}, loadScript:function(url) {
  return new Ext.Promise(function(resolve, reject) {
    Ext.Loader.loadScript({url:url, onLoad:function() {
      resolve();
    }, onError:function(error) {
      reject(url);
    }});
  });
}, getFlagColor:function(value, type, moduleId) {
  type = type === void 0 ? 'color' : type;
  var customSettings = BpcCommon.Api.getSetting(moduleId, 'custom_settings') || {};
  var flagColorSettings = {};
  if ('flags' in customSettings && Ext.isDefined(customSettings['flags']) && customSettings['flags'] !== null && Ext.isObject(customSettings['flags'])) {
    flagColorSettings = customSettings['flags'];
  }
  if (flagColorSettings[value]) {
    if (type in flagColorSettings[value]) {
      return flagColorSettings[value][type];
    }
  }
  return undefined;
}, preloadModuleInformation:{viewer:{}, manager:function(instanceId) {
  return new Ext.Promise(function(resolve, reject) {
    Ext.Promise.all([webtsm.Api.attributes.getTypes(instanceId), webtsm.Api.attributes.getList(instanceId)]).then(function(array) {
      var typesObj = {}, attributesObj = {}, translatedAttributes = [];
      try {
        if (Ext.isArray(array[0]) && Ext.isArray(array[1])) {
          var customSettings = BpcCommon.Api.getSetting(instanceId, 'search_customSettings');
          if (customSettings && 'searchExcluded' in customSettings && customSettings.searchExcluded && 'attributeTypes' in customSettings.searchExcluded && customSettings.searchExcluded.attributeTypes) {
            var hiddenTypes = customSettings['searchExcluded']['attributeTypes'];
            if (hiddenTypes) {
              var types = Ext.clone(array[0]);
              if (types.length) {
                Ext.Array.each(types, function(attributeType) {
                  var hidden = false;
                  if (Ext.Array.indexOf(hiddenTypes, attributeType.ID) !== -1) {
                    hidden = !hidden;
                  }
                  typesObj[attributeType.ID] = {Name:attributeType.Name, items:[], hidden:hidden};
                });
                var attributes = Ext.clone(array[1]);
                if (attributes.length) {
                  Ext.Array.each(attributes, function(attributeObj) {
                    if (attributeObj.Type) {
                      if (attributeObj.Type in typesObj) {
                        typesObj[attributeObj.Type]['items'].push(attributeObj.ID);
                      }
                    }
                    attributesObj[attributeObj.ID] = attributeObj.Type;
                  });
                }
              }
            }
          }
          var attributesArr = array[1], typesArr = array[0];
          translatedAttributes = attributesArr.map(function(attribute) {
            var matches = typesArr.filter(function(type) {
              return type.ID === attribute.Type;
            });
            return Ext.apply({}, attribute, {typeName:matches.length ? matches[0].Name : '-1'});
          });
        }
        resolve({types:typesObj, attributes:attributesObj, attributeList:translatedAttributes});
      } catch (e) {
        resolve({types:typesObj, attributes:attributesObj, attributeList:translatedAttributes});
      }
    });
  });
}}, loadBatchMetaData:function(timeseriesObjects, moduleId) {
  var tsMetaDataPromises = [], numberRegex = new RegExp(/^\d+$/);
  Ext.Array.each(timeseriesObjects, function(item) {
    if (item) {
      var nameCall = undefined;
      if (Ext.isNumber(item) || Ext.isString(item)) {
        if (!numberRegex.test(item)) {
          nameCall = true;
        }
        tsMetaDataPromises.push(webtsm.Api.timeseries.getMeta(moduleId, item, nameCall));
      } else if (Ext.isObject(item)) {
        if ('ID' in item || 'Name' in item) {
          var requestMetaNameOrId;
          if (item.ID) {
            requestMetaNameOrId = item.ID;
          } else if (item.Name) {
            requestMetaNameOrId = item.Name;
            nameCall = true;
          }
          if (!numberRegex.test(requestMetaNameOrId)) {
            nameCall = true;
          }
          tsMetaDataPromises.push(webtsm.Api.timeseries.getMeta(moduleId, requestMetaNameOrId, nameCall));
        }
      }
    }
  });
  return Ext.Promise.all(tsMetaDataPromises);
}, handleMetaDataPromiseResponse:function(responseObj, tsData) {
  try {
    var timeseriesObj = {ID:null, Name:null, Unit:null, Version:null, visibleForUser:true};
    if (responseObj && Ext.isObject(responseObj)) {
      if (responseObj.Name) {
        timeseriesObj.Name = responseObj.Name;
      }
      if (responseObj.ID) {
        timeseriesObj.ID = responseObj.ID;
      }
      if (responseObj.Unit) {
        timeseriesObj.Unit = responseObj.Unit;
      }
    } else if (responseObj && Ext.isNumber(responseObj)) {
      if (tsData && Ext.isObject(tsData)) {
        tsData = JSON.stringify(tsData);
      }
      if (responseObj === 404) {
        timeseriesObj.visibleForUser = false;
        timeseriesObj.tsData = 'Restricted - ' + tsData;
      } else {
        timeseriesObj.visibleForUser = false;
        timeseriesObj.tsData = 'Error - ' + tsData;
      }
    }
    return timeseriesObj;
  } catch (e) {
    return null;
  }
}, showNotification:function(obj) {
  obj = Ext.applyIf(obj, {sourceModule:'webtsm'});
  BpcCommon.Api.showNotification(obj);
}, createDatesFromEsDateRange:function(string) {
  var rounded = string.split('/');
  var round = rounded.length;
  if (round) {
    string = rounded[0];
  }
  var startEndArray = string.split('-');
  var start = null, end = null;
  var array = [];
  if (startEndArray.length === 2) {
    end = startEndArray[0];
    start = startEndArray[1];
    if (end === 'now') {
      end = new Date();
      var interval = start.slice(-1);
      var range = -7;
      if (interval === 'd') {
        range = start.slice(0, -1);
        interval = Ext.Date.DAY;
      }
      start = Ext.Date.add(end, interval, -range);
    }
  }
  if (startEndArray.length === 1) {
    var timeRange = startEndArray[0];
    if (timeRange === 'month') {
      end = new Date();
      start = Ext.Date.getFirstDateOfMonth(end);
    }
  }
  if (round && start !== null && end !== null) {
    start.setHours(0, 0, 0, 0);
    end.setHours(0, 0, 0, 0);
  }
  array['start'] = start;
  array['end'] = end;
  return array;
}, getTooltipFromRecord:function(record) {
  return 'data-qtip\x3d"' + webtsm.Support.createHtmlTooltipFromObject(record.getData(), false, true) + '"';
}, createHtmlTooltipFromObject:function(o, skipEncoding, beautifyAttributes) {
  var htmlString = '';
  try {
    htmlString = '\x3ctable\x3e';
    Ext.iterate(o, function(key, value) {
      if (key !== 'id' && value !== null) {
        if (value && (Ext.isArray(value) || Ext.isObject(value))) {
          if (beautifyAttributes) {
            if (key !== 'Attributes') {
              value = JSON.stringify(value, undefined, 2);
            } else {
              if (Ext.isArray(value) && value.length > 0) {
                var attributeTable = '\x3ctable\x3e';
                Ext.Array.each(value, function(attribute) {
                  attributeTable += '\x3ctr\x3e\x3ctd\x3e' + attribute.AttributeID + '\x3c/td\x3e\x3ctd\x3e' + JSON.stringify(attribute.Values) + '\x3c/td\x3e\x3c/tr\x3e';
                });
                attributeTable += '\x3c/table\x3e';
                value = attributeTable;
              } else {
                value = 'Keine Attribute definiert.';
              }
            }
          } else {
            value = JSON.stringify(value, undefined, 2);
          }
        }
        htmlString += '\x3ctr\x3e';
        htmlString += '\x3ctd\x3e\x3cb\x3e' + key + ':\x3c/b\x3e\x3c/td\x3e';
        htmlString += '\x3ctd\x3e' + value + '\x3c/td\x3e';
        htmlString += '\x3c/tr\x3e';
      }
    });
    htmlString += '\x3c/table\x3e';
  } catch (e) {
    htmlString = 'Fehler beim Verarbeiten des Records.';
  }
  return skipEncoding ? htmlString : Ext.String.htmlEncode(htmlString);
}, TR:function(k) {
  return this.getTranslation(k);
}, getTranslation:function(key, uppercase, splitWhitespaceWithBr) {
  key = key.toUpperCase();
  var starter = 'WEBTSM_';
  if (!Ext.String.startsWith(key, starter)) {
    key = starter + key;
  }
  var translation = BpcCommon.Api.getTranslation(key);
  if (key === translation) {
    webtsm.Util.translations.missing[key] = translation;
  }
  translation = uppercase ? translation.toUpperCase() : translation;
  return splitWhitespaceWithBr ? translation.replace(' ', '\x3cbr\x3e') : translation;
}, formatDates:function(dateObj, format) {
  format = format === void 0 ? 'c' : format;
  if (Ext.isDate(dateObj)) {
    return Ext.Date.format(dateObj, format);
  }
  return dateObj;
}, getSpanForIconCls:function(iconCls, color, size) {
  return BpcCommon.util.Icons.getSpanForIconCls(iconCls, color, size);
}, notify:function(textOrConfig, silent) {
  silent = Ext.isDefined(silent) ? silent : true;
  var originalNotification = textOrConfig;
  if (Ext.isString(textOrConfig)) {
    textOrConfig = {silent:silent, type:'INFO', text:originalNotification};
  } else if (Ext.isObject(textOrConfig)) {
    if (!textOrConfig.hasOwnProperty('type')) {
      textOrConfig.type = 'INFO';
    }
  } else {
    textOrConfig = {silent:silent, type:'INFO', text:'Oups... Something went wrong during processing the notification.'};
  }
  BpcCommon.Api.showNotification(textOrConfig);
}, storeData:{intervals:{}, aggregations:{}, units:{}}, openWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig, show, additionalWindowConf) {
  width = width === void 0 ? 800 : width;
  cmpAlias = cmpAlias === void 0 ? 'panel' : cmpAlias;
  cmpConfig = cmpConfig === void 0 ? {} : cmpConfig;
  show = show === void 0 ? true : show;
  return webtsm.util.Window.openWindow(title, iconCls, width, height, cmpAlias, cmpConfig, show, additionalWindowConf);
}, shuffle:function(array) {
  for (var i = array.length - 1; i > 0; i--) {
    var j = Math.floor(Math.random() * (i + 1));
    var temp = array[i];
    array[i] = array[j];
    array[j] = temp;
  }
  return array;
}, colors:['#46C5BE', '#B5E0E5', '#E6DEDA', '#B2AEB0', '#FF935D', '#F23C4D', '#F7BE57', '#BCB936', '#86CDD4', '#338891', '#FF6E25', '#B80C1C', '#A09A9D', '#D1C3BB', '#B2AEB0'], getRandomVirtimoColors:function() {
  return this.shuffle(this.colors);
}, getManagerInstanceForViewer:function(viewerId) {
  var managerId = BpcCommon.Api.getSetting(viewerId, 'webtsm_managerInstance');
  return managerId && Ext.isString(managerId) && managerId.length ? managerId : undefined;
}, handleValue:function(model, key) {
  var value = null;
  var modelValue = model.get(key);
  if (Ext.isDefined(modelValue)) {
    value = modelValue;
  }
  return value;
}, createPayloadFromModelInstanceArray:function(instanceCollection) {
  return instanceCollection.map(function(model) {
    return {color:webtsm.Support.handleValue(model, 'color'), ID:webtsm.Support.handleValue(model, 'ID'), Name:webtsm.Support.handleValue(model, 'Name'), Unit:webtsm.Support.handleValue(model, 'Unit'), Version:webtsm.Support.handleValue(model, 'Version'), Aggregation:webtsm.Support.handleValue(model, 'Aggregation'), AttributesCount:webtsm.Support.handleValue(model, 'AttributesCount'), visibleForUser:webtsm.Support.handleValue(model, 'visibleForUser')};
  });
}, getApiConfigKeybyInstanceId:function(moduleId, key) {
  key = key === void 0 ? 'application' : key;
  var viewerId = webtsm.Api.module.getViewerId(moduleId);
  var apiId = BpcCommon.Api.getSetting(viewerId, 'api_id');
  return webtsm.Api.helper.getKeyFromApiConfig(apiId, key);
}, createAggregationsStore:function(moduleId) {
  return webtsm.Support.createLocalStore(moduleId, 'meta/aggregations', {listeners:{load:function(s, records, successful, operation, eOpts) {
    if (successful) {
      var record = s.insert(3, {ID:4269, Name:'Standard'});
      var storeModels = s.getData().getRange();
      if (storeModels.length > 0) {
        webtsm.Support.storeData.aggregations[moduleId] = storeModels;
      }
    }
  }}});
}, createVersionStore:function(moduleId) {
  return webtsm.Support.createLocalStore(moduleId, 'versions', undefined, false);
}, createLocalStore:function(moduleId, pathSuffix, customStoreConfig, autoLoad) {
  var storeConfig = {proxy:{type:'ajax', url:webtsm.Api.tsmBasePath + moduleId + '/' + pathSuffix, reader:{type:'json'}}, autoLoad:Ext.isDefined(autoLoad) ? autoLoad : true};
  if (customStoreConfig) {
    storeConfig = Ext.apply(storeConfig, customStoreConfig);
  }
  return Ext.create('Ext.data.Store', storeConfig);
}, createTsmApiStore:function(moduleId, pathSuffix, autoLoad, withApplication, url) {
  withApplication = withApplication === void 0 ? false : withApplication;
  url = url === void 0 ? '' : url;
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'GET', withApplication);
  cfg.url = url.length ? url : cfg.url + pathSuffix;
  return Ext.create('Ext.data.Store', {proxy:{type:'ajax', url:cfg.url, pageParam:'', startParam:'', limitParam:'', noCache:false, cacheString:'', headers:cfg.headers, reader:{type:'json'}}, autoLoad:Ext.isDefined(autoLoad) ? autoLoad : true});
}, createIntervalStore:function(moduleId) {
  return webtsm.Support.createLocalStore(moduleId, 'intervals', {listeners:{load:function(s, records, successful, operation, eOpts) {
    if (successful) {
      var storeModels = s.getData().getRange();
      var intervals = [];
      s.each(function(r) {
        var interval = {ID:r.get('ID'), Name:r.get('Name'), languageKey:r.get('webtsmDisplayName')};
        intervals.push(interval);
        r.set('languageKey', webtsm.Support.getTranslation(r.get('webtsmDisplayName')));
      });
      if (storeModels.length > 0) {
        webtsm.Support.rendererData.intervals = intervals;
      }
    }
  }}});
}, rendererData:{intervals:undefined}, getDateFromRecordField:function(record, field, inputDateFormat) {
  if (!record) {
    return;
  }
  var fieldDateStringOrObject = record.get(field);
  if (fieldDateStringOrObject) {
    if (Ext.isDate(fieldDateStringOrObject)) {
      return fieldDateStringOrObject;
    } else {
      if (Ext.isDefined(inputDateFormat)) {
        var parsedDate = Ext.Date.parse(fieldDateStringOrObject, inputDateFormat);
        if (Ext.isDate(parsedDate)) {
          return parsedDate;
        } else {
          BpcCommon.Api.showNotification('DateFields parse error');
        }
      }
    }
  }
  return undefined;
}, getTimeseriesFromField:function(record, field, delimiter) {
  if (!record) {
    return [];
  }
  var nameOrIds = record.get(field);
  if (delimiter && Ext.isString(nameOrIds)) {
    nameOrIds = nameOrIds.split(delimiter);
  } else {
    nameOrIds = [nameOrIds];
  }
  return nameOrIds;
}, getBucketPayloadFromRecord:function(record, tsField, startField, endField, delimiter, idOrNames, inputDateFormat) {
  var payload = {};
  delimiter = delimiter || ',';
  var bucketKey = Ext.isDefined(idOrNames) && idOrNames === 'names' ? 'Name' : 'ID';
  var nameOrIds = webtsm.Support.getTimeseriesFromField(record, tsField, delimiter);
  var $jscomp$compprop1 = {};
  payload.bucket = Ext.isArray(nameOrIds) ? nameOrIds.map(function(nameOrId) {
    if (nameOrId) {
      var $jscomp$compprop0 = {};
      return $jscomp$compprop0[bucketKey] = nameOrId.trim(), $jscomp$compprop0;
    }
  }).filter(function(i) {
    return Ext.isDefined(i);
  }) : Ext.isString(nameOrIds) ? ($jscomp$compprop1[bucketKey] = nameOrIds, $jscomp$compprop1) : [];
  if (startField && endField) {
    payload.start = webtsm.Support.getDateFromRecordField(record, startField, inputDateFormat);
    payload.end = webtsm.Support.getDateFromRecordField(record, endField, inputDateFormat);
  }
  return payload;
}, defaultDateFormat:'d.m.Y H:i:s', defaultLanguage:'German', getDefaultGridStyle:function() {
  return {backgroundColor:'#FFF9C4'};
}, deleteTimeseriesWithMessage:function(moduleId, tsId, cmpToLoadMask) {
  return this.confirmDialog(webtsm.Support.getTranslation('WEBTSM_Q_DELETE_TIMESERIES_WARN'), webtsm.Support.getTranslation('WEBTSM_Q_DELETE_TIMESERIES')).then(function(success) {
    return success ? webtsm.Api.timeseries["delete"](moduleId, tsId) : success;
  }).then(function(response) {
    if (response === false) {
      return;
    }
    response = response || {};
    if (response.status && response.status === 204) {
      webtsm.Support.showNotification({text:'Löschen der Zeitreihe: ' + tsId + ' war erfolgreich.', sourceInstanceId:moduleId, object:tsId});
      try {
        webtsm.Api.cacheRefresh(moduleId, false);
      } catch (e) {
      }
      return true;
    } else {
      webtsm.Support.showNotification({text:'Löschen der Zeitreihe: ' + tsId + ' war nicht erfolgreich.', sourceInstanceId:moduleId, object:tsId});
      return false;
    }
  }, function(response) {
    var $jscomp$destructuring$var0 = response;
    var status = $jscomp$destructuring$var0.status;
    var statusText = $jscomp$destructuring$var0.statusText;
    statusText = statusText || '-1';
    webtsm.Support.showNotification({text:'Löschen der Zeitreihe: ' + tsId + ' war nicht erfolgreich. (' + status + '/' + statusText + ')', sourceInstanceId:moduleId, object:tsId});
  });
}, confirmDialog:function(title, message) {
  var deferred = new Ext.Deferred();
  Ext.Msg.show({title:title, message:message, buttons:Ext.Msg.YESNOCANCEL, icon:Ext.Msg.QUESTION, fn:function(b) {
    deferred.resolve(b === 'yes');
  }});
  return deferred.promise;
}, getResponseObject:function(responseObj) {
  responseObj = responseObj || {};
  if ('responseText' in responseObj && responseObj.responseText) {
    return Ext.decode(responseObj.responseText, true);
  } else if ('responseJson' in responseObj && responseObj.responseJson) {
    return responseObj.responseJson;
  }
}, pluginModulesLoaded:false, convertArrayToObject:function(array, key, value) {
  key = key === void 0 ? 'ID' : key;
  value = value === void 0 ? 'Name' : value;
  var obj = {};
  array.map(function(item) {
    obj[item[key]] = item[value];
  });
  return obj;
}, preloadPluginModules:function(moduleId) {
  var $jscomp$this = this;
  var cfg = this.getModuleSetting('plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  sourceModuleNames = Ext.Array.unique(sourceModuleNames);
  var pluginSettingValuesForModuleId = moduleId ? cfg.filter(function(settingsValue) {
    return settingsValue.targetInstance && Ext.isArray(settingsValue.targetInstance) && settingsValue.targetInstance.indexOf(moduleId) !== -1;
  }) : [];
  return new Promise(function(resolve) {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    Promise.all(moduleLoadPromises).then(function() {
      $jscomp$this.pluginModulesLoaded = true;
      resolve(pluginSettingValuesForModuleId);
    }, function() {
      resolve(false);
    });
  });
}});
Ext.define('webtsm.Api', {singleton:true, tsmBasePath:'cxf/bpc-webtsm/tsm/', models:{units:[{type:'text', key:'Name'}, {type:'number', key:'Factor'}, {type:'number', key:'Offset'}, {type:'text', key:'BaseUnit'}, {type:'text', key:'Aggregation'}, {type:'text', key:'IntegralUnit'}, {type:'text', key:'Description'}]}, types:{manager:''}, tempStore:{}, getPathByModuleId:function(moduleId) {
  return this.tsmBasePath + encodeURIComponent(moduleId);
}, date:{stringToDate:function(s) {
  return new Date(s);
}, dateToFormattedString:function(date, format) {
  format = format || 'd.m.Y H:i:s';
  return Ext.Date.format(date, format);
}, parse:function(s, format) {
  return Ext.Date.parse(s, format);
}}, clone:function(instanceId, NameOrId, newName) {
  var $jscomp$this = this;
  var deferred = new Ext.Deferred();
  var cloneResponseObject = {instanceId:instanceId, sourceTs:NameOrId, sourceTsId:undefined, targetTsName:newName, targetTsId:undefined, targetTsSuccess:undefined, targetAttributesSuccess:undefined, sourceTsAttributes:undefined, sourceTsAttributesCount:undefined, assignAttributesResponse:undefined};
  this.timeseries.getMeta(instanceId, NameOrId).then(function(obj) {
    var initId = obj.ID;
    cloneResponseObject.sourceTsId = initId;
    obj.ID = -1;
    obj.Name = newName;
    webtsm.Api.timeseries.create(instanceId, obj).then(function(r) {
      var tsNewId = r.responseText;
      cloneResponseObject.targetTsId = tsNewId;
      cloneResponseObject.targetTsSuccess = true;
      $jscomp$this.timeseries.getAttributes(instanceId, initId).then(function(attributesArray) {
        cloneResponseObject.sourceTsAttributes = attributesArray || [];
        cloneResponseObject.sourceTsAttributesCount = cloneResponseObject.sourceTsAttributes.length;
        if (attributesArray && attributesArray.length) {
          $jscomp$this.attributes.assignAttributesToTimeseries(instanceId, tsNewId, attributesArray).then(function(obj) {
            cloneResponseObject.targetAttributesSuccess = true;
            deferred.resolve(cloneResponseObject);
          });
        } else {
          deferred.resolve(cloneResponseObject);
        }
      });
    });
  });
  return deferred.promise;
}, maps:{days:{0:webtsm.Support.getTranslation('SUNDAY'), 1:webtsm.Support.getTranslation('MONDAY'), 2:webtsm.Support.getTranslation('TUESDAY'), 3:webtsm.Support.getTranslation('WEDNESDAY'), 4:webtsm.Support.getTranslation('THURSDAY'), 5:webtsm.Support.getTranslation('FRIDAY'), 6:webtsm.Support.getTranslation('SATURDAY')}}, helper:{getKeyFromApiConfig:function(apiId, key) {
  var keyFound = null;
  var apiConfig = BpcCommon.Api.getSetting('webtsm', 'module_apis');
  if (apiId in apiConfig && key in apiConfig[apiId]) {
    var app = apiConfig[apiId][key];
    if (Ext.isDefined(app) && app !== null) {
      keyFound = app;
    }
  }
  return keyFound;
}, isFormulaTs:function(isFormula) {
  var getFormulaText = function(isFormula) {
    if (isFormula) {
      return ' - Formelzeitreihe';
    }
    return '';
  };
  return getFormulaText(isFormula);
}}, versionEnabled:function(moduleId) {
  var versionEnabled = BpcCommon.Api.getSetting(moduleId, 'extensions_versionEnabled');
  return Ext.isDefined(versionEnabled) ? versionEnabled : false;
}, module:{getViewerId:function(instanceId) {
  if (this.isManager(instanceId)) {
    return BpcCommon.Api.getSetting(instanceId, 'client_instance');
  }
  return instanceId;
}, isManager:function(moduleId) {
  var model = BpcCommon.Api.getSetting(moduleId, 'module_name', true);
  return this.isInstanceType(model, 'tsm_manager');
}, isInstanceType:function(settingsModel, type) {
  type = type === void 0 ? '' : type;
  if (settingsModel) {
    var instanceType;
    try {
      instanceType = settingsModel.getModuleInstanceConfiguration().get('instanceType');
    } catch (e) {
      instanceType = undefined;
    }
    return instanceType && instanceType === type;
  }
  return false;
}, status:{overall:function(instanceId) {
  var versions = new Promise(function(resolve) {
    webtsm.Api.getVersionInfos(instanceId).then(function(r) {
      resolve(webtsm.Support.getResponseObject(r));
    }, function(error) {
      var message = 'REQUEST ERROR - PROBABLY API DOWN';
      var fakeResponse = {Version:message, message:message};
      resolve(fakeResponse);
    });
  });
  var live = new Promise(function(resolve) {
    webtsm.Api.module.status.health.live(instanceId).then(function(json) {
      resolve(json);
    }, function(json) {
      resolve(json);
    });
  });
  var ready = new Promise(function(resolve) {
    webtsm.Api.module.status.health.ready(instanceId).then(function(json) {
      resolve(json);
    }, function(json) {
      resolve(json);
    });
  });
  return Promise.all([versions, live, ready]).then(function(array) {
    return {version:array[0], live:array[1], ready:array[2]};
  });
}, health:{ready:function(instanceId) {
  var cfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', false);
  cfg.url += '/health/ready';
  return webtsm.Api.sendRequest(cfg).then(function(response) {
    var $jscomp$destructuring$var1 = response;
    var status = $jscomp$destructuring$var1.status;
    var responseText = $jscomp$destructuring$var1.responseText;
    return {status:status, text:responseText};
  }, function(error) {
    var $jscomp$destructuring$var2 = error;
    var status = $jscomp$destructuring$var2.status;
    var responseText = $jscomp$destructuring$var2.responseText;
    return {status:status, text:responseText};
  });
}, live:function(instanceId, processsed) {
  processsed = processsed === void 0 ? true : processsed;
  var cfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', false);
  cfg.url += '/health/live';
  return webtsm.Api.sendRequest(cfg).then(function(response) {
    var $jscomp$destructuring$var3 = response;
    var status = $jscomp$destructuring$var3.status;
    var responseText = $jscomp$destructuring$var3.responseText;
    return {status:status, text:responseText};
  }, function(error) {
    var $jscomp$destructuring$var4 = error;
    var status = $jscomp$destructuring$var4.status;
    var responseText = $jscomp$destructuring$var4.responseText;
    return {status:status, text:responseText};
  });
}}}}, calendar:{getAll:function(instanceId) {
  var url = webtsm.Api.tsmBasePath + instanceId + '/calendars';
  return null;
}}, attributes:{_path:'/attributes', get:function(instanceId, tsId, attributeId) {
  var cfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', true);
  cfg.url += '/timeseries/' + tsId + this._path + (attributeId ? '/' + attributeId : '');
  return webtsm.Api.sendRequest(cfg).then(function(r) {
    r = r || {};
    return webtsm.Support.getResponseObject(r);
  }, function(r) {
    r = r || {};
    var response = {error:true, response:r, status:r.status, responseJson:webtsm.Support.getResponseObject(r)};
    return response;
  });
}, create:function(moduleId, data) {
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'POST', true);
  cfg.url += '/attributes';
  cfg.jsonData = data;
  return webtsm.Api.sendRequest(cfg);
}, getNameById:function(instanceId, attributeId) {
  var componentArray = Ext.ComponentQuery.query('webtsmManagerMain');
  var attributeName = null;
  if (componentArray.length > 0) {
    Ext.Array.each(componentArray, function(cmp, index, array) {
      if ('moduleId' in cmp && Ext.isDefined(cmp.moduleId) && cmp.moduleId === instanceId) {
        if ('getNameById' in cmp && Ext.isFunction(cmp.getNameById)) {
          attributeName = cmp.getNameById(attributeId);
          return false;
        }
      }
    });
  }
  return attributeName;
}, getList:function(instanceId) {
  return webtsm.Api.getRequestData(instanceId, this._path, 'GET', true);
}, 'delete':function(moduleId, attributeNameId) {
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'DELETE', true);
  cfg.url += this._path + '/' + attributeNameId;
  return webtsm.Api.sendRequest(cfg);
}, getTypes:function(instanceId) {
  var cfg = webtsm.Api.getBaseRequestCfg(instanceId);
  cfg.url += '/attributetypes';
  return webtsm.Api.sendRequest(cfg).then(function(r) {
    r = r || {};
    return webtsm.Support.getResponseObject(r);
  });
}, assignAttributesToTimeseries:function(moduleId, tsId, payload) {
  payload = payload === void 0 ? [] : payload;
  var reqCfg = webtsm.Api.getBaseRequestCfg(moduleId, 'POST', true);
  reqCfg.url += '/timeseries/' + tsId + this._path;
  reqCfg.jsonData = payload;
  return webtsm.Api.sendRequest(reqCfg);
}, deleteAssignment:function(moduleId, tsId, attributeId) {
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'DELETE', true);
  cfg.url += '/timeseries/' + tsId + this._path + '/' + attributeId;
  return webtsm.Api.sendRequest(cfg);
}}, getInstanceBasePath:function(instanceId) {
  return this.tsmBasePath + instanceId;
}, cacheRefresh:function(moduleId, full) {
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'GET', true);
  cfg.url = webtsm.Api.tsmBasePath + 'cache/' + moduleId + '/refresh?full\x3d' + full;
  return webtsm.Api.sendRequest(cfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getRequestData:function(instanceId, path, method, withApplication) {
  method = method === void 0 ? 'GET' : method;
  withApplication = withApplication === void 0 ? false : withApplication;
  var reqCfg = this.getBaseRequestCfg(instanceId, method, withApplication);
  reqCfg.url += path;
  return this.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  }, function(r) {
    var $jscomp$destructuring$var5 = r;
    var status = $jscomp$destructuring$var5.status;
    var statusText = $jscomp$destructuring$var5.statusText;
    return {status:status, statusText:statusText};
  });
}, auth:{getCurrentUser:function(instanceId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', false);
  reqCfg.url += '/auth/providers/hakom/users/current';
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getUserRoles:function(instanceId, userId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', false);
  reqCfg.url += '/auth/providers/hakom/users/' + userId + '/roles';
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getAuthorizationRules:function(instanceId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', false);
  var application = webtsm.Api.getApiConfigPropertyByInstanceId(instanceId, 'application');
  reqCfg.url += '/authorization/repositories/' + application;
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}}, timeseries:{getMeta:function(instanceId, tsId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', true);
  reqCfg.url += '/timeseries/' + encodeURIComponent(tsId);
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getTimeseries:function(instanceId, urlSearchParams) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', true);
  reqCfg.url += '/timeseries?' + urlSearchParams.toString();
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getDeletedTimeseries:function(instanceId, urlSearchParams) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', true);
  reqCfg.url += '/deletedtimeseries?' + urlSearchParams.toString();
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getMetaInfo:function(instanceId, tsId, params) {
  params = params === void 0 ? {} : params;
  var reqCfg = webtsm.Api.getBaseRequestCfg(instanceId, 'GET', true);
  reqCfg.url += '/timeseries/' + encodeURIComponent(tsId) + '/metainfo';
  reqCfg.params = params;
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getAttributes:function(moduleId, tsId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(moduleId, 'GET', true);
  reqCfg.url += '/timeseries/' + encodeURIComponent(tsId) + '/attributes';
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getQuotations:function(moduleId, tsId) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(moduleId, 'GET', true);
  reqCfg.url += '/timeseries/' + encodeURIComponent(tsId) + '/quotations';
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getData:function(moduleId, tsId, params) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(moduleId, 'GET', false);
  reqCfg.url += (webtsm.Api.versionEnabled(moduleId) ? '/Extensions/Version' : '') + reqCfg._tsmApplicationPath + '/timeseries/' + encodeURIComponent(tsId) + '/' + 'data';
  reqCfg.params = params;
  reqCfg.timeout = 50000;
  return webtsm.Api.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  }, function(r) {
    return r.status;
  });
}, 'delete':function(moduleId, tsId) {
  var cfg = webtsm.Api.getBaseRequestCfg(moduleId, 'DELETE', true);
  cfg.url += '/timeseries/' + encodeURIComponent(tsId);
  return webtsm.Api.sendRequest(cfg);
}, create:function(moduleId, data) {
  var reqCfg = webtsm.Api.getBaseRequestCfg(moduleId, 'POST', true);
  reqCfg.url += '/timeseries';
  reqCfg.jsonData = data;
  return webtsm.Api.sendRequest(reqCfg);
}}, updateTimeseries:function(moduleId, tsId, tsObj) {
  var reqCfg = this.getBaseRequestCfg(moduleId, 'PUT', true);
  reqCfg.url += '/timeseries/' + tsId;
  reqCfg.jsonData = tsObj;
  return this.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getHttpProxyBaseUrl:function(moduleId) {
  var baseUrl = BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(moduleId, 'tsm_backendConnectionId'));
  baseUrl += '/api';
  return baseUrl;
}, getApplication:function(apiId) {
  return '/repositories/' + this.helper.getKeyFromApiConfig(apiId, 'application');
}, updateTimeseriesValues:function(moduleId, version, tsId, payload, unit) {
  var reqCfg = this.getBaseRequestCfg(moduleId, 'POST', false);
  var params = {};
  if (Ext.isDefined(unit) && unit !== null) {
    params.unit = unit;
  }
  if (Ext.isDefined(version) && version !== 'null') {
    params.version = version;
  } else {
  }
  reqCfg.params = params;
  reqCfg.url += (webtsm.Api.versionEnabled(moduleId) ? '/Extensions/Version' : '') + reqCfg._tsmApplicationPath + '/timeseries/' + encodeURIComponent(tsId) + '/' + 'data';
  reqCfg.jsonData = payload;
  return this.sendRequest(reqCfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getBackendBasePath:function(instanceId) {
  var viewerId = this.module.getViewerId(instanceId);
  if (viewerId) {
    return this.getHttpProxyBaseUrl(viewerId);
  }
}, getApiConfigPropertyByInstanceId:function(instanceId, property) {
  var viewerId = this.module.getViewerId(instanceId);
  var apiId = BpcCommon.Api.getSetting(viewerId, 'api_id');
  return this.helper.getKeyFromApiConfig(apiId, property);
}, getBaseRequestCfg:function(instanceId, method, withApplication) {
  method = method === void 0 ? 'GET' : method;
  withApplication = withApplication === void 0 ? false : withApplication;
  var viewerId = this.module.getViewerId(instanceId);
  var apiId = BpcCommon.Api.getSetting(viewerId, 'api_id');
  var application = this.getApplication(apiId);
  var headers = {Authorization:this.helper.getKeyFromApiConfig(apiId, 'authorization')};
  var contentType = this.helper.getKeyFromApiConfig(apiId, 'Content-Type');
  var accept = this.helper.getKeyFromApiConfig(apiId, 'Accept');
  if (contentType) {
    headers['Content-Type'] = contentType;
  }
  if (accept) {
    headers['Accept'] = accept;
  }
  return {url:this.getBackendBasePath(instanceId) + (withApplication ? application : ''), method:method, disableCaching:false, _tsmApplicationPath:application, headers:headers};
}, getFlags:function(instanceId) {
  var cfg = this.getBaseRequestCfg(instanceId);
  cfg.url += '/flags';
  return this.sendRequest(cfg).then(function(r) {
    return webtsm.Support.getResponseObject(r);
  });
}, getTypes:function(instanceId) {
  var cfg = this.getBaseRequestCfg(instanceId);
  cfg.url += '/types';
  return this.sendRequest(cfg);
}, getVersionInfos:function(instanceId) {
  var cfg = this.getBaseRequestCfg(instanceId);
  cfg.url += '/';
  return this.sendRequest(cfg);
}, getIntervals:function(instanceId) {
  var cfg = this.getBaseRequestCfg(instanceId);
  cfg.url += '/intervals';
  return this.sendRequest(cfg);
}, sendRequest:function(cfg) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(Ext.apply({}, cfg)).then(function(success) {
      resolve(success);
    }, function(error) {
      reject(error);
    });
  });
}, getCreateRequestPromise:function(url, payload, timeout) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(webtsm.Api.getSimpleAjaxObject(url, 'POST', function(response) {
      resolve(response);
    }, function(response) {
      reject(response);
    }, {jsonData:payload ? payload : null}));
  });
}, getSimpleAjaxObject:function(url, method, success, failure, cfg) {
  return Ext.apply({url:url, method:method, success:success, failure:failure}, cfg);
}, getAllActionsByViewerId:function(instanceId, internal) {
  if (instanceId) {
    var mgrInstanceId = BpcCommon.Api.getSetting(instanceId, 'webtsm_managerInstance');
    var actionsArray = webtsm.Api.getViewerActions(instanceId);
    return actionsArray.concat(webtsm.Api.getManagerActions(mgrInstanceId) || []).map(function(item) {
      if (!internal) {
        return item;
      } else {
        if (item.text.trim().startsWith('Manager - ')) {
          item.text = item.text.replace('Manager - ', '');
        }
        return item;
      }
    });
  }
  return [];
}, getViewerActions:function(instanceId) {
  var iconCls = BpcCommon.Api.getSetting(instanceId, 'module_iconCls');
  return iconCls ? [{text:webtsm.Support.getTranslation('WEBTSM_AM.WEBTSM.MENU.OPENVIEWER'), actionKey:'viewer', iconCls:iconCls, _moduleId:instanceId}] : [];
}, getManagerActions:function(instanceId) {
  if (instanceId) {
    return [{text:webtsm.Support.getTranslation('WEBTSM_AM.WEBTSM.MENU.OPENMANAGER'), iconCls:webtsm.Support.getBpcIconCls('fa-search'), actionKey:'search'}, {text:webtsm.Support.getTranslation('WEBTSM_AM.WEBTSM.MENU.EDITDEFINITIONS'), iconCls:webtsm.Support.getBpcIconCls('fa-wrench'), actionKey:'definitions'}, {text:webtsm.Support.getTranslation('WEBTSM_AM.WEBTSM.MENU.EDITATTRIBUTES'), iconCls:webtsm.Support.getBpcIconCls('fa-archive'), actionKey:'attributes'}, {text:webtsm.Support.getTranslation('WEBTSM_AM.WEBTSM.MENU.EDITTIMESERIES'), 
    iconCls:webtsm.Support.getBpcIconCls('fa-edit'), actionKey:'values'}].map(function(i) {
      i._moduleId = instanceId;
      return i;
    });
  }
  return [];
}});
Ext.define('webtsm.ConfigKeys', {singleton:true, requires:['webtsm.Support'], icons:{infoIcon:webtsm.Support.getBpcIconCls('fa-info-circle'), addToBucket:webtsm.Support.getBpcIconCls('fa-plus-square'), 'delete':webtsm.Support.getBpcIconCls('fa-trash'), clone:webtsm.Support.getBpcIconCls('fa-clone'), cancel:webtsm.Support.getBpcIconCls('fa-ban'), timeseriesData:webtsm.Support.getBpcIconCls('fa-database'), remove:webtsm.Support.getBpcIconCls('fa-times'), close:webtsm.Support.getBpcIconCls('fa-times'), 
users:webtsm.Support.getBpcIconCls('fa-user'), groups:webtsm.Support.getBpcIconCls('fa-users'), listMode:webtsm.Support.getBpcIconCls('fa-list-alt'), viewMode:webtsm.Support.getBpcIconCls('fa-eye'), edit:webtsm.Support.getBpcIconCls('fa-edit'), add:webtsm.Support.getBpcIconCls('fa-plus'), save:webtsm.Support.getBpcIconCls('fa-save'), plus:webtsm.Support.getBpcIconCls('fa-plus'), window:webtsm.Support.getBpcIconCls('fa-window'), list:webtsm.Support.getBpcIconCls('fa-list'), check:webtsm.Support.getBpcIconCls('fa-check'), 
gear:webtsm.Support.getBpcIconCls('fa-gear'), search:webtsm.Support.getBpcIconCls('fa-search'), download:webtsm.Support.getBpcIconCls('fa-download'), aggregations:webtsm.Support.getBpcIconCls('fa-microchip'), attributeTypes:webtsm.Support.getBpcIconCls('fa-archive'), timeseriesTypes:webtsm.Support.getBpcIconCls('fa-dot-circle'), settings:webtsm.Support.getBpcIconCls('fa-cog'), expand:webtsm.Support.getBpcIconCls('fa-expand'), filter:webtsm.Support.getBpcIconCls('fa-filter'), refresh:webtsm.Support.getBpcIconCls('fa-sync'), 
lineChart:webtsm.Support.getBpcIconCls('fa-line-chart'), barChart:webtsm.Support.getBpcIconCls('fa-bar-chart'), times:webtsm.Support.getBpcIconCls('fa-times'), gears:webtsm.Support.getBpcIconCls('fa-gears'), calendar:webtsm.Support.getBpcIconCls('fa-calendar'), timeseries:webtsm.Support.getBpcIconCls('chart-line'), chartArea:webtsm.Support.getBpcIconCls('chart-area')}});
Ext.define('webtsm.Files', {singleton:true, loadBlob:function() {
  (function() {
    var global = typeof window === 'object' ? window : typeof self === 'object' ? self : this;
    var BlobBuilder = global.BlobBuilder || global.WebKitBlobBuilder || global.MSBlobBuilder || global.MozBlobBuilder;
    global.URL = global.URL || global.webkitURL || function(href, a) {
      a = document.createElement('a');
      a.href = href;
      return a;
    };
    var origBlob = global.Blob;
    var createObjectURL = URL.createObjectURL;
    var revokeObjectURL = URL.revokeObjectURL;
    var strTag = global.Symbol && global.Symbol.toStringTag;
    var blobSupported = false;
    var blobSupportsArrayBufferView = false;
    var arrayBufferSupported = !!global.ArrayBuffer;
    var blobBuilderSupported = BlobBuilder && BlobBuilder.prototype.append && BlobBuilder.prototype.getBlob;
    try {
      blobSupported = (new Blob(['ä'])).size === 2;
      blobSupportsArrayBufferView = (new Blob([new Uint8Array([1, 2])])).size === 2;
    } catch (e) {
    }
    function mapArrayBufferViews(ary) {
      return ary.map(function(chunk) {
        if (chunk.buffer instanceof ArrayBuffer) {
          var buf = chunk.buffer;
          if (chunk.byteLength !== buf.byteLength) {
            var copy = new Uint8Array(chunk.byteLength);
            copy.set(new Uint8Array(buf, chunk.byteOffset, chunk.byteLength));
            buf = copy.buffer;
          }
          return buf;
        }
        return chunk;
      });
    }
    function BlobBuilderConstructor(ary, options) {
      options = options || {};
      var bb = new BlobBuilder();
      mapArrayBufferViews(ary).forEach(function(part) {
        bb.append(part);
      });
      return options.type ? bb.getBlob(options.type) : bb.getBlob();
    }
    function BlobConstructor(ary, options) {
      return new origBlob(mapArrayBufferViews(ary), options || {});
    }
    if (global.Blob) {
      BlobBuilderConstructor.prototype = Blob.prototype;
      BlobConstructor.prototype = Blob.prototype;
    }
    function stringEncode(string) {
      var pos = 0;
      var len = string.length;
      var out = [];
      var Arr = global.Uint8Array || Array;
      var at = 0;
      var tlen = Math.max(32, len + (len >> 1) + 7);
      var target = new Arr(tlen >> 3 << 3);
      while (pos < len) {
        var value = string.charCodeAt(pos++);
        if (value >= 55296 && value <= 56319) {
          if (pos < len) {
            var extra = string.charCodeAt(pos);
            if ((extra & 64512) === 56320) {
              ++pos;
              value = ((value & 1023) << 10) + (extra & 1023) + 65536;
            }
          }
          if (value >= 55296 && value <= 56319) {
            continue;
          }
        }
        if (at + 4 > target.length) {
          tlen += 8;
          tlen *= 1 + pos / string.length * 2;
          tlen = tlen >> 3 << 3;
          var update = new Uint8Array(tlen);
          update.set(target);
          target = update;
        }
        if ((value & 4.294967168E9) === 0) {
          target[at++] = value;
          continue;
        } else if ((value & 4.294965248E9) === 0) {
          target[at++] = value >> 6 & 31 | 192;
        } else if ((value & 4.29490176E9) === 0) {
          target[at++] = value >> 12 & 15 | 224;
          target[at++] = value >> 6 & 63 | 128;
        } else if ((value & 4.292870144E9) === 0) {
          target[at++] = value >> 18 & 7 | 240;
          target[at++] = value >> 12 & 63 | 128;
          target[at++] = value >> 6 & 63 | 128;
        } else {
          continue;
        }
        target[at++] = value & 63 | 128;
      }
      return target.slice(0, at);
    }
    function stringDecode(buf) {
      var end = buf.length;
      var res = [];
      var i = 0;
      while (i < end) {
        var firstByte = buf[i];
        var codePoint = null;
        var bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
        if (i + bytesPerSequence <= end) {
          var secondByte, thirdByte, fourthByte, tempCodePoint;
          switch(bytesPerSequence) {
            case 1:
              if (firstByte < 128) {
                codePoint = firstByte;
              }
              break;
            case 2:
              secondByte = buf[i + 1];
              if ((secondByte & 192) === 128) {
                tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
                if (tempCodePoint > 127) {
                  codePoint = tempCodePoint;
                }
              }
              break;
            case 3:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
                tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
                if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
                  codePoint = tempCodePoint;
                }
              }
              break;
            case 4:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              fourthByte = buf[i + 3];
              if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
                tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
                if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
                  codePoint = tempCodePoint;
                }
              }
          }
        }
        if (codePoint === null) {
          codePoint = 65533;
          bytesPerSequence = 1;
        } else if (codePoint > 65535) {
          codePoint -= 65536;
          res.push(codePoint >>> 10 & 1023 | 55296);
          codePoint = 56320 | codePoint & 1023;
        }
        res.push(codePoint);
        i += bytesPerSequence;
      }
      var len = res.length;
      var str = '';
      var i = 0;
      while (i < len) {
        str += String.fromCharCode.apply(String, res.slice(i, i += 4096));
      }
      return str;
    }
    var textEncode = typeof TextEncoder === 'function' ? TextEncoder.prototype.encode.bind(new TextEncoder()) : stringEncode;
    var textDecode = typeof TextDecoder === 'function' ? TextDecoder.prototype.decode.bind(new TextDecoder()) : stringDecode;
    function FakeBlobBuilder() {
      function isDataView(obj) {
        return obj && DataView.prototype.isPrototypeOf(obj);
      }
      function bufferClone(buf) {
        var view = new Array(buf.byteLength);
        var array = new Uint8Array(buf);
        var i = view.length;
        while (i--) {
          view[i] = array[i];
        }
        return view;
      }
      function array2base64(input) {
        var byteToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\x3d';
        var output = [];
        for (var i = 0; i < input.length; i += 3) {
          var byte1 = input[i];
          var haveByte2 = i + 1 < input.length;
          var byte2 = haveByte2 ? input[i + 1] : 0;
          var haveByte3 = i + 2 < input.length;
          var byte3 = haveByte3 ? input[i + 2] : 0;
          var outByte1 = byte1 >> 2;
          var outByte2 = (byte1 & 3) << 4 | byte2 >> 4;
          var outByte3 = (byte2 & 15) << 2 | byte3 >> 6;
          var outByte4 = byte3 & 63;
          if (!haveByte3) {
            outByte4 = 64;
            if (!haveByte2) {
              outByte3 = 64;
            }
          }
          output.push(byteToCharMap[outByte1], byteToCharMap[outByte2], byteToCharMap[outByte3], byteToCharMap[outByte4]);
        }
        return output.join('');
      }
      var create = Object.create || function(a) {
        function c() {
        }
        c.prototype = a;
        return new c();
      };
      if (arrayBufferSupported) {
        var viewClasses = ['[object Int8Array]', '[object Uint8Array]', '[object Uint8ClampedArray]', '[object Int16Array]', '[object Uint16Array]', '[object Int32Array]', '[object Uint32Array]', '[object Float32Array]', '[object Float64Array]'];
        var isArrayBufferView = ArrayBuffer.isView || function(obj) {
          return obj && viewClasses.indexOf(Object.prototype.toString.call(obj)) > -1;
        };
      }
      function concatTypedarrays(chunks) {
        var size = 0;
        var i = chunks.length;
        while (i--) {
          size += chunks[i].length;
        }
        var b = new Uint8Array(size);
        var offset = 0;
        for (i = 0, l = chunks.length; i < l; i++) {
          var chunk = chunks[i];
          b.set(chunk, offset);
          offset += chunk.byteLength || chunk.length;
        }
        return b;
      }
      function Blob(chunks, opts) {
        chunks = chunks || [];
        opts = opts == null ? {} : opts;
        for (var i = 0, len = chunks.length; i < len; i++) {
          var chunk = chunks[i];
          if (chunk instanceof Blob) {
            chunks[i] = chunk._buffer;
          } else if (typeof chunk === 'string') {
            chunks[i] = textEncode(chunk);
          } else if (arrayBufferSupported && (ArrayBuffer.prototype.isPrototypeOf(chunk) || isArrayBufferView(chunk))) {
            chunks[i] = bufferClone(chunk);
          } else if (arrayBufferSupported && isDataView(chunk)) {
            chunks[i] = bufferClone(chunk.buffer);
          } else {
            chunks[i] = textEncode(String(chunk));
          }
        }
        this._buffer = global.Uint8Array ? concatTypedarrays(chunks) : [].concat.apply([], chunks);
        this.size = this._buffer.length;
        this.type = opts.type || '';
        if (/[^\u0020-\u007E]/.test(this.type)) {
          this.type = '';
        } else {
          this.type = this.type.toLowerCase();
        }
      }
      Blob.prototype.arrayBuffer = function() {
        return Promise.resolve(this._buffer);
      };
      Blob.prototype.text = function() {
        return Promise.resolve(textDecode(this._buffer));
      };
      Blob.prototype.slice = function(start, end, type) {
        var slice = this._buffer.slice(start || 0, end || this._buffer.length);
        return new Blob([slice], {type:type});
      };
      Blob.prototype.toString = function() {
        return '[object Blob]';
      };
      function File(chunks, name, opts) {
        opts = opts || {};
        var a = Blob.call(this, chunks, opts) || this;
        a.name = name.replace(/\//g, ':');
        a.lastModifiedDate = opts.lastModified ? new Date(opts.lastModified) : new Date();
        a.lastModified = +a.lastModifiedDate;
        return a;
      }
      File.prototype = create(Blob.prototype);
      File.prototype.constructor = File;
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(File, Blob);
      } else {
        try {
          File.__proto__ = Blob;
        } catch (e$2) {
        }
      }
      File.prototype.toString = function() {
        return '[object File]';
      };
      function FileReader() {
        if (!(this instanceof FileReader)) {
          throw new TypeError("Failed to construct 'FileReader': Please use the 'new' operator, this DOM object constructor cannot be called as a function.");
        }
        var delegate = document.createDocumentFragment();
        this.addEventListener = delegate.addEventListener;
        this.dispatchEvent = function(evt) {
          var local = this['on' + evt.type];
          if (typeof local === 'function') {
            local(evt);
          }
          delegate.dispatchEvent(evt);
        };
        this.removeEventListener = delegate.removeEventListener;
      }
      function _read(fr, blob, kind) {
        if (!(blob instanceof Blob)) {
          throw new TypeError("Failed to execute '" + kind + "' on 'FileReader': parameter 1 is not of type 'Blob'.");
        }
        fr.result = '';
        setTimeout(function() {
          this.readyState = FileReader.LOADING;
          fr.dispatchEvent(new Event('load'));
          fr.dispatchEvent(new Event('loadend'));
        });
      }
      FileReader.EMPTY = 0;
      FileReader.LOADING = 1;
      FileReader.DONE = 2;
      FileReader.prototype.error = null;
      FileReader.prototype.onabort = null;
      FileReader.prototype.onerror = null;
      FileReader.prototype.onload = null;
      FileReader.prototype.onloadend = null;
      FileReader.prototype.onloadstart = null;
      FileReader.prototype.onprogress = null;
      FileReader.prototype.readAsDataURL = function(blob) {
        _read(this, blob, 'readAsDataURL');
        this.result = 'data:' + blob.type + ';base64,' + array2base64(blob._buffer);
      };
      FileReader.prototype.readAsText = function(blob) {
        _read(this, blob, 'readAsText');
        this.result = textDecode(blob._buffer);
      };
      FileReader.prototype.readAsArrayBuffer = function(blob) {
        _read(this, blob, 'readAsText');
        this.result = (blob._buffer.buffer || blob._buffer).slice();
      };
      FileReader.prototype.abort = function() {
      };
      URL.createObjectURL = function(blob) {
        return blob instanceof Blob ? 'data:' + blob.type + ';base64,' + array2base64(blob._buffer) : createObjectURL.call(URL, blob);
      };
      URL.revokeObjectURL = function(url) {
        revokeObjectURL && revokeObjectURL.call(URL, url);
      };
      var _send = global.XMLHttpRequest && global.XMLHttpRequest.prototype.send;
      if (_send) {
        XMLHttpRequest.prototype.send = function(data) {
          if (data instanceof Blob) {
            this.setRequestHeader('Content-Type', data.type);
            _send.call(this, textDecode(data._buffer));
          } else {
            _send.call(this, data);
          }
        };
      }
      global.FileReader = FileReader;
      global.File = File;
      global.Blob = Blob;
    }
    function fixFileAndXHR() {
      var isIE = !!global.ActiveXObject || '-ms-scroll-limit' in document.documentElement.style && '-ms-ime-align' in document.documentElement.style;
      var _send = global.XMLHttpRequest && global.XMLHttpRequest.prototype.send;
      if (isIE && _send) {
        XMLHttpRequest.prototype.send = function(data) {
          if (data instanceof Blob) {
            this.setRequestHeader('Content-Type', data.type);
            _send.call(this, data);
          } else {
            _send.call(this, data);
          }
        };
      }
      try {
        new File([], '');
      } catch (e$4) {
        try {
          var klass = (new Function('class File extends Blob {' + 'constructor(chunks, name, opts) {' + 'opts \x3d opts || {};' + 'super(chunks, opts || {});' + 'this.name \x3d name.replace(///g, ":");' + 'this.lastModifiedDate \x3d opts.lastModified ? new Date(opts.lastModified) : new Date();' + 'this.lastModified \x3d +this.lastModifiedDate;' + '}};' + 'return new File([], ""), File'))();
          global.File = klass;
        } catch (e$3) {
          var klass = function(b, d, c) {
            var blob = new Blob(b, c);
            var t = c && void 0 !== c.lastModified ? new Date(c.lastModified) : new Date();
            blob.name = d.replace(/\//g, ':');
            blob.lastModifiedDate = t;
            blob.lastModified = +t;
            blob.toString = function() {
              return '[object File]';
            };
            if (strTag) {
              blob[strTag] = 'File';
            }
            return blob;
          };
          global.File = klass;
        }
      }
    }
    if (blobSupported) {
      fixFileAndXHR();
      global.Blob = blobSupportsArrayBufferView ? global.Blob : BlobConstructor;
    } else if (blobBuilderSupported) {
      fixFileAndXHR();
      global.Blob = BlobBuilderConstructor;
    } else {
      FakeBlobBuilder();
    }
    if (strTag) {
      File.prototype[strTag] = 'File';
      Blob.prototype[strTag] = 'Blob';
      FileReader.prototype[strTag] = 'FileReader';
    }
    var blob = global.Blob.prototype;
    var stream;
    function promisify(obj) {
      return new Promise(function(resolve, reject) {
        obj.onload = obj.onerror = function(evt) {
          obj.onload = obj.onerror = null;
          evt.type === 'load' ? resolve(obj.result || obj) : reject(new Error('Failed to read the blob/file'));
        };
      });
    }
    try {
      new ReadableStream({type:'bytes'});
      stream = function stream() {
        var position = 0;
        var blob = this;
        return new ReadableStream({type:'bytes', autoAllocateChunkSize:524288, pull:function(controller) {
          var v = controller.byobRequest.view;
          var chunk = blob.slice(position, position + v.byteLength);
          return chunk.arrayBuffer().then(function(buffer) {
            var uint8array = new Uint8Array(buffer);
            var bytesRead = uint8array.byteLength;
            position += bytesRead;
            v.set(uint8array);
            controller.byobRequest.respond(bytesRead);
            if (position >= blob.size) {
              controller.close();
            }
          });
        }});
      };
    } catch (e$7) {
      try {
        new ReadableStream({});
        stream = function stream(blob) {
          var position = 0;
          var blob = this;
          return new ReadableStream({pull:function(controller) {
            var chunk = blob.slice(position, position + 524288);
            return chunk.arrayBuffer().then(function(buffer) {
              position += buffer.byteLength;
              var uint8array = new Uint8Array(buffer);
              controller.enqueue(uint8array);
              if (position == blob.size) {
                controller.close();
              }
            });
          }});
        };
      } catch (e$6) {
        try {
          (new Response('')).body.getReader().read();
          stream = function stream() {
            return (new Response(this)).body;
          };
        } catch (e$5) {
          stream = function stream() {
            throw new Error('Include https://github.com/MattiasBuelens/web-streams-polyfill');
          };
        }
      }
    }
    if (!blob.arrayBuffer) {
      blob.arrayBuffer = function arrayBuffer() {
        var fr = new FileReader();
        fr.readAsArrayBuffer(this);
        return promisify(fr);
      };
    }
    if (!blob.text) {
      blob.text = function text() {
        var fr = new FileReader();
        fr.readAsText(this);
        return promisify(fr);
      };
    }
    if (!blob.stream) {
      blob.stream = stream;
    }
  })();
}, loadFileSaver:function() {
  (function(global, factory) {
    if (typeof define === 'function' && define.amd) {
      define([], factory);
    } else if (typeof exports !== 'undefined') {
      factory();
    } else {
      var mod = {exports:{}};
      factory();
      global.FileSaver = mod.exports;
    }
  })(this, function() {
    var _global = typeof window === 'object' && window.window === window ? window : typeof self === 'object' && self.self === self ? self : typeof global === 'object' && global.global === global ? global : void 0;
    function bom(blob, opts) {
      if (typeof opts === 'undefined') {
        opts = {autoBom:false};
      } else if (typeof opts !== 'object') {
        console.warn('Deprecated: Expected third argument to be a object');
        opts = {autoBom:!opts};
      }
      if (opts.autoBom && /^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(blob.type)) {
        return new Blob([String.fromCharCode(65279), blob], {type:blob.type});
      }
      return blob;
    }
    function download(url, name, opts) {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', url);
      xhr.responseType = 'blob';
      xhr.onload = function() {
        saveAs(xhr.response, name, opts);
      };
      xhr.onerror = function() {
        console.error('could not download file');
      };
      xhr.send();
    }
    function corsEnabled(url) {
      var xhr = new XMLHttpRequest();
      xhr.open('HEAD', url, false);
      try {
        xhr.send();
      } catch (e) {
      }
      return xhr.status >= 200 && xhr.status <= 299;
    }
    function click(node) {
      try {
        node.dispatchEvent(new MouseEvent('click'));
      } catch (e) {
        var evt = document.createEvent('MouseEvents');
        evt.initMouseEvent('click', true, true, window, 0, 0, 0, 80, 20, false, false, false, false, 0, null);
        node.dispatchEvent(evt);
      }
    }
    var saveAs = _global.saveAs || (typeof window !== 'object' || window !== _global ? function saveAs() {
    } : 'download' in HTMLAnchorElement.prototype ? function saveAs(blob, name, opts) {
      var URL = _global.URL || _global.webkitURL;
      var a = document.createElement('a');
      name = name || blob.name || 'download';
      a.download = name;
      a.rel = 'noopener';
      if (typeof blob === 'string') {
        a.href = blob;
        if (a.origin !== location.origin) {
          corsEnabled(a.href) ? download(blob, name, opts) : click(a, a.target = '_blank');
        } else {
          click(a);
        }
      } else {
        a.href = URL.createObjectURL(blob);
        setTimeout(function() {
          URL.revokeObjectURL(a.href);
        }, 40000);
        setTimeout(function() {
          click(a);
        }, 0);
      }
    } : 'msSaveOrOpenBlob' in navigator ? function saveAs(blob, name, opts) {
      name = name || blob.name || 'download';
      if (typeof blob === 'string') {
        if (corsEnabled(blob)) {
          download(blob, name, opts);
        } else {
          var a = document.createElement('a');
          a.href = blob;
          a.target = '_blank';
          setTimeout(function() {
            click(a);
          });
        }
      } else {
        navigator.msSaveOrOpenBlob(bom(blob, opts), name);
      }
    } : function saveAs(blob, name, opts, popup) {
      popup = popup || open('', '_blank');
      if (popup) {
        popup.document.title = popup.document.body.innerText = 'downloading...';
      }
      if (typeof blob === 'string') {
        return download(blob, name, opts);
      }
      var force = blob.type === 'application/octet-stream';
      var isSafari = /constructor/i.test(_global.HTMLElement) || _global.safari;
      var isChromeIOS = /CriOS\/[\d]+/.test(navigator.userAgent);
      if ((isChromeIOS || force && isSafari) && typeof FileReader !== 'undefined') {
        var reader = new FileReader();
        reader.onloadend = function() {
          var url = reader.result;
          url = isChromeIOS ? url : url.replace(/^data:[^;]*;/, 'data:attachment/file;');
          if (popup) {
            popup.location.href = url;
          } else {
            location = url;
          }
          popup = null;
        };
        reader.readAsDataURL(blob);
      } else {
        var URL = _global.URL || _global.webkitURL;
        var url = URL.createObjectURL(blob);
        if (popup) {
          popup.location = url;
        } else {
          location.href = url;
        }
        popup = null;
        setTimeout(function() {
          URL.revokeObjectURL(url);
        }, 40000);
      }
    });
    _global.saveAs = saveAs.saveAs = saveAs;
    if (typeof module !== 'undefined') {
      module.exports = saveAs;
    }
  });
}, enableClientFileSupport:function() {
  webtsm.Files.loadBlob();
  webtsm.Files.loadFileSaver();
}, s2ab:function(s) {
  var buf = new ArrayBuffer(s.length);
  var view = new Uint8Array(buf);
  for (var i = 0; i != s.length; ++i) {
    view[i] = s.charCodeAt(i) & 255;
  }
  return buf;
}, downloadFile:function(fileObject) {
  if (!Ext.isEmpty(fileObject.fileName)) {
    try {
      var me = webtsm.Files;
      me.enableClientFileSupport();
      saveAs(new Blob([me.s2ab(atob(fileObject.file))], {type:fileObject.contentType}), fileObject.fileName);
    } catch (e) {
      webtsm.Support.notify('Fehler beim Bereitstellen des Dateidownloads.');
    }
  } else {
    var errorMessage = fileObject && Ext.isObject(fileObject) && fileObject.message ? fileObject.message || 'Fehler beim Dateidownload - Keine Details' : 'Fehler beim Dateidownload - Keine Details';
    webtsm.Support.notify(errorMessage);
  }
}});
Ext.define('webtsm.Util', {singleton:true, openDetailWindow:function(record, moduleId, moduleInstance) {
  webtsm.Support.openWindow('', undefined, document.body.clientWidth * 0.8, document.body.clientHeight * 0.7, 'webtsmDetailPanel', {record:record, moduleId:moduleId, moduleInstance:moduleInstance});
}, translations:{missing:{}}, getMissingTranslations:function() {
  return this.translations.missing;
}, toast:function(title, html, width, cmp) {
  var toastConfig = {title:title, html:html, width:width};
  if (width) {
    toastConfig.width = width;
  }
  if (cmp) {
    toastConfig.anchor = cmp;
  }
  Ext.toast(toastConfig);
}});
Ext.define('webtsm.view.components.widgets.TsmViewWidget', {extend:'Ext.panel.Panel', alias:'widget.tsmViewWidget', requires:['webtsm.ConfigKeys'], mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Zeitreihenvisualisierung', WIDGET_DESCRIPTION:'Linechart, Timeseries', WIDGET_ICON_CLS:webtsm.ConfigKeys.icons.barChart}, widgetConfigSettingMap:{moduleId:{settingType:'tsmTypeSelector'}, initView:{settingType:'text'}, startDate:{settingType:'tsmWidgetDateField'}, endDate:{settingType:'tsmWidgetDateField'}, 
startHour:{settingType:'number'}, endHour:{settingType:'number'}, startMinute:{settingType:'number'}, endMinute:{settingType:'number'}, requestInterval:{settingType:'text'}, requestVersion:{settingType:'text'}, requestUnit:{settingType:'text'}, requestAggregation:{settingType:'text'}}, config:{widgetConfiguration:{initView:undefined, startDate:new Date(), endDate:new Date(), startHour:0, endHour:0, startMinute:0, endMinute:0, requestInterval:0, requestVersion:'Standard', requestUnit:'Standard', requestAggregation:4269}}, 
layout:'card', activeItem:0, title:false, moduleId:undefined, widgetId:undefined, wrongConfigPanel:{xtype:'container', padding:'10 10 10 10', items:[{xtype:'box', html:'Die Konfiguration ist unvollständig. Es muss mindestens der zugehörige Monitor augewählt sein.'}, {xtype:'button', text:'Konfiguration anzeigen', iconCls:webtsm.ConfigKeys.icons.settings, handler:function() {
  var widget = this.up('tsmViewWidget');
  widget.getLayout().setActiveItem(widget.settingPanel);
}}]}, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.configureWidget.bind(this)}, {text:'Standardwerte', handler:this.prepareWidgetConfiguration.bind(this, true)}]});
}, initWidget:function() {
  var widgetDisplayCmp = {xtype:'webtsmErrorCmp'};
  if (this.moduleId && webtsm.Support.instanceExists(this.moduleId)) {
    var me = this, initView = undefined, defaultsWidgetSettingsObj = undefined;
    if ('widgetConfiguration' in me && me.widgetConfiguration && Ext.isObject(me.widgetConfiguration)) {
      var getValue = function(key) {
        if (key in me.widgetConfiguration && (me.widgetConfiguration[key] || me.widgetConfiguration[key] === 0)) {
          return me.widgetConfiguration[key];
        }
        return null;
      };
      initView = getValue('initView');
      if (!initView) {
        defaultsWidgetSettingsObj = {};
        var startDate = getValue('startDate');
        if (startDate && !Ext.isDate(startDate)) {
          startDate = new Date(startDate);
          if (startDate) {
            defaultsWidgetSettingsObj.startDate = startDate;
          }
        }
        var endDate = getValue('endDate');
        if (endDate && !Ext.isDate(endDate)) {
          endDate = new Date(endDate);
          if (endDate) {
            defaultsWidgetSettingsObj.endDate = endDate;
          }
        }
        defaultsWidgetSettingsObj.startHour = getValue('startHour');
        defaultsWidgetSettingsObj.endHour = getValue('endHour');
        defaultsWidgetSettingsObj.startMinute = getValue('startMinute');
        defaultsWidgetSettingsObj.endMinute = getValue('endMinute');
        defaultsWidgetSettingsObj.requestInterval = getValue('requestInterval');
        defaultsWidgetSettingsObj.requestVersion = getValue('requestVersion');
        defaultsWidgetSettingsObj.requestUnit = getValue('requestUnit');
        defaultsWidgetSettingsObj.requestAggregation = getValue('requestAggregation');
      }
    }
    widgetDisplayCmp = {xtype:'container', layout:'fit', items:[{xtype:'tsmPlugin', flex:1, moduleId:this.moduleId, widgetId:this.widgetId, tsmInititalView:initView, widgetSettings:defaultsWidgetSettingsObj, header:false}]};
  } else {
    widgetDisplayCmp.contextCmp = ' Widget ';
    widgetDisplayCmp.customText = '\x3cbr/\x3e Die ModuleId wurde dem Widget nicht zugewiesen oder existiert nicht.';
  }
  this.wrapper = this.add(widgetDisplayCmp);
}, getWrapperReference:function() {
  var plugin = this.down('tsmPlugin');
  if (plugin && plugin.isComponent) {
    return plugin;
  } else {
    return null;
  }
}, refreshWidget:function() {
  var wrapper = this.getWrapperReference();
  if (wrapper !== null) {
    wrapper.loadData();
  }
}, configureWidget:function() {
  var card = this.settingPanel;
  if (card && card.isComponent && card.isVisible(true)) {
    card = this.wrapper;
  }
  this.getLayout().setActiveItem(card);
}});
Ext.define('webtsm.view.components.widgets.ManagerWidget', {extend:'Ext.panel.Panel', alias:'widget.webtsmManagerWidget', mixins:['BpcCommon.mixin.Widget'], requires:['webtsm.ConfigKeys'], statics:{WIDGET_NAME:'WebTSM Manager Widget', WIDGET_DESCRIPTION:'Toolset zum Verwalten Ihrer Zeitreihen', WIDGET_ICON_CLS:webtsm.ConfigKeys.icons.barChart}, widgetConfigSettingMap:{moduleId:{settingType:'tsmTypeSelector'}}, layout:'card', activeItem:0, title:false, moduleId:undefined, wrongConfigPanel:{xtype:'container', 
padding:'10 10 10 10', items:[{xtype:'box', html:'Die Konfiguration ist unvollständig. Es muss mindestens der zugehörige Monitor augewählt sein.'}, {xtype:'button', text:'Konfiguration anzeigen', iconCls:webtsm.ConfigKeys.icons.settings, handler:function() {
  var widget = this.up('webtsmManagerWidget');
  widget.getLayout().setActiveItem(widget.settingPanel);
}}]}, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent();
  this.initWidget();
  try {
    this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.configureWidget.bind(this)}, {text:'Standardwerte', handler:this.prepareWidgetConfiguration.bind(this, true)}]});
  } catch (e$8) {
  }
}, initWidget:function() {
}, getWrapperReference:function() {
  var plugin = this.down('tsmPlugin');
  if (plugin && plugin.isComponent) {
    return plugin;
  } else {
    return null;
  }
}, refreshWidget:function() {
  var wrapper = this.getWrapperReference();
  if (wrapper !== null) {
    wrapper.getController().loadData();
  }
}, configureWidget:function() {
  var card = this.settingPanel;
  if (card && card.isComponent && card.isVisible(true)) {
    card = this.wrapper;
  }
  this.getLayout().setActiveItem(card);
}});
Ext.define('webtsm.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['webtsm.Support', 'webtsm.view.components.widgets.TsmViewWidget', 'webtsm.view.components.widgets.ManagerWidget', 'webtsm.view.components.widgets.ManagerWidget'], config:{moduleConfigurationComponents:['webtsmConfigMain', 'webtsmConfigIndicesMain', 'webtsmTranslations'], requiredModules:[], requiredLibraries:['AmCharts'], widgets:['webtsm.view.components.widgets.TsmViewWidget', 'webtsm.view.components.widgets.ManagerWidget', 
'webtsm.view.components.widgets.ApiStatus'], types:{none:'webtsm.view.viewer.Main', webtsm_module:'webtsm.view.viewer.Main', tsm_manager:'webtsm.view.manager.Main'}}});
Ext.define('webtsm.mixins.Component', {getSetting:function(key, defaultValue) {
  return this.doGetSetting(this.moduleId, defaultValue);
}, getModuleName:function() {
  return webtsm.Support.getModuleNameFromClassName();
}, doLog:function(title, message, width, cmp) {
  webtsm.Util.toast(title, message, width, cmp || this);
}, openWindow:function() {
  var args = $jscomp.getRestArguments.apply(0, arguments);
  return webtsm.Support.openWindow.apply(webtsm.Support, $jscomp.arrayFromIterable(args));
}, getGlobalSetting:function(key, defaultValue) {
  return this.doGetSetting('webtsm', key) || defaultValue;
}, doGetSetting:function(id, key) {
  return BpcCommon.Api.getSetting(id, key);
}, TR:function(key) {
  return webtsm.Support.TR(key);
}, faIcon:function(icon) {
  return webtsm.Support.icon(icon);
}, applyWidthHeight:function(height, width) {
  height = height === void 0 ? 0.5 : height;
  width = width === void 0 ? 0.5 : width;
  this.width = document.body.clientWidth * width;
  this.height = document.body.clientHeight * height;
}, applyTitleIconCls:function(title, iconCls) {
  title = title === void 0 ? '' : title;
  this.title = this.TR(title);
  this.iconCls = this.faIcon(iconCls);
}, getBaseBtnConfig:function(type) {
  var cfg = Ext.apply({}, this.bpcBtnConfigs[type] || {});
  if (cfg.tr) {
    cfg.text = this.TR(cfg.tr);
    delete cfg.tr;
  }
  if (cfg.iconCls) {
    cfg.iconCls = this.faIcon(cfg.iconCls);
  }
  return Ext.apply({}, cfg, this.bpcBaseButton);
}, getBtnConfig:function(type, config) {
  type = type === void 0 ? '' : type;
  config = config === void 0 ? {} : config;
  return Ext.apply({}, config, this.getBaseBtnConfig(type));
}, createBaseButton:function(btnId, cfg) {
  cfg = cfg === void 0 ? {} : cfg;
  return Ext.create(this.getBtnConfig(btnId, cfg));
}, getUrlSearchParams:function(obj) {
  obj = obj === void 0 ? {} : obj;
  return new URLSearchParams(obj);
}, getStandardButtonConfigs:function() {
  return {'delete':{iconCls:'fa-trash', tr:'DELETE', ui:'secondary'}, refresh:{iconCls:'fa-sync', tr:'REFRESH', ui:'secondary'}, save:{iconCls:'fa-save', tr:'SAVE', ui:'primary'}, total:{iconCls:'fa-database'}};
}, enableBaseButtons:function(btns, btnDefaults) {
  btns = btns === void 0 ? {} : btns;
  btnDefaults = btnDefaults === void 0 ? {} : btnDefaults;
  this.bpcBtnConfigs = Ext.apply({}, btns, this.getStandardButtonConfigs());
  this.bpcBaseButton = Ext.apply({}, {xtype:'button'}, btnDefaults);
}, bpcBtnConfigs:{}, bpcBaseButton:{}, getBaseToolbarCfg:function() {
  return {xtype:'toolbar', padding:'3 3 3 3', defaults:{margin:'2 2 2 2'}};
}, _addDocked:function(items, dock) {
  items = items === void 0 ? [] : items;
  dock = dock === void 0 ? 'bottom' : dock;
  var toolbar = Ext.apply({}, this.getBaseToolbarCfg(), {items:items, dock:dock});
  if (this.dockedItems === null) {
    this.dockedItems = [toolbar];
  } else if (Ext.isArray(this.dockedItems)) {
    this.dockedItems.push(toolbar);
  } else {
  }
}, _fill:function() {
  return {xtype:'tbfill'};
}});
Ext.define('webtsm.components.button.SearchGridButton', {extend:'Ext.button.Button', alias:'widget.webtsmSearchGridButton', requires:['webtsm.Support'], mixins:['webtsm.mixins.Component'], store:undefined, queryMode:'OR', initComponent:function() {
  this.callParent(arguments);
  this.changeBtnStyle(this.queryMode);
}, setQueryMode:function(mode, init) {
  init = init || undefined;
  if (mode && (mode === 'OR' || mode === 'AND')) {
    mode = mode.trim();
    this.queryMode = mode;
    if (init) {
    }
  }
  return this.queryMode;
}, tooltip:'Sucheingaben werden mit ODER verknüpft', toggleVariants:{AND:{iconCls:webtsm.Support.getBpcIconCls('fa-link'), tooltip:'Sucheingaben werden mit UND verknüpft'}, OR:{iconCls:webtsm.Support.getBpcIconCls('fa-unlink'), tooltip:'Sucheingaben werden mit ODER verknüpft'}}, changeBtnStyle:function(queryMode) {
  var $jscomp$destructuring$var6 = this.toggleVariants[queryMode] || {};
  var iconCls = $jscomp$destructuring$var6.iconCls;
  var tooltip = $jscomp$destructuring$var6.tooltip;
  this.setText(webtsm.Support.TR(queryMode).toUpperCase());
  this.setIconCls(iconCls);
  this.setTooltip(tooltip);
}, handler:function(b) {
  this.changeBtnStyle(this.setQueryMode(this.queryMode === 'AND' ? 'OR' : 'AND'));
  this.store.load();
}});
Ext.define('webtsm.components.button.StoreFilterValueButton', {extend:'Ext.button.Segmented', alias:'widget.webtsmStoreFilterBtn', requires:['webtsm.Support'], allowMultiple:false, allowDepress:true, tooltip:'Filter setzen', iconOnly:false, initComponent:function() {
  var $jscomp$this = this;
  this.items = [{iconCls:webtsm.Support.getBpcIconCls('fa-compress'), tsmFilterAction:'empty', tooltip:'0 als Wert ausblenden', text:'Nullwerte ausblenden'}, {iconCls:webtsm.Support.getBpcIconCls('fa-filter'), tsmFilterAction:'changed', tooltip:'Zeige nur geänderte Werte', text:'geänderte Werte'}].map(function(item) {
    if ($jscomp$this.iconOnly) {
      delete item.text;
    }
    item.ui = 'secondary';
    return item;
  });
  this.callParent(arguments);
}});
Ext.define('webtsm.view.components.calendar.CalendarList', {extend:'Ext.panel.Panel', alias:['widget.webtsmCalendarListMain'], requires:['webtsm.Support'], layout:{type:'hbox', align:'stretch'}, items:[{xtype:'toolbar', layout:'vbox', flex:1, items:[{xtype:'box', html:'\x3ch3\x3e' + webtsm.Support.getTranslation('WEBTSM_CALENDAR_OVERVIEW') + '\x3c/h3\x3e'}]}, {xtype:'webtsmCalendarGrid', header:false, flex:5}], initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  var me = this;
  this.callParent(arguments);
  var tb = me.down('toolbar');
  webtsm.Api.calendar.getAll(me.moduleId).then(function(arrayOfCalendarDefinitons) {
    if (arrayOfCalendarDefinitons !== null && Ext.isArray(arrayOfCalendarDefinitons)) {
      Ext.Array.each(arrayOfCalendarDefinitons, function(calendar, i) {
        var o = {text:calendar.Name, tooltip:calendar.Description, calendarId:calendar.ID, iconCls:webtsm.Support.getBpcIconCls('fa-calendar'), handler:function(btn) {
          btn.up('webtsmCalendarListMain').down('webtsmCalendarGrid').changeUrl(btn.calendarId);
        }};
        var btn = tb.add(o);
        if (i === 0) {
          btn.handler(btn);
        }
      });
    }
  }, function(reason) {
  });
}});
Ext.define('webtsm.view.components.calendar.CalendarGrid', {extend:'Ext.grid.Panel', alias:'widget.webtsmCalendarGrid', requires:['webtsm.Support'], definition:{title:webtsm.Support.getTranslation('DAYS'), iconCls:webtsm.Support.getBpcIconCls('fa-calendar'), url:{suffix:'/calendars'}, columns:[{dataIndex:'From', renderer:function(value) {
  if (Ext.isDefined(value)) {
    value = Ext.Date.format(Ext.Date.parse(value, 'c'), 'd.m.Y H:i:s');
  }
  return value;
}}, {dataIndex:'To', renderer:function(value) {
  if (Ext.isDefined(value)) {
    value = Ext.Date.format(Ext.Date.parse(value, 'c'), 'd.m.Y H:i:s');
  }
  return value;
}}, {dataIndex:'Value', text:webtsm.Support.getTranslation('DAY'), renderer:function(value) {
  var days = webtsm.Api.maps.days;
  if (Ext.isDefined(value) && value in days) {
    value = days[value];
  }
  return value;
}}, 'Flag']}, calendarId:undefined, gridFilterField:'Value', calendarBase:function() {
  return webtsm.Api.tsmBasePath + this.moduleId + this.definition.url.suffix;
}, createUrl:function() {
  return this.calendarBase() + '/' + this.calendarId + '/days';
}, changeUrl:function(calendarId) {
  this.calendarId = calendarId;
  var storeUrl = this.createUrl();
  var store = this.getStore(), proxy = store.getProxy();
  proxy.setUrl(storeUrl);
  store.load();
}});
Ext.define('webtsm.view.components.tab.TsmTab', {extend:'Ext.tab.Panel', alias:'widget.webtsmTabPanel', tabPosition:'left', tabRotation:0, webtsmLastTabItemId:undefined, customDefaults:{iconAlign:'top', textAlign:'center', tabConfig:{width:140}}, initComponent:function() {
  this.defaults = this.mergeCustomDefaults();
  this.callParent(arguments);
}, mergeCustomDefaults:function() {
  var o = this.customDefaults;
  if ('defaults' in this && Ext.isDefined(this.defaults)) {
    var newDefaults = this.defaults;
    o = Ext.apply(newDefaults, this.customDefaults);
  }
  return o;
}});
Ext.define('webtsm.view.components.calendar.Main', {extend:'webtsm.view.components.tab.TsmTab', alias:['widget.webtsmCalendarMain'], requires:['webtsm.Support'], initComponent:function() {
  this.callParent(arguments);
  this.add([{xtype:'container', layout:'fit', itemId:'calendarWrapper', title:webtsm.Support.getTranslation('CALENDAR'), iconCls:webtsm.Support.getBpcIconCls('fa-calendar')}, {xtype:'webtsmCalendarListMain', title:webtsm.Support.getTranslation('LIST'), iconCls:webtsm.Support.getBpcIconCls('fa-list')}]);
  this.loadCalendar();
}, loadCalendar:function() {
  var calWrapper = this.down('#calendarWrapper');
  if (calWrapper) {
    calWrapper.setLoading(webtsm.Support.getTranslation('WEBTSM_CALENDAR_WILL_BE_LOADED') + '...');
    webtsm.Api.calendar.getAll(this.moduleId).then(function(arrayOrNull) {
      if (arrayOrNull !== null && Ext.isArray(arrayOrNull)) {
        var calandarStoreData = [];
        Ext.Array.each(arrayOrNull, function(calendarItem) {
          if ('ID' in calendarItem && 'Name' in calendarItem && 'Description' in calendarItem) {
            var o = {};
            o.id = calendarItem.ID;
            o.title = calendarItem.Name;
            o.description = calendarItem.Description;
            o.eventStore = {model:'webtsm.model.calendar.Events', proxy:{'type':'ajax', 'url':webtsm.Api.tsmBasePath + this.moduleId + '/calendars/' + calendarItem.ID + '/days'}, extraParams:{extCalendar:true}, startParam:'from', endParam:'to'};
            calandarStoreData.push(o);
          }
        }, this);
        calWrapper.setLoading(false);
        if (calandarStoreData.length > 0) {
          calWrapper.add({xtype:'webtsmCalendar', store:calandarStoreData});
        }
      }
    }.bind(this), function(reason) {
      webtsm.Support.notify(webtsm.Support.getTranslation('WEBTSM_CALENDAR_FETCH_ERROR') + JSON.stringify(reason));
    });
  }
}});
Ext.define('webtsm.model.calendar.Events', {extend:'Ext.calendar.model.Event', getStartDate:function() {
  return Ext.Date.parse(this.data.From, 'c');
}, setStartDate:function(From) {
  this.set('startDate', From);
}, getEndDate:function() {
  return Ext.Date.parse(this.data.To, 'c');
}, setEndDate:function(From) {
  this.set('endDate', From);
}, getDescription:function() {
  return this.data.Flag;
}, setDescription:function(desc) {
  this.set('description', desc);
}, getTitle:function() {
  var value = this.data.Value;
  if (value in webtsm.Api.maps.days) {
    value = webtsm.Api.maps.days[value];
  }
  return value;
}, setTitle:function(title) {
  this.set('title', title);
}, getEditable:function() {
  return false;
}, setEditable:function(value) {
  this.set('editable', false);
}});
Ext.define('webtsm.view.components.calendar.Calendar', {extend:'Ext.calendar.panel.Panel', alias:['widget.webtsmCalendar'], createButton:null, views:{month:{xtype:'calendar-month', titleTpl:'{start:date("F Y")}', label:webtsm.Support.getTranslation('WEBTSM_MONTH'), weight:30}}});
Ext.define('webtsm.components.container.Error', {extend:'Ext.container.Container', alias:'widget.webtsmErrorCmp', padding:'5 5 5 5', layout:'center', customText:undefined, contextCmp:undefined, initComponent:function() {
  var message = '\x3ch3\x3eFehler bei der Erstellung der' + (this.contextCmp ? this.contextCmp : '') + ' Komponente\x3c/h3\x3e';
  if (this.customText) {
    message += this.customText;
  }
  this.items = [{xtype:'container', html:message, width:'80%'}];
  this.callParent(arguments);
}});
Ext.define('webtsm.view.contextmenu.ContextMenu', {extend:'Ext.menu.Menu', alias:'widget.tsmTableContextMenu', moduleId:undefined, gridReference:undefined, columnDataIndex:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  var isMetaColumn = ['dummy', 'timestampFrom', 'timestampTo'].indexOf(this.columnDataIndex) !== -1;
  this.isFormula = false;
  var valueColumn = this.gridReference.getColumns().filter(function(c) {
    return c.dataIndex && c.dataIndex === $jscomp$this.columnDataIndex;
  });
  var quotationEnabled = false;
  if (valueColumn.length) {
    var meta = valueColumn[0].timeSeriesMeta || {};
    quotationEnabled = meta.Quotation;
  }
  this.items = [{xtype:'menuitem', hidden:!webtsm.Support.canEdit(), disabled:this.isFormula || isMetaColumn, iconCls:webtsm.ConfigKeys.icons.edit, text:webtsm.Support.TR('EDIT_VALUE') + webtsm.Api.helper.isFormulaTs(this.isFormula), handler:function(b) {
    webtsm.Support.openWindow(webtsm.Support.TR('EDIT_VALUE'), webtsm.Support.getBpcIconCls('fa-edit'), document.body.clientWidth * 0.4, null, 'webtsmValueEditor', {selectedRecord:$jscomp$this.record, dataIndex:$jscomp$this.columnDataIndex, moduleId:$jscomp$this.moduleId, gridReference:$jscomp$this.gridReference});
  }}, {xtype:'menuitem', disabled:!quotationEnabled, iconCls:webtsm.Support.icon('fa-code-branch'), text:this.getMenuText('QUOTATIONS', true), handler:function(b) {
    webtsm.Support.openWindow(webtsm.Support.TR('QUOTATIONS'), webtsm.Support.getBpcIconCls('fa-code-branch'), document.body.clientWidth * 0.4, document.body.clientHeight * 0.5, 'webtsmQuotationsGrid', {moduleId:$jscomp$this.moduleId, gridReference:$jscomp$this.gridReference, dataIndex:$jscomp$this.columnDataIndex});
  }}, {xtype:'menuitem', disabled:isMetaColumn, iconCls:webtsm.Support.icon('fa-info'), text:this.getMenuText('Details'), handler:function(b) {
  }}];
  this.callParent(arguments);
}, getMenuText:function(trKey, interactive) {
  trKey = trKey === void 0 ? '' : trKey;
  interactive = interactive === void 0 ? false : interactive;
  return (webtsm.Support.TR(trKey) + (interactive ? ' ...' : '')).trim();
}});
Ext.define('webtsm.components.detailWindow.WindowPanel', {extend:'Ext.panel.Panel', alias:'widget.webtsmDetailPanel', layout:'fit', header:false, title:'Webtsm Window Panel', record:undefined, moduleId:undefined, moduleInstance:undefined, pluginDefinitions:[], initComponent:function() {
  this.recordViewer = this.createRecordViewer(this.record);
  this.pluginWrapper = this.createPluginWrapper();
  var wrapper = Ext.create({xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[{xtype:'webtsmBucketGrid', hidden:true, flex:1}, {xtype:'container', style:{backgroundColor:'#f7f6f6'}, flex:2, layout:'fit', items:[this.recordViewer]}, {xtype:'splitter'}, this.pluginWrapper]});
  this.items = [wrapper];
  this.callParent(arguments);
  this.updateTitle();
  if (this.pluginDefinitions.length === 0) {
    this.loadTimeseriesRange();
  }
}, updateTitle:function() {
  var title = 'Details: ' + this.record.get('Name') + ' /  ' + this.record.get('ID');
  if (this.windowReference) {
    this.windowReference.setTitle(title);
  }
  this.setTitle(title);
}, createPluginWrapper:function() {
  var pluginCmpDefinitionsHolder = Ext.create({xtype:'webtsmDetailHook', moduleId:this.moduleId, pluginDefaults:{moduleInstance:this.moduleInstance}});
  var holderCmp = {xtype:'panel', header:false, layout:'fit', items:[{xtype:'container', html:'no plugins added', style:{backgroundColor:'#f7f6f6'}}], flex:6, style:{backgroundColor:'#f7f6f6'}};
  this.pluginDefinitions = pluginCmpDefinitionsHolder.getPluginDefinitions(this.record) || [];
  var plugins = this.pluginDefinitions;
  if (plugins.length === 1) {
    plugins[0].header = false;
    holderCmp.items = plugins;
  } else if (plugins.length > 1) {
    holderCmp.xtype = 'tabpanel';
    holderCmp.items = plugins;
    delete holderCmp.header;
  }
  return Ext.create(holderCmp);
}, createRecordViewer:function(record) {
  return Ext.create({xtype:'webtsmRecordViewer', record:record, moduleId:this.moduleId});
}, loadTimeseriesRange:function() {
  var $jscomp$this = this;
  var timeSeriesId = this.record.get('ID');
  webtsm.Api.timeseries.getMetaInfo(this.moduleId, timeSeriesId).then(function(success) {
    success = success || {};
    return Object.keys(success).map(function(name) {
      var values = success[name] || {};
      var items = [];
      var startDate, endDate;
      var canLoad = false;
      for (var key in values) {
        if (values.hasOwnProperty(key)) {
          var value = values[key] ? Ext.Date.parse(values[key]) : undefined;
          items.push({xtype:'datefield', readOnly:true, value:value, emptyText:'NOT SET', fieldLabel:key});
          if (key.toLowerCase() === 'from') {
            startDate = value;
            canLoad = true;
          }
          if (key.toLowerCase() === 'to') {
            endDate = value;
            if (!canLoad) {
              canLoad = true;
            }
          }
        }
      }
      var fieldSet = {xtype:'fieldset', title:name, layout:'anchor', items:items};
      var chartWrapper = Ext.create({xtype:'tsChart', flex:1});
      if (canLoad) {
        $jscomp$this.loadChartData(timeSeriesId, {from:startDate, to:endDate, interval:3, intervalMultiplier:1}, chartWrapper);
      }
      return {xtype:'panel', layout:{type:'vbox', align:'stretch'}, items:[fieldSet, chartWrapper]};
    });
  }).then(function(items) {
    $jscomp$this.pluginWrapper.removeAll();
    $jscomp$this.pluginWrapper.add(items);
  });
}, loadChartData:function(id, params, chart) {
  params = params === void 0 ? {} : params;
  var meta = webtsm.Api.timeseries.getMeta(this.moduleId, id);
  var data = webtsm.Api.timeseries.getData(this.moduleId, id, params);
  Promise.all([meta, data]).then(function(array) {
    var promiseMetaResults = [array[0]];
    var promiseResults = [array[1]];
    var timeseriesData = promiseResults.map(function(item, index, array) {
      var editTimeseriesMeta = null;
      if (Ext.isObject(item) && item.Data) {
        if (!this.isTSM39x) {
          this.isTSM39x = true;
        }
        var $jscomp$destructuring$var7 = item;
        var Unit = $jscomp$destructuring$var7.Unit;
        var TimeZone = $jscomp$destructuring$var7.TimeZone;
        var Interval = $jscomp$destructuring$var7.Interval;
        editTimeseriesMeta = {Unit:Unit, TimeZone:TimeZone, Interval:Interval};
        item = (item.Data || []).map(function(i, index, array) {
          if (array[index + 1]) {
            var next = array[index + 1];
            if (next.From) {
              var $jscomp$destructuring$var8 = next;
              var From = $jscomp$destructuring$var8.From;
              i.To = From;
            }
          }
          return i;
        });
      }
      return {metadata:promiseMetaResults[index], data:Ext.isArray(item) ? item : [], editTimeseriesMeta:editTimeseriesMeta};
    });
    chart.buildChart(timeseriesData);
  });
}});
Ext.define('webtsm.components.detailWindow.RecordViewer', {extend:'Ext.container.Container', alias:'widget.webtsmRecordViewer', layout:{type:'vbox', align:'stretch'}, style:{backgroundColor:'#f7f6f6'}, padding:'5 10 5 10', record:undefined, initComponent:function() {
  this.recordGrid = this.createRecordGrid();
  this.items = [this.recordGrid];
  this.callParent(arguments);
  this.updateGrid(this.record);
}, createRecordGrid:function() {
  return Ext.create({xtype:'grid', header:false, store:Ext.create('Ext.data.Store', {data:[]}), columns:[{dataIndex:'key', flex:1}, {dataIndex:'value', flex:3}]});
}, updateGrid:function(record) {
  var $jscomp$this = this;
  var obj = record.getData() || {};
  ['ID', 'Name', 'IntervalText', 'TypeNames'].map(function(key) {
    if (obj.hasOwnProperty(key)) {
      $jscomp$this.addToStore(key, obj[key] || '-1');
    }
  });
  this.getTimeseriesRange(obj.ID);
}, addToStore:function(k, v) {
  this.recordGrid.store.add({key:k, value:v || '-1'});
}, getTimeseriesRange:function(id) {
  var $jscomp$this = this;
  webtsm.Api.timeseries.getMetaInfo(this.moduleId, id).then(function(json) {
    json = json || {};
    if (json.DataPeriod) {
      if (json.DataPeriod.From) {
        $jscomp$this.addToStore('From', json.DataPeriod.From);
      }
      if (json.DataPeriod.To) {
        $jscomp$this.addToStore('To', json.DataPeriod.To);
      }
    }
  });
}});
Ext.define('webtsm.components.fields.BaseCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.webtsmBaseCombo'], queryMode:'local', valueField:'ID', displayField:'Name', moduleId:undefined});
Ext.define('webtsm.components.fields.AggregationCombo', {extend:'webtsm.components.fields.BaseCombo', alias:['widget.webtsmAggregationCombo'], initComponent:function() {
  this.store = webtsm.Support.createTsmApiStore(this.moduleId, '/aggregations', false, false);
  this.store.on({load:function(s, recs, successful) {
    if (successful) {
      s.add({ID:4269, Name:'Standard'});
    }
  }});
  this.callParent(arguments);
  this.store.load();
}});
Ext.define('webtsm.components.fields.AttributeType', {extend:'Ext.form.field.ComboBox', alias:['widget.webtsmAttributeTypeCombo'], queryMode:'local', displayField:'Name', valueField:'ID', initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.callParent(arguments);
  webtsm.Api.attributes.getTypes(this.moduleId).then(function(value) {
    $jscomp$this.store.add(value);
  }, function(reason) {
  });
}});
Ext.define('webtsm.components.fields.BaseFilterCombo', {extend:'webtsm.components.fields.BaseCombo', alias:['widget.webtsmBasefilterCombo'], displayField:'name', valueField:'filterId', emptyText:webtsm.Support.getTranslation('WEBTSM_NO_BASEFILTER_DEFINED') + '.', grid:undefined, moduleId:undefined, initComponent:function() {
  if (!this.grid && !this.moduleId) {
    var g = this.up('grid');
    if (g) {
      this.moduleId = g.instanceId;
      this.grid = g;
    }
  }
  var baseFilterObj = BpcCommon.Api.getSetting(this.moduleId, 'restrictions_baseFilter');
  if ('default' in baseFilterObj) {
    delete baseFilterObj["default"];
  }
  var objectToBaseFilterStore = function(baseFilterO) {
    var storeData = [];
    Ext.iterate(baseFilterO, function(k, v) {
      if (k && v && 'name' in v && v.name) {
        if ('implicit' in v) {
        } else {
          storeData.push({name:v.name, filterId:k});
        }
      }
    });
    return storeData;
  };
  var storeData = objectToBaseFilterStore(baseFilterObj);
  if (storeData.length === 0) {
    this.disabled = true;
    this.hidden = true;
  }
  this.store = Ext.create('Ext.data.Store', {data:storeData});
  this.callParent(arguments);
}});
Ext.define('webtsm.view.components.fields.BpcTsmInputQueryField', {extend:'Ext.form.field.Text', alias:['widget.tsmInputQueryField'], requires:['webtsm.ConfigKeys'], emptyText:webtsm.Support.getTranslation('SEARCH'), tooltip:webtsm.Support.getTranslation('WEBTSM_SEARCH_TS_IN_CACHE'), listeners:{buffer:300, 'change':function(cmp, newVal, oldVal, eOpts) {
  var reset = cmp.getTrigger('resetField');
  reset.setVisible(newVal && newVal.length > 0);
  this.submitFilter();
}}, triggers:{resetField:{cls:webtsm.ConfigKeys.icons.remove, hidden:true, handler:function() {
  if (this.isUsedInManager()) {
    var inSearch = this.up('webtsmSearchOverview');
    inSearch.getController().removeAttributeFilters();
    return;
  }
  this.setValue('');
}}}, gridReference:undefined, gridFilterField:undefined, clearValueSilent:function() {
  this.suspendEvents();
  this.setValue(undefined);
  this.hideTsmTrigger('resetField');
  this.resumeEvents();
}, getValueSilent:function() {
  return this.getValue();
}, hideTsmTrigger:function(triggerName) {
  var trigger = this.getTrigger(triggerName);
  trigger.hide();
}, isUsedInManager:function() {
  var cmp = this.up('webtsmSearchOverview');
  return !!cmp;
}, loadManagerStore:function(v) {
  var cmp = this.up('webtsmSearchOverview');
  cmp.getController().loadSearchStore(v);
}, submitFilter:function() {
  var value = this.getValue();
  if (this.isUsedInManager()) {
    this.loadManagerStore(value);
  } else {
    this.loadStoreWithQuery(value);
  }
}, loadStoreWithQuery:function(query) {
  query = query === void 0 ? '' : query;
  var store = this.gridReference.store;
  store.getProxy().setExtraParam('query', query + '*');
  store.load();
}, updateFulltextSearchField:function(value) {
}});
Ext.define('webtsm.components.fields.FlagType', {extend:'Ext.form.field.ComboBox', alias:['widget.webtsmFlagCombo'], fieldLabel:webtsm.Support.getTranslation('FLAG'), queryMode:'local', valueField:'ID', displayField:'Name', allowBlank:false, moduleId:undefined, initComponent:function() {
  this.store = webtsm.Support.createTsmApiStore(this.moduleId, '/flags', true, false);
  this.callParent(arguments);
}});
Ext.define('webtsm.view.components.fields.GenericInstanceSelector', {extend:'BpcCommon.component.form.field.ModuleInstanceTypeSelector', alias:['widget.bpcconfig.tsmTypeSelector'], fieldLabel:webtsm.Support.getTranslation('WEBTSM_VIEWER_INSTANCE'), baseModuleName:'webtsm', instanceTypes:['none', 'webtsm_module']});
Ext.define('webtsm.components.fields.IntervalCombo', {extend:'webtsm.components.fields.BaseCombo', alias:['widget.webtsmIntervalCombo'], displayField:'NameTranslated', initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.callParent(arguments);
  this.loadIntervals();
}, loadIntervals:function() {
  var $jscomp$this = this;
  if (this.moduleId) {
    webtsm.Api.getIntervals(this.moduleId).then(function(r) {
      r = r || {};
      var data = webtsm.Support.getResponseObject(r);
      if (Ext.isArray(data)) {
        var storeData = [];
        data.map(function(i) {
          i.NameTranslated = webtsm.Support.getTranslation(i.Name);
          storeData.push(i);
          if (i.ID === 2) {
            storeData.push({ID:4269, Name:'Quarter_Hour', NameTranslated:webtsm.Support.getTranslation('Quarter_Hour')});
          }
        });
        $jscomp$this.store.add(storeData);
        var initialValue = $jscomp$this.getValue();
        if (Ext.isDefined(initialValue)) {
          $jscomp$this.setValue(initialValue);
        }
      }
    });
  }
}});
Ext.define('webtsm.view.components.fields.ManagerInstancesCombo', {extend:'BpcCommon.component.form.field.ModuleInstanceTypeSelector', alias:['widget.bpcconfig.webtsmManagerCombo'], fieldLabel:webtsm.Support.getTranslation('WEBTSM_MANAGER_INSTANCE'), baseModuleName:'webtsm', instanceTypes:['tsm_manager']});
Ext.define('webtsm.components.fields.UnitCombo', {extend:'webtsm.components.fields.BaseCombo', alias:['widget.webtsmUnitCombo'], valueField:'Name', initComponent:function() {
  this.store = webtsm.Support.createTsmApiStore(this.moduleId, '/units', true, true);
  this.callParent(arguments);
}});
Ext.define('webtsm.components.fields.VersionCombo', {extend:'webtsm.components.fields.BaseCombo', alias:['widget.webtsmVersionCombo'], initComponent:function() {
  var versionFeature = webtsm.Api.versionEnabled(this.moduleId);
  var s = Ext.create('Ext.data.Store', {data:[]});
  if (versionFeature) {
    var cfg = webtsm.Api.getBaseRequestCfg(this.moduleId, 'GET', false);
    var application = webtsm.Support.getApiConfigKeybyInstanceId(this.moduleId);
    cfg.url += '/Extensions/Version/repositories/' + application + '/versions';
    webtsm.Api.sendRequest(cfg).then(function(r) {
      var json = webtsm.Support.getResponseObject(r);
      if (json && Ext.isArray(json)) {
        json = json.map(function(versionName) {
          return {ID:versionName, Name:versionName};
        });
        s.add(json);
      }
    });
  }
  this.hidden = !versionFeature;
  this.store = s;
  this.callParent(arguments);
}});
Ext.define('webtsm.support.bpcconfig.fields.tsmDateField', {extend:'Ext.form.field.Date', alias:['widget.bpcconfig.tsmWidgetDateField'], initComponent:function() {
  var me = this;
  this.callParent(arguments);
}});
Ext.define('webtsm.support.bpcconfig.fields.tsmDefaultQueryMode', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.tsmDefaultQueryMode'], viewModel:{data:{}}, displayField:'text', valueField:'key', bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:[{key:'OR', text:'Suchparameter werden mit OR verknüpft'}, {key:'AND', text:'Suchparameter werden mit UND verknüpft'}]});
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('webtsm.support.bpcconfig.fields.webtsmAggregationCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.webtsmAggregationCombo', 'widget.bpcconfig.webtsmaggregationcombo'], viewModel:{data:{}}, displayField:'Name', valueField:'ID', bind:{value:'{setting.value}'}, initComponent:function() {
  var me = this;
  var moduleId = this.setting.get('instanceId');
  me.store = webtsm.Support.createAggregationsStore(moduleId);
  me.callParent(arguments);
  me.getViewModel().set('setting', this.setting);
}});
Ext.define('webtsm.support.bpcconfig.fields.webtsmApiCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.webtsmApiCombo'], viewModel:{data:{}}, displayField:'name', valueField:'id', bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:this.getApiKeysAsStoreData()});
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}, getApiKeysAsStoreData:function() {
  var obj = BpcCommon.Api.getSetting('webtsm', 'module_apis') || {};
  return Ext.isObject(obj) ? Ext.Object.getKeys(obj).map(function(apiId) {
    return {id:apiId || ' - ', name:apiId || ' - '};
  }) : [];
}});
Ext.define('webtsm.support.bpcconfig.fields.webtsmAttributesViewMode', {extend:'Ext.form.field.ComboBox', alias:'widget.bpcconfig.webtsmAttributesViewMode', viewModel:{data:{}}, displayField:'text', valueField:'key', bind:{value:'{setting.value}'}, initComponent:function() {
  var me = this;
  var storeConfig = {data:[{key:'attributes', text:'Attribute ohne Werte anzeigen'}, {key:'compressed', text:'Attribute mit Werten anzeigen'}]};
  me.store = Ext.create('Ext.data.Store', storeConfig);
  me.callParent(arguments);
  me.getViewModel().set('setting', this.setting);
}});
Ext.define('webtsm.support.bpcconfig.fields.webtsmDate', {extend:'Ext.form.field.Date', alias:['widget.bpcconfig.webtsmDate', 'widget.bpcconfig.webtsmdate'], viewModel:{data:{}}, format:'C', submitFormat:'C', bind:{value:'{setting.value}'}, initComponent:function() {
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('webtsm.support.bpcconfig.fields.webtsmIntervalCombo', {extend:'webtsm.components.fields.IntervalCombo', alias:['widget.bpcconfig.webtsmIntervalCombo', 'widget.bpcconfig.webtsmintervalcombo'], viewModel:{data:{}}, bind:{value:'{setting.value}'}, initComponent:function() {
  if (this.setting) {
    this.moduleId = this.setting.get('instanceId');
  }
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('webtsm.components.fields.Search', {extend:'Ext.form.field.ComboBox', alias:['widget.webtsmSearchCombo'], fieldLabel:'Suche', emptyText:'Zeitreihen hinzufügen', queryMode:'remote', valueField:'ID', displayField:'Name', allowBlank:false, moduleId:undefined, triggerAction:'last', minChars:2, hideTrigger:true, listeners:{'select':function(combo, record, eOpts) {
  combo.up(context).changeTimeseries([record], true);
  combo.clearValue();
}}, initComponent:function() {
  var storeConfig = {proxy:{type:'ajax', url:webtsm.Api.tsmBasePath + 'cache/' + this.moduleId, reader:{type:'json', rootProperty:'data', totalProperty:'total'}}, autoLoad:true};
  this.store = Ext.create('Ext.data.Store', storeConfig);
  this.callParent(arguments);
}});
Ext.define('webtsm.components.fields.StatesCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.webtsmStatesCombo'], emptyText:webtsm.Support.getTranslation('WEBTSM_VIEW_SELEKTOR'), valueField:'state', displayField:'name', moduleId:undefined, initComponent:function() {
  var views = BpcCommon.Api.getSetting(this.moduleId, 'view_states');
  if (!Ext.isArray(views)) {
    views = [];
  }
  this.store = Ext.create('Ext.data.Store', {data:views});
  this.callParent(arguments);
}});
Ext.define('webtsm.view.components.grid.Bucket', {extend:'Ext.grid.Panel', alias:'widget.webtsmBucketGrid', requires:['webtsm.ConfigKeys'], hideHeaders:true, viewConfig:{emptyText:'Zeitreihen Bucket ist leer', deferEmptyText:false, enableTextSelection:true}, bbar:[{xtype:'tbfill'}, {iconCls:webtsm.Support.getBpcIconCls('fa-bars'), tooltip:webtsm.Support.getTranslation('WEBTSM_CHANGE_MASTERDATA'), action:'definitions', handler:function(btn) {
  var view = btn.up('grid');
  var managerMain = view.up('webtsmManagerMain');
  var bucket = view.getStoreAsBucket();
  managerMain.openTsmComponent({action:btn.action, bucket:bucket});
}}, {iconCls:webtsm.Support.getBpcIconCls('fa-archive'), tooltip:webtsm.Support.getTranslation('WEBTSM_CHANGE_ATTRIBUTES'), action:'attributes', handler:function(btn) {
  var view = btn.up('grid');
  var managerMain = view.up('webtsmManagerMain');
  var bucket = view.getStoreAsBucket();
  managerMain.openTsmComponent({action:btn.action, bucket:bucket});
}}, {iconCls:webtsm.Support.getBpcIconCls('fa-edit'), tooltip:webtsm.Support.getTranslation('WEBTSM_CHANGE_VALUES'), action:'values', handler:function(btn) {
  var view = btn.up('grid');
  var managerMain = view.up('webtsmManagerMain');
  var bucket = view.getStoreAsBucket();
  managerMain.openTsmComponent({action:btn.action, bucket:bucket});
}}], getBucketAsArray:function() {
  var bucket = [];
  this.store.each(function(m) {
    bucket.push({ID:m.get('ID'), Name:m.get('Name'), Version:m.get('Version')});
  });
  return bucket;
}, getStoreAsBucket:function(index) {
  var storeModels = Ext.isDefined(index) ? [this.store.getAt(index)] : this.store.getData().getRange();
  return webtsm.Support.createPayloadFromModelInstanceArray(storeModels);
}, payload:[], moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  var data = this.payload || [];
  this.store = this.bucketStore ? this.bucketStore : Ext.create('Ext.data.Store', {fields:['ID', 'Name'], data:data});
  this.columns = [{dataIndex:'ID', text:webtsm.Support.getTranslation('TS_ID'), width:120}, {dataIndex:'Name', text:webtsm.Support.getTranslation('NAME'), flex:1}, {xtype:'actioncolumn', width:30, items:[{iconCls:webtsm.ConfigKeys.icons.remove, tooltip:'Zeitreihe aus Bucket entfernen', handler:function(tableView, rowIndex) {
    $jscomp$this.store.removeAt(rowIndex);
  }}]}].map(function(i) {
    i.style = webtsm.Support.getDefaultGridStyle();
    return i;
  });
  this.callParent(arguments);
}});
Ext.define('webtsm.view.config.SelectedGrid', {extend:'Ext.grid.Panel', alias:'widget.tsmSelectedGrid', requires:['webtsm.ConfigKeys'], viewConfig:{emptyText:webtsm.Support.getTranslation('WEBTSM_SELECTED_GRID_EMPTY_MSG'), enableTextSelection:true, deferEmptyText:false}, plugins:{ptype:'cellediting', clicksToEdit:1}, itemId:'selectedTsGrid', minHeight:65, editEnabled:undefined, hideHeaders:true, openDetailWindow:function(r) {
  webtsm.Util.openDetailWindow(r, this.moduleId);
}, initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.viewConfig.moduleId = this.moduleId;
  this.virtimoColors = webtsm.Support.getRandomVirtimoColors();
  this.listeners = {cellcontextmenu:function(view, td, cellI, record, tr, rowIndex, e) {
    e.preventDefault();
    Ext.create('Ext.menu.Menu', {width:50, items:$jscomp$this.virtimoColors.map(function(hexColor) {
      return {text:'\x26nbsp;', color:hexColor, style:'background-color:' + hexColor + ';', handler:function(m) {
        record.set('color', m.color);
      }};
    })}).showAt(e.getXY());
  }, rowdblclick:function(table, r) {
    return $jscomp$this.openDetailWindow(r);
  }};
  this.columns = [{xtype:'actioncolumn', text:'ACTIONS', width:30, items:[{iconCls:webtsm.ConfigKeys.icons.infoIcon, tooltip:webtsm.Support.getTranslation('WEBTSM_TIMESERIES_METAINFO'), handler:function(table, rI, cI, item, e, r) {
    return $jscomp$this.openDetailWindow(r);
  }}]}, {dataIndex:'ID', width:80, text:'ID', renderer:function(value, metaData, record) {
    var visible = record.get('visibleForUser');
    if (Ext.isDefined(visible) && visible === false) {
      metaData.tdCls = 'webtsm-restricted-timeseries';
      value = webtsm.Support.getSpanForIconCls(webtsm.Support.getBpcIconCls('fa-exclamation'), 'red', 12);
    }
    return value;
  }}, {dataIndex:'color', width:26, text:'Farbe', renderer:function(value, metaData, record) {
    metaData.tdAttr = 'bgcolor\x3d"' + value + '"';
    return '';
  }}, {dataIndex:'Name', flex:3, text:'NAME', renderer:function(value, metaData, record, rowIndex, colIndex, store, view) {
    if (!value) {
      var tsData = record.get('tsData');
      if (tsData) {
        value = tsData;
      }
    }
    return value;
  }}, {dataIndex:'Unit', text:'UNIT', editor:{completeOnEnter:false, field:{xtype:'webtsmUnitCombo', allowBlank:false, moduleId:this.moduleId}}, flex:1, renderer:function(value, metaData) {
    var unit = null;
    metaData.tdStyle = unit && unit !== null && value && value !== unit && unit !== 'null' ? 'background-color:yellow' : '';
    return value;
  }}].concat(webtsm.Api.versionEnabled(this.moduleId) ? [{dataIndex:'Version', text:'VERSION', itemId:'viewerVersionColumn', editor:{completeOnEnter:false, field:{xtype:'webtsmVersionCombo', allowBlank:false, moduleId:this.moduleId}}, flex:1, renderer:function(value) {
    return !Ext.isDefined(value) || value === null ? ' (Version) ' : value;
  }}] : []).concat([{dataIndex:'Aggregation', text:'AGGREGATION', editor:{completeOnEnter:false, field:{xtype:'webtsmAggregationCombo', allowBlank:false, moduleId:this.moduleId}}, flex:1, renderer:function(value) {
    if (!Ext.isDefined(value) || value === null) {
      value = ' (Aggregation) ';
    } else {
      var obj = webtsm.Support.storeData.aggregations;
      if (obj && $jscomp$this.moduleId in obj && obj[$jscomp$this.moduleId]) {
        var translationModels = obj[$jscomp$this.moduleId];
        var matches = translationModels.filter(function(m) {
          return m && m.get('ID') === value;
        });
        if (matches.length) {
          value = matches[0].get('Name');
        }
      }
    }
    return value;
  }}, {xtype:'actioncolumn', text:'ACTIONS', width:this.editEnabled === true ? 150 : 30, items:webtsm.Api.getManagerActions(webtsm.Support.getManagerInstanceForViewer(this.moduleId)).map(function(i) {
    i.hidden = !$jscomp$this.editEnabled;
    i.handler = function(v, rowIndex, colIndex, item) {
      $jscomp$this.openManager(item.actionKey);
    };
    return i;
  }).concat([{iconCls:webtsm.ConfigKeys.icons.remove, tooltip:webtsm.Support.getTranslation('WEBTSM_REMOVE'), handler:function(tableView, rowIndex, colIndex) {
    $jscomp$this.store.removeAt(rowIndex);
  }}])}]).map(function(col) {
    col.style = webtsm.Support.getDefaultGridStyle();
    return col;
  });
  this.callParent(arguments);
}, changeValueForItems:function(modelKey, value) {
  this.store.each(function(record) {
    record.set(modelKey, value);
  });
}, openManager:function(actionName, rowIndex) {
  var bucket = this.getStoreAsBucket(rowIndex), payload = {action:actionName, bucket:bucket};
  if (actionName === 'values') {
    var mainView = this.up('tsmMain');
    if (mainView) {
      var requestParams = mainView.getRequestObject();
      if ('interval' in requestParams && 'start' in requestParams && 'end' in requestParams) {
        payload.start = requestParams.start;
        payload.end = requestParams.end;
        payload.interval = requestParams.interval;
      }
    }
  }
  var managerInstanceId = webtsm.Support.getManagerInstanceForViewer(this.moduleId);
  managerInstanceId ? BpcCommon.Api.showModule(managerInstanceId, true, payload) : Ext.toast('ManagerId not found, please check your settings');
}, refreshStoreData:function(storeData) {
  this.resetGrid();
  return this.store.add(storeData || []);
}, getStoreAsBucket:function(index) {
  var storeModels = Ext.isDefined(index) ? [this.store.getAt(index)] : this.store.getData().getRange();
  return webtsm.Support.createPayloadFromModelInstanceArray(storeModels);
}, resetGrid:function() {
  this.getStore().removeAll();
}});
Ext.define('webtsm.view.components.grid.SimpleListGrid', {extend:'Ext.grid.Panel', alias:'widget.webtsmSimpleListGrid', requires:['webtsm.ConfigKeys', 'webtsm.Support'], viewConfig:{emptyText:webtsm.Support.getTranslation('NO_TIME_SERIES'), deferEmptyText:false, enableTextSelection:true}, viewModel:{data:{count:0, startDate:Ext.Date.add(new Date(), Ext.Date.DAY, -1), startHour:0, startMinute:0, endDate:new Date(), endHour:0, endMinute:0, requestInterval:0}, formulas:{selectionPeriod:{get:function(get) {
  var startDate = get('startDate');
  var endDate = get('endDate');
  var period = 'Fehler im ViewModel';
  if (startDate && endDate && Ext.isDate(startDate) && Ext.isDate(endDate)) {
    startDate.setHours(get('startHour'), get('startMinute'), 0, 0);
    endDate.setHours(get('endHour'), get('endMinute'), 0, 0);
    var format = get('getDateFormat');
    var startDateString = Ext.Date.format(startDate, format);
    var endDateString = Ext.Date.format(endDate, format);
    period = startDateString + ' Uhr - ' + endDateString + ' Uhr';
    var v = this.getView();
    v.handleSelectionPeriodString(period);
  }
  return period;
}}, getDateFormat:{get:function(get) {
  var format = 'd.m.Y H:i';
  if (get('requestInterval') === 's') {
    format = webtsm.Support.defaultDateFormat;
  }
  return format;
}}}}, handleSelectionPeriodString:function(str) {
  if (this.webtsmPluginWrapper.pluginView) {
    this.webtsmPluginWrapper.pluginView.setCustomTitle(str);
  }
}, selModel:{selType:'checkboxmodel'}, pluginMain:undefined, columnDataIndexes:undefined, webtsmEsSyntaxPeriod:undefined, webtsmPluginWrapper:undefined, pluginSourceInstanceId:undefined, moduleId:undefined, types:{}, intervals:{}, initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    $jscomp$this.getViewModel().set('count', s.getCount());
  }}});
  if (!this.hideToolbarTop) {
    this.bbar = [{xtype:'box', bind:{html:'\x26nbsp;\x26nbsp; {count} ' + webtsm.Support.getTranslation('DATASETS') + ''}}, {xtype:'tbfill', maxWidth:50, width:50}, {xtype:'fieldcontainer', flex:1, layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'numberfield', flex:1, allowBlank:false, width:120, maxWidth:120}, fieldLabel:webtsm.Support.getTranslation('FROM'), items:[{xtype:'datefield', bind:{value:'{startDate}'}, width:170, maxWidth:170}, {bind:{value:'{startHour}'}, maxValue:23, minValue:0, 
    tooltip:'Stunde'}, {bind:{value:'{startMinute}'}, maxValue:59, minValue:0, tooltip:'Minute'}]}, {xtype:'fieldcontainer', flex:1, layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'numberfield', flex:1, allowBlank:false, width:120, maxWidth:120}, fieldLabel:webtsm.Support.getTranslation('TO'), items:[{xtype:'datefield', bind:{value:'{endDate}'}, width:170, maxWidth:170}, {bind:{value:'{endHour}'}, maxValue:23, minValue:0, tooltip:'Stunde'}, {bind:{value:'{endMinute}'}, maxValue:59, minValue:0, 
    tooltip:'Minute'}]}];
  }
  var columns = this.createColumns(this.columnDataIndexes);
  columns.push({xtype:'actioncolumn', width:45, style:webtsm.Support.getDefaultGridStyle(), items:[{iconCls:webtsm.ConfigKeys.icons.chartArea, tooltip:webtsm.Support.getTranslation('ACTIONS'), handler:function(tv, rowIndex, colIndex, item, event, record) {
    Ext.create('Ext.menu.Menu', {items:$jscomp$this.getMenuItems(record)}).showAt(event.getXY());
  }, isActionDisabled:function() {
    return $jscomp$this.canAccessInstances() === false;
  }}]});
  this.columns = columns.map(function(col) {
    if ($jscomp$this.pluginColumns && Ext.isArray($jscomp$this.pluginColumns)) {
      col.hidden = col.dataIndex && $jscomp$this.pluginColumns.indexOf(col.dataIndex.toLowerCase()) === -1;
    }
    return col;
  });
  if (!this.hideToolbarTop) {
    this.tbar = this.getTbarConfig(true);
    this.listeners = {selectionchange:function(selModel, selection, eopts) {
      $jscomp$this.actionButton.setDisabled(!selection.length);
    }};
  }
  this.callParent(arguments);
  if (this.webtsmEsSyntaxPeriod) {
    var dateArray = webtsm.Support.createDatesFromEsDateRange(this.webtsmEsSyntaxPeriod);
    var vm = this.getViewModel();
    vm.set('startDate', dateArray.start);
    vm.set('endDate', dateArray.end);
  } else {
  }
}, canAccessInstances:function() {
  var permissions_advancedEnabled = BpcCommon.Api.getSetting('webtsm', 'permissions_advancedEnabled');
  return permissions_advancedEnabled ? BpcCommon.Api.hasUserRole('WEBTSM_USER') : true;
}, createColumns:function(arrayWithDataIndexes) {
  var $jscomp$this = this;
  var baseColumns = [{dataIndex:'ID', flex:0.75, renderer:function(v, m, r) {
    m.tdAttr = 'data-qtip\x3d"' + (r.get('Name') || '') + '"';
    return v;
  }}, {dataIndex:'Name', flex:2, renderer:function(v, m, r) {
    m.tdAttr = 'data-qtip\x3d"' + (v || '') + '"';
    return v;
  }}, {dataIndex:'Description', hidden:true, flex:2}, {dataIndex:'Unit', hideable:true, flex:0.5}, {dataIndex:'Interval', sortable:false, flex:0.75, renderer:function(val) {
    if (val && Ext.isObject(val)) {
      var $jscomp$destructuring$var9 = val;
      var Value = $jscomp$destructuring$var9.Value;
      var Multiplier = $jscomp$destructuring$var9.Multiplier;
      if (Value) {
        var s = this.intervals[String(Value)] ? this.intervals[String(Value)] : Value;
        if (Value === 2 && Multiplier && Multiplier === 15) {
          s = 'Quarter_Hour';
        }
        return webtsm.Support.getTranslation(s);
      }
    }
    return '';
  }}, {dataIndex:'Type', hideable:true, flex:0.5, renderer:function(v) {
    return $jscomp$this.types[String(v)] ? $jscomp$this.types[String(v)] : v;
  }}, {dataIndex:'Formula', cellWrap:true, renderer:function(val) {
    if (val && Ext.isObject(val)) {
      var html = '';
      var keys = Ext.Object.getKeys(val);
      keys.map(function(key) {
        html += key + ': ' + val[key] + '\x3cbr/\x3e';
      });
      return html;
    }
    return '';
  }, sortable:false, flex:1}, {dataIndex:'Table', flex:1}, {dataIndex:'ArchiveTable', flex:1}].map(function(c) {
    c.text = webtsm.Support.getTranslation('TS_' + c.dataIndex);
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  });
  if (arrayWithDataIndexes && arrayWithDataIndexes.length) {
    return baseColumns.filter(function(colCfg) {
      if (arrayWithDataIndexes.indexOf(colCfg.dataIndex) !== -1) {
        return colCfg;
      }
    });
  }
  return baseColumns;
}, getTbarConfig:function(addmenuBtn) {
  var $jscomp$this = this;
  this.actionButton = Ext.create({xtype:'button', iconCls:webtsm.Support.getBpcIconCls('fa-plus'), itemId:'webtsmActionBtn', disabled:true, hidden:!addmenuBtn, menu:this.getMenuItems()});
  return [{xtype:'textfield', emptyText:'Zeitreihen durchsuchen', flex:1}].concat(this.actionButton).concat([{iconCls:webtsm.Support.getBpcIconCls('sync'), handler:function(b) {
    $jscomp$this.refreshStoreData();
  }}]);
}, refreshStoreData:function() {
  var IDs = [];
  this.store.each(function(rec) {
    var id = rec.get('ID');
    if (!id) {
      id = rec.get('Name');
    }
    IDs.push(id);
  });
  this.updateStore(IDs);
}, updateStore:function(IDs) {
  var $jscomp$this = this;
  this.setLoading(webtsm.Support.getTranslation('LOADING'));
  webtsm.Support.loadBatchMetaData(IDs || [], this.moduleId).then(function(data) {
    $jscomp$this.store.removeAll();
    $jscomp$this.store.add(data);
    $jscomp$this.setLoading(false);
  }, function(reason) {
    $jscomp$this.setLoading(false);
  });
}, execAction:function(menuItem) {
  var selection;
  if (menuItem && menuItem.record) {
    selection = [menuItem.record];
  } else {
    selection = this.getSelectionModel().getSelection();
  }
  var payload = {bucket:selection.map(function(r) {
    return {ID:r.get('ID'), Name:r.get('Name')};
  })};
  if (menuItem && menuItem.actionKey) {
    payload['action'] = menuItem.actionKey;
  }
  BpcCommon.Api.showModule(menuItem._moduleId, true, payload);
}, getMenuItems:function(record) {
  var $jscomp$this = this;
  var menuItems = webtsm.Api.getAllActionsByViewerId(this.moduleId);
  menuItems = menuItems.map(function(item) {
    item.record = record;
    item.handler = $jscomp$this.execAction;
    item.scope = $jscomp$this;
    item.disabled = $jscomp$this.canAccessInstances() === false;
    return item;
  });
  return menuItems;
}});
Ext.define('webtsm.components.grid.feature.AbstractSummary', {extend:'Ext.grid.feature.Feature', alias:'feature.webtsmabstractsummary', summaryRowCls:Ext.baseCSSPrefix + 'grid-row-summary', summaryRowSelector:'.' + Ext.baseCSSPrefix + 'grid-row-summary', readDataOptions:{recordCreator:Ext.identityFn}, summaryRowTpl:{fn:function(out, values, parent) {
  if (values.record.isSummary) {
    this.summaryFeature.outputSummaryRecord(values.record, values, out, parent);
  } else {
    this.nextTpl.applyOut(values, out, parent);
  }
}, priority:1000}, showSummaryRow:true, init:function() {
  var me = this;
  me.view.summaryFeature = me;
  me.rowTpl = me.view.self.prototype.rowTpl;
  me.view.addRowTpl(me.summaryRowTpl).summaryFeature = me;
  me.summaryData = {};
  me.groupInfo = {};
  if (!me.summaryTableCls) {
    me.summaryTableCls = Ext.baseCSSPrefix + 'grid-item';
  }
  if (me.hasOwnProperty('summaryRowCls')) {
    me.summaryRowSelector = '.' + me.summaryRowCls;
  }
}, bindStore:function(grid, store) {
  var me = this;
  Ext.destroy(me.readerListeners);
  if (me.remoteRoot) {
    me.readerListeners = store.getProxy().getReader().on({scope:me, destroyable:true, rawdata:me.onReaderRawData});
  }
}, onReaderRawData:function(data) {
  this.summaryRows = null;
  this.readerRawData = data;
}, toggleSummaryRow:function(visible, fromLockingPartner) {
  var me = this, prev = me.showSummaryRow, doRefresh;
  visible = visible != null ? !!visible : !me.showSummaryRow;
  me.showSummaryRow = visible;
  if (visible && visible !== prev) {
    me.updateSummaryRow = true;
  }
  if (me.lockingPartner) {
    if (!fromLockingPartner) {
      me.lockingPartner.toggleSummaryRow(visible, true);
      doRefresh = true;
    }
  } else {
    doRefresh = true;
  }
  if (doRefresh) {
    me.grid.ownerGrid.getView().refresh();
  }
}, createRenderer:function(column, record) {
  var me = this, ownerGroup = record.ownerGroup, summaryData = ownerGroup ? me.summaryData[ownerGroup] : me.summaryData, dataIndex = column.dataIndex || column.getItemId();
  return function(value, metaData) {
    return column.summaryRenderer ? column.summaryRenderer(record.data[dataIndex], summaryData, dataIndex, metaData) : record.data[dataIndex];
  };
}, outputSummaryRecord:function(summaryRecord, contextValues, out) {
  var view = contextValues.view, savedRowValues = view.rowValues, columns = contextValues.columns || view.headerCt.getVisibleGridColumns(), colCount = columns.length, i, column, values = {view:view, record:summaryRecord, rowStyle:'', rowClasses:[this.summaryRowCls, this.summaryItemCls], itemClasses:[], recordIndex:-1, rowId:view.getRowId(summaryRecord), columns:columns};
  for (i = 0; i < colCount; i++) {
    column = columns[i];
    column.savedRenderer = column.renderer;
    if (column.summaryType || column.summaryRenderer) {
      column.renderer = this.createRenderer(column, summaryRecord);
    } else {
      column.renderer = Ext.emptyFn;
    }
  }
  view.rowValues = values;
  view.self.prototype.rowTpl.applyOut(values, out, parent);
  view.rowValues = savedRowValues;
  for (i = 0; i < colCount; i++) {
    column = columns[i];
    column.renderer = column.savedRenderer;
    column.savedRenderer = null;
  }
}, getSummary:function(store, type, field, group) {
  var isGrouped = !!group, item = isGrouped ? group : store;
  if (type) {
    if (Ext.isFunction(type)) {
      if (isGrouped) {
        return item.aggregate(field, type);
      } else {
        return item.aggregate(type, null, false, [field]);
      }
    }
    var tsm = function(items, values) {
      var sum = 0, count = 0;
      for (var i = 0; i < values.length; ++i) {
        if (Ext.isNumber(values[i])) {
          sum += values[i];
          count += 1;
        }
      }
      return sum / count;
    };
    switch(type) {
      case 'count':
        return item.count();
      case 'min':
        return item.min(field);
      case 'max':
        return item.max(field);
      case 'sum':
        return item.sum(field);
      case 'average':
        return item.average(field);
      case 'tsm':
        return item.aggregate(tsm, null, false, [field]);
      default:
        return '';
    }
  }
}, getRawData:function() {
  var data = this.readerRawData;
  if (data) {
    return data;
  }
  return this.view.getStore().getProxy().getReader().rawData;
}, generateSummaryData:function(groupField) {
  var me = this, summaryRows = me.summaryRows, convertedSummaryRow = {}, remoteData = {}, storeReader, reader, rawData, i, len, summaryRows, rows, row;
  if (!summaryRows) {
    rawData = me.getRawData();
    if (!rawData) {
      return;
    }
    storeReader = me.view.store.getProxy().getReader();
    reader = Ext.create('reader.' + storeReader.type, storeReader.getConfig());
    reader.setRootProperty(me.remoteRoot);
    summaryRows = reader.getRoot(rawData);
    if (summaryRows) {
      rows = [];
      if (!Ext.isArray(summaryRows)) {
        summaryRows = [summaryRows];
      }
      len = summaryRows.length;
      for (i = 0; i < len; ++i) {
        row = reader.extractRecordData(summaryRows[i], me.readDataOptions);
        rows.push(row);
      }
      me.summaryRows = summaryRows = rows;
    }
    reader.destroy();
    me.readerRawData = null;
  }
  if (summaryRows) {
    for (i = 0, len = summaryRows.length; i < len; i++) {
      convertedSummaryRow = summaryRows[i];
      if (groupField) {
        remoteData[convertedSummaryRow[groupField]] = convertedSummaryRow;
      }
    }
  }
  return groupField ? remoteData : convertedSummaryRow;
}, setSummaryData:function(record, colId, summaryValue, groupName) {
  var summaryData = this.summaryData;
  if (groupName) {
    if (!summaryData[groupName]) {
      summaryData[groupName] = {};
    }
    summaryData[groupName][colId] = summaryValue;
  } else {
    summaryData[colId] = summaryValue;
  }
}, destroy:function() {
  Ext.destroy(this.readerListeners);
  this.readerRawData = this.summaryRows = null;
  this.callParent();
}});
Ext.define('webtsm.components.grid.feature.Summary', {extend:'webtsm.components.grid.feature.AbstractSummary', alias:'feature.webtsmsummary', dock:undefined, summaryItemCls:Ext.baseCSSPrefix + 'grid-row-summary-item', dockedSummaryCls:Ext.baseCSSPrefix + 'docked-summary', summaryRowCls:Ext.baseCSSPrefix + 'grid-row-summary ' + Ext.baseCSSPrefix + 'grid-row-total', summaryRowSelector:'.' + Ext.baseCSSPrefix + 'grid-row-summary.' + Ext.baseCSSPrefix + 'grid-row-total', panelBodyCls:Ext.baseCSSPrefix + 
'summary-', hasFeatureEvent:false, fullSummaryTpl:{fn:function(out, values, parent) {
  var me = this.summaryFeature, record = me.summaryRecord, view = values.view, bufferedRenderer = view.bufferedRenderer;
  this.nextTpl.applyOut(values, out, parent);
  if (!me.disabled && me.showSummaryRow && !view.addingRows && view.store.isLast(values.record)) {
    if (bufferedRenderer && !me.dock) {
      bufferedRenderer.variableRowHeight = true;
    }
    me.outputSummaryRecord(record && record.isModel ? record : me.createSummaryRecord(view), values, out, parent);
  }
}, priority:300, beginRowSync:function(rowSync) {
  rowSync.add('fullSummary', this.summaryFeature.summaryRowSelector);
}, syncContent:function(destRow, sourceRow, columnsToUpdate) {
  destRow = Ext.fly(destRow, 'syncDest');
  sourceRow = Ext.fly(sourceRow, 'sycSrc');
  var summaryFeature = this.summaryFeature, selector = summaryFeature.summaryRowSelector, destSummaryRow = destRow.down(selector, true), sourceSummaryRow = sourceRow.down(selector, true);
  if (destSummaryRow && sourceSummaryRow) {
    if (columnsToUpdate) {
      this.summaryFeature.view.updateColumns(destSummaryRow, sourceSummaryRow, columnsToUpdate);
    } else {
      Ext.fly(destSummaryRow).syncContent(sourceSummaryRow);
    }
  }
}}, init:function(grid) {
  var me = this, view = me.view, dock = me.dock;
  me.callParent([grid]);
  if (dock) {
    grid.addBodyCls(me.panelBodyCls + dock);
    grid.headerCt.on({add:me.onStoreUpdate, afterlayout:me.onStoreUpdate, remove:me.onStoreUpdate, scope:me});
    grid.on({beforerender:function() {
      var tableCls = [me.summaryTableCls];
      if (view.columnLines) {
        tableCls[tableCls.length] = view.ownerCt.colLinesCls;
      }
      me.summaryBar = grid.addDocked({childEls:['innerCt', 'item'], renderTpl:['\x3cdiv id\x3d"{id}-innerCt" data-ref\x3d"innerCt" role\x3d"presentation"\x3e', '\x3ctable id\x3d"{id}-item" data-ref\x3d"item" cellPadding\x3d"0" cellSpacing\x3d"0" class\x3d"' + tableCls.join(' ') + '"\x3e', '\x3ctr class\x3d"' + me.summaryRowCls + '"\x3e\x3c/tr\x3e', '\x3c/table\x3e', '\x3c/div\x3e'], scrollable:{x:false, y:false}, hidden:!me.showSummaryRow, itemId:'summaryBar', cls:[me.dockedSummaryCls, me.dockedSummaryCls + 
      '-' + dock], xtype:'component', dock:dock, weight:10000000})[0];
    }, afterrender:function() {
      grid.getView().getScrollable().addPartner(me.summaryBar.getScrollable(), 'x');
      me.onStoreUpdate();
      me.columnSizer = me.summaryBar.el;
    }, single:true});
  } else {
    if (grid.bufferedRenderer) {
      me.wrapsItem = true;
      view.addRowTpl(me.fullSummaryTpl).summaryFeature = me;
      view.on('refresh', me.onViewRefresh, me);
    } else {
      me.wrapsItem = false;
      me.view.addFooterFn(me.renderSummaryRow);
    }
  }
  grid.headerCt.on({afterlayout:me.afterHeaderCtLayout, scope:me});
  grid.ownerGrid.on({beforereconfigure:me.onBeforeReconfigure, columnmove:me.onStoreUpdate, scope:me});
  me.bindStore(grid, grid.getStore());
}, onBeforeReconfigure:function(grid, store) {
  this.summaryRecord = null;
  if (store) {
    this.bindStore(grid, store);
  }
}, bindStore:function(grid, store) {
  var me = this;
  Ext.destroy(me.storeListeners);
  me.storeListeners = store.on({scope:me, destroyable:true, update:me.onStoreUpdate, datachanged:me.onStoreUpdate});
  me.callParent([grid, store]);
}, renderSummaryRow:function(values, out, parent) {
  var view = values.view, me = view.findFeature('webtsmsummary'), record;
  if (!me.disabled && me.showSummaryRow && !view.addingRows && !view.updatingRows) {
    record = me.summaryRecord;
    out.push('\x3ctable cellpadding\x3d"0" cellspacing\x3d"0" class\x3d"' + me.summaryItemCls + '" style\x3d"table-layout: fixed; width: 100%;"\x3e');
    me.outputSummaryRecord(record && record.isModel ? record : me.createSummaryRecord(view), values, out, parent);
    out.push('\x3c/table\x3e');
  }
}, toggleSummaryRow:function(visible, fromLockingPartner) {
  var me = this, bar = me.summaryBar;
  me.callParent([visible, fromLockingPartner]);
  if (bar) {
    bar.setVisible(me.showSummaryRow);
    me.onViewScroll();
  }
}, getSummaryBar:function() {
  return this.summaryBar;
}, getSummaryRowPlaceholder:function(view) {
  var placeholderCls = this.summaryItemCls, nodeContainer, row;
  nodeContainer = Ext.fly(view.getNodeContainer());
  if (!nodeContainer) {
    return null;
  }
  row = nodeContainer.down('.' + placeholderCls, true);
  if (!row) {
    row = nodeContainer.createChild({tag:'table', cellpadding:0, cellspacing:0, cls:placeholderCls, style:'table-layout: fixed; width: 100%', children:[{tag:'tbody'}]}, false, true);
  }
  return row;
}, vetoEvent:function(record, row, rowIndex, e) {
  return !e.getTarget(this.summaryRowSelector);
}, onViewScroll:function() {
  this.summaryBar.setScrollX(this.view.getScrollX());
}, onViewRefresh:function(view) {
  var me = this, record, row;
  if (!me.disabled && me.showSummaryRow && !view.all.getCount()) {
    record = me.createSummaryRecord(view);
    row = me.getSummaryRowPlaceholder(view);
    row.tBodies[0].appendChild(view.createRowElement(record, -1).querySelector(me.summaryRowSelector));
  }
}, createSummaryRecord:function(view) {
  var me = this, columns = view.headerCt.getGridColumns(), remoteRoot = me.remoteRoot, summaryRecord = me.summaryRecord || (me.summaryRecord = new Ext.data.Model({id:view.id + '-summary-record'})), colCount = columns.length, i, column, dataIndex, summaryValue;
  summaryRecord.beginEdit();
  if (remoteRoot) {
    summaryValue = me.generateSummaryData();
    if (summaryValue) {
      summaryRecord.set(summaryValue);
    }
  } else {
    for (i = 0; i < colCount; i++) {
      column = columns[i];
      dataIndex = column.dataIndex || column.getItemId();
      summaryValue = me.getSummary(view.store, column.summaryType, dataIndex);
      summaryRecord.set(dataIndex, summaryValue);
      me.setSummaryData(summaryRecord, column.getItemId(), summaryValue);
    }
  }
  summaryRecord.endEdit(true);
  summaryRecord.commit(true);
  summaryRecord.isSummary = true;
  return summaryRecord;
}, onStoreUpdate:function() {
  var me = this, view = me.view, selector = me.summaryRowSelector, dock = me.dock, record, newRowDom, oldRowDom, p;
  if (!view.rendered) {
    return;
  }
  record = me.createSummaryRecord(view);
  newRowDom = Ext.fly(view.createRowElement(record, -1)).down(selector, true);
  if (!newRowDom) {
    return;
  }
  if (dock) {
    p = me.summaryBar.item.dom.firstChild;
    oldRowDom = p.firstChild;
    p.insertBefore(newRowDom, oldRowDom);
    p.removeChild(oldRowDom);
  } else {
    oldRowDom = view.el.down(selector, true);
    p = oldRowDom && oldRowDom.parentNode;
    if (p) {
      p.removeChild(oldRowDom);
    }
    p = view.getRow(view.all.last());
    if (p) {
      p = p.parentElement;
    } else {
      p = me.getSummaryRowPlaceholder(view);
      p = p && p.tBodies && p.tBodies[0];
    }
    if (p) {
      p.appendChild(newRowDom);
    }
  }
}, afterHeaderCtLayout:function(headerCt) {
  var me = this, view = me.view, columns = view.getVisibleColumnManager().getColumns(), column, len = columns.length, i, summaryEl, el, width, innerCt;
  if (me.showSummaryRow && view.refreshCounter) {
    if (me.dock) {
      summaryEl = me.summaryBar.el;
      width = headerCt.getTableWidth();
      innerCt = me.summaryBar.innerCt;
      me.summaryBar.item.setWidth(width);
      if (headerCt.tooNarrow) {
        width += Ext.getScrollbarSize().width;
      }
      innerCt.setWidth(width);
    } else {
      summaryEl = Ext.fly(Ext.fly(view.getNodeContainer()).down('.' + me.summaryItemCls, true));
    }
    if (summaryEl) {
      for (i = 0; i < len; i++) {
        column = columns[i];
        el = summaryEl.down(view.getCellSelector(column), true);
        if (el) {
          Ext.fly(el).setWidth(column.width || (column.lastBox ? column.lastBox.width : 100));
        }
      }
    }
  }
}, destroy:function() {
  var me = this;
  me.summaryRecord = me.storeListeners = Ext.destroy(me.storeListeners);
  me.callParent();
}});
Ext.define('webtsm.view.manager.About', {extend:'Ext.panel.Panel', alias:'widget.webtsmAbout', mixins:['webtsm.mixins.Component'], header:false, layout:'fit', moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.applyTitleIconCls('CONFIG_TSM_CONFIG', 'fa-plug');
  var remoteFieldDefinitions = [{fieldLabel:'Hakom', urlPath:'/'}, {fieldLabel:'Config', urlPath:'/configuration', hideOnError:true}, {fieldLabel:'Repositories', urlPath:'/configuration/repositories'}, {fieldLabel:'Extensions', urlPath:'/extensions'}];
  var jsonTemplate = this.getCmpTemplate();
  var currentUserField = Ext.create({xtype:'textarea', anchor:'90%', fieldLabel:'Current User', grow:true, updateJson:function(json) {
    this.setValue(JSON.stringify(json, undefined, 4));
  }});
  var currentUserRolesField = Ext.create({xtype:'textarea', anchor:'90%', fieldLabel:'Roles', grow:true, updateJson:function(json) {
    this.setValue(JSON.stringify(json, undefined, 4));
  }});
  var authorizatiuonRules = Ext.create({xtype:'textarea', anchor:'90%', fieldLabel:'Authorization Rules', grow:true, updateJson:function(json) {
    this.setValue(JSON.stringify(json, undefined, 4));
  }});
  webtsm.Api.auth.getCurrentUser(this.moduleId).then(function(userObj) {
    var $jscomp$destructuring$var10 = userObj || {};
    var ID = $jscomp$destructuring$var10.ID;
    currentUserField.updateJson(userObj);
    webtsm.Api.auth.getUserRoles($jscomp$this.moduleId, ID).then(function(rolesData) {
      currentUserRolesField.updateJson(rolesData);
    });
  });
  webtsm.Api.auth.getAuthorizationRules(this.moduleId).then(function(json) {
    authorizatiuonRules.updateJson(json);
  });
  this.items = [{xtype:'fieldset', layout:{type:'vbox', align:'stretch'}, defaults:{xtype:'fieldset', layout:'anchor', collapsible:true}, scrollable:true, items:[{title:webtsm.Support.TR('CONFIG_API_CONFIG'), items:[this.getConfigAsTextareaForModuleId()]}, {title:webtsm.Support.TR('CONFIG_TSM_CONFIG'), items:remoteFieldDefinitions.map(function(baseCfg) {
    baseCfg.fieldLabel = webtsm.Support.TR('TSM_FIELD_' + baseCfg.fieldLabel);
    return Ext.create(Ext.apply({}, baseCfg, jsonTemplate));
  }).map(function(f) {
    f.loadRemoteData();
    return f;
  })}, {title:webtsm.Support.TR('USER_CONFIG'), items:[currentUserField, currentUserRolesField, authorizatiuonRules]}]}];
  this.callParent(arguments);
}, getCmpTemplate:function() {
  var moduleId = this.moduleId;
  return {anchor:'90%', readOnly:true, moduleId:moduleId, loadRemoteData:function() {
    var $jscomp$this = this;
    webtsm.Api.getRequestData(this.moduleId, this.urlPath).then(function(d) {
      $jscomp$this.updateJson(d);
    })["catch"](function(d) {
      if ($jscomp$this.hideOnError) {
        $jscomp$this.setVisible(false);
      }
      $jscomp$this.updateJson(d);
    });
  }, xtype:'textarea', updateJson:function(json) {
    this.setValue(JSON.stringify(json, undefined, 4));
  }};
}, getConfigAsTextareaForModuleId:function() {
  var $jscomp$this = this;
  var settingValue = BpcCommon.Api.getSetting('webtsm', 'module_apis') || {};
  var cmp = undefined;
  if (Ext.isObject(settingValue)) {
    var configuredApiId = BpcCommon.Api.getSetting(this.moduleId, 'api_id');
    Object.keys(settingValue).map(function(api_id) {
      if (api_id === configuredApiId) {
        var tmp = $jscomp$this.getCmpTemplate();
        tmp.fieldLabel = webtsm.Support.TR('CONFIG_API_CONFIG');
        tmp.grow = true;
        var textarea = Ext.create(tmp);
        textarea.updateJson(settingValue[api_id]);
        cmp = textarea;
      }
    });
  }
  return cmp;
}});
Ext.define('webtsm.view.cachemanager.CacheManagerMain', {extend:'Ext.container.Container', alias:'widget.webtsmCacheMain', layout:'fit', moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.tabpanel = Ext.create({xtype:'tabpanel', items:['webtsmEventLog', 'webtsmAbout'].map(function(xtype) {
    return {xtype:xtype, moduleId:$jscomp$this.moduleId};
  })});
  this.items = [this.tabpanel];
  this.callParent(arguments);
  this.tabpanel.setActiveTab(0);
}});
Ext.define('webtsm.components.moduleConfigurationComponents.Indices', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.webtsmConfigIndicesMain', mixins:['webtsm.mixins.Component'], initComponent:function() {
  this.callParent(arguments);
  this.componentsGrid.setVisible(false);
  this.setTitle(this.TR('INDICES'));
  this.setIconCls(this.faIcon('fa-database'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, getFilteredCoreIndicesGrid:function() {
  var $jscomp$this = this;
  var g = webtsm.util.BpcSupport.getIndicesGrid();
  var bottomToolbars = g.getDockedItems().filter(function(cmp) {
    return cmp.dock === 'bottom';
  });
  var moduleName = this.getModuleName();
  if (bottomToolbars.length) {
    var cacheIndex = moduleName + '-cache-';
    var toolbar = bottomToolbars[0];
    var pos = toolbar.items.length ? toolbar.items.length - 1 : 0;
    toolbar.insert(pos, {xtype:'button', ui:'primary', iconCls:webtsm.Support.icon('fa-trash'), text:webtsm.Support.TR('DELETE_INVALID_CACHE_INDICES'), handler:function(b) {
      var indexNamesToDelete = [];
      g.store.each(function(r) {
        if ((r.get('index') || '').startsWith(cacheIndex) && r.get('aliases').length === 0) {
          indexNamesToDelete.push(r.get('index'));
        }
      });
      $jscomp$this.api.deleteIndices(indexNamesToDelete).then(function() {
        g.store.load();
      });
    }});
    toolbar.insert(0, {xtype:'button', ui:'secondary', iconCls:webtsm.Support.icon('fa-cogs'), text:webtsm.Support.TR('ES_CLUSTER_SETTINGS'), handler:function(b) {
      webtsm.Api.sendRequest({method:'get', url:webtsm.Api.tsmBasePath + 'storage/settings'}).then(function(r) {
        return webtsm.Support.getResponseObject(r);
      }).then(function(obj) {
        var data = [];
        Object.keys(obj || {}).map(function(group) {
          var groupData = obj[group] || {};
          Object.keys(groupData).map(function(settingName) {
            var item = {key:settingName, groupName:group, value:groupData[settingName]};
            data.push(item);
          });
        });
        webtsm.util.Window.openWindow(webtsm.Support.TR('ES_CLUSTER_SETTINGS'), webtsm.Support.icon('fa-database'), undefined, undefined, 'panel', {layout:'fit', padding:'10 10 10 10', itemId:'esSettingsWrapper', items:[{xtype:'grid', store:Ext.create('Ext.data.Store', {data:data}), columns:(data.length ? Object.keys(data[0]).filter(function(dataIndex) {
          return dataIndex !== 'id';
        }).map(function(dataIndex) {
          return {dataIndex:dataIndex, text:webtsm.Support.TR('ES_SETTING_' + dataIndex), flex:1};
        }) : []).concat([{xtype:'actioncolumn', items:[{iconCls:webtsm.Support.icon('fa-cog'), tooltip:webtsm.Support.TR('EDIT'), isActionDisabled:function(v, rI, cI, item, record) {
          return record.get('key') !== 'search.max_buckets';
        }, handler:function(grid, rowIndex, colIndex) {
        }}]}])}], bbar:[{xtype:'tbfill'}, {text:webtsm.Support.TR('CLOSE'), ui:'primary', handler:function(b) {
          b.up('window').close();
        }}]});
      });
    }});
  }
  g.store.on('load', function(s, records, successful) {
    if (successful) {
      var moduleLog = moduleName + '-module-';
      var cacheIndex$9 = moduleName + '-cache-';
      s.filterBy(function(r) {
        return (r.get('index') || '').startsWith(moduleLog) || (r.get('index') || '').startsWith(cacheIndex$9);
      });
    }
  });
  return g;
}, api:{getDeleteIndexRequestConfig:function(name) {
  var storage = webtsm.util.BpcSupport.getFastStorageName();
  var url = 'cxf/bpc-core/' + storage + '/indices/operations/' + name;
  return {method:'delete', url:url};
}, getRequestFromConfig:function(cfg) {
  return webtsm.Api.sendRequest(cfg);
}, deleteIndices:function(indexNames) {
  var $jscomp$this = this;
  indexNames = indexNames === void 0 ? [] : indexNames;
  var requestConfigs = indexNames.map(function(name) {
    return $jscomp$this.api.getDeleteIndexRequestConfig(name);
  });
  var deleteRequests = requestConfigs.map(function(cfg) {
    return $jscomp$this.api.getRequestFromConfig(cfg);
  });
  return Promise.all(deleteRequests);
}}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  this.settingsWrapper.add(this.getFilteredCoreIndicesGrid());
}});
Ext.define('webtsm.components.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.webtsmConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-database'));
  this.setTitle(webtsm.Support.getTranslation('CACHE_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onCmpReady:function() {
  var $jscomp$this = this;
  if (this.ownerCt && this.ownerCt.moduleId) {
    var mi = BpcCommon.Api.getModuleInstances(this.ownerCt.moduleId);
    if (mi) {
      var instancesArray = mi.getData().getRange();
      var records = instancesArray.filter(function(model) {
        return !webtsm.Api.module.isManager(model.get('moduleId'));
      }).map(function(instanceModel) {
        return $jscomp$this.componentsGrid.store.add({moduleId:instanceModel.get('moduleId'), instanceName:instanceModel.get('instanceName')});
      });
      if (records.length) {
        this.componentsGrid.setSelection(records[0]);
      }
    }
  }
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var webtsmCacheMain = Ext.create({xtype:'webtsmCacheMain', moduleId:record.get('moduleId')});
  this.settingsWrapper.add(webtsmCacheMain);
}});
Ext.define('webtsm.components.moduleConfigurationComponents.Translations', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.webtsmTranslations', initComponent:function() {
  this.callParent(arguments);
  this.componentsGrid.setVisible(false);
  this.setTitle(webtsm.Support.TR('TRANSLATIONS'));
  this.setIconCls(webtsm.Support.icon('fa-globe'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  var $jscomp$this = this;
  this.settingsWrapper.removeAll();
  var store = Ext.create('Ext.data.Store', {data:[]});
  this.trGrid = this.settingsWrapper.add({xtype:'grid', store:store, selModel:'cellmodel', plugins:{cellediting:{clicksToEdit:1}}, tbar:[{text:'Show Missing Translations', handler:function() {
    var map = webtsm.Util.getMissingTranslations() || {};
    var data = Object.keys(map).map(function(key) {
      return {key:key, de:'', en:''};
    });
    $jscomp$this.trGrid.store.removeAll();
    $jscomp$this.trGrid.store.add(data);
  }}, {xtype:'tbfill'}, {text:'Export', iconCls:webtsm.Support.icon('fa-file-export'), handler:function() {
    var exportData = [];
    $jscomp$this.trGrid.store.each(function(r) {
      var $jscomp$destructuring$var11 = r.getData();
      var key = $jscomp$destructuring$var11.key;
      var de = $jscomp$destructuring$var11.de;
      var en = $jscomp$destructuring$var11.en;
      exportData.push({key:key, de:de, en:en});
    });
    var items = [];
    var de_data = exportData.map(function(item) {
      var $jscomp$destructuring$var12 = item;
      var key = $jscomp$destructuring$var12.key;
      var de = $jscomp$destructuring$var12.de;
      var value = de || '';
      return '"' + key + '" : "' + value + '"';
    });
    var en_data = exportData.map(function(item) {
      var $jscomp$destructuring$var13 = item;
      var key = $jscomp$destructuring$var13.key;
      var en = $jscomp$destructuring$var13.en;
      var value = en || '';
      return '"' + key + '" : "' + value + '"';
    });
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:de_data.join(',\n')}]});
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:en_data.join(',\n')}]});
    webtsm.util.Window.openWindow('MISSING_TRANSLATIONS', 'fa-info', document.body.clientWidth * 0.8, document.body.clientHeight * 0.7, 'tabpanel', {items:items});
  }}], columns:['key', 'de', 'en'].map(function(dataIndex) {
    var c = {dataIndex:dataIndex, text:dataIndex, flex:1};
    if (dataIndex !== 'key') {
      c.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
    }
    return c;
  })});
}});
Ext.define('webtsm.view.cachemanager.eventLog', {extend:'Ext.grid.Panel', alias:'widget.webtsmEventLog', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], viewConfig:{enableTextSelection:true}, apiId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = this.TR('EVENTS');
  this.iconCls = this.faIcon('fa-calendar');
  var apiId = BpcCommon.Api.getSetting(this.moduleId, 'api_id');
  this.apiId = apiId;
  this.listeners = {beforedestroy:function() {
    $jscomp$this.moduleInstanceCleanUp();
  }};
  var fields = [{xtype:'textfield', fieldLabel:this.TR('API_CONFIG_ID'), readOnly:true, value:apiId}, {xtype:'textfield', fieldLabel:this.TR('API_CONFIG_CUSTOM_CLIENT'), readOnly:true, value:webtsm.Api.helper.getKeyFromApiConfig(apiId, 'useCustomClient')}, {xtype:'textfield', fieldLabel:this.TR('API_CONFIG_CACHE_REFRESH_MIN'), readOnly:true, value:webtsm.Api.helper.getKeyFromApiConfig(apiId, 'cache_refresh')}, {xtype:'textfield', fieldLabel:this.TR('API_CONFIG_CACHE_REFRESH_FULL_H'), readOnly:true, 
  value:webtsm.Api.helper.getKeyFromApiConfig(apiId, 'cache_refresh_full')}].map(function(cfg) {
    var $jscomp$destructuring$var14 = cfg;
    var fieldLabel = $jscomp$destructuring$var14.fieldLabel;
    var length = (fieldLabel || '').length;
    if (length > 20) {
      cfg.labelWidth = length * 7;
    }
    return cfg;
  });
  this._addDocked(fields.concat([{xtype:'tbfill'}, {iconCls:this.faIcon('fa-redo'), text:this.TR('RECREATE_CACHE'), tooltip:webtsm.Support.TR('CACHE_START_FULL_REFRESH'), handler:function() {
    $jscomp$this.doCacheRefresh(true);
  }}, {iconCls:this.faIcon('fa-repeat-alt'), text:this.TR('UPDATE_CACHE'), tooltip:this.TR('CACHE_START_REFRESH'), handler:function() {
    $jscomp$this.doCacheRefresh();
  }}, {xtype:'tbfill'}, {iconCls:this.faIcon('fa-sync'), text:this.TR('REFRESH'), tooltip:webtsm.Support.TR('REFRESH_DATA'), handler:function(btn) {
    $jscomp$this.store.load();
  }}]), 'top');
  this.store = Ext.create('Ext.data.BufferedStore', {proxy:{type:'ajax', url:webtsm.Api.tsmBasePath + 'cache', reader:{type:'json', rootProperty:'data', totalProperty:'total'}, extraParams:{instanceId:this.moduleId, apiId:apiId}}, autoLoad:false, listeners:{prefetch:function(store) {
    $jscomp$this.updateCount(store.getTotalCount());
  }}});
  this.columns = [{dataIndex:'apiId', maxWidth:30, width:30, text:'OK?', renderer:function(val, m, record) {
    var recordObj = record ? record.getData() : {};
    var html = 'no object';
    if (recordObj) {
      var objectArray2Table = function(objectArray) {
        if (objectArray) {
          var table = '\x3ctable\x3e';
          Ext.iterate(objectArray, function(key, value) {
            var tableLeft = key, tableRight = value;
            if (tableRight && (Ext.isArray(tableRight) || Ext.isObject(tableRight))) {
              var subTable = objectArray2Table(tableRight);
              if (subTable) {
                tableRight = subTable;
              }
            }
            table += '\x3ctr\x3e\x3ctd\x3e\x3cb\x3e' + tableLeft + '\x3c/b\x3e\x3c/td\x3e\x3ctd\x3e' + tableRight + '\x3c/td\x3e\x3c/tr\x3e';
          });
          table += '\x3c/table\x3e';
          return table;
        }
        return null;
      };
      html = objectArray2Table(recordObj);
    }
    m.tdAttr = 'data-qtip\x3d"' + Ext.String.htmlEncode(html) + '"';
    var $jscomp$destructuring$var15 = recordObj;
    var endTime = $jscomp$destructuring$var15.endTime;
    var jobs = $jscomp$destructuring$var15.jobs;
    var event = $jscomp$destructuring$var15.event;
    var status = $jscomp$destructuring$var15.status;
    status = status && status === 'no-job-scheduled' ? 'disabled' : 'ok';
    if (status !== 'disabled') {
      if (jobs && 'msg' in jobs && jobs.msg && jobs.msg === 'ok') {
      } else if (jobs && 'msg' in jobs && jobs.msg && jobs.msg === 'not ok') {
        status = 'error';
      } else {
        if (event && event !== 'start') {
          status = 'warn';
        }
        if (event === 'end') {
          return '';
        }
      }
    }
    var map = {ok:{iconCls:'fa-check', color:'green'}, warn:{iconCls:'fa-exclamation', color:'orange'}, error:{iconCls:'fa-exclamation-triangle', color:'red'}, disabled:{iconCls:'fa-ban', color:'grey'}};
    if (status === 'ok') {
    }
    var $jscomp$destructuring$var16 = map[status] || {};
    var iconCls = $jscomp$destructuring$var16.iconCls;
    var color = $jscomp$destructuring$var16.color;
    return webtsm.Support.getSpanForIconCls(webtsm.Support.getBpcIconCls(iconCls), color, 12);
  }}, {xtype:'actioncolumn', width:30, text:'ACTIONS', items:[{iconCls:this.faIcon('fa-info-square'), tooltip:this.TR('OPEN_DETAILS'), isActionDisabled:function(v, rI, cI, item, r) {
    var $jscomp$destructuring$var17 = r.get('jobs') || {};
    var tsmStatusCode = $jscomp$destructuring$var17.tsmStatusCode;
    return !tsmStatusCode;
  }, handler:function(v, rI, cI, item, e, r) {
    var jobs = r.get('jobs') || {};
    var $jscomp$destructuring$var18 = jobs;
    var msg = $jscomp$destructuring$var18.msg;
    var tsmResponseBody = $jscomp$destructuring$var18.tsmResponseBody;
    var deleted = $jscomp$destructuring$var18.deleted;
    var tsmStatusCode = $jscomp$destructuring$var18.tsmStatusCode;
    var success = $jscomp$destructuring$var18.success;
    var modified = $jscomp$destructuring$var18.modified;
    var tsmRequestUrl = $jscomp$destructuring$var18.tsmRequestUrl;
    var config = {title:$jscomp$this.TR('CACHE_EVENT_RECORD'), layout:'fit', items:[{xtype:'panel', layout:{type:'vbox', align:'stretch'}, tbar:[{xtype:'textfield', fieldLabel:$jscomp$this.TR('EVENT_MSG'), value:msg}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('STATUS_CODE'), value:tsmStatusCode}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('OVERALL_SUCCESS'), value:success}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('CALL_MODIFIED_SUCCESS'), value:modified}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('CALL_DELETED_SUCCESS'), 
    value:deleted}], items:[{xtype:'textfield', fieldLabel:$jscomp$this.TR('URL'), value:tsmRequestUrl}, {xtype:'textarea', fieldLabel:$jscomp$this.TR('EVENT_RESPONSE_BODY'), value:tsmResponseBody}]}]};
    Ext.create('Ext.window.Window', Ext.apply(config, $jscomp$this.getHeightWidthDynamic())).show();
  }}]}, {dataIndex:'jobs', text:'TSM StatusCode', width:70, renderer:function(val) {
    return val && val.tsmStatusCode ? val.tsmStatusCode : '';
  }}, {dataIndex:'jobs', flex:1, text:'TYPE', renderer:function(val, m, record) {
    var jobs = val;
    var event = record.get('event');
    if (!jobs) {
      if (event && event === 'start') {
        val = '';
      } else if (event !== 'start') {
        val = '';
      } else {
        val = '??';
      }
    } else {
      if ('msg' in jobs && jobs.msg && jobs.msg === 'ok') {
        val = '';
        if ('modified' in jobs && jobs.modified) {
          val += 'changed';
        } else {
          val = 'full';
        }
        if ('deleted' in jobs && jobs.deleted) {
          val += ' + deleted';
        }
      } else {
        val = 'Achtung. Prüfen.';
      }
    }
    var mode = record.get('mode') || '';
    var isValidMode = ['automatically', 'manual'].indexOf(mode) !== -1;
    return val.length === 0 && isValidMode ? mode : val;
  }}, {dataIndex:'desc', flex:1, text:'DESC'}, {dataIndex:'user', flex:1, text:'USER'}, {dataIndex:'jobs', flex:1, text:'JOBS', hidden:true, renderer:function(val) {
    if (val) {
      return JSON.stringify(val, undefined, 4);
    }
    return val;
  }}, {dataIndex:'apiId', flex:1, text:'APIID', hidden:true}, {dataIndex:'startTime', width:170, renderer:function(v) {
    return v ? Ext.Date.format(Ext.Date.parse(v, 'time'), 'd.m. H:i:s.u') : '-1';
  }, text:'TIME'}].map(function(col) {
    col.style = webtsm.Support.getDefaultGridStyle();
    return col;
  });
  this.callParent(arguments);
  this.registerRefreshEvents();
  this.doTableRefresh();
}, moduleInstanceCleanUp:function() {
  try {
    if (this.eventReferenceStore.length) {
      this.eventReferenceStore.map(function(ref) {
        try {
          ref.destroy();
        } catch (e) {
          console.error('ERROR DESTROYING EVENT REF');
        }
      });
    }
  } catch (e) {
    console.error('ERROR REMOVING EVENTS');
  }
}, eventReferenceStore:[], registerRefreshEvents:function() {
  var eventRef = Ext.on({destroyable:true, cacheEvent:this.handleBpcEvent.bind(this)});
  this.eventReferenceStore = [eventRef];
}, handleBpcEvent:function(eventData) {
  var $jscomp$destructuring$var19 = eventData || {};
  var topic = $jscomp$destructuring$var19.topic;
  var properties = $jscomp$destructuring$var19.properties;
  var $jscomp$destructuring$var20 = properties || {};
  var cacheEventData = $jscomp$destructuring$var20.cacheEventData;
  topic = topic || '';
  var $jscomp$destructuring$var21 = cacheEventData || {};
  var apiId = $jscomp$destructuring$var21.apiId;
  apiId = apiId || '';
  var topicParts = topic.split('/');
  if (topicParts.length === 5 && topicParts[3] === 'webtsm' && apiId === this.apiId) {
    this.doTableRefresh();
  }
}, doTableRefresh:function() {
  try {
    this.store.load();
  } catch (e) {
    Ext.toast('ERROR LOADING STORE');
  }
}, getHeightWidthDynamic:function(height, width) {
  return {height:this.getHeightDynamic(height), width:this.getWidthDynamic(width)};
}, getHeightDynamic:function(height) {
  height = height === void 0 ? 0.5 : height;
  return document.body.clientHeight * height;
}, getWidthDynamic:function(width) {
  width = width === void 0 ? 0.5 : width;
  return document.body.clientWidth * width;
}, doCacheRefresh:function(full) {
  var $jscomp$this = this;
  full = full === void 0 ? false : full;
  webtsm.Support.confirmDialog(webtsm.Support.getTranslation('Q_CACHE_REFRESH'), webtsm.Support.getTranslation('WARN_CACHE_REFRESH') + ' ' + this.moduleId).then(function(yes) {
    if (yes) {
      return yes ? webtsm.Api.cacheRefresh($jscomp$this.moduleId, full) : Promise.reject('User canceled');
    }
  }).then(function(value) {
    webtsm.Support.notify('Cache refresh triggered successfully');
  });
}, updateCount:function(count) {
  this.setTitle('Events (' + count + ')');
}});
Ext.define('webtsm.view.components.panel.AttributeType', {extend:'Ext.panel.Panel', alias:'widget.webtsmAttributeTypeContainer', layout:{type:'vbox', align:'stretch'}, mixins:['webtsm.mixins.Component'], _grid:undefined, metaPanel:undefined, padding:'5 5 5 5', initComponent:function() {
  var $jscomp$this = this;
  this.title = this.TR('ATTRIBUTE_TYPES');
  this.createBtn = Ext.create({xtype:'button', text:this.TR('CREATE_ATTRIBUTE'), ui:'primary', iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.plus), disabled:true, handler:function(b) {
    b.setDisabled();
    webtsm.Api.attributes.create($jscomp$this.moduleId, {ID:-1, Name:$jscomp$this.attributeNameField.getValue(), Type:$jscomp$this.attributeTypeField.getValue()}).then(function() {
      $jscomp$this.doLog($jscomp$this.TR('ATTRIBUTE_CREATED'), $jscomp$this.TR('ATTRIBUTE_SUCCESSFULLY_CREATED'));
      $jscomp$this.reset();
      $jscomp$this.metaPanel.refreshData();
    }, function(response) {
      $jscomp$this.doLog($jscomp$this.TR('ERROR'), $jscomp$this.TR('ATTRIBUTE_CREATE_ERROR'));
      b.setDisabled(false);
    });
  }, reset:function() {
    this.setDisabled(true);
  }});
  this.closeBtn = Ext.create({xtype:'button', text:this.TR('CLOSE'), ui:'secondary', iconCls:this.faIcon(webtsm.Support.keys.icons.close), handler:function(b) {
    var w = $jscomp$this.up('window');
    if (w) {
      w.close();
    }
  }});
  this.warningBtn = Ext.create({xtype:'button', iconCls:this.faIcon('fa-exclamation-triangle'), scope:this, ui:'secondary', hidden:true, reset:function() {
    this.setText('');
    this.setTooltip('');
    this.setVisible(false);
  }});
  this.attributeNameField = Ext.create({xtype:'textfield', moduleId:this.moduleId, listeners:{change:this.enableSend.bind(this)}, fieldLabel:this.TR('ATTRIBUTE_NAME'), emptyText:this.TR('WEBTSM_ATTRIBUTE_DEFINE_NAME')});
  this.attributeTypeField = Ext.create({xtype:'webtsmAttributeTypeCombo', forceSelection:true, moduleId:this.moduleId, editable:false, emptyText:this.TR('WEBTSM_ATTRIBUTE_SELECT_TYPE'), fieldLabel:this.TR('ATTRIBUTE_TYPE'), listeners:{change:this.enableSend.bind(this)}});
  this.items = [this.attributeNameField, this.attributeTypeField];
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', padding:'5 5 5 5', items:[{xtype:'tbfill'}, this.warningBtn, this.closeBtn, this.createBtn]}];
  this.callParent(arguments);
}, enableSend:function() {
  var n = this.attributeNameField.getValue();
  var t = this.attributeTypeField.getValue();
  var nameExists = false;
  this._grid.store.each(function(r) {
    if (nameExists === false) {
      nameExists = n === r.get('Name');
    }
  });
  if (nameExists) {
    this.warningBtn.setText(webtsm.Support.getTranslation('NAME_EXISTS_ALREADY'));
    this.warningBtn.show();
  } else {
    this.warningBtn.reset();
  }
  this.createBtn.setDisabled(!(n && n.length > 0 && Ext.isDefined(t) && t !== null && nameExists === false));
}, reset:function() {
  this.attributeNameField.reset();
  this.attributeTypeField.reset();
  this.warningBtn.reset();
  this.createBtn.reset();
  this.createBtn.setDisabled(true);
}});
Ext.define('webtsm.view.components.panel.Unit', {extend:'Ext.panel.Panel', alias:'widget.webtsmUnitPanel', layout:{type:'vbox', align:'stretch'}, requires:['webtsm.ConfigKeys'], title:'Unit', moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.items = webtsm.Api.models.units.map(function(i) {
    i.xtype = i.type + 'field';
    delete i.type;
    i.fieldLabel = i.key;
    return i;
  });
  this.warningBtn = Ext.create({xtype:'button', iconCls:webtsm.Support.getBpcIconCls('fa-warning'), scope:this, hidden:true});
  this.createBtn = Ext.create({xtype:'button', text:'Create', iconCls:webtsm.Support.getBpcIconCls('fa-plus'), scope:this, handler:function(b) {
    b.setDisabled(true);
    var cfg = webtsm.Api.getBaseRequestCfg($jscomp$this.moduleId, 'POST', true);
    cfg.url += $jscomp$this._path;
    cfg.jsonData = $jscomp$this.getPayload;
    webtsm.Api.sendRequest(cfg).then(function(obj) {
      b.setDisabled(false);
      var json = Ext.decode(obj.responseText, true);
      var error = json && json.responseCode !== 201;
      $jscomp$this.warningBtn.setVisible(error);
      if (error) {
        $jscomp$this.warningBtn.setTooltip(json.responseString);
      } else {
        var fields = $jscomp$this.query('[key]');
        fields.map(function(f) {
          return f.reset();
        });
      }
    }, function(error) {
      b.setDisabled(false);
    });
  }});
  this.bbar = [{xtype:'tbfill'}, this.warningBtn, this.createBtn];
  this.callParent(arguments);
}, getPayload:function() {
  var fields = this.query('[key]');
  var payload = {};
  fields.map(function(f) {
    payload[f.key] = f.getValue();
  });
  payload.ID = -1;
  return payload;
}});
Ext.define('webtsm.components.plugin.hooks.DetailHook', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.webtsmDetailHook', inheritableStatics:{NAME:'WebTSM DetailWindow', HOOK_ID:'webtsm_detail_hook', HOOK_LEVEL:'instance'}, hidden:true, context:undefined, autoInjectPlugins:false, moduleId:undefined, pluginDefaults:{}, initComponent:function() {
  this.setModuleContext();
  this.callParent(arguments);
}, setModuleContext:function() {
  if (!this.context) {
    this.context = {};
  }
  this.context.baseModuleId = 'webtsm';
  this.context.moduleId = this.moduleId;
}, getPluginDefinitions:function(record) {
  var $jscomp$this = this;
  var bpcConfigs = BpcCommon.Api.getPluginComponents(this, this.context) || [];
  return bpcConfigs.map(function(cmpCfg) {
    return $jscomp$this.transformConfig(cmpCfg, {record:record});
  });
}, transformConfig:function(cmpCfg, individualContext) {
  cmpCfg = cmpCfg === void 0 ? {} : cmpCfg;
  individualContext = individualContext === void 0 ? {} : individualContext;
  var pluginConfig = Object.assign({}, cmpCfg);
  pluginConfig.pluginConfiguration = pluginConfig.pluginConfiguration || {};
  pluginConfig.pluginConfiguration.context = pluginConfig.pluginConfiguration.context || {};
  Object.assign(pluginConfig.pluginConfiguration.context, individualContext || {});
  return Object.assign(pluginConfig, this.pluginDefaults);
}});
Ext.define('webtsm.view.viewer.WebTsmViewerMixin', {getSelectedTimeseries:function() {
  var targetCmp = this.requestPanel.selectedGrid ? this.requestPanel.selectedGrid : this.query('#selectedTsGrid')[0];
  return targetCmp.getStoreAsBucket();
}, getRequestObject:function() {
  var p = this.requestPanel.getRequestParams();
  if (p) {
    p.tsSelection = this.getSelectedTimeseries();
  }
  return p ? p : null;
}, getSelectionPeriodAsText:function() {
  var p = this.getRequestObject();
  var period = 'Fehler !?';
  if (p && Ext.isDate(p.start) && Ext.isDate(p.end)) {
    var format = this.getDateFormat();
    period = Ext.Date.format(p.start, format) + ' Uhr - ' + Ext.Date.format(p.end, format) + ' Uhr';
  }
  return period;
}, getQueryFromRequestObject:function(requestObject, obj, compareModuleId) {
  var query = {from:requestObject.start.toISOString(), to:requestObject.end.toISOString(), interval:requestObject.interval, intervalMultiplier:requestObject.intervalMultiplier, aggregation:requestObject.aggregation, unit:requestObject.unit, version:requestObject.version};
  if (query.aggregation === 4269 || !Ext.isDefined(query.aggregation) || query.aggregation === 'Standard' || query.aggregation === '4269' || query.aggregation === null) {
    delete query.aggregation;
  }
  var moduleId = compareModuleId || this.moduleId;
  if (webtsm.Api.versionEnabled(moduleId)) {
    if (Ext.isDefined(obj) && obj !== null && Ext.isObject(obj)) {
      if ('Version' in obj && Ext.isDefined(obj.Version) && obj.Version !== null) {
        query.version = obj.Version;
      }
    }
  } else {
    delete query.version;
  }
  if (query.interval === 4269) {
    query.interval = 2;
    query.intervalMultiplier = 15;
  } else if (query.interval === 0) {
    delete query.interval;
    delete query.intervalMultiplier;
  } else {
    var intervalMultiplier = this.intervalMultiplier;
    if (Ext.isDefined(intervalMultiplier) && intervalMultiplier !== null && intervalMultiplier !== '') {
      query.intervalMultiplier = intervalMultiplier;
    }
  }
  if (query.unit === 'null' || query.unit === null || query.unit === 'Standard') {
    delete query.unit;
  }
  if (obj && Ext.isObject(obj)) {
    if ('Unit' in obj && obj.Unit && obj.Unit !== 'Standard') {
      query.unit = obj.Unit;
    }
    if ('Aggregation' in obj && obj.Aggregation && obj.Aggregation !== 'Standard' && obj.Aggregation !== 4269) {
      query.aggregation = obj.Aggregation;
    }
  }
  return query;
}, setRequestObject:function(stateObj, loadTs) {
  var p = this.addToSelectedStore(stateObj.tsSelection, loadTs);
  p.then(function(obj) {
    var start = new Date(stateObj.start);
    var end = new Date(stateObj.end);
    this.requestPanel.setRequestParams({startDate:start, endDate:end, startHour:'' + start.getHours(), endHour:'' + end.getHours(), startMinute:'' + start.getMinutes(), endMinute:'' + end.getMinutes(), interval:stateObj.interval, intervalMultiplier:stateObj.intervalMultiplier, aggregation:stateObj.aggregation, unit:stateObj.unit});
    if (obj.records && obj.records.length) {
      this.loadData();
    }
  }.bind(this));
}, writeState:function(view, loadTs) {
  this.setRequestObject(view, loadTs);
}, addToSelectedStore:function(selectedTimeseries, loadTs, addDirectly) {
  var $jscomp$this = this;
  var addToStore = function(storeData, loadTs, addDirect) {
    return {records:$jscomp$this.requestPanel.selectedGrid.refreshStoreData(storeData), loadData:loadTs, addDirect:addDirect};
  };
  if (!this.virtimoColors) {
    this.virtimoColors = webtsm.Support.getRandomVirtimoColors();
  }
  return new Promise(function(resolve, reject) {
    if (addDirectly) {
      selectedTimeseries = selectedTimeseries.map(function(tsData) {
        tsData.color = $jscomp$this.virtimoColors[Ext.Number.randomInt(0, $jscomp$this.virtimoColors.length)];
        return tsData;
      });
      resolve(addToStore(selectedTimeseries, loadTs, addDirectly));
    } else {
      webtsm.Support.loadBatchMetaData(selectedTimeseries, $jscomp$this.moduleId).then(function(results) {
        var storeData = [];
        Ext.Array.each(results, function(item, index) {
          var favItem = selectedTimeseries[index];
          var tsData = ' - ', id = null, name = null;
          if ('ID' in favItem && favItem.ID) {
            id = favItem.ID;
            tsData = id;
          }
          if ('Name' in favItem && favItem.Name) {
            name = favItem.Name;
            tsData = name;
          }
          var timeseriesObj = {ID:null, Name:null, Unit:null, Version:null, visibleForUser:true, color:favItem.color ? favItem.color : $jscomp$this.virtimoColors[Ext.Number.randomInt(0, $jscomp$this.virtimoColors.length)]};
          if (item && Ext.isObject(item)) {
            if ('Name' in item && item.Name) {
              timeseriesObj.Name = item.Name;
            }
            if ('ID' in item && item.ID) {
              timeseriesObj.ID = item.ID;
            }
            if ('Unit' in item && item.Unit) {
              timeseriesObj.Unit = item.Unit;
            }
          } else if (item && Ext.isNumber(item)) {
            if (item === 404) {
              timeseriesObj.visibleForUser = false;
              timeseriesObj.tsData = 'Restricted - ' + tsData;
              timeseriesObj.ID = id;
              timeseriesObj.Name = name;
            } else {
              timeseriesObj.visibleForUser = false;
              timeseriesObj.tsData = 'Error - ' + tsData;
              timeseriesObj.ID = id;
              timeseriesObj.Name = name;
            }
          }
          storeData.push(timeseriesObj);
        });
        resolve(addToStore(storeData, loadTs));
      }, function() {
        reject();
      });
    }
  });
}, changeTimeseries:function(timeseriesRecordsArray, addToExisting) {
  var selectedTimeseries = [];
  if (addToExisting && addToExisting === true) {
    selectedTimeseries = this.getSelectedTimeseries();
  }
  if (timeseriesRecordsArray.length) {
    selectedTimeseries = selectedTimeseries.concat(timeseriesRecordsArray.map(function(record) {
      return {Name:record.get('Name'), ID:record.get('ID'), Unit:record.get('Unit'), Version:record.get('Version')};
    }));
  }
  this.addToSelectedStore(selectedTimeseries);
}, getDataForExport:function() {
  return new Ext.Promise(function(resolve, reject) {
    var moduleId = this.moduleId, tsPromises = [], tsMetaPromises = [], requestObject = this.getRequestObject();
    var tfSelection = requestObject.tsSelection;
    if (!tfSelection.length) {
    } else {
      var filteredArray = Ext.Array.filter(tfSelection, function(item, index, array) {
        if ('visibleForUser' in item && item.visibleForUser === true) {
          return true;
        } else if (item.visibleForUser === null) {
          return true;
        }
      });
      if (filteredArray.length === tfSelection.length) {
      } else {
        if (filteredArray.length === 0) {
          return;
        } else if (filteredArray.length > tfSelection.length) {
        }
      }
      var requestParameter = [];
      Ext.Array.each(filteredArray, function(obj, index, array) {
        if ('ID' in obj && obj.ID) {
          var params = this.getQueryFromRequestObject(requestObject, obj);
          requestParameter.push(params);
          tsPromises.push(webtsm.Api.timeseries.getData(moduleId, obj.ID, params));
          tsMetaPromises.push(webtsm.Api.timeseries.getMeta(moduleId, obj.ID));
        }
      }, this);
      var timeseriesData = [];
      Ext.Promise.all(tsMetaPromises).then(function(promiseMetaResults) {
        Ext.Promise.all(tsPromises).then(function(promiseResults) {
          Ext.Array.each(promiseResults, function(item, index, array) {
            timeseriesData.push({definition:promiseMetaResults[index], data:item, requestParam:requestParameter[index]});
          });
          resolve(timeseriesData);
        }, function() {
          resolve(timeseriesData);
        });
      });
    }
  }.bind(this));
}, reEnableBtn:function(b) {
  if (b) {
    b.setIconCls(b.defaultTsmIconCls);
    b.setText(b.defaultTsmText);
    b.enable();
  }
}, isTSM39x:false, loadData:function(btn) {
  var $jscomp$this = this;
  try {
    Ext.util.Format.decimalSeparator = ',';
    Ext.util.Format.thousandSeparator = '.';
    var view = this, moduleId = view.moduleId, tsPromises = [], tsMetaPromises = [], tsGrid = this.tsGrid, tv = tsGrid.down('tableview'), tsChart = this.chartView, submitRequestBtn = btn ? btn : null, requestObject = this.getRequestObject(), restoreFilters = tsGrid.isFiltered ? {tsmFilterAction:tsGrid.tsmFilterType} : null, tfSelection = this.getSelectedTimeseries();
    tsGrid.resetGrid();
    tsChart.resetData();
    if (!tfSelection.length) {
      tv.setEmptyText(webtsm.Support.getTranslation('WEBTSM_SELECTION_NOT_VALID'));
      this.reEnableBtn(submitRequestBtn);
    } else {
      var filteredArray = tfSelection.filter(function(i) {
        return i && ('visibleForUser' in i && i.visibleForUser === true || i.visibleForUser === null);
      });
      if (filteredArray.length === 0) {
        tv.setEmptyText('Sie haben keinen Zugriff auf diese Zeiteihen');
        return;
      }
      tsGrid.setLoading(webtsm.Support.getTranslation('LOADING_DATA'));
      tsChart.setLoading(webtsm.Support.getTranslation('LOADING_DATA'));
      tsChart.removeAll();
      tv.setEmptyText('');
      var requestParameter = filteredArray.filter(function(obj) {
        return 'ID' in obj && obj.ID;
      }).map(function(obj) {
        var params = view.getQueryFromRequestObject(requestObject, obj);
        tsPromises.push(webtsm.Api.timeseries.getData(moduleId, obj.ID, params));
        tsMetaPromises.push(webtsm.Api.timeseries.getMeta(moduleId, obj.ID));
        params.color = obj.color || '#e3e3e3';
        return params;
      });
      var isSingle = tsPromises.length === 1, hasRequestErrors = false, msg = '', setEmptyText = false;
      Ext.Promise.all(tsMetaPromises).then(function(promiseMetaResults) {
        Ext.Promise.all(tsPromises).then(function(promiseResults) {
          var arrayResponses = promiseResults.filter(function(item) {
            return Ext.isArray(item);
          });
          var responsesOK = arrayResponses.length === promiseResults.length;
          setEmptyText = arrayResponses.length === 0;
          var timeseriesData = promiseResults.map(function(item, index, array) {
            if (!responsesOK && !hasRequestErrors && !msg.length) {
              hasRequestErrors = Ext.isObject(item);
              if (hasRequestErrors && item.Message) {
                msg = item.Message;
                setEmptyText = true;
              }
            }
            var editTimeseriesMeta = null;
            if (Ext.isObject(item) && item.Data) {
              if (!this.isTSM39x) {
                this.isTSM39x = true;
              }
              var $jscomp$destructuring$var22 = item;
              var Unit = $jscomp$destructuring$var22.Unit;
              var TimeZone = $jscomp$destructuring$var22.TimeZone;
              var Interval = $jscomp$destructuring$var22.Interval;
              var $jscomp$destructuring$var23 = Interval;
              var Value = $jscomp$destructuring$var23.Value;
              var Multiplier = $jscomp$destructuring$var23.Multiplier;
              var extIntervalConstant = undefined;
              var intervalConfig = webtsm.Support.intervals.provider.hakom.filter(function(i) {
                return i.ID === Value;
              });
              if (intervalConfig.length) {
                var $jscomp$destructuring$var24 = intervalConfig[0];
                var type = $jscomp$destructuring$var24.type;
                if (type) {
                  extIntervalConstant = type;
                }
              }
              editTimeseriesMeta = {Unit:Unit, TimeZone:TimeZone, Interval:Interval};
              var valueData = item.Data || [];
              var diffMillis, canAddDate = false;
              if (valueData.length >= 2) {
                var first = valueData[0] || {};
                var second = valueData[1] || {};
                var d1 = new Date(first.From);
                var d2 = new Date(second.From);
                diffMillis = Math.abs(d2 - d1);
                canAddDate = true;
              }
              item = valueData.map(function(i, index, array) {
                if (array[index + 1]) {
                  var next = array[index + 1];
                  if (next.From) {
                    var $jscomp$destructuring$var25 = next;
                    var From = $jscomp$destructuring$var25.From;
                    i.To = From;
                  }
                }
                if (canAddDate && array.length - 1 === index) {
                  var from = new Date(i.From);
                  var millis = from.getTime() + diffMillis;
                  i.To = (new Date(millis)).toISOString();
                }
                if (array.length === 1 && extIntervalConstant) {
                  var to = Ext.Date.add(new Date(i.From), extIntervalConstant, Multiplier);
                  i.To = to.toISOString();
                }
                return i;
              });
            }
            return {metadata:promiseMetaResults[index], data:Ext.isArray(item) ? item : [], color:requestParameter[index].color, requestParam:requestParameter[index], editTimeseriesMeta:editTimeseriesMeta};
          });
          tsGrid.setGridTitle();
          $jscomp$this.updateData(timeseriesData);
          $jscomp$this.finishTsmRequest(true, submitRequestBtn, restoreFilters, isSingle, hasRequestErrors, msg, setEmptyText);
        }, function() {
          $jscomp$this.finishTsmRequest(false, submitRequestBtn, restoreFilters, isSingle, hasRequestErrors, msg, setEmptyText);
        });
      });
    }
  } catch (e) {
    this.finishTsmRequest(false, submitRequestBtn, restoreFilters, isSingle, hasRequestErrors, msg, setEmptyText);
  }
}, updateData:function(data) {
  this.tsGrid.updateTimeseries(data);
  this.chartView.buildChart(data);
}, finishTsmRequest:function(success, callerBtn, restoreFilters, isSingle, hasRequestErrors, msg, setEmptyText) {
  var tsGrid = this.tsGrid, submitRequestBtn = callerBtn ? callerBtn : null;
  if ((isSingle && hasRequestErrors || setEmptyText) && tsGrid) {
    var tv = tsGrid.down('tableview');
    if (tv && msg.length) {
      tv.setEmptyText(msg);
    }
  }
  if (success) {
    if ('widgetId' in this) {
      this.updatePeriod();
    }
    if (restoreFilters) {
      tsGrid.getController().filterTsmValuesStore(restoreFilters);
    }
  } else {
    BpcCommon.Api.showNotification(webtsm.Support.getTranslation('WEBTSM_ERROR_PROCESSING_DATA'));
  }
  tsGrid.setLoading(false);
  this.chartView.setLoading(false);
  this.reEnableBtn(submitRequestBtn);
}, getDateFormat:function() {
  var format = 'd.m.Y H:i';
  var intervalIdsWithSeconds = [1, 2];
  if (intervalIdsWithSeconds.indexOf(this.requestPanel.getInterval()) !== -1) {
    format = webtsm.Support.defaultDateFormat;
  }
  return format;
}, getDefaultParameters:function(moduleId) {
  var dateArray = webtsm.Support.createDatesFromEsDateRange(BpcCommon.Api.getSetting(moduleId, 'default_period'));
  var p = {};
  p.startDate = dateArray['start'];
  p.endDate = dateArray['end'];
  p.startHour = BpcCommon.Api.getSetting(moduleId, 'day_start_hour');
  p.endHour = BpcCommon.Api.getSetting(moduleId, 'day_start_hour');
  p.startMinute = BpcCommon.Api.getSetting(moduleId, 'day_start_minute');
  p.endMinute = BpcCommon.Api.getSetting(moduleId, 'day_start_minute');
  p.interval = BpcCommon.Api.getSetting(moduleId, 'default_interval');
  return p;
}, setModuleInstanceDefaults:function() {
  this.requestPanel.setRequestParams(this.getDefaultParameters(this.moduleId));
}, getComponentConfig:function() {
  var stateObj = this.getState();
  if (stateObj) {
    this.persistConfig(stateObj);
  }
}, restoreViewerConfig:function() {
  var selectedKey = window.localStorage.getItem(this.getWebTsmStateKey());
  if (selectedKey) {
    var stateObj = JSON.parse(selectedKey);
    if (stateObj && Ext.isObject(stateObj)) {
      this.writeState(stateObj, true);
      return true;
    }
  }
  return false;
}, persistConfig:function(stateObj) {
  if (stateObj) {
    var stateObjString = stateObj;
    if (Ext.isObject(stateObj) || Ext.isArray(stateObj)) {
      stateObjString = JSON.stringify(stateObj);
    }
    window.localStorage.setItem(this.getWebTsmStateKey(), stateObjString);
  }
}});
Ext.define('webtsm.components.plugin.BpcPluginMixin', {getValueFromConfigLegacy:function(key, context) {
  return this.internalValueHandler(this.getValueFromPluginConfiguration(key, context));
}, internalValueHandler:function(value) {
  return value === null ? undefined : value;
}, setPluginDisabled:function(disabled) {
  disabled = disabled === void 0 ? false : disabled;
  if (this.setDisabled) {
    this.setDisabled(disabled);
  }
}, updateTitle:function(title) {
  this.setTitle(title);
}});
Ext.define('webtsm.components.plugin.detailWindow.ViewerMain', {extend:'Ext.panel.Panel', alias:'widget.webtsmViewerPlugin', mixins:['webtsm.view.viewer.WebTsmViewerMixin', 'webtsm.components.plugin.BpcPluginMixin', 'BpcCommon.mixin.PsPluginMixin'], requires:['webtsm.ConfigKeys'], iconCls:webtsm.ConfigKeys.icons.chartArea, moduleId:undefined, padding:'0 0 0 0', stateful:false, record:undefined, editableRequest:false, requestPanelAsTab:true, hideRequestPanel:false, defaultViewTab:'data', tabOrder:['data', 
'chart', 'request'], bucket:undefined, bucketCount:0, layout:'fit', usePluginAsComponent:false, createFieldHidden:true, defaultCreateName:undefined, customStyle:undefined, showOnlyGrid:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = webtsm.Support.getTranslation('TIMESERIES');
  if (!this.usePluginAsComponent) {
    this.moduleId = this.getValueFromConfigLegacy('moduleId') || undefined;
    var value = this.getValueFromConfigLegacy('createFieldHidden');
    if (Ext.isDefined(value)) {
      this.createFieldHidden = value;
    }
  }
  this.timeseriesKey = this.getValueFromConfigLegacy('timeseriesKey') || undefined;
  this.webtsmStartDateStringField = this.getValueFromConfigLegacy('webtsmStartDateStringField') || undefined;
  this.webtsmEndDateStringField = this.getValueFromConfigLegacy('webtsmEndDateStringField') || undefined;
  this.webtsmDateStringFormat = this.getValueFromConfigLegacy('webtsmDateStringFormat') || 'C';
  this.delimiter = this.getValueFromConfigLegacy('delimiter') || undefined;
  this.record = this.getValueFromConfigLegacy('record', true) || undefined;
  this.defaultViewTab = this.getValueFromConfigLegacy('defaultViewTab') || 'data';
  this.tabOrder = ['data', 'chart', 'request'];
  this.tooltipDetails = [];
  if (this.record) {
    var recordData = this.record.getData();
    [this.timeseriesKey, this.webtsmStartDateStringField, this.webtsmEndDateStringField].map(function(prop) {
      if (prop) {
        if (recordData.hasOwnProperty(prop)) {
          var v = recordData[prop] || '';
          if (v.length === 0) {
            $jscomp$this.tooltipDetails.push(prop + ' exists, but looks like empty');
          }
        } else {
          $jscomp$this.tooltipDetails.push(prop + ' does not exist in process record');
        }
      } else {
        $jscomp$this.tooltipDetails.push('config wrong - improve');
      }
    });
  }
  var bucket = webtsm.Support.getBucketPayloadFromRecord(this.record, this.timeseriesKey, this.webtsmStartDateStringField, this.webtsmEndDateStringField, this.delimiter, undefined, this.webtsmDateStringFormat) || [];
  if (this.usePluginAsComponent) {
    bucket = this.bucket;
    if (this.customStyle) {
      this.style = this.customStyle;
    }
  }
  if (bucket) {
    this.bucket = bucket;
    if (bucket.bucket && Ext.isArray(bucket.bucket) && bucket.bucket.length) {
      this.bucketCount = bucket.bucket.length;
      this.canLoad = true;
    } else {
      this.canLoad = false;
    }
  } else {
    this.canLoad = false;
  }
  if (this.usePluginAsComponent) {
    this.header = false;
  }
  this.requestPanel = Ext.create({xtype:'tsmViewWidgetConfig', iconCls:'x-fas fa-cogs', moduleId:this.moduleId, moduleInstance:this, editableRequest:this.editableRequest, title:webtsm.Support.getTranslation('WEBTSM_REQUEST')});
  this.tsGrid = Ext.create({xtype:'tsGrid', layout:'fit', flex:1, moduleId:this.moduleId, moduleInstance:this, contextMenuDisabled:true});
  this.chartView = Ext.create({xtype:'tsChart', layout:'fit', pluginMode:true, moduleInstance:this, moduleId:this.moduleId});
  this.createTimeseriesField = Ext.create({xtype:'textfield', fieldLabel:'Name', name:'timeseriesCreatedName', hidden:this.createFieldHidden});
  this.createTimeseriesIdField = Ext.create({xtype:'textfield', name:'timeseriesCreatedId', width:100, readOnly:true, hidden:this.createFieldHidden});
  if (this.defaultCreateName) {
    this.createTimeseriesField.setValue(this.defaultCreateName);
  }
  this.createTimeseriesButton = Ext.create({xtype:'button', text:webtsm.Support.getTranslation('TS_CREATE'), iconCls:webtsm.Support.getBpcIconCls('fa-plus'), hidden:this.createFieldHidden, handler:function(b) {
    $jscomp$this.createTimeseries($jscomp$this.createTimeseriesField.getValue());
  }});
  var controlConfig = {xtype:'toolbar', dock:'bottom', ui:'footer', defaults:{margin:'0 2 0 2'}, layout:{type:'hbox', align:'stretch'}, items:[this.createTimeseriesField, this.createTimeseriesButton, this.createTimeseriesIdField, {xtype:'tbfill'}, this.requestPanel.intervalCombo, {xtype:'button', iconCls:webtsm.ConfigKeys.icons.refresh, text:webtsm.Support.getTranslation('WEBTSM_REFRESH'), handler:function(b) {
    this.loadData();
  }, scope:this}, {xtype:'button', iconCls:webtsm.Support.getBpcIconCls('fa-external-link'), menu:webtsm.Api.getAllActionsByViewerId(this.moduleId).map(function(i) {
    i.scope = $jscomp$this;
    i.handler = function(b) {
      BpcCommon.Api.showModule(b._moduleId, true, b.actionKey ? {bucket:this.bucket.bucket, action:b.tsmAction} : this.bucket || {});
    };
    return i;
  })}]};
  if (this.customStyle) {
    controlConfig.style = this.customStyle;
  }
  this.dockedItems = [controlConfig];
  var tabPanelConfig = {xtype:'tabpanel', items:[this.tsGrid, this.chartView, this.requestPanel], listeners:{tabchange:function(panel, newCard, oldCard) {
    if (newCard.title.toLowerCase() === 'chart') {
      newCard.buildChart();
    }
  }}};
  if (this.customStyle) {
    tabPanelConfig.tabBar = {style:this.customStyle, defaults:{overCls:''}};
  }
  this.tabPanel = Ext.create(tabPanelConfig);
  var wrapper;
  if (this.showOnlyGrid) {
    this.metaGrid = Ext.create({xtype:'grid', header:false, viewConfig:{markDirty:false}, store:Ext.create('Ext.data.Store', {data:[]}), columns:[{dataIndex:'foo', text:'Daten nicht geladen...', flex:1}]});
    this.tsGrid.region = 'center';
    this.tsGrid.metaGrid = this.metaGrid;
    this.tsGrid.showOnlyGrid = true;
    wrapper = Ext.create({xtype:'container', layout:'border', items:[this.tsGrid, {xtype:'panel', collapsible:true, width:450, title:webtsm.Support.getTranslation('MASTERDATA'), split:true, layout:'fit', items:[this.metaGrid], region:'east'}]});
  }
  this.items = [this.showOnlyGrid ? wrapper : this.tabPanel];
  var disablePlugin = this.bucketCount === 0;
  this.tabConfig = {tooltip:disablePlugin ? webtsm.Support.getTranslation('NO_TIMESERIES_FOUND') + '\x3cbr\x3e\x3cbr\x3e' + this.tooltipDetails.join('\x3cbr\x3e') : '', style:{pointerEvents:'all'}};
  this.callParent(arguments);
  if (!this.usePluginAsComponent) {
    this.updateTitle(this.getPluginTitle(this.bucketCount));
    if (disablePlugin) {
      this.setPluginDisabled(disablePlugin);
      return;
    }
  }
  if (this.canLoad) {
    this.requestPanel.intervalCombo.getStore().load({scope:this, callback:function(records, operation, success) {
      if (success) {
        $jscomp$this.loadViewer();
      }
    }});
  }
  if (Ext.isDefined(this.defaultViewTab) && !this.showOnlyGrid) {
    var tabpanel = this.down('tabpanel');
    var card = null;
    if (this.defaultViewTab === 'data') {
      card = this.tsGrid;
    } else if (this.defaultViewTab === 'chart') {
      card = this.chartView;
    } else if (this.defaultViewTab === 'request') {
      card = this.requestPanel;
    }
    tabpanel.setActiveTab(card);
  }
}, createTimeseries:function(name) {
  var $jscomp$this = this;
  name = name === void 0 ? 'ZeitreihenName' : name;
  var data = {Name:name, Type:1, Interval:{Value:2, Multiplier:15}};
  if (this.defaultUnit) {
    data.Unit = this.defaultUnit;
  }
  return new Promise(function(resolve) {
    webtsm.Api.timeseries.create($jscomp$this.moduleId, data).then(function(r) {
      $jscomp$this.createTimeseriesIdField.setValue(r.responseText);
      var data = $jscomp$this.bucket.bucket.concat([{ID:r.responseText}]);
      $jscomp$this.loadDataFromRecord(data).then(function(results) {
        var storeData = results.map(function(result, i) {
          return webtsm.Support.handleMetaDataPromiseResponse(result, data[i]);
        });
        $jscomp$this.addToSelectedStore(storeData, true, true).then(function(obj) {
          $jscomp$this.loadData();
          $jscomp$this.createTimeseriesField.setDisabled(true);
          $jscomp$this.createTimeseriesButton.setDisabled(true);
        });
      });
      resolve(r.responseText);
    }, function(r) {
      var json = webtsm.Support.getResponseObject(r);
      var $jscomp$destructuring$var26 = json || {};
      var Message = $jscomp$destructuring$var26.Message;
      if (Message) {
        Ext.toast({html:webtsm.Support.getTranslation('REQUEST_ERROR') + '\x3cbr\x3e\x3cbr/\x3e' + 'Status: ' + r.status + '\x3cbr/\x3e' + Message, width:200, anchor:$jscomp$this});
      }
      resolve(false);
    });
  });
}, getPluginTitle:function(count) {
  return webtsm.Support.getTranslation('TIMESERIES') + '\x26nbsp;\x26nbsp;(' + count + ') ';
}, loadViewer:function() {
  var $jscomp$this = this;
  this.setModuleInstanceDefaults();
  if (this.bucket.start && this.bucket.end) {
    this.requestPanel.setRequestRange(this.bucket.start, this.bucket.end);
  }
  this.loadDataFromRecord().then(function(results) {
    var storeData = results.map(function(result, i) {
      return webtsm.Support.handleMetaDataPromiseResponse(result, $jscomp$this.bucket.bucket[i]);
    });
    $jscomp$this.addToSelectedStore(storeData, true, true).then(function(obj) {
      $jscomp$this.loadData();
      $jscomp$this.requestPanel.updateQueryTextView();
    });
  });
}, loadDataFromRecord:function(data) {
  data = data || this.bucket.bucket;
  if (this.canLoad) {
    return webtsm.Support.loadBatchMetaData(data, this.moduleId);
  }
}});
Ext.define('webtsm.components.plugin.detailWindow.ViewerMainWrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'WebTSM Viewer Plugin', COMPONENT_XTYPE:'webtsmViewerPlugin', PLUGIN_ID:'webtsm-detailwindow-plugin-viewer'}});
Ext.define('webtsm.components.plugin.simpleAttributeEditor.Interface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'WebTSM Simple Attribute Editor Plugin', COMPONENT_XTYPE:'webtsmSimpleAttributeEditorPlugin', PLUGIN_ID:'webtsm-plugin-simple-attribute-editor'}});
Ext.define('webtsm.components.plugin.simpleAttributeEditor.Main', {extend:'Ext.panel.Panel', alias:'widget.webtsmSimpleAttributeEditorPlugin', mixins:['webtsm.components.plugin.BpcPluginMixin', 'webtsm.mixins.Component', 'BpcCommon.mixin.PsPluginMixin'], layout:'fit', title:'Simple Attribute Editor', submitDelay:300, style:{backgroundColor:'#f7f6f6'}, typeMap:{'text':'textfield', 'txt':'textfield', 'cb':'checkbox', 'box':'checkbox', 'checkbox':'checkbox', 'combobox':'combobox', 'multi':'combobox', 
'num':'numberfield', 'int':'numberfield', 'number':'numberfield'}, commitDisabled:true, allowEmptyStrings:true, initComponent:function() {
  var $jscomp$this = this;
  this.record = this.getValueFromConfigLegacy('record', true) || undefined;
  this.attributes = this.getValueFromConfigLegacy('attributes') || [];
  this.labelWidth = this.getValueFromConfigLegacy('labelWidth') || 150;
  this.title = this.getValueFromConfigLegacy('title') || 'Simple Attribute Editor';
  this.iconCls = webtsm.Support.getBpcIconCls(this.getValueFromConfigLegacy('iconCls') || webtsm.Support.keys.icons.infoIcon);
  this.headline = this.getValueFromConfigLegacy('headline') || '';
  this.description = this.getValueFromConfigLegacy('description') || '';
  this.attributeKey = this.getValueFromConfigLegacy('attributeKey');
  this.showDateField = this.getValueFromConfigLegacy('showDateField');
  this.moduleId = this.getValueFromConfigLegacy('instanceId', true) || undefined;
  this.commitDisabled = true;
  this.allowEmptyStrings = true;
  this.activeAttributes = [];
  var attributeDate;
  try {
    attributeDate = this.attributeKey ? Ext.Date.parse(this.attributeKey, 'd.m.Y') : new Date();
  } catch (e) {
    attributeDate = new Date();
  }
  this.attributeDate = attributeDate;
  var items = [];
  if (this.headline.length) {
    items.push({xtype:'container', html:'\x3ch3\x3e ' + this.headline + '\x3c/h3\x3e'});
  }
  if (this.description.length) {
    items.push({xtype:'container', html:this.description});
  }
  this.resetButton = Ext.create({xtype:'button', text:'RESET', ui:'secondary', margin:'0 2 0 0', disabled:this.isReadOnlyUser(), iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.remove), handler:this.onResetClick.bind(this)});
  this.saveButton = Ext.create({xtype:'button', text:'SAVE', disabled:true, ui:'primary', iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.save), handler:this.onSaveClick.bind(this)});
  this.items = [{xtype:'container', layout:'center', items:[{xtype:'container', width:'70%', layout:{type:'vbox', align:'stretch'}, items:items.concat(this.getAttributeFields())}]}];
  this.successBtn = Ext.create({xtype:'button', text:'', hidden:true, ui:'secondary', disabled:true});
  this._addDocked([this.successBtn, {xtype:'tbfill'}, this.resetButton, this.saveButton]);
  this.callParent(arguments);
  this.activeAttributes.map(function(obj) {
    return webtsm.Api.attributes.get($jscomp$this.moduleId, $jscomp$this.record.get('ID'), obj.attributeId).then(function(success) {
      if (success.error) {
        obj.field.setValue(success.status);
        obj.field.setDisabled(true);
        obj.button.setDisabled(true);
        return;
      }
      var values = success.Values || {};
      var array = Object.keys(values).map(function(dateString) {
        return {key:Ext.Date.parse(dateString, 'c'), value:values[dateString]};
      }).sort(function(a, b) {
        return a.key > b.key ? -1 : 1;
      });
      if (array.length) {
        var targetField = $jscomp$this.commitDisabled ? obj.button.valueField : obj.field;
        targetField.setValue(array[0].value);
      }
    });
  });
  this.query('field[attributeId]').map(function(f) {
    f.on('change', $jscomp$this.onFieldChanged.bind($jscomp$this));
  });
}, activeAttributes:[], getNewAssignment:function() {
  var attributeMap = this.getFieldValuesMap();
  var attributes = Object.keys(attributeMap).map(function(attributeId) {
    return attributeMap[attributeId];
  });
  return [{ID:this.record.get('ID'), Attributes:attributes || []}];
}, onSaveClick:function(b) {
  var $jscomp$this = this;
  b.setDisabled(true);
  var text = '';
  this.setLoading('Attribute werden aktualisiert');
  this.mergeAttributes(this.getNewAssignment()).then(function(promises) {
    return Ext.Promise.all(promises);
  }).then(function(responses) {
    var faulty = [];
    if (responses && Ext.isArray(responses)) {
      faulty = responses.filter(function(r) {
        return r.responseCode && [200, 201].indexOf(r.responseCode) === -1;
      });
    }
    return faulty.length === 0;
  }).then(function(success) {
    if (success) {
      $jscomp$this.successBtn.setText(BpcCommon.Api.getUserName() + ' - ' + Ext.Date.format(new Date(), 'd.m.Y H:i:s'));
      text = 'Attribute wurden erfolgreich aktualisiert';
    } else {
      text = 'TSM Error';
      $jscomp$this.successBtn.setText(text);
    }
    $jscomp$this.successBtn.setIconCls(webtsm.Support.getBpcIconCls(success ? 'fa-check-circle' : webtsm.Support.keys.icons.warning));
    $jscomp$this.setIconCls(webtsm.Support.getBpcIconCls(success ? 'fa-check-circle' : webtsm.Support.keys.icons.warning));
    $jscomp$this.successBtn.setVisible(true);
  })["catch"](function(error) {
    text = 'Es trat ein Fehler auf';
  })["finally"](function() {
    BpcCommon.Api.showNotification(text);
    $jscomp$this.setLoading(false);
  });
}, getFieldValuesMap:function() {
  var $jscomp$this = this;
  var fields = this.query('field[attributeId]').filter(function(f) {
    return f.isDisabled() === false;
  });
  var map = {};
  var date = this.down('#dateField').getValue();
  date.setHours(0, 0, 0, 0);
  fields.map(function(f) {
    var values = {};
    var value = f.getValue();
    if (!Ext.isString(value)) {
      value = String(value);
    }
    values[$jscomp$this.toHakomIsoString(date)] = value;
    map[f.attributeId] = {AttributeID:parseInt(f.attributeId), Values:values};
  });
  return map;
}, toHakomIsoString:function(dt) {
  var dateString = Ext.Date.format(dt, 'C');
  var dateTimeArray = dateString.split('T');
  var HisTime = dateTimeArray[1].split('.');
  return dateTimeArray[0] + 'T' + HisTime[0] + 'Z';
}, onResetClick:function(b) {
  this.query('field[attributeId]').map(function(f) {
    return f.setValue(undefined);
  });
}, getAttributeFields:function() {
  var $jscomp$this = this;
  var fields = this.attributes.map(function(item) {
    item.type = item.type || 'text';
    var xtype = $jscomp$this.typeMap[item.type];
    var fieldCfg = {xtype:xtype, fieldLabel:$jscomp$this.getAttributeName(item.ID), attributeId:item.ID, labelWidth:$jscomp$this.labelWidth, emptyText:webtsm.Support.getTranslation('PLEASE_FILL_OUT'), labelStyle:'font-weight:700;', flex:1};
    if (fieldCfg.fieldLabel === fieldCfg.attributeId) {
      fieldCfg.disabled = true;
    }
    if (Ext.isDefined(item.required)) {
      fieldCfg.allowBlank = false;
    }
    if (xtype === 'combobox') {
      fieldCfg.store = Ext.create('Ext.data.Store', {data:item.values || []});
      fieldCfg.valueField = 'key';
      fieldCfg.displayField = 'value';
    }
    if (xtype === 'textfield') {
      fieldCfg = Ext.apply(fieldCfg, {listeners:{change:function(f, newVal, oldVal) {
        f.getTrigger('reset').setVisible(newVal && newVal.length > 0);
      }}, triggers:{reset:{cls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.remove), hidden:true, handler:function() {
        this.setValue(undefined);
      }}}, validator:function(val) {
        return $jscomp$this.allowEmptyStrings ? true : val && val.length > 0;
      }});
      if ($jscomp$this.allowEmptyStrings) {
        fieldCfg.allowBlank = true;
      }
    }
    return fieldCfg;
  });
  fields = fields.map(function(cfg) {
    var valueField = Ext.create(cfg);
    var attributePreviewField = Ext.create({xtype:'textfield', readOnly:true, hidden:$jscomp$this.commitDisabled});
    var useAssignedValueBtn = Ext.create({xtype:'button', text:'Übernehmen', hidden:$jscomp$this.commitDisabled, handler:function(b) {
      b.valueField.setValue(attributePreviewField.getValue());
    }, attributePreviewField:attributePreviewField, valueField:valueField});
    if (cfg.fieldLabel !== cfg.attributeId) {
      $jscomp$this.activeAttributes.push({field:attributePreviewField, valueField:valueField, button:useAssignedValueBtn, attributeId:cfg.attributeId});
    } else {
      attributePreviewField.setDisabled(true);
      useAssignedValueBtn.setDisabled(true);
    }
    return {xtype:'fieldcontainer', attributePreviewField:attributePreviewField, layout:{type:'hbox', align:'stretch'}, items:[valueField, attributePreviewField, useAssignedValueBtn]};
  });
  if (fields.length > 0) {
    fields.push({xtype:'container', html:'\x3chr\x3e', hidden:!this.showDateField});
    fields.push({xtype:'datefield', fieldLabel:webtsm.Support.getTranslation('ATTRIBUTE_KEY_VALUE'), value:this.attributeDate, format:'d.m.Y', labelWidth:this.labelWidth, itemId:'dateField', hidden:!this.showDateField, labelStyle:'font-weight:700;'});
  }
  return fields.map(function(cfg) {
    return Ext.create(cfg);
  });
}, isReadOnlyUser:function() {
  return BpcCommon.Api.hasUserRight('WEBTSM_user') && !BpcCommon.Api.hasUserRole('bpcadmin');
}, onFieldChanged:function(f) {
  var fields = this.query('field[attributeId]');
  var validFields = fields.map(function(f) {
    return f.validate();
  });
  var isReadOnlyUser = this.isReadOnlyUser();
  var saveButtonDisabled = isReadOnlyUser ? true : !(fields.length === validFields.length && validFields.indexOf(false) === -1);
  this.saveButton.setDisabled(saveButtonDisabled);
}, getAttributeName:function(id) {
  return this.moduleInstance ? this.moduleInstance.getNameById(parseInt(id)) || id : id;
}, mergeAttributes:function(payload) {
  var $jscomp$this = this;
  if (payload && !payload.length) {
    webtsm.Support.notify('Payload empty, loaded without ts ?', false);
    return;
  }
  return Promise.all(this.getExistingAttributesById(payload.map(function(item) {
    return item.ID;
  }))).then(function(responses) {
    responses.map(function(assignments, i) {
      payload[i].existing = assignments;
      payload[i].existingIds = assignments.map(function(item) {
        return item.AttributeID;
      });
      payload[i].processedIds = [];
    });
    var mergedPayload = [];
    payload.map(function(item) {
      var merged = {ID:item.ID, data:[]};
      item.Attributes.map(function(newAssignment) {
        var newValues = Ext.apply({}, newAssignment.Values);
        var match = item.existing.filter(function(item) {
          return item.AttributeID === newAssignment.AttributeID;
        });
        if (match.length) {
          newValues = Ext.applyIf(newValues, match[0].Values || {});
        }
        merged.data.push({AttributeID:newAssignment.AttributeID, Values:newValues});
        item.processedIds.push(newAssignment.AttributeID);
      });
      item.existing.map(function(obj) {
        if (item.processedIds.indexOf(obj.AttributeID) === -1) {
          merged.data.push(obj);
        }
      });
      mergedPayload.push(merged);
    });
    return $jscomp$this.assignAttributes(mergedPayload);
  });
}, assignAttributes:function(payload) {
  var $jscomp$this = this;
  return payload.map(function(item) {
    return webtsm.Api.attributes.assignAttributesToTimeseries($jscomp$this.moduleId, item.ID, item.data);
  });
}, getExistingAttributesById:function(ids) {
  var $jscomp$this = this;
  ids = ids === void 0 ? [] : ids;
  return ids.map(function(id) {
    return webtsm.Api.attributes.get($jscomp$this.moduleId, id);
  });
}});
Ext.define('webtsm.components.plugin.simpleList.simpleList', {extend:'Ext.panel.Panel', alias:'widget.webtsmSimpleListPlugin', mixins:['webtsm.components.plugin.BpcPluginMixin', 'BpcCommon.mixin.PsPluginMixin'], layout:'fit', webtsmViewerInstanceId:undefined, header:undefined, grid:undefined, initComponent:function() {
  var $jscomp$this = this;
  var webtsmViewerInstanceId = this.getValueFromConfigLegacy('moduleId') || undefined;
  var pluginSourceInstanceId = this.getValueFromConfigLegacy('instanceId', true) || undefined;
  var esSyntaxPeriod = this.getValueFromConfigLegacy('esSyntaxPeriod') || undefined;
  var hideToolbarTop = this.getValueFromConfigLegacy('hideToolbarTop') || false;
  var hideToolbarBottom = this.getValueFromConfigLegacy('hideToolbarBottom') || false;
  var pluginColumns = this.getValueFromConfigLegacy('columns');
  var item;
  if (Ext.isDefined(webtsmViewerInstanceId) && Ext.isDefined(pluginSourceInstanceId)) {
    if (webtsm.Support.instanceExists(webtsmViewerInstanceId)) {
      this.grid = Ext.create({xtype:'webtsmSimpleListGrid', pluginSourceInstanceId:pluginSourceInstanceId, columnDataIndexes:this.getValueFromConfigLegacy('columnDataIndexes') || [], moduleId:webtsmViewerInstanceId, webtsmPluginWrapper:this, webtsmEsSyntaxPeriod:esSyntaxPeriod, hideToolbarTop:hideToolbarTop, hideToolbarBottom:hideToolbarBottom, pluginColumns:pluginColumns});
      Promise.all([webtsm.Api.getTypes(webtsmViewerInstanceId), webtsm.Api.getIntervals(webtsmViewerInstanceId)]).then(function(responses) {
        responses.map(function(r, i) {
          var key = i === 0 ? 'types' : 'intervals';
          $jscomp$this.grid[key] = webtsm.Support.convertArrayToObject(webtsm.Support.getResponseObject(r));
        });
      });
      item = this.grid;
      this.webtsmViewerInstanceId = webtsmViewerInstanceId;
    } else {
      item = {xtype:'container', html:'WebTSM instance does not exist, please check access.'};
    }
  } else {
    item = {xtype:'container', html:'Plugin config not correct, please check.'};
  }
  this.items = [item];
  this.title = this.getValueFromConfigLegacy('customTitle') || webtsm.Support.getTranslation('PLUGIN_SIMPLELIST_DEFAULT_TITLE');
  this.presetTitle = this.getValueFromConfigLegacy('customTitle') || webtsm.Support.getTranslation('PLUGIN_SIMPLELIST_DEFAULT_TITLE');
  this.iconCls = webtsm.Support.getBpcIconCls(this.getValueFromConfigLegacy('customIcon') || BpcCommon.Api.getSetting(webtsmViewerInstanceId, 'module_iconCls'));
  this.callParent(arguments);
  if (this.grid) {
    var timeseriesColumn = this.getValueFromConfigLegacy('timeseriesColumn') || undefined;
    if (timeseriesColumn) {
      var r = this.getValueFromConfigLegacy('record', true) || undefined;
      var data = r.get(timeseriesColumn);
      if (data) {
        data = data.split(webtsm.Support.defaultDelimiter);
        this.grid.updateStore(data);
      }
    }
  }
}, getTitle:function() {
  if (this.grid) {
    var selPeriod = this.grid.getViewModel().get('selectionPeriod');
    if (selPeriod) {
      return this.presetTitle + ' - ' + selPeriod;
    }
  }
  return this.presetTitle;
}, updateGridData:function(data, reload) {
  reload = reload === void 0 ? false : reload;
  if (this.grid) {
    var s = this.grid.getStore();
    s.removeAll();
    data = data && Ext.isArray(data) ? data : [];
    s.add(data);
    if (reload) {
      this.reloadPlugin();
    }
  }
}, reloadPlugin:function() {
  if (this.grid) {
    this.grid.refreshStoreData();
  }
}});
Ext.define('webtsm.components.plugin.simpleList.simpleListInterface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'WebTSM List Plugin', COMPONENT_XTYPE:'webtsmSimpleListPlugin', PLUGIN_ID:'webtsm-plugin-simplelist'}});
Ext.define('webtsm.components.queryViews.QueryViewPanel', {extend:'Ext.window.Window', alias:'widget.webtsmQueryViewPanel', mixins:['webtsm.mixins.Component'], viewModel:{data:{viewData:[], activeView:{name:'Keine Abfrage gewählt.'}}}, iconCls:webtsm.Support.getBpcIconCls('fa-tablet'), layout:{type:'border'}, requires:['webtsm.ConfigKeys'], width:900, height:700, constrain:true, stateViewCmpName:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.stateViewCmpName = this.statePlugin.stateViewCmpName;
  this.title = this.TR('QUERIES');
  this.defaults = {moduleId:this.statePlugin.moduleId, stateViewCmpName:this.statePlugin.stateViewCmpName};
  var items = [{xtype:'grid', viewConfig:{enableTextSelection:true}, region:'west', itemId:'statesPluginGenericGrid', split:true, listeners:{select:function(selModel, record, tr, rowIndex, e, eOpts) {
    var stateViewCmp = $jscomp$this.down($jscomp$this.stateViewCmpName);
    stateViewCmp.applyStateViewObj(record);
  }, boxready:function(cmp) {
    cmp.up('window').refreshFavs();
  }}, store:Ext.create('Ext.data.Store', {data:[]}), refreshStateStore:function(states) {
    var s = this.getStore();
    s.removeAll();
    s.add(states);
    var models = s.getData().getRange();
    if (models && models.length) {
      this.setSelection(models[0]);
    }
  }, columns:[{text:this.TR('NAME'), dataIndex:'name', flex:3}, {text:this.TR('FAVORITE'), dataIndex:'favorite', flex:1, xtype:'checkcolumn', listeners:{checkchange:function(col, rowIndex, checked, record, e, eOpts) {
    $jscomp$this.onFavChange(record);
  }}}, {xtype:'actioncolumn', text:' ', width:60, items:[{iconCls:webtsm.ConfigKeys.icons.check, tooltip:this.TR('APPLY_VIEW'), handler:function(v, rI, cI, item, e, r) {
    $jscomp$this.showFavorite(r.get('id'));
  }}, {iconCls:this.faIcon('trash'), tooltip:this.TR('DELETE_VIEW'), handler:function(v, rI, cI, item, e, r) {
    $jscomp$this.deleteFavorite(r.get('id'));
  }}]}].map(function(c) {
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  }), width:400}];
  items.push({xtype:'webtsmPluginStateView', region:'center', stateViewCmpName:this.stateViewCmpName});
  this.items = items;
  this._addDocked([{xtype:'tbfill'}, {text:this.TR('DELETE'), iconCls:this.faIcon('fa-trash'), ui:'secondary', handler:function(btn) {
    $jscomp$this.deleteFavorite();
  }}, {iconCls:this.faIcon('fa-times'), text:this.TR('CLOSE'), ui:'secondary', handler:function(btn) {
    $jscomp$this.close();
  }}, {text:this.TR('SAVE'), ui:'primary', iconCls:webtsm.ConfigKeys.icons.save, handler:function(btn) {
    $jscomp$this.updateFavorite();
  }}, {text:this.TR('APPLY'), iconCls:webtsm.ConfigKeys.icons.check, ui:'primary', handler:function(btn) {
    $jscomp$this.showFavorite();
  }}]);
  this.callParent(arguments);
}, getStateViewComponent:function() {
  var view = this.down('webtsmPluginStateView');
  return view ? view.getStateViewComponent() : undefined;
}, getActiveStateId:function() {
  var cmp = this.getStateViewComponent();
  return cmp ? cmp.getStateId() : undefined;
}, onFavChange:function(record) {
  var c = this.down(this.stateViewCmpName);
  var vm = c.getViewModel();
  vm.set('favorite', record.get('favorite'));
}, updateWindowView:function(views) {
  var vm = this.getViewModel();
  vm.set('viewData', []);
  vm.set('viewData', views);
  this.refreshFavs();
}, findMatchingJsonSetting:function(itemOrIndex, id) {
  var match = null;
  var stateSetting = this.statePlugin.getStatesViews(true);
  var viewArray = stateSetting.getData().value;
  if (viewArray.length) {
    Ext.Array.each(viewArray, function(view, index) {
      if (itemOrIndex === 'item') {
        if (view.id === id) {
          match = view;
          return false;
        }
      }
      if (itemOrIndex === 'index') {
        if (view.id === id) {
          match = index;
          return false;
        }
      }
    });
  }
  return match;
}, showFavorite:function(id) {
  id = id || this.getActiveStateId();
  var favorite = this.findMatchingJsonSetting('item', id);
  if (favorite !== null) {
    this.setLoading(this.TR('LOADING'));
    if ('name' in favorite && favorite.name) {
      var stateItem = this.statePlugin;
      var stateItemVm = stateItem.getViewModel();
      stateItemVm.set('lastStateAppliedName', favorite.name);
      stateItemVm.set('lastStateAppliedId', favorite.id);
    }
    stateItem.moduleInstance.writeState(favorite, true);
    var me = this;
    Ext.defer(function() {
      me.close();
    }, 500);
  }
}, updateFavorite:function(id, state) {
  var $jscomp$this = this;
  var me = this;
  id = id || this.getActiveStateId();
  state = state || this.getStateViewComponent().getState();
  var stateSetting = this.statePlugin.getStatesViews(true);
  var viewArray = stateSetting.getData().value;
  var removeIndex = this.findMatchingJsonSetting('index', id);
  if (removeIndex !== null) {
    viewArray = Ext.Array.removeAt(viewArray, removeIndex);
    viewArray = Ext.Array.insert(viewArray, removeIndex - 1, [state]);
    stateSetting.set('value', viewArray);
    me.setLoading(this.TR('UPDATING_VIEW'));
    stateSetting.save({failure:function(record, operation) {
      webtsm.Support.notify($jscomp$this.TR('ERROR_UPDATING_VIEW'));
      me.updateWindowView(viewArray);
    }, success:function(record, operation) {
      webtsm.Support.notify($jscomp$this.TR('SUCCESS_UPDATING_VIEW'));
    }, callback:function(record, operation) {
      $jscomp$this.setLoading(false);
    }});
  }
}, refreshFavs:function() {
  var g = this.down('#statesPluginGenericGrid');
  if (g) {
    g.refreshStateStore(this.statePlugin.getStatesViews());
  }
}, deleteFavorite:function(id) {
  var $jscomp$this = this;
  id = id || this.getActiveStateId();
  var stateSetting = this.statePlugin.getStatesViews(true);
  var viewArray = stateSetting.getData().value || [];
  if (viewArray.length) {
    var removeIndex = this.findMatchingJsonSetting('index', id);
    if (removeIndex !== null) {
      viewArray = Ext.Array.removeAt(viewArray, removeIndex);
      stateSetting.set('value', viewArray);
      this.setLoading('Ansicht wird gelöscht');
      stateSetting.save({failure:function(record, operation) {
        webtsm.Support.notify('Ansicht wurde erfolgreich gelöscht');
        $jscomp$this.updateWindowView(viewArray);
      }, success:function(record, operation) {
        webtsm.Support.notify('Ansicht wurde nicht gelöscht');
        $jscomp$this.refreshFavs();
      }, callback:function(record, operation) {
        $jscomp$this.setLoading(false);
      }});
    } else {
      webtsm.Support.notify('Ansicht wurde nicht gefunden. Es wird nichts gelöscht.');
    }
  }
}});
Ext.define('webtsm.components.queryViews.QueryViewWrapper', {extend:'Ext.panel.Panel', alias:'widget.webtsmPluginStateView', requires:['webtsm.ConfigKeys'], layout:'fit', bodyPadding:5, scrollable:true, stateViewCmpName:undefined, moduleId:undefined, initComponent:function() {
  this.items = [{xtype:this.stateViewCmpName, moduleId:this.moduleId}];
  this.callParent(arguments);
}, getStateViewComponent:function() {
  var stateViewCmp = this.down(this.stateViewCmpName);
  return stateViewCmp ? stateViewCmp : undefined;
}});
Ext.define('webtsm.components.queryViews.ToolbarItem', {extend:'Ext.button.Button', alias:'widget.webtsmViewsToolbarItem', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], viewModel:{data:{lastStateAppliedName:null, lastStateAppliedId:null}}, moduleId:undefined, moduleInstance:undefined, disabled:true, viewSettingWindow:undefined, viewsSettingName:'view_states', stateViewTypes:{none:'webtsmViewerStateView', webtsm_module:'webtsmViewerStateView', tsm_manager:'webtsmManagerStateView'}, 
stateViewCmpName:undefined, instanceId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = this.faIcon('fa-browser');
  this.tooltip = this.TR('VIEWS');
  if (this.instanceId) {
    this.moduleId = this.instanceId;
    var model = BpcCommon.Api.getModuleModel(this.instanceId);
    var instanceType = model.get('instanceType');
    if (instanceType && instanceType in this.stateViewTypes) {
      this.stateViewCmpName = this.stateViewTypes[instanceType];
    }
  }
  this.menu = {plain:true, items:[{text:this.TR('RESET_VIEW'), iconCls:this.faIcon('fa-undo'), disabled:true, hidden:true, handler:function(menuItem) {
  }}, {text:this.TR('ADD_NEW_VIEW'), iconCls:this.faIcon('fa-plus-square'), disabled:false, handler:function() {
    $jscomp$this.saveCurrentStatePopup();
  }}, {bind:{text:'Änderungen speichern als {lastStateAppliedName}'}, iconCls:webtsm.ConfigKeys.icons.edit, handler:function(item) {
    var vm = $jscomp$this.getViewModel();
    $jscomp$this.saveCurrentState(vm.get('lastStateAppliedId'), vm.get('lastStateAppliedName'));
  }}, {xtype:'menuseparator'}, {text:this.TR('MANAGE_VIEWS'), iconCls:webtsm.ConfigKeys.icons.edit, handler:function(menuItem) {
    $jscomp$this.viewSettingWindow = Ext.create({xtype:'webtsmQueryViewPanel', statePlugin:$jscomp$this});
    $jscomp$this.viewSettingWindow.show();
  }}, {xtype:'menuseparator'}, {text:this.TR('NO_VIEWS_STORED'), itemId:'filterListPlaceholder', disabled:true, cls:'bpc-menu-item-text-default'}]};
  this.callParent(arguments);
  Ext.defer(function() {
    if ($jscomp$this.instanceId) {
      var moduleInstance = BpcCommon.Api.getModuleInstanceComponent($jscomp$this.instanceId);
      if (moduleInstance) {
        $jscomp$this.moduleInstance = moduleInstance;
        var viewsModel = $jscomp$this.getStatesViews(true);
        if (viewsModel) {
          viewsModel.on('changed', $jscomp$this.updateViewList, $jscomp$this);
          $jscomp$this.enable();
          $jscomp$this.updateViewList();
        }
      }
    }
  }, 500);
}, saveCurrentStatePopup:function() {
  var view = this;
  this.saveCurrentStatePopup.msgBox = Ext.create('Ext.window.MessageBox', {closeAction:'destroy', buttonText:{ok:'Ok', cancel:'Abbrechen'}, listeners:{show:function(msgBox) {
    msgBox.add({xtype:'checkbox', reference:'favorite', boxLabel:'als Favorit speichern', padding:10});
  }}}).prompt('Ansicht speichern', 'Bitte geben Sie einen Namen für die Ansicht ein:', function(btn, text) {
    if (btn == 'ok' && text && text.length) {
      var checkBox = this.saveCurrentStatePopup.msgBox.down('checkbox');
      var favorite = checkBox.getValue() || false;
      view.saveCurrentState(null, text, favorite);
    } else if (btn == 'ok' && (!text || text.length === 0)) {
      this.saveCurrentStatePopup();
    }
  }, this);
}, getStatesViews:function(model) {
  model = Ext.isDefined(model) ? model : false;
  return BpcCommon.Api.getSetting(this.moduleId, this.viewsSettingName, model);
}, getCurrentStateCollection:function() {
  var stateSetting = this.getStatesViews(true);
  var stateArray = stateSetting.get('value');
  var stateCollection = Ext.create('Ext.util.Collection');
  if (stateArray) {
    stateCollection.add(stateArray.filter(function(state) {
      return state && state.id;
    }));
  }
  return stateCollection;
}, saveCurrentState:function(id, name, favorite) {
  var stateSetting = this.getStatesViews(true);
  var stateCollection = this.getCurrentStateCollection();
  stateCollection.add({id:id || (new Date()).getTime(), name:name, favorite:Ext.isDefined(favorite) ? favorite : true, state:this.moduleInstance.getState()});
  stateSetting.set('value', stateCollection.getRange());
  stateSetting.save();
}, updateViewList:function() {
  var $jscomp$this = this;
  var views = this.getStatesViews();
  if (views && views.length) {
    var targetMenu = this.getMenu();
    if (targetMenu) {
      var refItem = targetMenu.down('#filterListPlaceholder');
      var oldItems = this.query('[viewFavorite\x3dtrue]');
      Ext.Array.each(oldItems, function(item) {
        targetMenu.remove(item, true);
      });
      if (refItem) {
        refItem.hide();
      }
      var tb = this.moduleInstance.bpcModuleHeader.down('toolbar');
      tb.removeAll();
      var insertIndex = targetMenu.items.indexOf(refItem) + 1;
      if (Ext.isDefined(insertIndex)) {
        var me = this;
        Ext.Array.each(views, function(state) {
          var stateObj = {text:state.name, handler:function(menuItem) {
            $jscomp$this.applyViewState(menuItem.requestObj);
          }, iconCls:webtsm.Support.getBpcIconCls('fa-star'), stateId:state.id, viewFavorite:true, requestObj:state};
          if (state.favorite) {
            targetMenu.insert(insertIndex, stateObj);
          } else {
            delete stateObj.iconCls;
          }
          delete stateObj.handler;
          stateObj = Ext.apply(stateObj, {ui:'moduleHeader', statePlugin:me, listeners:{click:function(button) {
            button.statePlugin.applyViewState(button.requestObj);
          }}});
          tb.add(stateObj);
          insertIndex++;
        }, this);
      }
    }
  }
}, applyViewState:function(state) {
  if (this.viewSettingWindow) {
    this.viewSettingWindow.close();
  }
  var vm = this.getViewModel();
  vm.set('lastStateAppliedName', state.name);
  vm.set('lastStateAppliedId', state.id);
  this.moduleInstance.writeState(state.state, true);
}});
Ext.define('webtsmm.components.plugin.state.ManagerStateView', {extend:'Ext.container.Container', alias:'widget.webtsmManagerStateView', viewModel:{data:{favorite:null, name:null, id:null, state:{}}}, layout:{type:'vbox', align:'stretch'}, scrollable:true, itemId:undefined, applyStateViewObj:function(obj) {
  var me = this;
  var vm = this.getViewModel();
  Ext.iterate(obj.getData(), function(k, v) {
    vm.set(k, v);
    if (k === 'state' && v) {
      me.down('bpcCommonJsonFieldContainer').updateJson(v);
    }
  });
}, getStateId:function() {
  var vm = this.getViewModel();
  if (vm) {
    var id = vm.get('id');
    return Ext.isDefined(id) ? id : undefined;
  }
  return undefined;
}, getState:function() {
  var vm = this.getViewModel();
  if (vm) {
    var data = vm.getData();
    if (data) {
      return data;
    }
  }
  return undefined;
}, moduleId:undefined, initComponent:function() {
  this.items = [{xtype:'checkbox', fieldLabel:'Favorit', bind:{value:'{favorite}'}}, {xtype:'textfield', fieldLabel:'Name', bind:{value:'{name}'}}, {xtype:'textfield', fieldLabel:'ID', bind:{value:'{id}'}}, {xtype:'bpcCommonJsonFieldContainer', flex:1, fieldLabel:'State'}];
  this.callParent(arguments);
}});
Ext.define('webtsmm.components.plugin.state.ViewerStateView', {extend:'Ext.container.Container', alias:'widget.webtsmViewerStateView', mixins:['webtsm.mixins.Component'], viewModel:{data:{favorite:null, name:null, id:null, state:{tsSelection:[], aggregation:null, interval:null, start:null, end:null, endHour:null, endMinute:null, startHour:null, startMinute:null}}, stores:{timeseriesStore:{data:'{state.tsSelection}'}}}, layout:{type:'vbox', align:'stretch'}, itemId:undefined, applyStateViewObj:function(obj) {
  var $jscomp$this = this;
  var vm = this.getViewModel();
  Ext.iterate(obj.getData(), function(k, v) {
    vm.set(k, v);
    if (k === 'state' && Ext.isObject(v)) {
      if ('start' in v && 'end' in v && Ext.isDefined(v.end) && Ext.isDefined(v.start)) {
        $jscomp$this.applyDateValues('start', v.start);
        $jscomp$this.applyDateValues('end', v.end);
      }
    }
  });
}, applyDateValues:function(k, v) {
  var date = Ext.Date.parse(v, 'c');
  var vm = this.getViewModel();
  if (Ext.isDate(date)) {
    vm.set('state.' + k + 'Hour', date.getHours());
    vm.set('state.' + k + 'Minute', date.getMinutes());
    vm.set('state.' + k, date);
    vm.set('state.' + k, date);
  }
}, getStateId:function() {
  return this.getViewModel().get('id');
}, getState:function() {
  var data = this.getViewModel().getData();
  if (data) {
    delete data.timeseriesStore;
    return data;
  }
}, moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.items = [{xtype:'fieldset', title:this.TR('VIEW'), layout:{type:'hbox', align:'stretch'}, items:[{xtype:'checkbox', boxLabel:this.TR('Favorite'), bind:{value:'{favorite}'}, flex:1}, {xtype:'textfield', flex:2, fieldLabel:this.TR('Name'), bind:{value:'{name}'}}]}, {xtype:'fieldset', title:'Konfiguration', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'container', defaults:{xtype:'datefield', flex:1, allowBlank:false, width:'100%'}, items:[{fieldLabel:this.TR('START'), bind:{value:'{state.start}'}}, 
  {fieldLabel:this.TR('END'), bind:{value:'{state.end}'}}]}, {xtype:'container', layout:'vbox', defaults:{xtype:'fieldcontainer', flex:1, layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'numberfield', flex:1, allowBlank:false}}, items:[{fieldLabel:this.TR('FROM'), items:[{bind:{value:'{state.startHour}'}, maxValue:23, minValue:0, tooltip:this.TR('HOUR')}, {bind:{value:'{state.startMinute}'}, maxValue:59, minValue:0, tooltip:this.TR('MINUTE')}]}, {fieldLabel:this.TR('TO'), items:[{bind:{value:'{state.endHour}'}, 
  maxValue:23, minValue:0, tooltip:this.TR('HOUR')}, {bind:{value:'{state.endMinute}'}, maxValue:59, minValue:0, tooltip:this.TR('MINUTE')}]}]}, {xtype:'combobox', fieldLabel:this.TR('INTERVAL'), itemId:'intervalCombo', displayField:'Name', valueField:'ID', bind:{value:'{state.interval}'}, store:webtsm.Support.createIntervalStore(this.moduleId)}, {xtype:'combobox', fieldLabel:this.TR('AGGREGATION'), bind:{value:'{requestAggregation}'}, displayField:'Name', valueField:'ID', store:webtsm.Support.createAggregationsStore(this.moduleId)}]}, 
  {xtype:'fieldset', title:this.TR('TIME_SERIES'), flex:1, layout:'fit', items:[{xtype:'grid', viewConfig:{emptyText:this.TR('NO_TIME_SERIES_STORED'), deferEmptyText:true, enableTextSelection:true}, columns:[{dataIndex:'ID'}, {dataIndex:'Name', flex:1}, {dataIndex:'Unit'}].map(function(c) {
    c.text = $jscomp$this.TR(c.dataIndex);
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  }), bind:{store:'{timeseriesStore}'}}]}];
  this.callParent(arguments);
}});
Ext.define('webtsm.components.quotations.QuotationsGrid', {extend:'Ext.grid.Panel', alias:'widget.webtsmQuotationsGrid', viewConfig:{emptyText:webtsm.Support.TR('NO_DATA'), enableTextSelection:true, deferEmptyText:false, markDirty:false}, minHeight:65, dataIndex:undefined, gridReference:undefined, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.columns = [{dataIndex:'quoteDateString', width:200, renderer:function(v) {
    return Ext.Date.format(new Date(v), 'd.m.Y H:i:s');
  }}, {dataIndex:'quotation', width:200, hidden:true}, {dataIndex:'quotationName', width:120}, {dataIndex:'quotationDetails', flex:1}].map(function(c) {
    c.text = webtsm.Support.TR(c.dataIndex);
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  });
  this.callParent(arguments);
  this.initQuotations();
}, initQuotations:function() {
  var $jscomp$this = this;
  var $jscomp$destructuring$var27 = BpcCommon.Api.getSetting(this.moduleId, 'quotationConfig') || {};
  var retrieveNameFromAttribute = $jscomp$destructuring$var27.retrieveNameFromAttribute;
  var attributeId = $jscomp$destructuring$var27.attributeId;
  var timeSeries = this.getTimeSeriesFromColumn();
  this.loadQuotations(timeSeries).then(function(d) {
    $jscomp$this.store.add(d);
    if (retrieveNameFromAttribute) {
      $jscomp$this.retrieveNameFromAttribute(timeSeries, attributeId);
    }
    $jscomp$this.retrieveQuotationMetaData(timeSeries);
  });
}, retrieveNameFromAttribute:function(timeSeries, attributeId) {
  var $jscomp$this = this;
  if (attributeId) {
    webtsm.Api.timeseries.getAttributes(this.moduleId, timeSeries).then(function(attributes) {
      var versionAttributes = attributes.filter(function(attribute) {
        return attribute.AttributeID === attributeId;
      });
      if (versionAttributes.length) {
        var values = (versionAttributes[0] || {}).Values || {};
        Object.keys(values).map(function(dateString) {
          $jscomp$this.store.each(function(r) {
            if (r.get('quotation') === dateString) {
              r.set('quotationName', values[dateString]);
            }
          });
        });
      }
    });
  }
}, retrieveQuotationMetaData:function(timeSeries, attributeId) {
  var $jscomp$this = this;
  this.setLoading(webtsm.Support.TR('LOADING_DETAILS'));
  var params = [];
  this.store.each(function(r) {
    params.push({quotation:r.get('quotation'), exactQuotation:true});
  });
  var requests = params.map(function(p) {
    return webtsm.Api.timeseries.getMetaInfo($jscomp$this.moduleId, timeSeries, p);
  });
  Promise.all(requests).then(function(requestsData) {
    requestsData.map(function(response, i) {
      var param = params[i];
      $jscomp$this.store.each(function(r) {
        if (r.get('quotation') === param.quotation) {
          var $jscomp$destructuring$var28 = response;
          var DataPeriod = $jscomp$destructuring$var28.DataPeriod;
          var $jscomp$destructuring$var29 = DataPeriod || {};
          var From = $jscomp$destructuring$var29.From;
          var To = $jscomp$destructuring$var29.To;
          var details = 'VON: ' + From + ' - BIS:' + To;
          r.set('quotationDetails', details);
          r.set('quotationDetailsRaw', JSON.stringify(response));
        }
      });
    });
  })["finally"](function() {
    $jscomp$this.setLoading(false);
  });
}, getTimeSeriesFromColumn:function() {
  if (Ext.String.endsWith(this.dataIndex, '_flag')) {
    this.dataIndex = this.dataIndex.replace('_flag', '');
  }
  var valueColumn = this.gridReference.columnManager.getHeaderByDataIndex(this.dataIndex);
  return (valueColumn || {})._tsmName || '';
}, loadQuotations:function(timeSeries) {
  timeSeries = timeSeries === void 0 ? '' : timeSeries;
  return webtsm.Api.timeseries.getQuotations(this.moduleId, timeSeries).then(function(data) {
    return (data || []).map(function(i) {
      return {quoteDateString:i, quotation:i, quotationName:'-1'};
    });
  }).then(function(storeData) {
    return storeData;
  });
}, refreshTitle:function() {
  this.up('window');
}});
Ext.define('webtsm.mixins.AuditLog', {writeAuditLog:false, logActionName:undefined, initAuditLog:function(logActionName) {
  this.logActionName = logActionName;
  this.writeAuditLog = BpcCommon.Api.getSetting('webtsm', 'storeActionsInBpcAuditLog');
}, writeAuditLogData:function(data) {
  try {
    if (this.writeAuditLog) {
      webtsm.util.BpcSupport.createAuditLogEntry(undefined, this.logActionName, 'Time series value update', data);
    }
  } catch (e) {
  }
}});
Ext.define('webtsm.components.webtsm.EditTimeseriesValueContainer', {extend:'Ext.panel.Panel', alias:['widget.webtsmValueEditor'], requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component', 'webtsm.mixins.AuditLog'], header:false, selectedRecord:undefined, dataIndex:undefined, gridReference:undefined, layout:{type:'vbox', align:'stretch'}, padding:'5 15 5 15', windowReference:undefined, setWindowTitle:function() {
  var t = this.windowReference.getTitle();
  this.windowReference.setTitle(t + ' - ' + this.tsmName + (this.tsmVersion !== 'null' ? ' - ' + this.tsmVersion : ''));
}, isTSM39x:false, initComponent:function() {
  var $jscomp$this = this;
  this.modeSelector = Ext.create({xtype:'fieldcontainer', labelWidth:150, fieldLabel:this.TR('EDITMODE'), defaults:{xtype:'radio', margin:'0 20 0 20', listeners:{change:function(f, newVal) {
    if (newVal) {
      var isSingle = f.inputValue === 'single';
      $jscomp$this.fromField.setDisabled(isSingle);
      $jscomp$this.toField.setDisabled(isSingle);
      if (isSingle) {
        $jscomp$this.fromField.setValue($jscomp$this.selectedRecord.get('timestampFrom'));
        $jscomp$this.toField.setValue($jscomp$this.selectedRecord.get('timestampTo'));
      }
    }
  }}}, layout:{type:'hbox', align:'stretch'}, items:[{boxLabel:this.TR('SINGLE_VALUE'), name:'mode', value:true, inputValue:'single'}, {boxLabel:this.TR('ROLLOUT'), name:'mode', inputValue:'multi'}], getEditMode:function() {
    return this.query('radio').filter(function(c) {
      return c.getValue();
    })[0].inputValue;
  }});
  var fieldAnchor = '90%';
  this.timeseriesField = Ext.create({xtype:'textfield', fieldLabel:this.TR('NAME'), readOnly:true, anchor:fieldAnchor});
  this.versionField = Ext.create({xtype:'textfield', fieldLabel:this.TR('VERSION'), emptyText:this.TR('NO_VERSION'), readOnly:true, anchor:fieldAnchor});
  var fromData = [], toData = [];
  this.gridReference.store.each(function(r) {
    var from = r.get('timestampFrom');
    var to = r.get('timestampTo');
    fromData.push({display:webtsm.Support.formatDates(from, webtsm.Support.defaultDateFormat), key:webtsm.Support.formatDates(from), value:from});
    toData.push({display:webtsm.Support.formatDates(to, webtsm.Support.defaultDateFormat), key:webtsm.Support.formatDates(to), value:to});
  });
  this.fromField = Ext.create({xtype:'combo', store:Ext.create('Ext.data.Store', {data:fromData}), queryMode:'local', displayField:'display', forceSelection:true, valueField:'value', disabled:true, anchor:fieldAnchor, fieldLabel:this.TR('FROM'), listeners:{change:function() {
    $jscomp$this.handleRangeChange();
  }}});
  this.toField = Ext.create({xtype:'combo', store:Ext.create('Ext.data.Store', {data:toData}), queryMode:'local', displayField:'display', forceSelection:true, disabled:true, valueField:'value', fieldLabel:this.TR('TO'), anchor:fieldAnchor, listeners:{change:function() {
    $jscomp$this.handleRangeChange();
  }}});
  this.flagField = Ext.create({xtype:'webtsmFlagCombo', fieldLabel:this.TR('FLAG'), allowBlank:false, moduleId:this.moduleId, anchor:fieldAnchor});
  this.unitField = Ext.create({xtype:'webtsmUnitCombo', fieldLabel:this.TR('UNIT'), emptyText:'Keine Einheit übergeben, Bitte wählen', moduleId:this.moduleId, anchor:fieldAnchor});
  this.valueField = Ext.create({xtype:'textfield', fieldLabel:this.TR('VALUE'), allowBlank:false, moduleId:this.moduleId, anchor:fieldAnchor});
  this.rangeFieldSet = Ext.create({xtype:'fieldset', title:this.TR('RANGE'), collapsible:false, layout:'anchor', items:[this.modeSelector, this.fromField, this.toField]});
  this.items = [{xtype:'fieldset', title:this.TR('TIME_SERIES'), collapsible:false, layout:'anchor', items:[this.timeseriesField, this.versionField]}, this.rangeFieldSet, {xtype:'fieldset', flex:1, title:this.TR('VALUE'), collapsible:false, defaultType:'textfield', scrollable:true, defaults:{anchor:fieldAnchor, moduleId:this.moduleId}, layout:'anchor', items:[this.valueField, this.flagField, this.unitField]}];
  if (Ext.String.endsWith(this.dataIndex, '_flag')) {
    this.dataIndex = this.dataIndex.replace('_flag', '');
  }
  var valueColumn = this.gridReference.columnManager.getHeaderByDataIndex(this.dataIndex);
  this.tsmName = valueColumn._tsmName || 'not found';
  this.tsmUnit = valueColumn._tsmUnit || 'not found';
  this.tsmVersion = valueColumn._tsmVersion || 'null';
  this.tsmId = valueColumn._tsmId || 'not found';
  if (valueColumn.editTimeseriesMeta) {
    this.isTSM39x = true;
    this.editTimeseriesMeta = valueColumn.editTimeseriesMeta;
  }
  this.timeseriesField.setValue(this.tsmName);
  this.listeners = {afterrender:function(c) {
    c.setWindowTitle();
  }};
  this.keepOpenCheckBox = Ext.create({xtype:'checkbox', labelWidth:160, fieldLabel:this.TR('KEEP_OPEN'), inputValue:true, value:false});
  this.submitButton = Ext.create({xtype:'button', text:this.TR('SAVE'), iconCls:webtsm.ConfigKeys.icons.check, ui:'primary', handler:function(btn) {
    $jscomp$this.writeTimeseriesValues();
  }});
  this._addDocked([{xtype:'tbfill'}, this.keepOpenCheckBox, {text:this.TR('CLOSE'), iconCls:webtsm.ConfigKeys.icons.times, ui:'secondary', handler:function() {
    $jscomp$this.windowReference.close();
  }}, this.submitButton]);
  this.initAuditLog(webtsm.Support.logEventNames.edit);
  this.callParent(arguments);
  this.unitField.setValue(this.tsmUnit);
  this.versionField.setValue(this.tsmVersion);
  if (Ext.isDefined(this.selectedRecord)) {
    this.valueField.setValue(this.selectedRecord.get(this.dataIndex));
    this.flagField.setValue(this.selectedRecord.get(this.dataIndex + '_flag'));
    this.fromField.setValue(this.selectedRecord.get('timestampFrom'));
    this.toField.setValue(this.selectedRecord.get('timestampTo'));
  }
}, handleRangeChange:function() {
  var values = this.getValues();
  this.submitButton.setDisabled(values.length === 0);
  var trKey = values.length === 1 ? 'VALUE' : 'VALUES';
  this.rangeFieldSet.setTitle(this.TR('RANGE') + '    ' + '( ' + values.length + ' ' + this.TR(trKey) + ' ) ');
}, getValues:function() {
  var $jscomp$this = this;
  if (this.modeSelector.getEditMode() === 'single') {
    return [this.toTimeSeriesEntry(this.fromField.getValue(), this.toField.getValue())];
  }
  var values = [];
  var from = this.fromField.getValue();
  var to = this.toField.getValue();
  this.gridReference.store.each(function(r) {
    if (r.get('timestampFrom') >= from && r.get('timestampTo') <= to) {
      values.push($jscomp$this.toTimeSeriesEntry(r.get('timestampFrom'), r.get('timestampTo')));
    }
  });
  return values;
}, toTimeSeriesEntry:function(From, To) {
  From = webtsm.Support.formatDates(From);
  To = webtsm.Support.formatDates(To);
  return {From:From, To:To};
}, getBaseObject:function() {
  return Ext.apply({}, {Value:Number(this.valueField.getValue()), Flag:Number(this.flagField.getValue())});
}, prepareValues:function() {
  var $jscomp$this = this;
  var values = this.getValues().map(function(o) {
    return Ext.apply({}, o, $jscomp$this.getBaseObject());
  });
  if (this.isTSM39x) {
    var body = this.editTimeseriesMeta || {};
    body.Data = values.map(function(item) {
      delete item.To;
      return item;
    });
    values = body;
  }
  return values;
}, writeTimeseriesValues:function() {
  var $jscomp$this = this;
  var values = this.prepareValues();
  var auditLogData = {_moduleId:this.moduleId, ID:this.tsmId, Version:this.tsmVersion, Unit:this.unitField.getValue(), Values:values};
  this.doAsyncAction(values).then(function(error) {
    auditLogData.error = error;
    $jscomp$this.writeAuditLogData(auditLogData);
    return error;
  }).then(function(error) {
    BpcCommon.Api.showNotification($jscomp$this.TR(error ? 'ERROR_WRITING_VALUES' : 'SUCCESS_WRITING_VALUES'));
    if (!$jscomp$this.keepOpenCheckBox.getValue()) {
      $jscomp$this.windowReference.close();
    }
  });
}, doAsyncAction:function(values) {
  var $jscomp$this = this;
  var error = false;
  return webtsm.Api.updateTimeseriesValues(this.moduleId, this.tsmVersion, this.tsmId, values, this.unitField.getValue()).then(function(response) {
    var tsmMain = $jscomp$this.gridReference.up('tsmMain');
    var pluginView = $jscomp$this.gridReference.up('webtsmViewerPlugin');
    var loadingCmp = tsmMain || pluginView;
    if (loadingCmp) {
      loadingCmp.loadData();
    }
  }, function(response, opts) {
    error = true;
  })["finally"](function() {
    return error;
  });
}});
Ext.define('webtsm.mixins.RequestPanelUtil', {createRequestButtons:function() {
  var $jscomp$this = this;
  var intervalCfg = {flex:1, allowBlank:false, moduleId:this.moduleId};
  this.intervalCombo = Ext.create(Ext.apply({itemId:'intervalCombo', xtype:'webtsmIntervalCombo', value:'Hour'}, intervalCfg));
  this.intervalMultiplier = Ext.create(Ext.apply({}, {xtype:'textfield', itemId:'intervalMultiplier', tooltip:'Interval Multiplier', value:1}, intervalCfg));
  var dateCfg = {xtype:'datefield', width:250, flex:1, margin:'0 5 0 5', allowBlank:false, valuePublishEvent:['select', 'change', 'blur']};
  this.startDateField = Ext.create(Ext.apply({}, dateCfg, {fieldLabel:webtsm.Support.getTranslation('START') + ':'}));
  this.endDateField = Ext.create(Ext.apply({}, dateCfg, {fieldLabel:webtsm.Support.getTranslation('END') + ':'}));
  var numCfg = {xtype:'numberfield', flex:1, allowBlank:false};
  this.startMinuteField = Ext.create(Ext.apply({}, numCfg, {maxValue:59, minValue:0, tooltip:'Minute'}));
  this.endMinuteField = Ext.create(Ext.apply({}, numCfg, {maxValue:59, minValue:0, tooltip:'Minute'}));
  this.startHourField = Ext.create(Ext.apply({}, numCfg, {maxValue:23, minValue:0, tooltip:'Stunde'}));
  this.endHourField = Ext.create(Ext.apply({}, numCfg, {maxValue:23, minValue:0, tooltip:'Stunde'}));
  this.unitCombo = Ext.create({xtype:'webtsmUnitCombo', itemId:'unitCombo', fieldLabel:webtsm.Support.getTranslation('UNIT'), value:'Standard', allowBlank:false, moduleId:this.moduleId, webtsmBucketKey:'Unit', listeners:{change:function(cmp, newVal, oldVal) {
    this.changeValueInSelection(cmp.webtsmBucketKey, newVal);
  }.bind(this)}});
  var aggregationVersionCfg = {flex:1, margin:'0 5 0 5', allowBlank:false, moduleId:this.moduleId};
  this.aggregationCombo = Ext.create(Ext.apply({}, {xtype:'webtsmAggregationCombo', itemId:'aggregationCombo', fieldLabel:webtsm.Support.getTranslation('AGGREGATION'), value:4269, webtsmBucketKey:'Aggregation', listeners:{change:function(cmp, newVal, oldVal) {
    this.changeValueInSelection(cmp.webtsmBucketKey, newVal);
  }.bind(this)}}, aggregationVersionCfg));
  this.versionCombo = Ext.create(Ext.apply({}, {xtype:'webtsmVersionCombo', itemId:'versionCombo', fieldLabel:webtsm.Support.getTranslation('VERSION'), value:'Standard', webtsmBucketKey:'Version', listeners:{change:function(cmp, newVal, oldVal) {
    $jscomp$this.changeValueInSelection(cmp.webtsmBucketKey, newVal);
  }}}, aggregationVersionCfg));
}, getDefaultParameters:function(moduleId) {
  var dateArray = webtsm.Support.createDatesFromEsDateRange(BpcCommon.Api.getSetting(moduleId, 'default_period'));
  var p = {};
  p.startDate = dateArray['start'];
  p.endDate = dateArray['end'];
  p.startHour = BpcCommon.Api.getSetting(moduleId, 'day_start_hour');
  p.endHour = BpcCommon.Api.getSetting(moduleId, 'day_start_hour');
  p.startMinute = BpcCommon.Api.getSetting(moduleId, 'day_start_minute');
  p.endMinute = BpcCommon.Api.getSetting(moduleId, 'day_start_minute');
  p.interval = BpcCommon.Api.getSetting(moduleId, 'default_interval');
  return p;
}, setRequestParams:function(params) {
  if (params.startDate) {
    this.startDateField.setValue(params.startDate);
  }
  if (params.endDate) {
    this.endDateField.setValue(params.endDate);
  }
  if (Ext.isDefined(params.endMinute)) {
    this.endMinuteField.setValue(params.endMinute);
  }
  if (Ext.isDefined(params.endHour)) {
    this.endHourField.setValue(params.endHour);
  }
  if (Ext.isDefined(params.startHour)) {
    this.startHourField.setValue(params.startHour);
  }
  if (Ext.isDefined(params.startMinute)) {
    this.startMinuteField.setValue(params.startMinute);
  }
  if (params.interval) {
    this.intervalCombo.setValue(params.interval);
  }
  if (Ext.isDefined(params.intervalMultiplier)) {
    this.intervalMultiplier.setValue(params.intervalMultiplier);
  }
  if (params.aggregation) {
    this.aggregationCombo.setValue(params.aggregation);
  }
  if (params.unit) {
    this.unitCombo.setValue(params.unit);
  }
}, setRequestRange:function(start, end) {
  if (Ext.isDate(start) && Ext.isDate(end)) {
    this.startDateField.setValue(start);
    this.endDateField.setValue(end);
    this.endMinuteField.setValue(end.getMinutes());
    this.endHourField.setValue(end.getHours());
    this.startHourField.setValue(start.getHours());
    this.startMinuteField.setValue(start.getMinutes());
  }
}, getRequestParams:function() {
  var startDate = this.startDateField.getValue();
  var endDate = this.endDateField.getValue();
  startDate.setHours(this.startHourField.getValue(), this.startMinuteField.getValue(), 0, 0);
  endDate.setHours(this.endHourField.getValue(), this.endMinuteField.getValue(), 0, 0);
  var params = {start:startDate, end:endDate, interval:this.intervalCombo.getValue(), intervalMultiplier:this.intervalMultiplier.getValue(), unit:this.unitCombo.getValue(), aggregation:this.aggregationCombo.getValue()};
  if (this.versionCombo && this.versionCombo.isVisible(true)) {
    params.version = this.versionCombo.getValue();
  }
  return params;
}});
Ext.define('webtsm.components.webtsm.RequestContainer', {extend:'Ext.container.Container', alias:'widget.webtsmRequestContainer', mixins:['webtsm.view.viewer.WebTsmViewerMixin', 'webtsm.components.plugin.BpcPluginMixin', 'BpcCommon.mixin.PsPluginMixin', 'webtsm.mixins.RequestPanelUtil', 'webtsm.mixins.Component'], layout:{type:'vbox', align:'stretch'}, defaults:{xtype:'container', layout:{type:'hbox', align:'stretch'}, padding:'2 2 2 2'}, moduleId:undefined, initComponent:function() {
  this.moduleId = webtsm.Api.module.getViewerId(this.moduleId);
  this.createRequestButtons();
  this.items = [{items:[this.startDateField, this.endDateField]}, {defaults:{xtype:'fieldcontainer', flex:1, margin:'0 5 0 5', width:250, layout:{type:'hbox', align:'stretch'}}, items:[{fieldLabel:this.TR('FROM'), items:[this.startHourField, this.startMinuteField]}, {fieldLabel:this.TR('TO'), items:[this.endHourField, this.endMinuteField]}]}, {defaults:{flex:1, margin:'0 5 0 5', moduleId:this.moduleId}, items:[{xtype:'fieldcontainer', flex:1, margin:'0 5 0 5', width:250, layout:{type:'hbox', align:'stretch'}, 
  fieldLabel:this.TR('INTERVAL'), items:[this.intervalCombo, this.intervalMultiplier]}, this.unitCombo]}, {items:[this.aggregationCombo, this.versionCombo]}];
  this.callParent(arguments);
}, changeValueInSelection:function(bucketKey, value) {
  if (this.requestPanel) {
    this.requestPanel.changeValueInSelection(bucketKey, value);
  }
}});
Ext.define('webtsm.view.components.widgets.ApiStatus', {extend:'Ext.panel.Panel', alias:'widget.webtsmApiStatus', mixins:['BpcCommon.mixin.Widget', 'webtsm.mixins.Component'], requires:['webtsm.ConfigKeys'], statics:{WIDGET_NAME:'WebTSM API Status', WIDGET_DESCRIPTION:'', WIDGET_ICON_CLS:'x-fal fa-shield-alt'}, widgetConfigSettingMap:{moduleId:{settingType:'tsmTypeSelector'}}, layout:'card', activeItem:0, title:false, moduleId:undefined, wrongConfigPanel:{xtype:'container', padding:'10 10 10 10', 
items:[{xtype:'box', html:'Die Konfiguration ist unvollständig. Es muss mindestens der zugehörige Monitor augewählt sein.'}, {xtype:'button', text:'Konfiguration anzeigen', iconCls:webtsm.ConfigKeys.icons.settings, handler:function() {
  var widget = this.up('webtsmManagerWidget');
  widget.getLayout().setActiveItem(widget.settingPanel);
}}]}, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent();
  this.initWidget();
  try {
    this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:this.TR('RESET_TO_DEFAULTS'), ui:'secondary', handler:this.prepareWidgetConfiguration.bind(this, true)}, {text:this.TR('APPLY'), ui:'primary', handler:this.configureWidget.bind(this)}]});
  } catch (e$10) {
  }
}, initWidget:function() {
  var $jscomp$this = this;
  if (this.moduleId) {
    this.removeAll();
    var wrapper = Ext.create({xtype:'container', style:{backgroundColor:'#fff'}, layout:'center'});
    this.infopanel = Ext.create({xtype:'container', width:'80%', html:'Daten werden geladen'});
    this.retryButton = Ext.create({xtype:'button', ui:'primary', hidden:true, text:webtsm.Support.TR('RETRY'), iconCls:webtsm.Support.icon('fa-redo'), handler:function() {
      $jscomp$this.initWidget();
    }});
    var p = Ext.create({xtype:'panel', layout:{type:'vbox', align:'stretch'}, width:'70%', padding:'5 5 5 5', items:[this.infopanel], bbar:[{xtype:'tbfill'}, this.retryButton]});
    webtsm.Api.module.status.overall(this.moduleId).then(function(data) {
      Object.keys(data).map(function(name) {
        if (name === 'version') {
          p.add({xtype:'textfield', readOnly:true, fieldLabel:name.toUpperCase(), value:data[name].Version});
        } else {
          var item = data[name] || {};
          var $jscomp$destructuring$var30 = item;
          var text = $jscomp$destructuring$var30.text;
          var status = $jscomp$destructuring$var30.status;
          var statusStr = '' + status;
          var apiAvailable = statusStr.startsWith('2');
          if (!apiAvailable) {
            $jscomp$this.infopanel.update('\x3cdiv\x3e\x3ch3\x3eAPI DOWN\x3c/h3\x3e');
            $jscomp$this.infopanel.show();
            $jscomp$this.retryButton.show();
          }
          p.add({xtype:'fieldcontainer', fieldLabel:name.toUpperCase(), readOnly:true, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'button', text:' ', style:{backgroundColor:apiAvailable ? 'green' : 'red'}}, {xtype:'textfield', width:60, value:status, margin:'3 3 3 3'}, {xtype:'textfield', flex:2, value:text, margin:'3 3 3 3'}]});
        }
      });
    });
    wrapper.add(p);
    this.getLayout().setActiveItem(wrapper);
  }
}, getWrapperReference:function() {
  var plugin = this.down('tsmPlugin');
  if (plugin && plugin.isComponent) {
    return plugin;
  } else {
    return null;
  }
}, refreshWidget:function() {
  try {
    this.initWidget();
  } catch (e) {
  }
}, configureWidget:function() {
  var card = this.settingPanel;
  if (card && card.isComponent && card.isVisible(true)) {
    card = this.wrapper;
  }
  this.getLayout().setActiveItem(card);
}});
Ext.define('webtsm.components.plugin.VboxConfig', {extend:'Ext.container.Container', alias:'widget.tsmViewWidgetConfig', mixins:['webtsm.mixins.RequestPanelUtil'], layout:{type:'vbox', align:'stretch'}, border:0, margin:'5 5 5 5', scrollable:true, editableRequest:true, getInterval:function() {
  return this.intervalCombo.getValue();
}, initComponent:function() {
  this.selectedGrid = Ext.create({xtype:'tsmSelectedGrid', moduleId:this.moduleId, hideHeaders:false, flex:this.editableRequest === false ? 3 : 1});
  this.createRequestButtons();
  this.queryTextView = Ext.create({xtype:'box', html:'', flex:1, itemId:'webtsmSelectionPeriod', moduleId:this.moduleId, padding:'5 5 5 5'});
  var items;
  if (this.editableRequest === false) {
    this.layout.type = 'hbox';
    items = [this.queryTextView, {xtype:'splitter'}, this.selectedGrid];
    this.padding = '5 5 5 5';
  } else {
    items = [{xtype:'container', layout:{type:'vbox', align:'stretch'}, defaults:{xtype:'fieldcontainer', layout:{type:'hbox', align:'stretch'}, defaults:{flex:1}}, items:[{items:[this.startDateField, this.startHourField]}, {items:[this.endDateField, this.endHourField]}, {items:[this.intervalCombo, this.intervalMultiplier]}, {items:[this.unitCombo, this.aggregationCombo]}]}, this.selectedGrid, {xtype:'webtsmSearchCombo', margin:'10 0 0 0', moduleId:this.moduleId}];
  }
  this.items = items;
  this.callParent(arguments);
}, updateQueryTextView:function() {
  var htmlString = '\x3cb\x3eZeitraum:\x3c/b\x3e\x3cbr\x3e ' + this.moduleInstance.getSelectionPeriodAsText().split('-').map(function(i) {
    return i.trim();
  }).join('\x3cbr\x3e') + '\x3cbr\x3e\x3cbr\x3e' + '\x3cb\x3eAggregation:\x3c/b\x3e\x3cbr/\x3e ' + this.aggregationCombo.getValue() + ' \x3cbr\x3e\x3cbr\x3e' + '\x3cb\x3eEinheit:\x3c/b\x3e\x3cbr/\x3e ' + this.unitCombo.getValue() + ' \x3cbr\x3e\x3cbr\x3e';
  this.queryTextView.update(htmlString);
}});
Ext.define('webtsm.view.components.plugin.TsmPluginWrapper', {extend:'Ext.panel.Panel', alias:'widget.tsmPlugin', requires:['webtsm.ConfigKeys'], mixins:['webtsm.view.viewer.WebTsmViewerMixin'], layout:'card', activeItem:2, moduleId:undefined, widgetId:undefined, webtsmStatePrefix:'webtsmDashboardWidget', tsmInititalView:undefined, webtsmStateId:'tsmDashBoardWidget', widgetSettings:undefined, getWebTsmStateKey:function(name, cmp) {
  if (!cmp) {
    cmp = this;
  }
  if (!name) {
    if ('webtsmStateId' in cmp && cmp.webtsmStateId) {
      name = cmp.webtsmStateId;
    }
  }
  if (name) {
    var keys = [];
    keys.push(name);
    keys.push(cmp.moduleId);
    keys.push(cmp.widgetId);
    return keys.join('-');
  }
  return null;
}, getState:function() {
  return this.getRequestObject();
}, changeActiveItem:function(btn) {
  this.getLayout().setActiveItem(btn.cardToShow);
}, initComponent:function() {
  this.requestPanel = Ext.create({xtype:'tsmViewWidgetConfig', moduleId:this.moduleId, header:false, moduleInstance:this});
  this.tsGrid = Ext.create({xtype:'tsGrid', height:400, layout:'fit', moduleInstance:this, moduleId:this.moduleId, contextMenuDisabled:true, header:false});
  this.chartView = Ext.create({xtype:'tsChart', layout:'fit', moduleInstance:this, height:400, moduleId:this.moduleId, header:false, pluginMode:true});
  this.statesCombo = Ext.create({xtype:'webtsmStatesCombo', getWebTsmStateKey:function(name, cmp) {
    if (!cmp) {
      cmp = this;
    }
    if (!name) {
      if ('webtsmStateId' in cmp && cmp.webtsmStateId) {
        name = cmp.webtsmStateId;
      }
    }
    if (name) {
      var keys = [];
      keys.push(cmp.webtsmStatePrefix);
      keys.push(name);
      keys.push(cmp.moduleId);
      keys.push(cmp.widgetId);
      return keys.join('-');
    }
    return null;
  }, webtsmStateId:'widgetStateCombo', moduleInstance:this, moduleId:this.moduleId, widgetId:this.widgetId, webtsmStatePrefix:this.webtsmStatePrefix, listeners:{select:function(combo, record, eOpts) {
    var recordData = record.getData();
    combo.moduleInstance.writeState(recordData.state, true);
    window.localStorage.setItem(combo.getWebTsmStateKey(), recordData.name);
  }}});
  this.periodDisplay = Ext.create({xtype:'box', html:'', style:{fontSize:'larger'}, height:25, flex:1, padding:'5 5 5 15'});
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', ui:'footer', defaults:{margin:'0 2 0 2', moduleId:this.moduleId, widgetId:this.widgetId, webtsmStatePrefix:this.webtsmStatePrefix}, layout:{type:'hbox', align:'stretch'}, items:[this.statesCombo, {xtype:'button', flex:1, scope:this, handler:function(b) {
    this.loadData(b);
  }, text:webtsm.Support.getTranslation('WEBTSM_USE_REQUEST'), defaultTsmText:webtsm.Support.getTranslation('WEBTSM_USE_REQUEST'), defaultTsmIconCls:webtsm.ConfigKeys.icons.refresh, iconCls:webtsm.ConfigKeys.icons.refresh}, {xtype:'button', iconCls:webtsm.ConfigKeys.icons.settings, tooltip:webtsm.Support.getTranslation('WEBTSM_CONFIGURATION'), cardToShow:this.requestPanel, itemId:'requestPanelBtn', handler:this.changeActiveItem, scope:this}, {xtype:'button', iconCls:webtsm.ConfigKeys.icons.timeseriesData, 
  tooltip:webtsm.Support.getTranslation('WEBTSM_DATA'), cardToShow:this.tsGrid, itemId:'dataViewPanelBtn', handler:this.changeActiveItem, scope:this}, {xtype:'button', iconCls:webtsm.ConfigKeys.icons.chartArea, cardToShow:this.chartView, tooltip:webtsm.Support.getTranslation('WEBTSM_GRAPH'), itemId:'chartPanelBtn', handler:this.changeActiveItem, scope:this}]}, {xtype:'toolbar', dock:'top', defaults:{margin:'0 2 0 2'}, layout:{type:'hbox', align:'stretch'}, items:[this.periodDisplay]}];
  this.items = [this.requestPanel, this.tsGrid, this.chartView];
  this.callParent(arguments);
  this.requestPanel.intervalCombo.getStore().load({scope:this, callback:function(records, operation, success) {
    if (success) {
      this.loadViewer();
    }
  }});
}, loadViewer:function() {
  this.setModuleInstanceDefaults();
  var viewName = window.localStorage.getItem(this.statesCombo.getWebTsmStateKey()) || this.tsmInititalView;
  if (viewName) {
    var viewRecordToShow;
    this.statesCombo.store.each(function(r) {
      if (r.get('name') === viewName) {
        viewRecordToShow = r;
        return false;
      }
    });
    if (viewRecordToShow) {
      this.statesCombo.setSelection(viewRecordToShow);
    }
  } else {
    var restored = this.restoreViewerConfig();
    if (restored) {
      this.loadData();
      return;
    }
  }
  this.updatePeriod(webtsm.Support.getTranslation('NOT_LOADED'));
}, updatePeriod:function(msg) {
  this.periodDisplay.update('\x3cb\x3eZeitraum:\x3c/b\x3e ' + (msg || this.getSelectionPeriodAsText()));
}});
Ext.define('webtsm.shared.PsCommon', {singleton:true, errorResponseToStoreData:function(e) {
  var storeData = ['status', 'statusText', 'responseText'].map(function(k) {
    return {key:webtsm.Support.TR('ERROR_INFO_REQUEST_' + k.toUpperCase()), value:e[k] || '-1'};
  });
  if (e.request && e.request.url) {
    storeData.push({key:webtsm.Support.TR('ERROR_INFO_REQUEST_URL'), value:e.request.url});
  }
  return storeData;
}, getErrorPanel:function(title, data) {
  data = data === void 0 ? [] : data;
  return Ext.create({xtype:'panel', title:title, iconCls:webtsm.Support.icon('fa-exclamation-triangle'), layout:'fit', items:[{xtype:'grid', header:false, listeners:{rowdblclick:function(tableView, record) {
  }}, store:Ext.create('Ext.data.Store', {data:data}), columns:[{dataIndex:'key', text:webtsm.Support.TR('KEY'), flex:1, menuDisabled:true}, {dataIndex:'value', text:webtsm.Support.TR('VALUE'), flex:3, menuDisabled:true}]}]});
}});
Ext.define('webtsm.util.BpcSupport', {singleton:true, getIndicesGrid:function() {
  var g = Ext.create({xtype:'bpcCoreOpenSearch', header:false, stateful:false});
  var f = g.down('bpcGridFilterField');
  if (f) {
    f.setVisible(false);
  }
  return g;
}, getFastStorageName:function() {
  return 'opensearch';
}, createAuditLogEntry:function(originator, action, description, data) {
  originator = originator === void 0 ? '[WEBTSM]' : originator;
  action = action === void 0 ? 'FOO BAR ACTION' : action;
  description = description === void 0 ? 'Test entry' : description;
  data = data === void 0 ? null : data;
  var url = webtsm.Api.tsmBasePath + 'log';
  var config = {url:url, method:'PUT', params:{action:action, description:description}, jsonData:data};
  webtsm.Api.sendRequest(config);
}});
Ext.define('webtsm.util.Button', {singleton:true, openDetailWindow:function(record, moduleId, moduleInstance) {
  return this.openWindow('', undefined, document.body.clientWidth * 0.8, document.body.clientHeight * 0.7, 'webtsmDetailPanel', {record:record, moduleId:moduleId, moduleInstance:moduleInstance});
}, openWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig, show) {
  width = width === void 0 ? 800 : width;
  cmpAlias = cmpAlias === void 0 ? 'panel' : cmpAlias;
  cmpConfig = cmpConfig === void 0 ? {} : cmpConfig;
  show = show === void 0 ? true : show;
  var windowConfig = {title:title, width:width, padding:'0 0 0 0', style:{backgroundColor:'#eceaea'}, layout:'fit', iconCls:iconCls || webtsm.Support.icon('fa-info')};
  if (height !== null) {
    windowConfig.height = height || 600;
  }
  var w = Ext.create('Ext.window.Window', windowConfig);
  cmpConfig.windowReference = w;
  var cmp = Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig));
  w.add(cmp);
  if (show) {
    w.show();
  }
  return w;
}});
Ext.define('webtsm.util.MessageBox', {singleton:true, deleteEntries:function(title, message, records) {
  title = title === void 0 ? 'WEBTSM_Q_DELETE_TIMESERIES_WARN' : title;
  message = message === void 0 ? 'WEBTSM_Q_DELETE_TIMESERIES' : message;
  records = records === void 0 ? [] : records;
  var cmps = [{xtype:'container', padding:'0 10 0 10', layout:{type:'vbox'}, items:records.map(function(r) {
    return {xtype:'checkbox', readOnly:true, boxLabel:r.get('Name'), checked:true};
  })}];
  return this.createAndShowMessageBox(title, message, undefined, cmps, {buttonText:{ok:webtsm.Support.TR('BTN_TEXT_DELETE'), cancel:webtsm.Support.TR('BTN_TEXT_CANCEL')}});
}, createAndShowMessageBox:function(titleKey, messageKey, iconCls, components, customConfig) {
  iconCls = iconCls === void 0 ? 'fa-exclamation-triangle' : iconCls;
  components = components === void 0 ? [] : components;
  customConfig = customConfig === void 0 ? {} : customConfig;
  return new Promise(function(resolve) {
    var m = Ext.create({xtype:'messagebox', closeAction:'destroy'});
    if (components.length) {
      m.add(components);
    }
    var config = {title:webtsm.Support.TR(titleKey), message:webtsm.Support.TR(messageKey), buttons:Ext.Msg.OKCANCEL, iconCls:webtsm.Support.icon(iconCls), fn:function(btn) {
      resolve(btn === 'ok');
    }};
    m.show(Ext.apply({}, config, customConfig));
  });
}});
Ext.define('webtsm.util.Window', {singleton:true, openDetailWindow:function(record, moduleId, moduleInstance) {
  return this.openWindow('', undefined, document.body.clientWidth * 0.8, document.body.clientHeight * 0.7, 'webtsmDetailPanel', {record:record, moduleId:moduleId, moduleInstance:moduleInstance});
}, openWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig, show, additionalWindowConfig) {
  width = width === void 0 ? 800 : width;
  cmpAlias = cmpAlias === void 0 ? 'panel' : cmpAlias;
  cmpConfig = cmpConfig === void 0 ? {} : cmpConfig;
  show = show === void 0 ? true : show;
  additionalWindowConfig = additionalWindowConfig === void 0 ? {} : additionalWindowConfig;
  var windowConfig = {title:title, width:width, padding:'0 0 0 0', style:{backgroundColor:'#eceaea'}, layout:'fit', iconCls:iconCls || webtsm.Support.icon('fa-info')};
  if (height !== null) {
    windowConfig.height = height || 600;
  }
  windowConfig = Ext.apply(windowConfig, additionalWindowConfig);
  var w = Ext.create('Ext.window.Window', windowConfig);
  cmpConfig.windowReference = w;
  var cmp = Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig));
  w.add(cmp);
  if (show) {
    w.show();
  }
  return w;
}});
Ext.define('webtsm.view.Main', {extend:'Ext.container.Container', layout:'fit', items:[]});
Ext.define('webtsm.view.instanceTypes.client.moduleheader.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.webtsmModuleHeader', layout:{type:'hbox', align:'stretch'}, moduleId:undefined, disableElements:function() {
  [this.centerFlexContainer, this.statesButton, this.quickJumpButtonsToolbar, this.stateButtonsToolbar].map(function(c) {
    c.hide();
  });
  [this.applicationButton, this.versionButton].map(function(c) {
    c.setStyle({backgroundColor:'red'});
  });
}, initComponent:function() {
  var $jscomp$this = this;
  this.defaults = {moduleId:this.moduleId, hidden:this.moduleInstance.moduleConfigInvalid};
  this.searchField = Ext.create({xtype:'textfield', minWidth:250, itemId:'fullTextSearch', emptyText:webtsm.Support.TR('TIME_SERIES_SEARCH'), hidden:webtsm.Api.module.isManager(this.moduleId), triggers:{resetField:{cls:webtsm.Support.getBpcIconCls('fa-times'), hidden:true, handler:function() {
    this.setValue('');
  }}}, listeners:{change:function(f, newVal) {
    var trigger = f.getTrigger('resetField');
    var selGrid = $jscomp$this.moduleInstance.query('tsmSelectGrid')[0];
    var field = selGrid.query('#cacheSearchField')[0];
    var selector = $jscomp$this.moduleInstance.query('#webtsmSelector')[0];
    if (!selGrid.isVisible(true)) {
      selector.expand();
    }
    trigger.setVisible((newVal || '').length > 0);
    field.setValue(newVal);
  }}});
  this.centerFlexContainer = Ext.create({xtype:'container', flex:1, layout:'center', items:[this.searchField]});
  this.quickJumpButtonsToolbar = Ext.create({xtype:'toolbar', items:[], hidden:true, flex:2, moduleId:this.moduleId});
  this.stateButtonsToolbar = Ext.create({xtype:'toolbar', itemId:'stateButtons', overflowHandler:'scroller', items:[], hidden:false, flex:2, moduleId:this.moduleId, defaults:{enableToggle:true, toggleGroup:'tsmModuleHeaderFavs', moduleId:this.moduleId, tooltip:webtsm.Support.getTranslation('WEBTSM_TAKE_REQUEST')}});
  var states = BpcCommon.Api.getSetting(this.moduleId, 'view_states') || [];
  states.filter(function(state) {
    return state.favorite;
  }).map(function(s) {
    $jscomp$this.stateButtonsToolbar.add({text:s.name, ui:'secondary', state:s, handler:function(b) {
      $jscomp$this.moduleInstance.writeState(b.state.state, true);
    }});
  });
  this.applicationButton = Ext.create({xtype:'button', ui:'transparent-small', iconCls:webtsm.Support.getBpcIconCls('fa-database'), tooltip:webtsm.Support.getTranslation('REPOSITORY')});
  this.versionButton = Ext.create({xtype:'button', ui:'transparent-small', iconCls:webtsm.Support.getBpcIconCls('fa-plug'), tooltip:webtsm.Support.getTranslation('API_VERSION')});
  this.statesButton = Ext.create({xtype:'webtsmViewsToolbarItem', ui:'transparent-small', instanceId:this.moduleId});
  this.items = [this.centerFlexContainer, this.statesButton, this.quickJumpButtonsToolbar, this.stateButtonsToolbar, {xtype:'tbfill'}, this.applicationButton, this.versionButton];
  this.callParent(arguments);
}, applyApiConfig:function() {
  var $jscomp$this = this;
  var app = webtsm.Support.getApiConfigKeybyInstanceId(this.moduleId);
  if (app) {
    this.applicationButton.setText(app);
  }
  var compatApiVersion = webtsm.Support.getApiConfigKeybyInstanceId(this.moduleId, 'compatApiVersion');
  var versionSuccess = false;
  return webtsm.Api.getVersionInfos(webtsm.Api.module.getViewerId(this.moduleId)).then(function(response) {
    response = response || {};
    response = webtsm.Support.getResponseObject(response);
    if (response && Ext.isObject(response) && response.Version) {
      versionSuccess = true;
      $jscomp$this.versionButton.setText(response.Version || ' - ');
    }
    return versionSuccess;
  }, function(error) {
    throw error;
  });
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.export.ExportMain', {extend:'Ext.panel.Panel', alias:'widget.webtsmExportMain', requires:['webtsm.ConfigKeys'], iconCls:webtsm.ConfigKeys.icons.download, title:'Exporter', layout:{type:'hbox', align:'stretch'}, payload:[], hakomResponses:[], webtsmBucketLoaded:false, disableTsmActions:false, instanceId:undefined, types:undefined, intervals:undefined, loadTsMeta:function(payload, win) {
  var $jscomp$this = this;
  payload = payload || [];
  this.hakomResponses = [];
  this.definitionsGrid.store.removeAll();
  var settingValue = BpcCommon.Api.getSetting(this.moduleId, 'mgr_maxBucketSize');
  var maxBucketSize = Ext.isDefined(settingValue) && Ext.isNumber(settingValue) && settingValue < 1000 ? settingValue : 1000;
  this.bucketStore.each(function(r) {
    payload.push({ID:r.get('ID')});
  });
  if (payload.length > maxBucketSize) {
    payload = payload.slice(0, maxBucketSize);
  }
  var finished = function(index, array) {
    return array.length - 1 === index;
  };
  return new Ext.Promise(function(resolve, reject) {
    Ext.Array.each(payload, function(item, index, array) {
      webtsm.Api.timeseries.getMeta($jscomp$this.moduleId, item.ID).then(function(value) {
        var timeseriesMetadata = value;
        webtsm.Api.timeseries.getAttributes($jscomp$this.moduleId, item.ID).then(function(attributesArray) {
          if (Ext.isArray(attributesArray) && attributesArray.length > 0) {
            Ext.Array.each(attributesArray, function(attributeObj) {
              if ('AttributeID' in attributeObj && Ext.isDefined(attributeObj.AttributeID)) {
                attributeObj.AttributeName = $jscomp$this.searchGrid.getNameById(attributeObj.AttributeID);
              }
            });
          }
          timeseriesMetadata.Attributes = attributesArray;
        }, function(reason) {
          timeseriesMetadata.Attributes = {msg:'Error while fetching attributes for ' + item.ID};
        });
        $jscomp$this.definitionsGrid.store.add(timeseriesMetadata);
        $jscomp$this.hakomResponses.push(timeseriesMetadata);
        if (finished(index, array)) {
          if (win) {
            win.setLoading(false);
          }
          resolve();
        }
      }, function(reason) {
        if (finished(index, array)) {
          if (win) {
            win.setLoading(false);
          }
          resolve();
        }
      });
    });
  });
}, initComponent:function() {
  var $jscomp$this = this;
  Ext.apply(this, webtsm.Support.legacy);
  this.bucket = Ext.create({xtype:'webtsmBucketGrid', bbar:[], flex:1, bucketStore:this.bucketStore, moduleId:this.moduleId});
  this.definitionsGrid = Ext.create({xtype:'grid', flex:3, moduleId:this.moduleId, header:false, title:'Zeitreihensuche', store:Ext.create('Ext.data.Store', {data:[]}), iconCls:webtsm.ConfigKeys.icons.search, columns:['ID', {dataIndex:'Name', flex:3}, 'Description', 'Type', 'Interval', 'Unit', 'Formula', 'Version'].map(function(c) {
    if (Ext.isString(c)) {
      return {dataIndex:c, text:c};
    } else {
      c.text = c.dataIndex.toUpperCase();
      return c;
    }
  })});
  this.items = [this.bucket, {xtype:'splitter'}, this.definitionsGrid];
  var application = webtsm.Support.getApiConfigKeybyInstanceId(this.moduleId);
  var bbar = [{xtype:'tbfill'}, {iconCls:webtsm.ConfigKeys.icons.download, text:'HAKOM-Stammdatenexport', disabled:false, exportUrl:undefined, handler:function(btn) {
    if (Ext.isDefined(btn.exportUrl)) {
      var exportData = this.hakomResponses.map(function(tsObj) {
        if ('id' in tsObj) {
          delete tsObj.id;
        }
        if (tsObj && 'Type' in tsObj && this.types) {
          if (tsObj.Type in this.types) {
            tsObj.resolvedType = this.types[tsObj.Type];
            if (tsObj.resolvedType && tsObj.resolvedType.toLowerCase() in this.legacyTypes) {
              tsObj.resolvedLegacyType = this.legacyTypes[tsObj.resolvedType.toLowerCase()];
            }
          }
        }
        if (tsObj && 'Interval' in tsObj && this.intervals) {
          if (tsObj.Interval && 'Value' in tsObj.Interval && tsObj.Interval.Value in this.intervals) {
            tsObj.resolvedInterval = this.intervals[tsObj.Interval.Value];
            if (tsObj.resolvedInterval && tsObj.resolvedInterval.toLowerCase() in this.legacyIntervals) {
              tsObj.resolvedLegacyInterval = this.legacyIntervals[tsObj.resolvedInterval.toLowerCase()];
              if ('Multiplier' in tsObj.Interval) {
                tsObj.resolvedLegacyIntervalLength = tsObj.Interval.Multiplier;
              }
            }
          }
        }
        return tsObj;
      });
      this.sendData(btn.exportUrl, {format:'hakom-masterdata', application:application, timeseries:exportData}).then(function(v) {
        v = webtsm.Support.getResponseObject(v);
        if (v) {
          webtsm.Files.downloadFile(v);
          return;
        }
        webtsm.Support.notify('Fehler beim Parsen der Antwort des Dateidownloads.');
      });
    } else {
      BpcCommon.Api.showNotification('Export nicht möglich. Bitte Konfiguration in der ClientInstanz prüfen.');
    }
  }.bind(this), initComponent:function() {
    var exportMain = this.up('webtsmExportMain');
    if (Ext.isDefined(exportMain) && 'moduleId' in exportMain && Ext.isDefined(exportMain.moduleId)) {
      var viewerModuleId = webtsm.Api.module.getViewerId(exportMain.moduleId);
      var enabled = BpcCommon.Api.getSetting(viewerModuleId, 'function_externalExportEnabled');
      if (enabled) {
        var backendConnectionId = BpcCommon.Api.getSetting(viewerModuleId, 'bpc_backendConnectionId');
        var path = BpcCommon.Api.getSetting(viewerModuleId, 'function_externalExportPath');
        if (Ext.isDefined(backendConnectionId) && Ext.isDefined(path) && backendConnectionId !== null && path != null) {
          var url = BpcCommon.Api.getBackendUrl(backendConnectionId) + path;
          Ext.log({dump:url, msg:'Send a POST to URL with Payload'});
          this.exportUrl = url;
        } else {
          Ext.log({dump:backendConnectionId, msg:'backendConnection ID maybe null'});
          Ext.log({dump:path, msg:'path maybe null'});
        }
      } else {
        this.disabled = true;
      }
    } else {
      this.disabled = true;
    }
    this.callParent(arguments);
  }}];
  if (Ext.isDefined(this.moduleId)) {
    var obj = BpcCommon.Api.getSetting(this.moduleId, 'manager_customExports');
    if ('enabled' in obj && obj.enabled) {
      if ('exports' in obj && Ext.isArray(obj.exports)) {
        var disabled = true, exportUrl = undefined;
        var enabled = BpcCommon.Api.getSetting(this.moduleId, 'function_externalExportEnabled');
        if (Ext.isDefined(enabled) && enabled === true) {
          var backendConnectionId = BpcCommon.Api.getSetting(this.moduleId, 'bpc_backendConnectionId');
          var path = BpcCommon.Api.getSetting(this.moduleId, 'function_externalExportPath');
          if (Ext.isDefined(backendConnectionId) && Ext.isDefined(path) && backendConnectionId !== null && path != null) {
            exportUrl = BpcCommon.Api.getBackendUrl(backendConnectionId) + path;
            disabled = false;
          }
        }
        Ext.Array.each(obj.exports, function(exportBtnDef) {
          var idOnly = false;
          if ('idOnly' in exportBtnDef) {
            if (Ext.isDefined(exportBtnDef.idOnly) && exportBtnDef.idOnly) {
              idOnly = true;
            }
          }
          bbar.push({xtype:'button', text:exportBtnDef.text, iconCls:exportBtnDef.iconCls, format:exportBtnDef.format, disabled:disabled, idOnly:idOnly, exportUrl:exportUrl, handler:function(btn) {
            if (Ext.isDefined(btn.exportUrl)) {
              var requestObject = {format:btn.format};
              if (btn.idOnly === true) {
                var ids = this.hakomResponses.filter(function(tsObject) {
                  return 'ID' in tsObject;
                });
                ids = ids.map(function(item) {
                  return item.ID;
                });
                requestObject.ids = ids;
              }
              this.sendData(btn.exportUrl, requestObject);
            } else {
              BpcCommon.Api.showNotification('Export nicht möglich. Bitte Konfiguration in der ClientInstanz prüfen.');
            }
          }.bind(this)});
        }, this);
      }
    }
  }
  this.bbar = bbar;
  this.callParent(arguments);
  this.bucketStore.on({datachanged:function(s) {
    if (!$jscomp$this.destroyed) {
      $jscomp$this.loadTsMeta();
    }
  }});
  Promise.all([webtsm.Api.getTypes(this.moduleId), webtsm.Api.getIntervals(this.moduleId)]).then(function(responses) {
    responses.map(function(r, i) {
      var key = i === 0 ? 'types' : 'intervals';
      $jscomp$this[key] = webtsm.Support.convertArrayToObject(webtsm.Support.getResponseObject(r));
    });
    $jscomp$this.loadTsMeta();
  });
}, sendData:function(url, requestObject) {
  var $jscomp$this = this;
  return new Ext.Promise(function(resolve, reject) {
    webtsm.Api.getCreateRequestPromise(url, requestObject).then(function(value) {
      var w = $jscomp$this.up('window');
      if (Ext.isDefined(w)) {
        w.close();
      }
      resolve(value);
    }, function(reason) {
      BpcCommon.Api.showNotification('Fehler beim Download.');
    });
  });
}});
Ext.define('webtsm.view.manager.Main', {extend:'Ext.container.Container', alias:'widget.tsmManager', requires:['webtsm.Support'], mixins:['webtsm.mixins.Component'], layout:'fit', moduleId:undefined, webtsmStateId:'webtsmMainManagerView', initComponent:function() {
  var $jscomp$this = this;
  this.applicationToolbarRight = Ext.create({xtype:'toolbar', hidden:true, layout:{pack:'end'}, defaults:{moduleId:this.moduleId, instanceId:this.moduleId, moduleInstance:this, disabled:true}, items:[{xtype:'webtsmViewsToolbarItem'}]});
  this.callParent(arguments);
  this.bpcModuleHeader = Ext.createByAlias('widget.webtsmModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
  this.bpcModuleHeader.applyApiConfig().then(function(success) {
    if (success) {
      return $jscomp$this.loadManagerCmp();
    }
  })["catch"](function(e) {
    var cmp = webtsm.shared.PsCommon.getErrorPanel(webtsm.Support.TR('REQUEST_ERROR'), webtsm.shared.PsCommon.errorResponseToStoreData(e));
    cmp.setWidth('70%');
    cmp.setHeight('40%');
    $jscomp$this.bpcModuleHeader.disableElements();
    $jscomp$this.add({xtype:'panel', header:false, layout:'center', items:[cmp]});
  });
}, loadManagerCmp:function() {
  var $jscomp$this = this;
  return webtsm.Support.loadLibraries().then(function() {
    return webtsm.Support.preloadPluginModules($jscomp$this.moduleId);
  }).then(function(success) {
    if (!success) {
      $jscomp$this.pluginLoadError = true;
    }
    return success;
  }).then(function() {
    $jscomp$this.removeAll();
    $jscomp$this.managerRoot = Ext.create({xtype:'webtsmManagerMain', moduleId:$jscomp$this.moduleId, moduleInstance:$jscomp$this});
    $jscomp$this.add($jscomp$this.managerRoot);
    $jscomp$this.applicationToolbarRight.items.each(function(btn) {
      return btn.enable();
    });
  }).then(function() {
    webtsm.Api.attributes.getTypes($jscomp$this.moduleId).then(function(value) {
      $jscomp$this.handleAttributeTypesCacheCallResponse(value);
      $jscomp$this.applyManagerState();
    }, function(reason) {
      $jscomp$this.handleAttributeTypesCacheCallResponse();
      $jscomp$this.applyManagerState();
    });
  });
}, applyManagerState:function() {
  if (this.moduleCfg && Ext.isObject(this.moduleCfg)) {
    var keysArray = Ext.Object.getKeys(this.moduleCfg);
    if (keysArray && keysArray.length > 0) {
      this.updateInstance(this.moduleCfg);
      return;
    } else {
      this.restoreManagerConfig();
    }
  }
  this.restoreManagerConfig();
  this.managerRoot.bucketStore.stateRestored = true;
}, pluginLoadError:false, handleAttributeTypesCacheCallResponse:function(value) {
  value = value || null;
  webtsm.Api.tempStore[this.moduleId] = {'attributeTypes':value};
}, updateInstance:function(configObject) {
  if (configObject && Ext.isObject(configObject) && configObject.bucket && Ext.isArray(configObject.bucket) && configObject.bucket.length) {
    webtsm.Support.bpc.removeReplaceStateFromUrl();
    var actions = {definitions:'tsmDefinitionsOverview', attributes:'webtsmAttributesOverview', values:'webtsmEditorMain'};
    if (configObject.action) {
      if (configObject.action === 'search') {
        this.managerRoot.changeSearch(configObject.bucket);
        this.managerRoot.bucketStore.stateRestored = true;
        return;
      }
      if (configObject.action in actions) {
        this.managerRoot.openTsmComponent(configObject, actions);
        this.managerRoot.bucketStore.stateRestored = true;
        return;
      }
    }
  }
}, getWebTsmStateKey:function(name, cmp) {
  if (!cmp) {
    cmp = this;
  }
  if (!name) {
    if ('webtsmStateId' in cmp && cmp.webtsmStateId) {
      name = cmp.webtsmStateId;
    }
  }
  if (name) {
    var keys = [];
    keys.push(name);
    keys.push(cmp.moduleId);
    return keys.join('-');
  }
  return null;
}, getManagerConfig:function() {
  var stateObj = this.getState();
  if (stateObj) {
    if (stateObj.tabConfig) {
      var tab = this.down('#' + stateObj.tabConfig);
      if (tab && 'webtsmLastTabItemId' in tab && tab.webtsmLastTabItemId) {
        stateObj.subTab = tab.webtsmLastTabItemId;
      }
    }
    this.persistConfig(stateObj);
  }
}, restoreManagerConfig:function() {
  var selectedKey = window.localStorage.getItem(this.getWebTsmStateKey());
  if (selectedKey) {
    var stateObj = JSON.parse(selectedKey);
    if (stateObj && Ext.isObject(stateObj)) {
      if ('tabConfig' in stateObj && stateObj.tabConfig) {
        var webtsmMain = this.down('#webtsmTabMain');
        var activeTab = webtsmMain.down('#' + stateObj.tabConfig);
        if (activeTab) {
          if ('subTab' in stateObj && stateObj.subTab) {
            var subTab = activeTab.down('#' + stateObj.subTab);
            if (subTab) {
              activeTab.setActiveTab(subTab);
            }
          }
          webtsmMain.setActiveTab(activeTab);
        }
      }
      if ('search' in stateObj && stateObj.search) {
        this.writeState({state:stateObj.search});
      }
      if (stateObj.bucket) {
        var manager = this.down('webtsmManagerMain');
        if (manager && manager.bucketStore) {
          stateObj.bucket.map(function(item) {
            if (manager.bucketStore.find('ID', item.ID) === -1) {
              manager.bucketStore.add(item);
            }
          });
          manager.bucketStore.stateRestored = true;
        }
      }
      webtsm.Support.bpc.removeReplaceStateFromUrl();
    }
  }
}, persistConfig:function(stateObj) {
  if (stateObj) {
    var stateObjString = stateObj;
    if (Ext.isObject(stateObj) || Ext.isArray(stateObj)) {
      webtsm.Support.bpc.removeReplaceStateFromUrl(stateObj);
      stateObjString = JSON.stringify(stateObj);
    }
    window.localStorage.setItem(this.getWebTsmStateKey(), stateObjString);
  }
}, getState:function() {
  var stateObj = {search:undefined, tabConfig:undefined, bucket:[]};
  var grid = this.down('webtsmSearchGrid');
  if (grid) {
    stateObj.search = grid.getState();
  }
  var manager = this.down('webtsmManagerMain');
  if (manager && manager.bucketStore) {
    stateObj.bucket = manager.bucketStore.getDataAsArray();
  }
  var webtsmMain = this.down('#webtsmTabMain');
  if (webtsmMain) {
    if (webtsmMain.webtsmLastTabItemId) {
      stateObj.tabConfig = webtsmMain.webtsmLastTabItemId;
    }
  }
  return stateObj;
}, writeState:function(stateObj) {
  webtsm.Support.bpc.removeReplaceStateFromUrl();
  if ('state' in stateObj && Ext.isDefined(stateObj.state)) {
    var grid = this.down('webtsmSearchGrid');
    if (grid) {
      grid.writeState(stateObj.state);
    }
  }
}});
Ext.define('webtsm.view.manager.MetaData', {extend:'Ext.panel.Panel', alias:'widget.webtsmMetaPanel', requires:['webtsm.ConfigKeys', 'webtsm.mixins.Component'], mixins:['webtsm.mixins.Component'], moduleId:undefined, layout:'fit', moduleInstance:undefined, tempStore:[], flags:undefined, searchExclusive:false, respectUiConfig:false, hiddenTabs:[], hideEdit:undefined, cmpWideBucket:undefined, getSettingModel:function(settingName, moduleId) {
  moduleId = moduleId || this.moduleId;
  return BpcCommon.Api.getSetting(moduleId, settingName, true);
}, saveSettingModel:function(m, saveParams) {
  saveParams = saveParams || {failure:function(record, operation) {
  }, success:function(record, operation) {
  }, callback:function() {
  }};
  m.save(saveParams);
}, openedInViewer:false, initComponent:function() {
  var $jscomp$this = this;
  this.hideEdit = this.openedInViewer === true;
  this.readOnly = this.openedInViewer === true;
  this.iconCls = webtsm.Support.icon('fa-cog');
  this.extraButtonsToolbar = Ext.create({xtype:'toolbar', padding:'5 5 5 5', defaults:{margin:'2 2 2 2'}, hidden:true});
  var metaDefinitions = [{textKey:'ATTRIBUTE', iconCls:'fa-archive', request:{path:'attributes', withApplication:true}}, {textKey:'ATTRIBUTETYPES', iconCls:'fa-archive', request:{path:'attributetypes'}}, {textKey:'UNITS', iconCls:'fa-eye', request:{path:'units', withApplication:true}}, {textKey:'INTERVALS', iconCls:'fa-arrow-to-right', request:{path:'intervals'}}, {textKey:'AGGREGATIONEN', iconCls:'fa-compress', request:{path:'aggregations'}}, {textKey:'FLAGS', iconCls:'fa-flag', request:{path:'flags'}}, 
  {textKey:'TYPES', iconCls:'fa-dot-circle', request:{path:'types'}}, {textKey:'TIMEZONES', iconCls:'fa-dot-circle', request:{path:'timezones'}}, {textKey:'QUOTATIONDEFAULTBEHAVIORS', iconCls:'fa-dot-circle', request:{path:'quotationdefaultbehaviors'}}, {textKey:'VERSIONS', iconCls:'fa-code-branch', hidden:!BpcCommon.Api.getSetting(this.viewerId, 'extensions_versionEnabled'), request:{path:'/Extensions/Version/repositories/' + webtsm.Support.getApiConfigKeybyInstanceId(this.moduleId) + '/versions'}}];
  this.dockedItems = [{xtype:'container', dock:'top', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'toolbar', padding:'5 5 5 5', items:metaDefinitions.map(function(cfg) {
    var $jscomp$destructuring$var31 = cfg;
    var textKey = $jscomp$destructuring$var31.textKey;
    var iconCls = $jscomp$destructuring$var31.iconCls;
    var hidden = $jscomp$destructuring$var31.hidden;
    var request = $jscomp$destructuring$var31.request;
    return {text:$jscomp$this.TR(textKey), iconCls:$jscomp$this.faIcon(iconCls), request:request, hidden:hidden, handler:function(b) {
      $jscomp$this.refreshData(b.request);
    }};
  }).map(function(b) {
    b.scale = 'medium';
    b.ui = 'secondary';
    b.iconAlign = 'top';
    b.margin = '2 2 2 2';
    return b;
  })}, {xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[this.tsmMetaFilterField, this.extraButtonsToolbar]}]}];
  this.infoIconButton = Ext.create({xtype:'button', iconCls:webtsm.Support.getBpcIconCls('fa-database'), text:'', _key:'', updateTotal:function(val) {
    val = val === void 0 ? 0 : val;
    this.setText(val + ' ' + this._key);
  }});
  var getMetaStoreFilter = function(val) {
    val = val === void 0 ? '' : val;
    return function(record) {
      var obj = record.data || {};
      var matches = Object.keys(obj).filter(function(k) {
        var value = String(obj[k]) || '';
        return value.toLowerCase().includes(val.toLowerCase());
      });
      return matches.length > 0;
    };
  };
  this.tsmMetaFilterField = Ext.create({xtype:'textfield', triggers:{resetField:{cls:webtsm.ConfigKeys.icons.remove, hidden:true, handler:function() {
    this.setValue('');
  }}}, flex:1, emptyText:webtsm.Support.getTranslation('SEARCH'), listeners:{change:function(f, newVal, oldVal) {
    if (newVal && newVal.length > 0) {
      $jscomp$this.store.clearFilter();
      $jscomp$this.store.filterBy(getMetaStoreFilter(newVal));
      f.getTrigger('resetField').show();
    } else {
      $jscomp$this.store.clearFilter();
      f.getTrigger('resetField').hide();
    }
    $jscomp$this.infoIconButton.updateTotal($jscomp$this.store.getCount());
  }}});
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.title = this.TR('MANAGER_PANEL_METADATA');
  this.grid = Ext.create({xtype:'grid', viewConfig:{enableTextSelection:true}, header:false, iconCls:webtsm.ConfigKeys.icons.settings, store:this.store, columns:[{dataIndex:'noData', text:'Keine Daten', flex:1}], bbar:[this.infoIconButton, {xtype:'tbfill'}, {iconCls:this.faIcon('fa-sync'), ui:'secondary', text:this.TR('REFRESH'), handler:function() {
    $jscomp$this.refreshData();
  }}]});
  this.items = [this.grid];
  this.callParent(arguments);
}, lastRequest:undefined, refreshData:function(request) {
  if (request) {
    this.lastRequest = request;
  } else if (this.lastRequest) {
    request = this.lastRequest;
  } else {
    return;
  }
  this.loadDataByRequest(request);
}, loadDataByRequest:function(request) {
  var $jscomp$destructuring$var32 = request || {};
  var path = $jscomp$destructuring$var32.path;
  var withApplication = $jscomp$destructuring$var32.withApplication;
  this.lastRequest = request;
  this.updateDateDefinitionsGrid('/' + path, 'GET', withApplication);
}, getAction:function(key) {
  var $jscomp$this = this;
  var actions = {units:{extraButtons:[{xtype:'button', iconCls:webtsm.ConfigKeys.icons.plus, tooltip:this.TR('WEBTSM_UNIT_ADD'), handler:function(btn) {
    var w = webtsm.Support.openWindow(webtsm.Support.getTranslation('ATTRIBUTE_CREATE'), webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.plus), undefined, undefined, 'webtsmUnitPanel', {moduleId:$jscomp$this.moduleId, header:false, _grid:$jscomp$this.grid});
  }}], additionalColumns:[{dataIndex:'Name', text:'LEISTUNGSARTIGE EINHEIT', width:120, renderer:function(value) {
    var unitNamesArray = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'units_powerLike');
    if (unitNamesArray && unitNamesArray.length > 0 && unitNamesArray.indexOf(value) !== -1) {
      return 'x';
    }
    return '';
  }}], actionColumns:[{iconCls:this.faIcon('fa-edit'), tooltip:this.TR('WEBTSM_POWER_LIKE_UNIT'), handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var idForInterval = rec.get('Name');
    var defaultIntervalModel = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'units_powerLike', true);
    var existingUnits = defaultIntervalModel['data']['value'];
    if (existingUnits && Ext.isArray(existingUnits)) {
      if (existingUnits.indexOf(idForInterval) === -1) {
        existingUnits.push(idForInterval);
      } else {
        existingUnits = Ext.Array.remove(existingUnits, idForInterval);
      }
    } else {
      existingUnits = [idForInterval];
    }
    defaultIntervalModel['data']['value'] = existingUnits;
    $jscomp$this.saveSettingModel(defaultIntervalModel);
  }}, {iconCls:this.faIcon('fa-times'), handler:function(tableView, rowIndex) {
    var cfg = webtsm.Api.getBaseRequestCfg($jscomp$this.moduleId, 'DELETE', true);
    var rec = tableView.getStore().getAt(rowIndex);
    cfg.url += '/units/' + rec.get('ID');
    return webtsm.Api.sendRequest(cfg).then(function(r) {
      r = r || {};
      return webtsm.Support.getResponseObject(r);
    });
  }}], renderer:{}}, attributetypes:{actionColumns:[{isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    var value = record.get('ID');
    item.iconCls = $jscomp$this.faIcon('fa-eye-slash');
    item.tooltip = $jscomp$this.TR('WEBTSM_ATTRIBUTE_EXCLUDE_FROM_SEARCH_TODO');
    if (Ext.isDefined(value)) {
      var customSettings = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'search_customSettings');
      if (Ext.isDefined(customSettings) && customSettings != null && Ext.isObject(customSettings)) {
        if ('searchExcluded' in customSettings && 'attributeTypes' in customSettings['searchExcluded']) {
          var array = customSettings['searchExcluded']['attributeTypes'];
          if (Ext.Array.indexOf(array, value) === -1) {
            item.iconCls = $jscomp$this.faIcon('fa-eye');
            item.tooltip = $jscomp$this.TR('WEBTSM_ATTRIBUTE_EXCLUDE_FROM_SEARCH');
            return false;
          }
        }
      }
    }
    return false;
  }, handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var id = rec.get('ID');
    var setting = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'search_customSettings', true);
    var customSettings = setting.get('value');
    if ('searchExcluded' in customSettings && 'attributeTypes' in customSettings['searchExcluded']) {
      var array = customSettings['searchExcluded']['attributeTypes'];
      if (Ext.Array.indexOf(array, id) === -1) {
        array.push(id);
      } else {
        array = Ext.Array.remove(array, id);
      }
      customSettings['searchExcluded']['attributeTypes'] = array;
      setting.set('value', customSettings);
      $jscomp$this.saveSettingModel(setting);
    }
  }}]}, intervals:{actionColumns:[{iconCls:webtsm.ConfigKeys.icons.edit, tooltip:webtsm.Support.getTranslation('WEBTSM_INTERVALS_SET_STANDARD_FOR_VIEWER'), handler:function(tableView, rowIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var defaultIntervalModel = BpcCommon.Api.getSetting($jscomp$this.viewerId, 'default_interval', true);
    defaultIntervalModel.set('value', rec.get('ID'));
    $jscomp$this.saveSettingModel(defaultIntervalModel);
  }}], additionalColumns:[{dataIndex:'webtsmDisplayName', text:'webtsmDisplayName'}, {dataIndex:'ID', text:this.TR('WEBTSM_INTERVALS_VIEWER_DEFAULT'), width:250, renderer:function(value) {
    var viewerDefault = BpcCommon.Api.getSetting($jscomp$this.viewerId, 'default_interval');
    if (Ext.isDefined(viewerDefault) && Ext.isDefined(value) && viewerDefault === value) {
      return ' x ';
    }
    return '';
  }}, {dataIndex:'Name', text:'Legacy Intervals', width:250, renderer:function(value) {
    value = value || '';
    return webtsm.Support.legacy.legacyIntervals[value.toLowerCase()] || '';
  }}]}, types:{additionalColumns:[{dataIndex:'Name', text:'Legacy Types', width:250, renderer:function(value) {
    value = value || '';
    return webtsm.Support.legacy.legacyTypes[value.toLowerCase()] || '';
  }}]}, flags:{renderer:{color:function(v, m, r) {
    var color = webtsm.Support.getFlagColor(r.get('ID'), undefined, $jscomp$this.viewerId);
    if (color) {
      m.tdAttr = 'bgcolor\x3d"' + color + '"';
    }
    return '';
  }, background:function(v, m, r) {
    var color = webtsm.Support.getFlagColor(r.get('ID'), 'bgColor', $jscomp$this.viewerId);
    if (color) {
      m.tdAttr = 'bgcolor\x3d"' + color + '"';
    }
    return '';
  }}, additionalColumns:[{dataIndex:'ID', text:'DEFAULT', width:120, renderer:function(value) {
    var defaultsSetting = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'flags_defaultEditing');
    return value === defaultsSetting ? 'x' : '';
  }}, {dataIndex:'color', text:webtsm.Support.getTranslation('COLOR'), width:250}, {dataIndex:'background', text:webtsm.Support.getTranslation('BACKGROUND'), width:250}], actionColumns:[{iconCls:this.faIcon('fa-map-marker'), tooltip:'Als Standard-Flag wählen', handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var defaultIntervalModel = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'flags_defaultEditing', true);
    defaultIntervalModel.set('value', rec.get('ID'));
    $jscomp$this.saveSettingModel(defaultIntervalModel);
  }}, {iconCls:this.faIcon('fa-edit'), tooltip:this.TR('EDIT'), handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var moduleId = $jscomp$this.viewerId;
    var flagId = rec.get('ID');
    Ext.create('Ext.window.Window', {title:webtsm.Support.getTranslation('SET_COLOR_FOR_FLAG') + ': ' + flagId, layout:'fit', width:800, height:600, defaults:{moduleId:$jscomp$this.moduleId}, moduleId:$jscomp$this.moduleId, flagId:flagId, items:{xtype:'panel', layout:{type:'hbox', align:'strech'}, defaults:{flex:1, moduleId:$jscomp$this.moduleId, xtype:'container', layout:{type:'vbox', align:'stretch'}}, items:[{items:[{html:'\x3ch3\x3e' + webtsm.Support.getTranslation('COLOR') + '\x3ch3\x3e'}, {xtype:'colorpicker', 
    listeners:{select:function(picker, selColor) {
      var tf = picker.up('container').down('textfield');
      tf.setValue(selColor);
    }}}, {xtype:'textfield', itemId:'color'}]}, {items:[{html:'\x3ch3\x3e' + webtsm.Support.getTranslation('BACKGROUND') + '\x3ch3\x3e'}, {xtype:'colorpicker', listeners:{select:function(picker, selColor) {
      var tf = picker.up('container').down('textfield');
      tf.setValue(selColor);
    }}}, {xtype:'textfield', itemId:'bgColor'}]}]}, bbar:[{xtype:'tbfill'}, {xtype:'button', iconCls:$jscomp$this.faIcon('fa-save'), handler:function(btn) {
      var win = btn.up('window');
      var customSettingsModel = BpcCommon.Api.getSetting(moduleId, 'custom_settings', true);
      var o = customSettingsModel.getData();
      var flags = {};
      if ('flags' in o['value']) {
        flags = o['value']['flags'];
        if (flags === null) {
          flags = {};
        }
      } else {
        o['value'].flags = {};
      }
      var fields = win.query('textfield');
      var color = null, bgColor = null;
      if (fields.length > 0) {
        Ext.Array.each(fields, function(field) {
          if (field.itemId === 'color') {
            color = '#' + field.getValue();
          }
          if (field.itemId === 'bgColor') {
            bgColor = '#' + field.getValue();
          }
        });
      }
      if (win.flagId in flags) {
        if (color != null) {
          flags[win.flagId]['color'] = color;
        }
        if (bgColor != null) {
          flags[win.flagId]['bgColor'] = bgColor;
        }
      } else {
        flags[win.flagId] = {};
        if (color != null) {
          flags[win.flagId]['color'] = color;
        }
        if (bgColor != null) {
          flags[win.flagId]['bgColor'] = bgColor;
        }
      }
      customSettingsModel['data']['value']['flags'] = flags;
      customSettingsModel.save({failure:function(record, operation) {
        webtsm.Support.notify(webtsm.Support.getTranslation('WEBTSM_CO_WERE_NOT_UPDATED'));
      }, success:function(record, operation) {
        webtsm.Support.notify(webtsm.Support.getTranslation('WEBTSM_CO_WERE_UPDATED'));
        win.destroy();
      }});
    }}]}).show();
  }}]}, attributes:{extraButtons:[{xtype:'button', iconCls:this.faIcon(webtsm.Support.keys.icons.plus), text:this.TR('ATTRIBUTE_CREATE'), attributesPanel:undefined, ui:'primary', handler:function(btn) {
    $jscomp$this.openWindow($jscomp$this.TR('ATTRIBUTE_CREATE'), $jscomp$this.faIcon(webtsm.Support.keys.icons.plus), undefined, null, 'webtsmAttributeTypeContainer', {moduleId:$jscomp$this.moduleId, header:false, _grid:$jscomp$this.grid, metaPanel:$jscomp$this}, undefined, {modal:true});
  }}], actionColumns:[{iconCls:this.faIcon('fa-eye-slash'), tooltip:this.TR('WEBTSM_ATTRIBUTE_EXCLUDE_FROM_SEARCH'), handler:function(tableView, rowIndex, colIndex, item, event, r) {
    var id = r.get('ID');
    var setting = $jscomp$this.getSettingModel('search_customSettings');
    var customSettings = setting.get('value');
    if ('searchExcluded' in customSettings && 'attributes' in customSettings['searchExcluded']) {
      var array = customSettings['searchExcluded']['attributes'];
      if (Ext.Array.indexOf(array, id) === -1) {
        array.push(id);
      } else {
        array = Ext.Array.remove(array, id);
      }
      customSettings['searchExcluded']['attributes'] = array;
      setting.set('value', customSettings);
      $jscomp$this.saveSettingModel(setting);
    }
  }}, {iconCls:webtsm.ConfigKeys.icons["delete"], tooltip:this.TR('WEBTSM_DELETE'), handler:function(tableView, rowIndex, colIndex, item, event, r) {
    webtsm.Api.attributes["delete"]($jscomp$this.moduleId, r.get('ID')).then(function(response) {
      response = response || {};
      var $jscomp$destructuring$var33 = response;
      var status = $jscomp$destructuring$var33.status;
      var title = $jscomp$this.TR('DELETING_ATTRIBUTE'), message = $jscomp$this.TR((status === 204 ? 'WAS_SUCCESSFUL' : 'WAS_NOT_SUCCESSFUL') + (status === 204 ? '' : '(' + 'status' + ')').trim() + '.');
      $jscomp$this.doLog(title, message, undefined, $jscomp$this.grid);
      $jscomp$this.refreshData();
    }, function() {
      $jscomp$this.doLog($jscomp$this.TR('ERROR'), $jscomp$this.TR('WEBTSM_ERROR_WHILE_DELETING_ATTRIBUTE'), undefined, $jscomp$this.grid);
    });
  }}], renderer:{Type:function(value, metaData, record) {
    if ($jscomp$this.moduleId in webtsm.Api.tempStore) {
      var arrayOrNull = webtsm.Api.tempStore[$jscomp$this.moduleId]['attributeTypes'];
      if (Ext.isArray(arrayOrNull)) {
        var match = arrayOrNull.filter(function(i) {
          return i.ID === value;
        });
        return match.length ? match[0].Name + ' ' + '(' + value + ')' : value;
      }
    }
    return value;
  }}}};
  return actions;
}, updateDateDefinitionsGrid:function(path, method, withApplication) {
  var $jscomp$this = this;
  method = method === void 0 ? 'GET' : method;
  withApplication = withApplication === void 0 ? false : withApplication;
  this.grid.setLoading(true);
  this.store.clearFilter();
  this.extraButtonsToolbar.setVisible(false);
  this.store.removeAll();
  this.extraButtonsToolbar.removeAll();
  this.tsmMetaFilterField.setValue(undefined);
  webtsm.Api.getRequestData(this.moduleId, path, method, withApplication).then(function(data) {
    var columns = [];
    var key = path.replace('/', '').trim();
    if (key.startsWith('Extensions')) {
      data = data || [];
      data = data.map(function(name) {
        return {ID:name, Name:name};
      });
    }
    var actions = $jscomp$this.getAction();
    if (data && data.length) {
      columns = Object.keys(data[0]).map(function(name) {
        var col = {dataIndex:name, text:name.toUpperCase()};
        if (name === 'ID') {
          col.width = 120;
        } else {
          col.flex = 1;
        }
        if (actions[key] && actions[key].renderer && actions[key].renderer[name]) {
          col.renderer = actions[key].renderer[name];
        }
        return col;
      });
      if (actions[key] && actions[key].additionalColumns) {
        var additionalColumns = actions[key].additionalColumns;
        additionalColumns = additionalColumns.map(function(c) {
          if (actions[key] && actions[key].renderer && actions[key].renderer[c.dataIndex]) {
            c.renderer = actions[key].renderer[c.dataIndex];
          }
          return c;
        });
        columns = columns.concat(additionalColumns);
      }
      if (actions[key] && actions[key].actionColumns) {
        var items = actions[key].actionColumns;
        columns = columns.concat([{xtype:'actioncolumn', width:items.length * 35, items:items}]);
      }
    }
    if (actions[key] && actions[key].extraButtons) {
      $jscomp$this.extraButtonsToolbar.setVisible(true);
      $jscomp$this.extraButtonsToolbar.add(actions[key].extraButtons);
    }
    $jscomp$this.store.add(data);
    $jscomp$this.grid.reconfigure($jscomp$this.store, columns);
    $jscomp$this.grid.setLoading(false);
    $jscomp$this.infoIconButton._key = key;
    $jscomp$this.infoIconButton.updateTotal(data.length);
  });
}, attributeList:[], getNameById:function(attributeId) {
  var match = this.attributeList.filter(function(attributeObj) {
    return attributeObj.ID === attributeId;
  });
  return match.length ? match[0].Name : undefined;
}});
Ext.define('webtsm.view.manager.TsManager', {extend:'Ext.container.Container', alias:'widget.webtsmManagerMain', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], moduleId:undefined, layout:'fit', moduleInstance:undefined, tempStore:[], flags:undefined, searchExclusive:false, respectUiConfig:false, hiddenTabs:[], hideEdit:undefined, cmpWideBucket:undefined, hideTab:function(tabName) {
  return tabName ? this.hiddenTabs.indexOf(tabName) !== -1 : false;
}, getSettingModel:function(settingName, moduleId) {
  moduleId = moduleId || this.moduleId;
  return BpcCommon.Api.getSetting(moduleId, settingName, true);
}, saveSettingModel:function(m, saveParams) {
  saveParams = saveParams || {failure:function(record, operation) {
  }, success:function(record, operation) {
  }, callback:function() {
  }};
  m.save(saveParams);
}, openedInViewer:false, initComponent:function() {
  var $jscomp$this = this;
  this.hideEdit = this.openedInViewer === true;
  this.readOnly = this.openedInViewer === true;
  this.bucketStore = Ext.create('Ext.data.Store', {fields:['ID', 'Name'], data:[], stateRestored:false, listeners:{datachanged:function(s) {
    if (s.stateRestored) {
      $jscomp$this.storeBpcState();
    }
  }}, getDataAsArray:function() {
    var array = [];
    this.each(function(r) {
      var $jscomp$destructuring$var34 = r.getData() || {};
      var ID = $jscomp$destructuring$var34.ID;
      var Name = $jscomp$destructuring$var34.Name;
      var Version = $jscomp$destructuring$var34.Version;
      array.push({ID:ID, Name:Name, Version:Version});
    });
    return array;
  }});
  webtsm.Api.getFlags(this.moduleId).then(function(value) {
    $jscomp$this.flags = Ext.isArray(value) ? value : [];
  }, function(reason) {
  });
  var uiConfig = BpcCommon.Api.getSetting(this.moduleId, 'configuration') || {};
  var $jscomp$destructuring$var35 = uiConfig;
  var hiddenTabs = $jscomp$destructuring$var35.hiddenTabs;
  if (hiddenTabs && Ext.isArray(hiddenTabs)) {
    this.hiddenTabs = hiddenTabs;
  }
  if (!Ext.isDefined(this.hideEdit)) {
    this.hideEdit = !webtsm.Support.canEdit();
  }
  this.searchOverview = Ext.create({xtype:'webtsmSearchOverview', moduleId:this.moduleId, readOnly:!webtsm.Support.canEdit(), moduleInstance:this.moduleInstance, managerRoot:this, managerMain:this, hidden:this.hideTab('search')});
  this.editTimeseriesSingle = Ext.create({xtype:'tsmDefinitionsOverview', header:false, itemId:'masterEditData', moduleId:this.moduleId, moduleInstance:this.moduleInstance, managerMain:this});
  this.editAttributes = Ext.create({xtype:'webtsmAttributesOverview', itemId:'attributeEditData', header:false, moduleId:this.moduleId, moduleInstance:this.moduleInstance, managerMain:this});
  this.createTimeseries = Ext.create({xtype:'webtsmTsCreateGrid', moduleId:this.moduleId, itemId:'tsCreatePanel', title:webtsm.Support.getTranslation('WEBTSM_CREATE_SINGLE_TS', undefined, true), iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.addToBucket), managerMain:this});
  this.editTimeseriesValues = Ext.create({xtype:'webtsmEditorMain', header:false, itemId:'tsEditorData', moduleId:this.moduleId, moduleInstance:this, managerMain:this});
  this.displayBox = Ext.create({xtype:'container'});
  this.createAndEditPanel = Ext.create({xtype:'panel', hidden:this.hideEdit === true, iconCls:webtsm.ConfigKeys.icons.edit, title:this.TR('MANAGER_PANEL_CREATEANDEDIT'), dockedItems:[{xtype:'container', dock:'top', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'toolbar', padding:'5 5 5 5', items:[{iconCls:this.faIcon('fa-wrench'), text:webtsm.Support.getTranslation('CHANGE_MASTERDATA', undefined, true), linkedCardView:this.editTimeseriesSingle}, {iconCls:this.faIcon('fa-archive'), text:webtsm.Support.getTranslation('CHANGE_ATTRIBUTES', 
  undefined, true), linkedCardView:this.editAttributes}, {text:webtsm.Support.getTranslation('WEBTSM_CREATE_SINGLE_TS', undefined, true), iconCls:this.faIcon(webtsm.Support.keys.icons.addToBucket), linkedCardView:this.createTimeseries}, {iconCls:webtsm.ConfigKeys.icons.edit, text:webtsm.Support.getTranslation('EDIT_VALUES', undefined, true), linkedCardView:this.editTimeseriesValues}].map(function(b) {
    b.scale = 'medium';
    b.iconAlign = 'top';
    b.margin = '2 2 2 2';
    b.ui = 'secondary';
    b.handler = $jscomp$this._changeActiveItem.bind($jscomp$this);
    return b;
  }).concat([this.displayBox])}]}], layout:'card'});
  this.setSubMain(this.editTimeseriesSingle);
  this.viewerId = webtsm.Api.module.getViewerId(this.moduleId);
  var cards = [this.searchOverview, this.createAndEditPanel, this.metaPanel];
  if (!this.hideTab('meta')) {
    this.metaPanel = Ext.create({xtype:'webtsmMetaPanel', moduleId:this.moduleId, viewerId:this.viewerId});
    cards.push(this.metaPanel);
  }
  if (!this.hideTab('history')) {
    this.timeseriesHistoryGrid = Ext.create({xtype:'webtsmReporting', moduleId:this.moduleId, viewerId:this.viewerId});
    cards.push(this.timeseriesHistoryGrid);
  }
  this.tabPanel = Ext.create({xtype:'tabpanel', triggerPersist:function() {
    $jscomp$this.moduleInstance.getManagerConfig();
  }, listeners:{tabchange:function(tabPanel, newTab, oldTab) {
    if (newTab) {
      var itemId = newTab.getItemId();
      if (itemId) {
        tabPanel.webtsmLastTabItemId = itemId;
        $jscomp$this.storeBpcState();
      }
    }
    return null;
  }}, itemId:'webtsmTabMain', items:cards});
  this.items = [this.tabPanel];
  this.callParent(arguments);
}, _changeActiveItem:function(btnSrc) {
  this.displayBox.update('\x3ch3\x3e' + btnSrc.text + '\x3c/h3\x3e');
  this.setSubMain(btnSrc.linkedCardView);
}, storeBpcState:function() {
  if (!this.openedInViewer) {
    this.moduleInstance.getManagerConfig();
  }
}, attributeList:[], getNameById:function(attributeId) {
  var match = this.attributeList.filter(function(attributeObj) {
    return attributeObj.ID === attributeId;
  });
  return match.length ? match[0].Name : undefined;
}, checkAndCorrectBucket:function(bucket) {
  var $jscomp$this = this;
  bucket = bucket === void 0 ? [] : bucket;
  return Ext.Promise.all(bucket.map(function(item) {
    return webtsm.Api.timeseries.getMeta($jscomp$this.moduleId, item && item.ID ? item.ID : item.Name);
  })).then(function(array) {
    return array.map(function(metaData, index) {
      return {ID:metaData && Ext.isObject(metaData) ? metaData.ID : 'No ID found', Name:metaData && Ext.isObject(metaData) ? metaData.Name : 'No Name found', Version:bucket[index].Version};
    });
  });
}, openTsmComponent:function(stateObject, actions) {
  var $jscomp$this = this;
  stateObject = stateObject === void 0 ? {} : stateObject;
  if (!this.hideEdit) {
    if (!actions) {
      actions = {definitions:this.editTimeseriesSingle, attributes:this.editAttributes, values:this.editTimeseriesValues};
    }
    var bucket = Ext.isObject(stateObject) && stateObject.bucket ? stateObject.bucket : Ext.isArray(stateObject) ? stateObject : [];
    if (bucket.length) {
      this.checkAndCorrectBucket(bucket).then(function(correctBucket) {
        $jscomp$this.bucketStore.add(correctBucket);
      });
    }
    var cmpToShow = actions[stateObject.action];
    if (!cmpToShow) {
      return;
    } else {
      this.setSubMain(cmpToShow);
      this.setMainTab(this.createAndEditPanel);
    }
  }
}, changeSearch:function(payload) {
  this.setMainTab(this.searchOverview);
  this.searchOverview.searchGrid.loadIdsFromBucket(payload);
}, setMainTab:function(cmp) {
  this.tabPanel.setActiveTab(cmp);
}, setSubMain:function(cmp) {
  this.createAndEditPanel.getLayout().setActiveItem(cmp);
}});
Ext.define('webtsm.view.manager.reporting.Reporting', {extend:'Ext.grid.Panel', alias:'widget.webtsmReporting', mixins:['webtsm.mixins.Component'], initComponent:function() {
  var $jscomp$this = this;
  var historyStore = Ext.create('Ext.data.Store', {data:[]});
  var ranges = Ext.create('Ext.data.Store', {data:[{key:'DAY', value:Ext.Date.DAY}, {key:'HOUR', value:Ext.Date.HOUR}]});
  this.iconCls = this.faIcon('history');
  this.title = this.TR('REPORTING');
  var fields = ['ID', 'Name', 'Type', 'Interval', 'Unit', 'Table'];
  this.enableBaseButtons();
  this._addDocked([this._fill(), {xtype:'fieldcontainer', fieldLabel:this.TR('OPTIONS'), defaultType:'radiofield', defaults:{flex:1}, layout:'hbox', items:[{boxLabel:this.TR('CHANGED'), name:'changed', inputValue:'changed', value:true}, {boxLabel:this.TR('DELETED'), name:'changed', inputValue:'deleted'}]}, {xtype:'numberfield', fieldLabel:this.TR('CHANGES_SINCE'), labelWidth:150, value:7}, {xtype:'combo', fieldLabel:this.TR('CHANGED_SINCE_INTERVAL'), store:ranges, labelWidth:100, value:Ext.Date.DAY, 
  queryMode:'local', displayField:'key', valueField:'value'}, {text:this.TR('GENERATE_REPORT'), iconCls:this.faIcon('fa-list'), ui:'primary', itemId:'generateReport', handler:function(c) {
    c.setDisabled(true);
    var range = c.up('grid').down('combo').getValue();
    var intervalValue = c.up('grid').down('numberfield').getValue();
    var since = Ext.Date.subtract(new Date(), range, intervalValue);
    since = since.toISOString();
    var f = c.up('grid').query('radiofield').filter(function(r) {
      return r.getValue() === true;
    });
    f = f[0];
    $jscomp$this.setLoading();
    if (f.inputValue === 'changed') {
      var params = $jscomp$this.getUrlSearchParams({changedSince:since, includeMetaInfo:true, includeAttributes:true});
      fields.map(function(field) {
        params.append('field', field);
      });
      webtsm.Api.timeseries.getTimeseries($jscomp$this.moduleId, params).then(function(json) {
        $jscomp$this.updateGridData(json);
        $jscomp$this.setLoading(false);
        c.setDisabled(false);
      });
    } else {
      webtsm.Api.timeseries.getDeletedTimeseries($jscomp$this.moduleId, $jscomp$this.getUrlSearchParams({since:since})).then(function(json) {
        $jscomp$this.updateGridData(json);
        $jscomp$this.setLoading(false);
        c.setDisabled(false);
      });
    }
  }}, this._fill()], 'top');
  this.columns = fields.map(function(dataIndex) {
    var col = {dataIndex:dataIndex, text:$jscomp$this.TR('COL_' + dataIndex)};
    if (dataIndex === 'Name') {
      col.flex = 1;
    }
    if (dataIndex === 'Interval') {
      col.renderer = function(v, m, r) {
        var $jscomp$destructuring$var36 = v;
        var Multiplier = $jscomp$destructuring$var36.Multiplier;
        var Value = $jscomp$destructuring$var36.Value;
        return '' + Value + ' (Value) ' + Multiplier + ' Multiplier';
      };
    }
    col.style = webtsm.Support.getDefaultGridStyle();
    return col;
  });
  this.store = historyStore;
  this.refreshButton = this.createBaseButton('refresh', {handler:function(b) {
    var btn = b.up('grid').down('#generateReport');
    btn.handler(btn);
  }});
  this.infoIconButton = this.createBaseButton('total', {_key:'', updateTotal:function(val) {
    val = val === void 0 ? 0 : val;
    this.setText(val + ' ' + this._key);
  }});
  this.bbar = [this.infoIconButton, {xtype:'tbfill'}, this.refreshButton];
  this.callParent(arguments);
}, updateGridData:function(json) {
  json = json === void 0 ? [] : json;
  this.store.removeAll();
  this.infoIconButton.updateTotal(json.length);
  this.store.add(json);
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.search.contextmenu.SearchContextMenu', {extend:'Ext.menu.Menu', alias:'widget.webtsmSearchContextMenu', requires:['webtsm.ConfigKeys'], overview:undefined, showOpenDetailView:false, record:undefined, runWebtsmAction:function(actionName) {
  var managerMain = this.overview.searchGrid.up('webtsmManagerMain');
  if (managerMain) {
    managerMain.openTsmComponent({action:actionName, bucket:this.overview.searchGrid.getPayloadFromSelection()});
  }
}, initComponent:function() {
  var $jscomp$this = this;
  var disabled = Ext.isDefined(this.overview.readOnly) ? this.overview.readOnly : false;
  this.items = [{iconCls:webtsm.ConfigKeys.icons.window, text:'Detailfenster öffnen', handler:function() {
    $jscomp$this.overview.openDetailWindow($jscomp$this.record);
  }}, {iconCls:webtsm.ConfigKeys.icons.plus, text:'Bucket hinzufügen', handler:function() {
    $jscomp$this.overview.getController().addToBucket();
  }}, {iconCls:webtsm.Support.getBpcIconCls('fa-wrench'), text:'Stammdaten bearbeiten', hidden:this.overview.managerRoot.hideEdit, action:'definitions', handler:function(menuItem) {
    $jscomp$this.runWebtsmAction(menuItem.action);
  }}, {iconCls:webtsm.Support.getBpcIconCls('fa-archive'), text:'Attribute bearbeiten', hidden:this.overview.managerRoot.hideEdit, action:'attributes', handler:function(menuItem) {
    $jscomp$this.runWebtsmAction(menuItem.action);
  }}, {iconCls:webtsm.Support.getBpcIconCls('fa-archive'), text:'Zeitreihenwerte editieren', action:'values', hidden:this.overview.managerRoot.hideEdit, handler:function(menuItem) {
    $jscomp$this.runWebtsmAction(menuItem.action);
  }}, {xtype:'menuseparator', hidden:disabled}, {iconCls:webtsm.Support.getBpcIconCls('fa-external-link'), text:'Zeitreihen in Viewer öffnen', hidden:disabled, handler:function(menuItem) {
    BpcCommon.Api.showModule(webtsm.Api.module.getViewerId($jscomp$this.overview.managerRoot.moduleId), true, {'tsIds':$jscomp$this.overview.searchGrid.getSelection().map(function(m) {
      return m.get('ID');
    })});
  }}];
  this.callParent(arguments);
}});
Ext.define('webtsm.view.manager.search.SearchController', {extend:'Ext.app.ViewController', alias:'controller.webtsmSearchController', requires:['webtsm.Support'], control:{'* \x3e webtsmSearchGrid':{cellcontextmenu:'onContextMenu'}}, webtsmAttributeViewMode:undefined, attributeOrderArray:undefined, init:function() {
  var view = this.getView();
  view.searchGrid.store.on('prefetch', this.onLoad.bind(this));
  this.getAttributeSortOrder();
}, onLoad:function(store, records, successful, operation, eOpts) {
  this.addActiveFilter(undefined, true);
  var main = this.getView();
  main.loadHiddenAttributeTypes();
  this.handleEmptyText(successful, store.getTotalCount());
  if (successful) {
    var jsObject = webtsm.Support.getResponseObject(operation.getResponse());
    if (jsObject) {
      var $jscomp$destructuring$var37 = jsObject;
      var mode = $jscomp$destructuring$var37.mode;
      var detailErrors = $jscomp$destructuring$var37.detailErrors;
      var detailErrorDetails = $jscomp$destructuring$var37.detailErrorDetails;
      if (detailErrors) {
        this.searchRequestHasErrors = true;
        this.searchRequestError = detailErrorDetails;
      }
      main.errorButton.setVisible(detailErrors);
      main.errorButton.setDisabled(!detailErrors);
      this.webtsmAttributeViewMode = mode;
      this.handleError(jsObject);
      this.handleAggregations(jsObject, store);
    }
  }
}, searchRequestHasErrors:false, getAttributeSortOrder:function() {
  var order = undefined;
  var json = BpcCommon.Api.getSetting(this.getView().moduleId, 'search_customSettings');
  if (json && 'searchAttributeOrder' in json && Ext.isDefined(json.searchAttributeOrder) && Ext.isArray(json.searchAttributeOrder)) {
    order = json.searchAttributeOrder;
  }
  this.attributeOrderArray = order;
}, addToBucket:function() {
  var view = this.getView();
  var selection = view.searchGrid.getSelection();
  view.managerMain.bucketStore.add(selection.map(function(model) {
    return {ID:model.get('ID'), Name:model.get('Name'), AttributesCount:model.get('AttributesCount')};
  }));
}, onContextMenu:function(tableView, td, cellIndex, record, tr, rowIndex, e, eOpts) {
  e.preventDefault();
  Ext.createByAlias('widget.webtsmSearchContextMenu', {overview:this.getView(), showOpenDetailView:true, record:record}).showAt(e.getXY());
}, submitAttributeFilters:function(btn) {
  var view = this.getView();
  var container = view.down('#aggregatedAttributes');
  if ('attributeFilters' in container) {
    var filterObj = container.attributeFilters;
    view.searchGrid.updateStoreFilterSetNew(filterObj);
    if (view.moduleInstance) {
      view.moduleInstance.getManagerConfig();
    }
  }
}, removeAttributeFilters:function(btn) {
  var view = this.getView();
  view.query('datefield').map(function(f) {
    return f.setValue(undefined);
  });
  var searchField = view.down('tsmInputQueryField');
  searchField.clearValueSilent();
  var cb = view.down('webtsmBasefilterCombo');
  if (cb) {
    cb.suspendEvents();
    cb.setValue(undefined);
    cb.resumeEvents();
  }
  this.resetFilterObject();
  view.searchGrid.updateStoreFilterSetNew({}, true, true, this.webtsmAttributeViewMode);
}, resetFilterObject:function() {
  var view = this.getView();
  view.searchPanel.aggregatedAttributes.attributeFilters = {filter:'', attributes:[]};
}, getName:function(attributeId) {
  return this.getView().getNameById(attributeId) || attributeId;
}, handleError:function(responseText) {
  var main = this.getView();
  if (main.searchGrid && responseText.log) {
    var tv = main.searchGrid.down('tableview');
    if (tv) {
      tv.setEmptyText(responseText.log);
    }
  }
}, loadSearchStore:function(queryString) {
  var view = this.getView();
  var g = view.searchGrid;
  if (queryString) {
    var params = g.getExtraParams();
    params.query = queryString;
    g.setExtraParams(params, true);
  }
  g.getStore().load();
}, resetInputQueryField:function() {
  var v = this.getView();
  var qf = v.searchGrid.down('tsmInputQueryField');
  qf.setValue('');
  qf.updateFulltextSearchField('');
  qf.loadStoreWithQuery('');
}, handleTextQuery:function(params) {
  var $jscomp$this = this;
  params = params === void 0 ? {} : params;
  var emptyFilterSet = true;
  if ((params.query || '').length) {
    this.getView().searchPanel.filterWrapper.add({text:params.query, tooltip:'Ein Klick entfernt den aktiven Filter', handler:function(btn) {
      $jscomp$this.resetInputQueryField();
    }});
    emptyFilterSet = false;
  }
  return emptyFilterSet;
}, addActiveFilter:function(o, resetCount) {
  var view = this.getView();
  var wrapper = view.searchPanel.filterWrapper, wrap = view.searchPanel.activeFilterWrapper;
  if (resetCount) {
    wrapper.webtsmFilterCount = 0;
    wrap.hide();
  } else {
    wrapper.webtsmFilterCount = wrapper.webtsmFilterCount + 1;
    wrapper.add(o);
    wrap.show();
  }
}, stringParamToArray:function(params, stringKey) {
  params = params === void 0 ? {} : params;
  stringKey = stringKey === void 0 ? '' : stringKey;
  if (params[stringKey]) {
    return ((params[stringKey] || '') + '').trim().split(',').filter(function(item) {
      return item && item.length;
    });
  }
  return [];
}, handleFilters:function(params) {
  var $jscomp$this = this;
  params = params === void 0 ? {} : params;
  var attributeIdArray = this.stringParamToArray(params, 'filter');
  var attributeFilterConfigs = attributeIdArray.map(function(attributeId) {
    var tooltip = 'Ein Klick entfernt den aktiven Filter';
    var filterType = 'attributeId';
    var text = $jscomp$this.getName(parseInt(attributeId));
    var handler = function(btn) {
      $jscomp$this.getView().down('#aggregatedAttributes').removeFromFilterSet(btn.attributeId);
      $jscomp$this.submitAttributeFilters();
    };
    return {tooltip:tooltip, filterType:filterType, text:text, attributeId:attributeId, handler:handler};
  });
  this.attributeIdArray = attributeIdArray;
  var tsIds = this.stringParamToArray(params, 'tsIds');
  var tsFilterConfigs = tsIds.map(function(tsId) {
    var tooltip = 'Ein Klick entfernt den aktiven Zeitreihenfilter';
    var filterType = 'tsId';
    var text = 'TS:' + parseInt(tsId);
    var handler = function(btn) {
      $jscomp$this.getView().down('webtsmSearchGrid').removeTsIdFromSearch(btn.tsId);
    };
    return {tooltip:tooltip, tsId:tsId, filterType:filterType, text:text, handler:handler};
  });
  var activeFilters = attributeFilterConfigs.concat(tsFilterConfigs);
  activeFilters.map(function(filterConfig) {
    $jscomp$this.addActiveFilter(filterConfig);
  });
  return activeFilters.length;
}, attributeIdArray:[], extractFromParams:function(params, key, defaultType) {
  params = params === void 0 ? {} : params;
  key = key === void 0 ? '' : key;
  defaultType = defaultType === void 0 ? [] : defaultType;
  var target = params[key];
  target = Ext.JSON.decode(target, true);
  return target || defaultType;
}, handleAggregations:function(json, store) {
  var $jscomp$this = this;
  json = json === void 0 ? {} : json;
  var main = this.getView();
  var maxResults = BpcCommon.Api.getSetting(main.moduleId, 'attributes_maxResultsInSearch');
  maxResults = Ext.isNumber(maxResults) ? maxResults : 50;
  if (json.attributesList) {
    if (main) {
      var attributesList = json.attributesList || [];
      if (main.searchGrid) {
        main.searchGrid.attributeCountButton.updateTitle(attributesList.length);
      }
      var fieldCon = main.down('#aggregatedAttributes');
      if (Ext.isDefined(fieldCon)) {
        fieldCon.removeAll(true);
        var attributes = {};
        var params = main.searchGrid.getExtraParams() || {};
        var activeFiltersMap = {};
        var paramsAttributes = this.extractFromParams(params, 'attributes');
        paramsAttributes.map(function(item) {
          item = item || {};
          var $jscomp$destructuring$var38 = item;
          var attributeId = $jscomp$destructuring$var38.attributeId;
          var value = $jscomp$destructuring$var38.value;
          if (attributeId) {
            activeFiltersMap[parseInt(attributeId)] = [];
          }
          if (value) {
            activeFiltersMap[parseInt(attributeId)].push(value);
          }
        });
        if (this.webtsmAttributeViewMode !== 'attributes') {
          var $jscomp$destructuring$var39 = json;
          var attributesAggregation = $jscomp$destructuring$var39.attributesAggregation;
          attributesAggregation = attributesAggregation || [];
          attributesAggregation.map(function(item) {
            var $jscomp$destructuring$var40 = item;
            var values = $jscomp$destructuring$var40.values;
            var attributeID = $jscomp$destructuring$var40.attributeID;
            values = values || [];
            values.map(function(item) {
              if (attributeID in attributes) {
                if ('values' in attributes[attributeID] && Ext.isArray(attributes[attributeID].values)) {
                } else {
                  attributes[attributeID].values = [];
                }
                attributes[attributeID].values.push({value:item.value, valueCount:item.count});
              } else {
                attributes[attributeID] = {values:[{value:item.value, valueCount:item.count}]};
              }
            });
          });
        }
        var wrapper = main.down('#webtsmFilterWrapper');
        wrapper.removeAll();
        var emptyFilterSet = this.handleFilters(params);
        emptyFilterSet = this.handleTextQuery(params);
        var attributesValueMap = {};
        Ext.Array.each(paramsAttributes, function(item) {
          if ('attributeId' in item) {
            if (item.attributeId in attributesValueMap && Ext.isArray(attributesValueMap[item.attributeId])) {
              attributesValueMap[item.attributeId].push(item);
            } else {
              attributesValueMap[item.attributeId] = [item];
            }
            var label = '';
            if ('value' in item && Ext.isDefined(item.value)) {
              label = ' : ' + (item.value === 'webtsmEmpty' ? 'Leerer Wert' : item.value === 'webtsmNotEmpty' ? 'Nicht leerer Wert' : item.value);
            }
            $jscomp$this.addActiveFilter({text:$jscomp$this.getName(parseInt(item.attributeId)) + label, tooltip:'Ein Klick entfernt den aktiven Filter: \x3cbr\x3e\x3cbr\x3e' + webtsm.Support.createHtmlTooltipFromObject(item, true), attributeId:item.attributeId, attributeKey:item.key, attributeValue:item.value, handler:function(btn) {
              main.down('#aggregatedAttributes').removeFromAttributesFilterSet(btn.attributeId, btn.attributeKey, btn.attributeValue);
              $jscomp$this.submitAttributeFilters();
            }});
            emptyFilterSet = false;
          }
        });
        if (emptyFilterSet) {
          wrapper.setHtml('Keine Filter gesetzt.');
        }
        var attributesInSearch = 0, arrayOfAttributes = [], searchLimitHit = false;
        json.attributesList.map(function(item) {
          var hidden = false;
          var $jscomp$destructuring$var41 = item;
          var attributeID = $jscomp$destructuring$var41.attributeID;
          var tsCount = $jscomp$destructuring$var41.tsCount;
          if (main.feCache) {
            var attIdNum = Ext.clone(attributeID);
            if (Ext.isString(attIdNum)) {
              attIdNum = parseInt(attIdNum);
            }
            var cache = main.feCache || {};
            var $jscomp$destructuring$var42 = cache;
            var attributes$11 = $jscomp$destructuring$var42.attributes;
            var types = $jscomp$destructuring$var42.types;
            attributes$11 = attributes$11 || {};
            types = types || {};
            if (attIdNum in attributes$11) {
              var typeId = attributes$11[attIdNum];
              if (typeId in types) {
                hidden = (types[typeId] || {}).hidden ? !hidden : hidden;
              }
            }
          }
          if (attributesInSearch < maxResults) {
            if (!hidden) {
              attributesInSearch += 1;
              var activeValues = [];
              Ext.Array.each(paramsAttributes, function(attributeFilterObj) {
                if ('attributeId' in attributeFilterObj && attributeFilterObj.attributeId) {
                  var targetId = attributeID;
                  if (Ext.isString(targetId)) {
                    targetId = parseInt(targetId);
                  }
                  if (parseInt(attributeFilterObj.attributeId) === targetId) {
                    activeValues.push(attributeFilterObj);
                  }
                }
              });
              var values = attributes[attributeID];
              var $jscomp$destructuring$var43 = $jscomp$this;
              var webtsmAttributeViewMode = $jscomp$destructuring$var43.webtsmAttributeViewMode;
              arrayOfAttributes.push({webtsmAttributeId:attributeID, webtsmAttributeName:$jscomp$this.getName(attributeID), attributesCheckboxDef:{tsId:tsCount, activeValues:activeValues, attributeId:attributeID, name:attributeID, values:values, webtsmAttributeViewMode:webtsmAttributeViewMode}});
            }
          } else {
            searchLimitHit = true;
            return false;
          }
        });
        if (this.attributeOrderArray) {
          var sorted = new Array(this.attributeOrderArray.length);
          Ext.Array.each(arrayOfAttributes, function(item) {
            var pos = $jscomp$this.attributeOrderArray.indexOf(item.webtsmAttributeId);
            if (pos !== -1) {
              sorted[pos] = item;
            } else {
              sorted.push(item);
            }
          });
          arrayOfAttributes = sorted.filter(function(o) {
            return typeof o !== 'undefined' && o !== null;
          });
        } else {
          arrayOfAttributes.sort(webtsm.Support.sortWrapper('webtsmAttributeName', true));
        }
        fieldCon.add(arrayOfAttributes);
        if (searchLimitHit) {
          fieldCon.add({xtype:'container', html:'Anzahl der maximalen Attribute erreicht (' + maxResults + ').\x3cbr/\x3e Ggf. Setting in Moduleinstellungen anpassen.'});
        }
        Ext.defer(function() {
          fieldCon.updateLayout();
        }, 50);
      }
    }
  } else {
    webtsm.Support.notify('Fehler beim Verarbeiten der Suchanfrage - Aggregation wurde nicht in der Serverantwort gefunden.');
  }
}, handleEmptyText:function(success, count) {
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.search.SearchGrid', {extend:'Ext.grid.Panel', alias:'widget.webtsmSearchGrid', requires:['webtsm.ConfigKeys', 'webtsm.mixins.Component'], viewConfig:{bind:{emptyText:'{emptyText}'}, enableTextSelection:true, deferEmptyText:false}, specialRendererActive:false, attributeRendererConfig:undefined, activeBucketReference:undefined, readOnly:undefined, moduleId:undefined, columns:undefined, queryMode:undefined, initComponent:function() {
  var $jscomp$this = this;
  if (this.readOnly) {
  }
  this.title = 'Zeitreihen';
  this.iconCls = webtsm.ConfigKeys.icons.search;
  this.store = Ext.create('Ext.data.BufferedStore', {proxy:{type:'ajax', url:webtsm.Api.tsmBasePath + 'cache/' + this.moduleId, reader:{type:'json', rootProperty:'data', totalProperty:'total'}, extraParams:{detail:this.detailSearch}, timeout:300000}, autoLoad:false, pageSize:50, listeners:{beforeprefetch:function(store, operation, eOpts) {
    var params = $jscomp$this.getExtraParams();
    params.querymode = $jscomp$this.searchModeButton.queryMode;
    return true;
  }, prefetch:function(s, records, successful, operation) {
    $jscomp$this.totalCountButton.updateTitle(successful ? s.getTotalCount() : 0);
  }}});
  this.searchModeButton = Ext.create({xtype:'webtsmSearchGridButton', store:this.store});
  this.dockedItems = [{xtype:'toolbar', dock:'top', padding:'5 5 5 5', defaults:{margin:'1 1 1 1', moduleId:this.moduleId}, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'container', layout:{type:'hbox', align:'stretch'}, defaults:{moduleId:this.moduleId, _grid:this}, items:[this.searchModeButton, {xtype:'tsmInputQueryField', searchWithCommit:this.searchWithCommit, emptyText:webtsm.Support.getTranslation('WEBTSM_SEARCH_IN'), tooltip:'Zeitreihensuche', flex:1, gridReference:this, gridFilterField:'Name', 
  visualisation:true, grid:this}, {xtype:'button', iconCls:webtsm.Support.getBpcIconCls('fa-list-ul'), itemId:'attributesViewModeBtn', handler:function(btn) {
    $jscomp$this.changeAttributeViewMode();
  }}]}]}];
  var columns = [{dataIndex:'ID', width:80}, {xtype:'actioncolumn', width:30, items:[{iconCls:webtsm.Support.getBpcIconCls('fa-external-link'), tooltip:webtsm.Support.getTranslation('OPEN_IN_VIEWER'), handler:function(tv, rowIndex, colIndex, item, e, r) {
    $jscomp$this.openInViewer({tsIds:[r.get('ID')]});
  }}]}, {dataIndex:'Name', flex:3}, {dataIndex:'Description'}, {dataIndex:'IntervalX', text:'INTERVAL', width:90}, {dataIndex:'TypeNames', text:'TYPE', width:90}, {dataIndex:'Unit', width:90}, {dataIndex:'AttributesCount', text:'ATTRIBUTECOUNT', width:30}, {dataIndex:'Attributes', webtsmForce:['sortable'], sortable:false, flex:3, tooltip:'Sortierung deaktiviert, Werte in JSON Notation können nicht sortiert werden.', renderer:function(value, meta, record) {
    if (Ext.isArray(value) && value.length) {
      var attributeTable = '';
      if ($jscomp$this.specialRendererActive) {
        var t = [];
        if ($jscomp$this.attributeRendererConfig) {
          var c = $jscomp$this.attributeRendererConfig;
          Ext.Array.each(value, function(attribute) {
            var arrayOfValues = $jscomp$this.getObjectAsArray(attribute.Values);
            arrayOfValues.sort(webtsm.Support.sortWrapper('keyDate'));
            var getStringFromConfig = function(config, array) {
              var showAttributeValueKeys = false;
              var showLastAttributeValueOnly = true;
              var sortByAttributeName = true;
              if (config && 'showAttributeValueKeys' in config && 'showLastAttributeValueOnly' in config && 'sortByAttributeName' in config) {
                showAttributeValueKeys = config.showAttributeValueKeys;
                showLastAttributeValueOnly = config.showLastAttributeValueOnly;
                sortByAttributeName = config.sortByAttributeName;
              }
              var string = '', temp = [];
              Ext.Array.each(array, function(item, index, arr) {
                if (showLastAttributeValueOnly && !showAttributeValueKeys && index === 0) {
                  string = item.value;
                  return false;
                } else {
                  var timestampString = '';
                  if (showAttributeValueKeys) {
                    timestampString = item.key + ' : ';
                  }
                  timestampString += item.value;
                  temp.push(timestampString);
                  if (arr.length - 1 === index) {
                    string = temp.join(', ');
                  }
                }
              });
              return string;
            };
            value = getStringFromConfig(c, arrayOfValues);
            t.push({name:$jscomp$this.getNameForId(attribute.AttributeID), string:'\x3cb\x3e' + $jscomp$this.getNameForId(attribute.AttributeID) + ':\x3c/b\x3e' + value + '\x26nbsp;'});
          });
          if (c.sortByAttributeName) {
            t.sort(webtsm.Support.sortWrapper('name', true));
          }
          t.map(function(o) {
            return attributeTable += o.string;
          });
        }
      } else {
        value.map(function(attribute) {
          attributeTable += '\x3cb\x3e' + $jscomp$this.getNameForId(attribute.AttributeID) + ' \x3c/b\x3e ( ' + attribute.AttributeID + $jscomp$this.isAttributeHidden(attribute.AttributeID) + ' ) ' + $jscomp$this.getObjectAsList(attribute.Values);
        });
      }
      value = attributeTable;
    }
    return value || '';
  }}];
  if (this.readOnly) {
    columns.push(this.getTsActionColumn(this.moduleId, undefined, [0]));
  } else {
    columns.push(this.getTsActionColumn(this.moduleId));
  }
  this.columns = columns.map(function(c) {
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  });
  this.bucketGrid = Ext.create({xtype:'webtsmBucketGrid', itemId:'zrBucket', hidden:true});
  this.totalCountButton = Ext.create({xtype:'button', hoverCls:'', iconCls:webtsm.Support.getBpcIconCls('fa-database'), updateTitle:function(count) {
    count = count === void 0 ? 0 : count;
    this.setText('Zeitreihen: ' + count);
  }});
  this.totalCountButton.updateTitle();
  this.attributeCountButton = Ext.create({xtype:'button', hoverCls:'', iconCls:webtsm.Support.getBpcIconCls('fa-archive'), updateTitle:function(count) {
    count = count === void 0 ? 0 : count;
    this.setText('Attribute: ' + count);
  }});
  this.attributeCountButton.updateTitle();
  this.bbar = [this.totalCountButton, this.attributeCountButton];
  this.listeners = {rowdblclick:this.onRowDblCLick.bind(this)};
  this.callParent(arguments);
  this.setDefaultAttributeRenderer();
}, onRowDblCLick:function(tv, record) {
  this.searchRoot.openDetailWindow(record);
}, setDefaultAttributeRenderer:function(list) {
  var attributeViewModeConfig = BpcCommon.Api.getSetting(this.moduleId, 'search_attributeViewModes');
  if (list) {
    attributeViewModeConfig.mode = list;
  }
  var iconCls, tooltip, lineRendererActive, cfg = undefined;
  if (attributeViewModeConfig.mode === 'list') {
    lineRendererActive = false;
    iconCls = webtsm.Support.getBpcIconCls('fa-list-ul');
    tooltip = 'Listenansicht aktiv - Inlineansicht aktivieren';
  } else if (attributeViewModeConfig.mode === 'line') {
    lineRendererActive = true;
    cfg = attributeViewModeConfig.modes['line'];
    iconCls = webtsm.Support.getBpcIconCls('fa-bars');
    tooltip = 'Inlineansicht aktiv - Listenansicht aktivieren';
  }
  this.attributeRendererConfig = cfg;
  this.specialRendererActive = lineRendererActive;
  var btn = this.down('#attributesViewModeBtn');
  if (btn) {
    btn.setIconCls(iconCls);
  }
  if (btn) {
    btn.setTooltip(tooltip);
  }
}, getObjectAsList:function(obj) {
  var htmlList = '\x3cul\x3e';
  if (Ext.isObject(obj)) {
    var dateApi = webtsm.Api.date;
    Ext.iterate(obj, function(k, v) {
      var d = dateApi.stringToDate(k);
      htmlList += '\x3cli\x3e' + dateApi.dateToFormattedString(d) + ' - ' + v + '\x3c/li\x3e';
    });
  }
  htmlList += '\x3c/ul\x3e';
  return htmlList;
}, getObjectAsArray:function(obj) {
  var array = [];
  if (obj && Ext.isObject(obj)) {
    Ext.iterate(obj, function(k, v) {
      array.push({keyDate:new Date(k), key:k, value:v});
    });
  }
  return array;
}, getNameForId:function(attributeId) {
  return this.searchRoot.getNameById(attributeId) || attributeId;
}, startInitialLoad:function() {
  this.searchModeButton.setQueryMode(BpcCommon.Api.getSetting(this.moduleId, 'search_defaultQueryMode'), true);
  this.store.load();
}, isAttributeHidden:function(attributeId) {
  if ('feCache' in this.searchRoot) {
    var attIdNum = Ext.clone(attributeId);
    if (Ext.isString(attIdNum)) {
      attIdNum = parseInt(attIdNum);
    }
    if (attIdNum in this.searchRoot['feCache']['attributes']) {
      var typeId = this.searchRoot['feCache']['attributes'][attIdNum];
      if (typeId in this.searchRoot['feCache']['types']) {
        var typeObj = this.searchRoot['feCache']['types'][typeId];
        if (typeObj.hidden) {
          return ', ' + webtsm.Support.getSpanForIconCls(webtsm.Support.getBpcIconCls('fa-eye-slash'), 'black', 12);
        }
      }
    }
  }
  return '';
}, getState:function() {
  return this.getStore().getProxy().getExtraParams();
}, writeState:function(params) {
  if (params) {
    this.setExtraParams(params, true);
  }
}, selModel:{mode:'MULTI', pruneRemoved:false}, detailSearch:undefined, getExtraParams:function() {
  return this.store.getProxy().getExtraParams();
}, setExtraParams:function(p, load) {
  this.store.getProxy().setExtraParams(p);
  if (load) {
    this.store.load();
  }
}, removeTsIdFromSearch:function(idToRemove) {
  var extraParams = this.getExtraParams();
  if (Ext.isObject(extraParams)) {
    if (extraParams.tsIds) {
      var tsIds = extraParams.tsIds.split(',');
      if (tsIds.length && tsIds.indexOf(idToRemove) !== -1) {
        tsIds = tsIds.filter(function(id) {
          return id !== idToRemove;
        });
        extraParams.tsIds = tsIds.join(',');
      }
    }
  }
  this.setExtraParams(extraParams, true);
}, loadIdsFromBucket:function(b) {
  var queryMode = this.searchModeButton.queryMode;
  if (queryMode !== 'AND' && b.length > 0) {
    this.searchModeButton.setQueryMode('AND', true);
    BpcCommon.Api.showNotification(webtsm.Support.getTranslation('WEBTSM_WARN_QUERYMODE_CHANGED_TO_AND'));
  }
  var ids = [];
  var attributes = [];
  Ext.Array.each(b, function(item) {
    if (!('tsmType' in item)) {
      ids.push(item.ID);
    } else if ('tsmType' in item && Ext.isDefined(item.tsmType) && item.tsmType === 'attribute') {
      attributes.push(item.ID);
    }
  });
  var proxy = this.store.getProxy();
  var kill = false;
  var extraParams = proxy.getExtraParams();
  if (Ext.isObject(extraParams)) {
    if (Ext.isDefined(kill) && kill === true) {
      if ('filter' in extraParams && Ext.isDefined(extraParams.filter)) {
        var filter = String(extraParams.filter);
        var filterStringArray = filter.split(';');
        if (filterStringArray.indexOf(String(attributeId)) !== -1) {
          Ext.Array.remove(filterStringArray, String(attributeId));
          extraParams.filter = filterStringArray.join(',');
        }
      } else {
      }
    } else {
      extraParams.tsIds = ids.join(',');
      extraParams.filter = attributes.join(',');
    }
  }
  this.setExtraParams(extraParams, true);
}, updateStoreFilterSetNew:function(filterObj, kill, killAll, mode) {
  var extraParams = this.getExtraParams();
  if (killAll) {
    extraParams = {filter:'', tsIds:'', query:'', baseFilter:'', attributes:JSON.stringify([]), detail:mode};
  } else {
    if (Ext.isObject(extraParams)) {
      if (!Ext.isDefined(kill)) {
        var v = this.getView();
        var searchField = v.up('webtsmSearchOverview').down('tsmInputQueryField');
        var queryValue = searchField.getValueSilent();
        if (queryValue) {
          extraParams.query = queryValue;
        }
        if ('filter' in extraParams && Ext.isDefined(extraParams.filter)) {
          extraParams.filter = filterObj.filter;
          extraParams.attributes = JSON.stringify(filterObj.attributes);
        } else {
          extraParams.filter = filterObj.filter;
          extraParams.attributes = JSON.stringify(filterObj.attributes);
        }
      } else {
        extraParams.filter = '';
        extraParams.tsIds = '';
        extraParams.query = '';
        extraParams.baseFilter = '';
        extraParams.attributes = JSON.stringify([]);
      }
    }
  }
  var view = this.up('webtsmSearchOverview');
  var fromField = view.down('#from');
  var toField = view.down('#to');
  var fromDate = fromField.getValue();
  var toDate = toField.getValue();
  if (Ext.isDefined(fromDate)) {
    extraParams.from = Ext.Date.format(fromDate, 'time');
  } else {
    if ('from' in extraParams) {
      delete extraParams.from;
    }
  }
  if (Ext.isDefined(toDate)) {
    extraParams.to = Ext.Date.format(toDate, 'time');
  } else {
    if ('to' in extraParams) {
      delete extraParams.to;
    }
  }
  this.setExtraParams(extraParams, true);
}, changeStoreParams:function(key, value, kill) {
  var params = this.getExtraParams();
  if (!kill) {
    params[key] = value;
    if (key && value && value === 'attributes') {
      if ('attributes' in params && params.attributes) {
        var attributes = JSON.parse(params.attributes);
        delete params.attributes;
        var attributesNew = attributes.map(function(item) {
          if (item && 'attributeId' in item && item.attributeId) {
            return {attributeId:item.attributeId};
          }
          return false;
        });
        params.attributes = JSON.stringify(attributesNew);
      }
    }
  } else {
    if (key in params) {
      delete params.key;
    }
  }
  this.setExtraParams(params, true);
}, getPayloadFromSelection:function() {
  return this.getSelection().map(function(model) {
    return {ID:model.get('ID'), Name:model.get('Name'), AttributesCount:model.get('AttributesCount')};
  });
}, changeAttributeViewMode:function() {
  var $jscomp$this = this;
  var columns = this.getColumns();
  columns.map(function(column) {
    if (!$jscomp$this.specialRendererActive) {
      if ('dataIndex' in column && column.dataIndex) {
        if (['ID', 'Name', 'Attributes'].indexOf(column.dataIndex) === -1) {
          column.hide();
        } else {
          if (column.dataIndex === 'Attributes') {
            column.setFlex(5);
          }
          if (column.dataIndex === 'Name') {
            column.setFlex(1);
          }
        }
      } else if (column) {
      }
    } else {
      column.show();
      if ('dataIndex' in column) {
        if (column.dataIndex === 'Attributes') {
          column.setFlex(3);
        }
        if (column.dataIndex === 'Name') {
          column.setFlex(2);
        }
      }
    }
  });
  this.setDefaultAttributeRenderer(!this.specialRendererActive ? 'line' : 'list');
  this.store.load();
}, openInViewer:function(params) {
  BpcCommon.Api.showModule(webtsm.Api.module.getViewerId(this.moduleId), true, params || {});
}, getTsActionColumn:function(modId, customActions, limiter) {
  var $jscomp$this = this;
  var actions = [{iconCls:webtsm.ConfigKeys.icons.addToBucket, tooltip:'Zeitreihe dem Bucket hinzufügen', handler:function(tableView, rowIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var store = $jscomp$this.managerMain.bucketStore;
    var tsId = rec.get('ID');
    if (store.find('ID', tsId) === -1) {
      store.add({ID:tsId, Name:rec.get('Name'), AttributesCount:rec.get('AttributesCount')});
    }
  }}, {iconCls:webtsm.Support.getBpcIconCls('fa-wrench'), tooltip:'Stammdaten bearbeiten', handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var bucket = [{ID:rec.get('ID'), Name:rec.get('Name'), AttributesCount:rec.get('AttributesCount')}];
    $jscomp$this.managerMain.openTsmComponent({action:'definitions', bucket:bucket});
  }}].concat(BpcCommon.Api.hasUserRole('bpcadmin') ? [{iconCls:webtsm.Support.getBpcIconCls('fa-copy'), tooltip:'Zeitreihe kopieren', handler:function(tableView, rowIndex, colIndex) {
    var record = tableView.getStore().getAt(rowIndex);
    var moduleId = $jscomp$this.moduleId;
    Ext.create('Ext.window.Window', {title:'Zeitreihe kopieren', iconCls:webtsm.Support.getBpcIconCls('fa-copy'), height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.5, layout:'fit', items:[{xtype:'panel', padding:'5 5 5 5', itemId:'copyPanel', header:false, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'textfield', fieldLabel:'Quellzeitreihenname', value:record.get('Name'), readOnly:true}, {xtype:'textfield', fieldLabel:'Quellzeitreihen ID', value:record.get('ID'), 
    readOnly:true}, {xtype:'textfield', fieldLabel:'Quellzeitreihen Attribute', readOnly:true, itemId:'sourceTsAttributesCount'}, {xtype:'textfield', fieldLabel:'Zielzeitreihenname', emptyText:'Bitte setzen', itemId:'newTsName', listeners:{change:function(f, newVal, oldVal) {
      var btn = f.up('#copyPanel').down('#copyBtn');
      btn.setDisabled(!(newVal && newVal.length));
    }}}, {xtype:'textfield', fieldLabel:'ZielzeitreihenID', readOnly:true, itemId:'targetTsId'}, {xtype:'checkbox', fieldLabel:'ZR Anlage Erfolgreich', itemId:'targetTsSuccess', readOnly:true}, {xtype:'checkbox', fieldLabel:'ZR Attributes Erfolgreich', itemId:'targetAttributesSuccess', readOnly:true}].map(function(cmp) {
      cmp.labelWidth = 160;
      return cmp;
    }), bbar:[{xtype:'tbfill'}, {iconCls:webtsm.Support.getBpcIconCls('fa-copy'), text:'Kopieren', itemId:'copyBtn', disabled:true, moduleId:moduleId, sourceID:record.get('ID'), handler:function(btn) {
      btn.disable();
      var p = btn.up('#copyPanel');
      var newNameField = p.down('#newTsName');
      webtsm.Api.clone(btn.moduleId, btn.sourceID, newNameField.getValue()).then(function(successObj) {
        ['targetTsSuccess', 'targetAttributesSuccess', 'targetTsId', 'sourceTsAttributesCount'].map(function(itemId) {
          var field = p.down('#' + itemId);
          field.setValue(successObj[itemId]);
        });
        btn.enable();
      });
    }}, {iconCls:webtsm.Support.getBpcIconCls('fa-times'), text:'Schließen', handler:function(b) {
      b.up('window').close();
    }}]}]}).show();
  }}] : []).concat([{iconCls:webtsm.Support.getBpcIconCls('fa-archive'), tooltip:'Attribute bearbeiten', handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var bucket = [{ID:rec.get('ID'), Name:rec.get('Name'), AttributesCount:rec.get('AttributesCount')}];
    $jscomp$this.managerMain.openTsmComponent({action:'attributes', bucket:bucket});
  }}, {iconCls:webtsm.Support.getBpcIconCls('fa-edit'), tooltip:'Zeitreihenwerte bearbeiten', handler:function(tableView, rowIndex, colIndex) {
    var rec = tableView.getStore().getAt(rowIndex);
    var bucket = [{ID:rec.get('ID'), Name:rec.get('Name'), AttributesCount:rec.get('AttributesCount')}];
    $jscomp$this.managerMain.openTsmComponent({action:'values', bucket:bucket});
  }}, {iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons["delete"]), tooltip:webtsm.Support.TR('DELETE'), handler:function(v, rowIndex, colIndex, item, e, r) {
    var timeSeriesId = r.get('ID');
    var timeSeriesName = r.get('Name');
    webtsm.util.MessageBox.deleteEntries(undefined, undefined, [r]).then(function(proceedWithDelete) {
      return proceedWithDelete ? webtsm.Api.timeseries["delete"]($jscomp$this.moduleId, timeSeriesId) : proceedWithDelete;
    }).then(function(falseOrResponse) {
      if (falseOrResponse === false) {
        return;
      }
      falseOrResponse = falseOrResponse || {};
      if (falseOrResponse.status && falseOrResponse.status === 204) {
        webtsm.Support.showNotification({text:'Löschen der Zeitreihe: ' + timeSeriesId + ' war erfolgreich.', sourceInstanceId:$jscomp$this.moduleId, object:timeSeriesId});
        try {
          webtsm.Api.cacheRefresh($jscomp$this.moduleId, false);
        } catch (e$12) {
        }
        return true;
      } else {
        $jscomp$this.createErrorNotification(timeSeriesName || timeSeriesId, falseOrResponse);
        return false;
      }
    }, function(response) {
      $jscomp$this.createErrorNotification(timeSeriesName || timeSeriesId, response);
    });
  }}]);
  if (Ext.isDefined(customActions)) {
    actions = customActions;
  }
  var w = 150;
  if (limiter && Ext.isArray(limiter)) {
    var limitedActions = [];
    var w1 = w / actions.length;
    Ext.Array.each(actions, function(action, index, array) {
      if (limiter.indexOf(index) !== -1) {
        limitedActions.push(action);
      }
    });
    actions = limitedActions;
    w = w1 * limitedActions.length + 20;
  }
  return {xtype:'actioncolumn', text:'OPTIONEN', width:w, items:actions};
}, createErrorNotification:function(timeSeriesIdOrName, response) {
  var errorText = 'Löschen der Zeitreihe: ' + timeSeriesIdOrName + ' war nicht erfolgreich.' + this.getDetailErrorText(response);
  this.displayNotification({text:errorText, sourceInstanceId:this.moduleId, object:timeSeriesIdOrName});
}, displayNotification:function(cfg) {
  webtsm.Support.showNotification(cfg);
}, getDetailErrorText:function(response) {
  var json = webtsm.Support.getResponseObject(response);
  var $jscomp$destructuring$var44 = response;
  var status = $jscomp$destructuring$var44.status;
  var statusText = $jscomp$destructuring$var44.statusText;
  var $jscomp$destructuring$var45 = json || {};
  var Message = $jscomp$destructuring$var45.Message;
  Message = Message || '';
  return '\n Details: ' + status + ' (' + statusText + ')\n' + Message + ')';
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.search.SearchOverview', {extend:'Ext.panel.Panel', alias:'widget.webtsmSearchOverview', requires:['webtsm.ConfigKeys'], controller:'webtsmSearchController', layout:{type:'hbox', align:'stretch'}, readOnly:false, feCache:undefined, openDetailWindow:function(record) {
  webtsm.Util.openDetailWindow(record, this.moduleId, this.managerRoot);
}, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = webtsm.ConfigKeys.icons.search;
  this.title = webtsm.Support.getTranslation('OVERVIEW_AND_SEARCH');
  var baseButton = {xtype:'button', scale:'medium', iconAlign:'top', margin:'2 2 2 2', ui:'secondary', disabled:true, handler:function(btn) {
    $jscomp$this.managerRoot.openTsmComponent({action:btn.action});
  }};
  this.bucketButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.getBpcIconCls('fa-database'), text:'Bearbeiten und exportieren', handler:function(btn) {
    webtsm.util.Window.openWindow(webtsm.Support.getTranslation('WEBTSM_EXPORTER'), webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons.download), document.body.clientWidth * 0.8, document.body.clientHeight * 0.8, 'webtsmExportMain', {header:false, moduleId:$jscomp$this.moduleId, searchGrid:$jscomp$this, bucketStore:$jscomp$this.managerMain.bucketStore});
  }, hidden:this.managerRoot.hideEdit}, baseButton));
  this.editDefinitionsButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.icon('fa-wrench'), text:'Stammdaten bearbeiten', hidden:this.managerRoot.hideEdit, action:'definitions'}, baseButton));
  this.errorButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.icon('fa-exclamation-triangle'), text:'Achtung: Abfragefehler', hidden:true, handler:function(b) {
    webtsm.util.Window.openWindow('ERROR', 'fa-exclamation-triangle', document.body.clientWidth * 0.8, document.body.clientHeight * 0.8, 'panel', {layout:'fit', items:[{xtype:'panel', tbar:[{xtype:'textfield', value:$jscomp$this.getController().searchRequestHasErrors ? ($jscomp$this.getController().searchRequestError || {}).msg || 'no message' : ''}], layout:'fit', items:[{xtype:'textarea', grow:true, value:$jscomp$this.getController().searchRequestHasErrors ? ($jscomp$this.getController().searchRequestError || 
    {}).stacktrace || 'no stacktrace' : ''}]}]});
  }}, baseButton));
  this.editAttributesButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.icon('fa-archive'), text:'Attribute bearbeiten', action:'attributes', hidden:this.managerRoot.hideEdit}, baseButton));
  this.editValuesButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.icon('fa-edit'), text:'Zeitreihenwerte bearbeiten', action:'values', hidden:this.managerRoot.hideEdit}, baseButton));
  this.viewerButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.getBpcIconCls('fa-external-link'), text:this.managerMain.openedInViewer ? 'Auswahl übernehmen' : 'Im Viewer öffnen', openedInViewer:this.managerMain.openedInViewer, handler:function(btn) {
    var bucketData = $jscomp$this.managerMain.bucketStore.getDataAsArray();
    if (btn.openedInViewer) {
      $jscomp$this.managerMain.baseCmp.openBucketFromAdvancedSearch(bucketData);
      var w = $jscomp$this.managerMain.up('window');
      if (w) {
        w.close();
      }
    } else {
      $jscomp$this.searchGrid.openInViewer({bucket:bucketData});
    }
  }}, baseButton));
  this.attributeModeButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.getBpcIconCls('fa-archive'), text:'Attribute mit Werten', webtsmAttributeViewMode:'attributes', disabled:false, handler:function(b) {
    var targetMode, targetIconCls, targetText, targetTooltip;
    if (b.webtsmAttributeViewMode === 'attributes') {
      targetMode = 'compressed';
      targetIconCls = 'fa-compress';
      targetText = 'Attribute + Werte';
      targetTooltip = 'Suchmodus: Attribute und Werte\x3cbr\x3eButton klicken, um nur nach Attributen zu suchen.';
    } else {
      targetMode = 'attributes';
      targetIconCls = 'fa-archive';
      targetText = 'Attribute';
      targetTooltip = 'Suchmodus: Attribute und Werte\x3cbr\x3eButton klicken, um nach Attributen und Werten zu suchen.';
    }
    b.setText(targetText);
    b.setTooltip(targetTooltip);
    b.setIconCls(webtsm.Support.getBpcIconCls(targetIconCls));
    b.webtsmAttributeViewMode = targetMode;
    $jscomp$this.searchGrid.changeStoreParams('detail', targetMode, undefined, true);
  }}, baseButton));
  this.dateFilterButton = Ext.create(Ext.applyIf({iconCls:webtsm.Support.getBpcIconCls('fa-calendar-alt'), tooltip:'Zeitbereichfilter ein/ausblenden', text:'Attribute - Zeitraum begrenzen', hidden:true, disabled:true, handler:function(b) {
  }}, baseButton));
  this.bucketButtons = [this.bucketButton, this.editDefinitionsButton, this.editAttributesButton, this.editValuesButton, this.viewerButton];
  this.dockedItems = [{xtype:'container', dock:'top', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'toolbar', padding:'5 5 5 5', items:[this.attributeModeButton, this.dateFilterButton, this.errorButton, {xtype:'tbfill'}].concat(this.bucketButtons)}]}];
  var defaults = {moduleId:this.moduleId, readOnly:this.readOnly, detailSearch:BpcCommon.Api.getSetting(this.moduleId, 'search_attributesViewMode') || 'compressed', managerRoot:this.managerRoot, managerMain:this.managerMain, searchRoot:this};
  this.searchPanel = Ext.create(Ext.apply({}, {xtype:'webtsmSearchPanelLeft', flex:1}, defaults));
  this.searchGrid = Ext.create(Ext.apply({}, {xtype:'webtsmSearchGrid', header:false, flex:5}, defaults));
  this.items = [this.searchPanel, {xtype:'splitter'}, this.searchGrid];
  this.callParent(arguments);
  if (this.readOnly) {
  }
  this.managerMain.bucketStore.on({datachanged:function(s) {
    if (!$jscomp$this.destroyed) {
      $jscomp$this.bucketButtons.map(function(b) {
        return b.setDisabled(s.getCount() === 0);
      });
    }
  }});
  webtsm.Support.preloadModuleInformation.manager(this.moduleId).then(function(obj) {
    $jscomp$this.feCache = obj;
    $jscomp$this.managerRoot.attributeList = obj.attributeList || [];
    $jscomp$this.searchGrid.startInitialLoad();
  });
}, getNameById:function(attributeId) {
  return this.managerRoot.getNameById(attributeId) || attributeId;
}, loadHiddenAttributeTypes:function() {
  var count = 0, typeCount = 0;
  if ('feCache' in this && Ext.isDefined(this.feCache)) {
    if ('types' in this.feCache) {
      if (Ext.isDefined(this.feCache.types) && Ext.isObject(this.feCache.types)) {
        Ext.iterate(this.feCache.types, function(id, obj) {
          if ('hidden' in obj && obj.hidden) {
            count = count + obj.items.length;
            typeCount = typeCount + 1;
          }
        });
      }
    }
  }
}});
Ext.define('webtsm.manager.search.SearchPanelLeft', {extend:'Ext.panel.Panel', alias:'widget.webtsmSearchPanelLeft', header:false, layout:{type:'vbox', align:'stretch'}, readOnly:undefined, initComponent:function() {
  var defaults = {moduleId:this.moduleId, readOnly:this.readOnly, detailSearch:this.detailSearch, searchRoot:this.searchRoot, searchPanelLeft:this};
  this.filterWrapper = Ext.create({xtype:'container', layout:'vbox', itemId:'webtsmFilterWrapper', webtsmFilterCount:0, minHeight:30, defaults:{xtype:'button', maxWidth:'80%', minWidth:150, iconAlign:'left', textAlign:'left', iconCls:webtsm.Support.getBpcIconCls('fa-minus-circle')}});
  this.activeFilterWrapper = Ext.create(Ext.apply({}, {xtype:'container', itemId:'webtsmActiveFilterWrapper', hidden:true, layout:'vbox', items:[{xtype:'box', itemId:'filterOverview', bind:{html:'\x3ch4\x3eAktive Filter:\x3c/h4\x3e'}}, this.filterWrapper]}, defaults));
  this.attributeOverview = Ext.create(Ext.apply({}, {xtype:'box', itemId:'attributeOverview', bind:{html:'\x3ch4\x3eAttributauswahl:\x3c/h4\x3e'}}, defaults));
  this.aggregatedAttributes = Ext.create(Ext.apply({}, {xtype:'container', title:'Attribute', flex:1, collapsible:true, scrollable:'y', attributeFilters:{filter:'', attributes:[]}, itemId:'aggregatedAttributes', padding:'0 0 0 0', defaultType:'webtsmAttributesSearchField', defaults:{xtype:'webtsmAttributesSearchField', searchRoot:this.searchRoot, searchPanelLeft:this}, items:[], addToFilterSet:function(attributeId) {
    attributeId = String(attributeId);
    var o = this.attributeFilters;
    if ('filter' in o) {
      if (o.filter.length) {
        var arrayOfAttributeIds = o.filter.split(',');
        if (arrayOfAttributeIds.indexOf(attributeId) === -1) {
          arrayOfAttributeIds.push(attributeId);
        }
        o.filter = arrayOfAttributeIds.join(',');
      } else {
        o.filter = attributeId;
      }
    }
    this.attributeFilters = o;
    this.updateFilterSelection();
  }, removeFromFilterSet:function(attributeId) {
    attributeId = String(attributeId);
    var o = this.attributeFilters;
    if ('filter' in o) {
      if (o.filter.length) {
        var arrayOfAttributeIds = o.filter.split(',');
        if (arrayOfAttributeIds.indexOf(attributeId) !== -1) {
          Ext.Array.remove(arrayOfAttributeIds, attributeId);
        }
        o.filter = arrayOfAttributeIds.join(',');
      } else {
      }
    }
    this.attributeFilters = o;
    this.updateFilterSelection();
  }, updateFilterSelection:function() {
    var l = 0;
    if (this.attributeFilters.filter.length) {
      var filterArray = this.attributeFilters.filter.split(',');
      l = filterArray.length;
    }
  }, addToAttributesFilterSet:function(id, key, value) {
    var o = {attributeId:String(id)};
    if (Ext.isDefined(key) && Ext.isDefined(value)) {
      o.key = key;
      o.value = value;
    } else {
      if (Ext.isDefined(value)) {
        o.value = value;
      }
    }
    this.attributeFilters.attributes.push(o);
  }, removeFromAttributesFilterSet:function(id, key, value) {
    if (this.attributeFilters.attributes.length) {
      var removeIndex = undefined;
      Ext.Array.each(this.attributeFilters.attributes, function(filter, index) {
        if (filter && filter.attributeId === String(id)) {
          if (Ext.isDefined(value)) {
            if ('value' in filter) {
              if (filter.value === value) {
                removeIndex = index;
              }
            }
          }
        }
      });
      if (typeof removeIndex !== 'undefined') {
        this.attributeFilters.attributes = Ext.Array.removeAt(this.attributeFilters.attributes, removeIndex);
      }
    }
  }}, defaults));
  this.dateFilterContainer = Ext.create({xtype:'container', itemId:'dateContainer', padding:'5 0 5 0', hidden:true, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'datefield', flex:1, itemId:'from', emptyText:'Von'}, {xtype:'datefield', flex:1, itemId:'to', emptyText:'Bis'}]});
  this.items = [this.dateFilterContainer, this.activeFilterWrapper, this.attributeOverview, this.aggregatedAttributes];
  this.dockedItems = [{xtype:'toolbar', items:[{iconCls:webtsm.ConfigKeys.icons.cancel, tooltip:'Filter entfernen', handler:'removeAttributeFilters', text:'Remove', ui:'secondary', flex:1}, {iconCls:webtsm.ConfigKeys.icons.search, tooltip:'Filter übernehmen \x26 Suche absetzen', handler:'submitAttributeFilters', text:'Search', ui:'primary', flex:2}], readOnly:this.readOnly, dock:'bottom', moduleId:this.moduleId}];
  this.callParent(arguments);
}, onDateFilterContainerToggle:function() {
  this.dateFilterContainer.setVisible(!this.dateFilterContainer.isVisible(true));
}});
Ext.define('webtsm.manager.search.AttributesSearchField', {extend:'Ext.container.Container', alias:'widget.webtsmAttributesSearchField', layout:{type:'vbox', align:'stretch'}, padding:'0 0 0 0', margin:'0 0 0 0', attributesCheckboxDef:undefined, initComponent:function() {
  var $jscomp$this = this;
  var items = [];
  var defaults = {flex:1, margin:'-5 0 0 0', padding:'0 0 0 0', xtype:'checkboxfield', listeners:{change:function(cmp, newVal, oldVal) {
    var valueCheckBoxes = $jscomp$this.query('checkboxfield');
    if ('attributeId' in cmp && Ext.isDefined(cmp.attributeId)) {
      newVal ? $jscomp$this.addToAttributesFilterSet(cmp.attributeId, cmp.attributeKey, cmp.attributeValue) : $jscomp$this.removeFromAttributesFilterSet(cmp.attributeId, cmp.attributeKey, cmp.attributeValue);
    } else {
      if ('attributeSelect' in cmp) {
        Ext.Array.each(valueCheckBoxes, function(checkbox) {
          if ('attributeId' in checkbox) {
            checkbox.setValue(!!newVal);
          }
        });
      }
    }
  }}};
  this.defaults = defaults;
  var attributeCheckBox = {xtype:'checkboxfield', padding:'0 0 0 0', margin:'-5 0 0 0', attributeValues:0, tsId:0, listeners:{change:function(cmp, newVal, oldVal) {
    if ('attributeId' in cmp && Ext.isDefined(cmp.attributeId)) {
      if (newVal) {
        this.addToFilterSet(cmp.attributeId);
        return;
      }
      this.removeFromFilterSet(cmp.attributeId);
    }
  }.bind(this)}};
  var valuesCount = 0, isCompressed = false;
  if (Ext.isObject(this.attributesCheckboxDef)) {
    attributeCheckBox = Ext.apply(attributeCheckBox, this.attributesCheckboxDef);
    if (attributeCheckBox && 'webtsmAttributeViewMode' in attributeCheckBox && attributeCheckBox.webtsmAttributeViewMode === 'compressed') {
      if ('values' in attributeCheckBox && attributeCheckBox.values && Ext.isObject(attributeCheckBox.values)) {
        if ('values' in attributeCheckBox.values) {
          var values = attributeCheckBox.values.values;
          isCompressed = true;
          if ('attributeId' in attributeCheckBox) {
            var attributeId = attributeCheckBox.attributeId;
            valuesCount = values.length;
            values.sort(webtsm.Support.sortWrapper('value', true, true));
            var relevantValues = values.filter(function(item) {
              return 'value' in item;
            });
            var newItems = relevantValues.map(function(item) {
              var value = item.value, boxLabel = value;
              if (!value || value === 'null') {
                value = 'webtsmEmpty';
                boxLabel = 'Leerer Wert';
              }
              var attributeValue = value;
              var o = {boxLabel:boxLabel + ' ( ' + item.valueCount + ' ) ', attributeValue:attributeValue, attributeId:attributeId, margin:'-12 0 0 25'};
              if ('activeValues' in attributeCheckBox && attributeCheckBox.activeValues && Ext.isArray(attributeCheckBox.activeValues)) {
                Ext.Array.each(attributeCheckBox.activeValues, function(obj) {
                  if ('value' in obj && obj.value && obj.value === attributeValue) {
                    o.disabled = true;
                    attributeCheckBox.value = true;
                  }
                });
              }
              return o;
            });
            items = items.concat(newItems);
            if (values.length > 0) {
              items.push({boxLabel:'Nicht leerer Wert', attributeValue:'webtsmNotEmpty', attributeId:attributeId, margin:'-12 0 0 25'});
            }
          }
        }
      }
    }
  }
  attributeCheckBox.boxLabel = this.searchRoot.getNameById(attributeCheckBox.attributeId) + ' ( ' + attributeCheckBox.tsId + (isCompressed ? ' / ' + valuesCount : '') + ' )';
  this.items = Ext.Array.insert(items, 0, [attributeCheckBox]);
  this.callParent(arguments);
}, addToFilterSet:function(attributeId) {
  this.searchPanelLeft.aggregatedAttributes.addToFilterSet(attributeId);
}, removeFromFilterSet:function(attributeId) {
  this.searchPanelLeft.aggregatedAttributes.removeFromFilterSet(attributeId);
}, addToAttributesFilterSet:function(id, key, value) {
  this.searchPanelLeft.aggregatedAttributes.addToAttributesFilterSet(id, key, value);
}, removeFromAttributesFilterSet:function(id, key, value) {
  this.searchPanelLeft.aggregatedAttributes.removeFromAttributesFilterSet(id, key, value);
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.tseditor.CreateTimeseriesGrid', {extend:'Ext.grid.Panel', alias:'widget.webtsmTsCreateGrid', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component', 'webtsm.mixins.AuditLog'], viewModel:{data:{Name:null, Type:null, Unit:null, units:[], types:[]}, stores:{unitStore:{data:'{units}'}, typeStore:{data:'{types}'}}}, header:false, hideHeaders:false, initComponent:function() {
  var $jscomp$this = this;
  this.viewConfig = {emptyText:this.TR('GRID_EMPTYTEXT_INFO_NO_TIMESERIES_CONFIG_EXISTS_PLEASE_CREATE'), grid:this, deferEmptyText:true, enableTextSelection:true, getRowClass:function(record, rowIndex, rowParams, store) {
    return record.get('hasError') === true ? 'ts-error' : 'ts-valid';
  }};
  this.store = Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    var v = $jscomp$this.down('tableview');
    if (v) {
      v.refresh();
    }
    var timeseriesExists = false;
    s.each(function(r) {
      var id = r.get('ID');
      if (id && id !== -1 && !timeseriesExists) {
        timeseriesExists = true;
      }
    });
    var b = $jscomp$this.down('#viewerJumpButton');
    if (b) {
      b.setDisabled(!timeseriesExists);
    }
    return true;
  }}});
  this.columns = [{dataIndex:'ID', flex:1, maxWidth:100}, {dataIndex:'Name', flex:1}, {dataIndex:'Type', flex:1, renderer:function(value) {
    var match = $jscomp$this.types.filter(function(i) {
      return i.ID === value;
    });
    return match.length ? match[0].Name : value;
  }}, {text:'INTERVAL', dataIndex:'interval', flex:1, renderer:function(value, metaData, record, rowIndex, colIndex, store, view) {
    var rendered = (record.get('intervalMultiplier') === 1 ? '' : record.get('intervalMultiplier')) + ' ' + view.grid.getIntervalText(value);
    return rendered.trim();
  }}, {dataIndex:'interval', flex:1, hidden:true, renderer:function(value, metaData, record, rowIndex, colIndex, store, view) {
    return view.grid.getIntervalText(value);
  }}, {dataIndex:'intervalMultiplier', hidden:true, flex:1}, {dataIndex:'Unit', renderer:function(value, metaData, record, rowIndex, colIndex, store, view) {
    var g = view.up('webtsmTsCreateGrid');
    var match = g.units.filter(function(i) {
      return i.ID === value;
    });
    return match.length ? match[0].Name : value;
  }}, {xtype:'actioncolumn', text:'ACTIONS', width:70, style:webtsm.Support.getDefaultGridStyle(), items:[{iconCls:webtsm.ConfigKeys.icons.remove, tooltip:this.TR('REMOVE'), handler:function(tableView, rowIndex, colIndex, item) {
    tableView.getStore().removeAt(rowIndex);
  }}, {iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons["delete"]), tooltip:this.TR('DELETE'), actionKey:'ts_delete', isActionDisabled:function(v, row, col, item, r) {
    return r.get('created') !== true && r.get('ID') === -1;
  }, handler:function(tableView, rowIndex, colIndex, item, e, r) {
    webtsm.Support.deleteTimeseriesWithMessage($jscomp$this.moduleId, r.get('ID')).then(function(success) {
      if (success) {
        $jscomp$this.store.removeAt(rowIndex);
      }
    }, function(error) {
    });
  }}].map(function(item) {
    if (!Ext.isDefined(item.isActionDisabled)) {
      item.isActionDisabled = function(tableView, rowI, colI, item) {
        var rec = tableView.getStore().getAt(rowI);
        return !(rec && rec.get('created'));
      };
    }
    return item;
  })}, {xtype:'checkcolumn', dataIndex:'created', readOnly:true}, {dataIndex:'Message'}].map(function(item) {
    return Ext.apply(item, {text:item.dataIndex ? item.dataIndex.toUpperCase() : item.text ? item.text.toUpperCase() : '', style:webtsm.Support.getDefaultGridStyle()});
  });
  this.addTsmConfigBtn = Ext.create({iconCls:this.faIcon('fa-plus'), text:this.TR('WEBTSM_ADD_TS'), itemId:'addBtn', ui:'primary', xtype:'button', disabled:true, handler:function(btn) {
    var nameField = $jscomp$this.down('#newTsName');
    var typeCombo = $jscomp$this.down('#typeCombo');
    var unitCombo = $jscomp$this.down('#unitCombo');
    var intervalCombo = $jscomp$this.down('#intervalCombo');
    var intervalValue = intervalCombo.getValue();
    var interval = intervalValue, intervalMultiplier = 1;
    if (intervalValue === 4269) {
      interval = 2;
      intervalMultiplier = 15;
    }
    var tsToCreateObj = Ext.apply({'ID':-1, 'interval':interval, 'intervalMultiplier':intervalMultiplier, 'Type':typeCombo.getValue(), 'Unit':unitCombo.getValue(), created:false}, {Name:nameField.getValue()});
    $jscomp$this.store.add(tsToCreateObj);
    nameField.setValue('');
  }});
  this.dockedItems = [{xtype:'toolbar', dock:'top', padding:'5 5 5 5', defaults:{margin:'0 5 0 5'}, items:[{xtype:'textfield', fieldLabel:'Name', itemId:'newTsName', flex:1, grid:this, bind:{value:'{Name}', emptyText:this.TR('WEBTSM_SELECT_TS_NAME_PLEASE')}, listeners:{change:function(f, newVal) {
    f.grid.addTsmConfigBtn.setDisabled(!(newVal && newVal.length));
  }}}, {xtype:'combobox', fieldLabel:this.TR('TYPE'), itemId:'typeCombo', displayField:'Name', valueField:'ID', flex:1, emptyText:this.TR('SELECT_TYPE_PLEASE'), bind:{value:'{Type}', store:'{typeStore}'}, queryMode:'local'}, {xtype:'combobox', fieldLabel:this.TR('UNIT'), itemId:'unitCombo', displayField:'Name', flex:1, valueField:'Name', emptyText:this.TR('SELECT_UNIT_PLEASE'), bind:{value:'{Unit}', store:'{unitStore}'}, queryMode:'local'}, {xtype:'combobox', fieldLabel:this.TR('INTERVAL'), itemId:'intervalCombo', 
  displayField:'Name', flex:1, valueField:'ID', emptyText:this.TR('SELECT_INTERVAL_PLEASE'), store:webtsm.Support.createIntervalStore(this.moduleId)}, this.addTsmConfigBtn]}];
  this.enableBaseButtons({clear:{iconCls:'fa-eraser', tr:'CLEAR_MASK', ui:'secondary'}, create:{iconCls:'fa-plus', tr:'BTN_LABEL_CREATE_TIMESERIES', ui:'primary'}});
  this.clearButton = this.createBaseButton('clear', {iconAlign:'top', scale:'medium', handler:function() {
    $jscomp$this.store.removeAll();
  }});
  this.createButton = this.createBaseButton('create', {iconAlign:'top', scale:'medium', handler:function() {
    $jscomp$this.createTimeseries();
  }});
  var bottomItems = [].concat(webtsm.Api.getViewerActions(this.moduleId).map(function(item) {
    item.iconAlign = 'top';
    item.scale = 'medium';
    item.handler = function(b) {
      var bucket = {bucket:[]};
      $jscomp$this.store.each(function(r) {
        if (r.get('created') && r.get('ID') !== -1) {
          bucket.bucket.push({ID:r.get('ID')});
        }
      });
      BpcCommon.Api.showModule(webtsm.Api.module.getViewerId($jscomp$this.moduleId), true, bucket || {});
    };
    item.ui = 'primary';
    item.itemId = 'viewerJumpButton';
    return item;
  })).concat([this._fill(), this.clearButton, this.createButton]);
  this._addDocked(bottomItems);
  this.initAuditLog(webtsm.Support.logEventNames.create);
  this.callParent(arguments);
  webtsm.Api.getRequestData(this.moduleId, '/types', 'GET', false).then(function(data) {
    data = data || [];
    $jscomp$this.types = data;
    $jscomp$this.getViewModel().set('types', data);
  });
  webtsm.Api.getRequestData(this.moduleId, '/units', 'GET', true).then(function(data) {
    data = data || [];
    $jscomp$this.units = data;
    $jscomp$this.getViewModel().set('units', data);
  });
}, createTimeseries:function() {
  var $jscomp$this = this;
  var tsDefinitions = [], storeModels = [];
  var store = this.store;
  store.each(function(r) {
    if (r.get('created') === false) {
      var $jscomp$destructuring$var46 = r.getData();
      var ID = $jscomp$destructuring$var46.ID;
      var interval = $jscomp$destructuring$var46.interval;
      var intervalMultiplier = $jscomp$destructuring$var46.intervalMultiplier;
      var Name = $jscomp$destructuring$var46.Name;
      var Type = $jscomp$destructuring$var46.Type;
      var Unit = $jscomp$destructuring$var46.Unit;
      tsDefinitions.push({ID:ID, Interval:{Value:interval, Multiplier:intervalMultiplier}, Name:Name, Type:Type, Unit:Unit});
      storeModels.push(r);
    }
  });
  if (tsDefinitions.length) {
    var requests = tsDefinitions.map(function(data, i) {
      return new Promise(function(resolve) {
        webtsm.Api.timeseries.create($jscomp$this.moduleId, data).then(function(r) {
          storeModels[i].set('created', true);
          storeModels[i].set('responseCode', r.status);
          storeModels[i].set('ID', r.responseText);
          $jscomp$this.writeAuditLogData({ID:r.responseText});
          resolve(true);
        }, function(r) {
          var obj = webtsm.Support.getResponseObject(r);
          if (obj.Message) {
            storeModels[i].set('Message', obj.Message);
          }
          data.error = true;
          $jscomp$this.writeAuditLogData(data);
          resolve(false);
        });
      });
    });
    Promise.all(requests).then(function(array) {
      if (array.indexOf(true) !== -1) {
        webtsm.Api.cacheRefresh($jscomp$this.moduleId, false);
      }
    });
  } else {
    BpcCommon.Api.showNotification('WARN_NO_MATCHING_TIMESERIES_FOUND');
  }
}, getIntervalText:function(value) {
  var match = (webtsm.Support.rendererData.intervals || []).filter(function(i) {
    return i.ID === value;
  });
  return match.length ? webtsm.Support.getTranslation(match[0].languageKey.toUpperCase()) : value;
}, getStoreAsBucket:function(index) {
  var storeModels = Ext.isDefined(index) ? [this.store.getAt(index)] : this.store.getData().getRange();
  return webtsm.Support.createPayloadFromModelInstanceArray(storeModels);
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.tseditor.EditorMain', {extend:'Ext.panel.Panel', alias:'widget.webtsmEditorMain', mixins:['webtsm.view.viewer.WebTsmViewerMixin', 'webtsm.mixins.Component', 'webtsm.mixins.AuditLog'], requires:['webtsm.ConfigKeys'], iconCls:webtsm.ConfigKeys.icons.edit, layout:{type:'hbox', align:'stretch'}, moduleInstance:undefined, tsmInitialPayload:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = webtsm.Support.getTranslation('EDIT_VALUES', undefined, false);
  this.viewerId = webtsm.Api.module.getViewerId(this.moduleId);
  this.bucket = Ext.create({xtype:'webtsmBucketGrid', flex:2, bucketStore:this.managerMain.bucketStore, hideHeaders:false, bbar:[], moduleId:this.moduleId, moduleInstance:this.moduleInstance, listeners:{select:function(selModel, record, index, eOpts) {
    $jscomp$this.updateTimeseriesId(record.get('ID'));
  }}});
  this.requestContainer = Ext.create({xtype:'webtsmRequestContainer', moduleId:this.moduleId});
  this.valueEditor = Ext.create({xtype:'tsmValueEditorGrid', editorMain:this, moduleId:this.moduleId, moduleInstance:this.moduleInstance, flex:1});
  this.editor = Ext.create({xtype:'container', itemId:'webtsmEditorWrapper', padding:'5 5 5 5', flex:6, layout:{type:'vbox', align:'stretch'}, moduleId:this.moduleId, moduleInstance:this.moduleInstance, items:[this.requestContainer, this.valueEditor]});
  this.items = [this.bucket, this.editor];
  this.initAuditLog(webtsm.Support.logEventNames.edit);
  this.callParent(arguments);
  this.requestContainer.intervalCombo.getStore().load({callback:function(records, operation, success) {
    if (success) {
      $jscomp$this.loadViewer();
    }
  }});
}, loadViewer:function() {
  this.requestContainer.setRequestParams(this.getDefaultParameters(webtsm.Api.module.getViewerId(this.moduleId)));
}, loadBucket:function(payload) {
  var bucketGrid = this.bucket, store = bucketGrid.getStore(), bucket = undefined;
  store.removeAll();
  if (Ext.isDefined(payload) && Ext.isObject(payload) && 'bucket' in payload && payload.bucket && Ext.isArray(payload.bucket)) {
    this.tsmInitialPayload = payload;
    bucket = payload.bucket;
  } else {
    if (payload && Ext.isArray(payload)) {
      bucket = payload;
    } else {
      return;
    }
  }
  store.add(bucket);
  if (Ext.isArray(bucket) && bucket.length) {
    if ('ID' in bucket[0] && bucket[0].ID) {
      this.updateTimeseriesId(bucket[0].ID);
    }
  }
}, getSelectedTimeseries:function() {
  return this.bucket.getStoreAsBucket();
}, updateTimeseriesId:function(id) {
  var $jscomp$this = this;
  webtsm.Api.timeseries.getMeta(this.moduleId, id).then(function(metadataObj) {
    var id = null, name = null, unit = undefined, intervalId = undefined, multiplier = undefined;
    Ext.iterate(metadataObj, function(k, v) {
      if (k === 'Name' || k === 'ID') {
        if (k === 'Name') {
          name = v;
        }
        if (k === 'ID') {
          id = v;
        }
        if (k === 'Unit') {
          id = v;
        }
      } else {
        if (k === 'Interval') {
          intervalId = v.Value;
          multiplier = v.Multiplier;
          if (Ext.isDefined(intervalId) && Ext.isDefined(multiplier)) {
          }
        }
      }
    });
    var string = '';
    if (Ext.isDefined(name) && name !== null) {
      string += name;
    }
    if (Ext.isDefined(unit) && unit !== null) {
      string += ' in ' + unit;
    }
    if (Ext.isDefined(intervalId) && intervalId !== null && Ext.isDefined(multiplier) && multiplier !== null) {
      string += ' - Intervall: ' + intervalId + ' - Multiplikator: ' + multiplier;
    }
    $jscomp$this.tsId = id;
    $jscomp$this.loadValues(id);
  }, function(reason) {
    webtsm.Support.notify('Beim Abruf der Metadaten für ID: ' + id + ' trat ein Fehler auf.');
  });
}, tsId:undefined, loadValues:function(timeseriesId) {
  var $jscomp$this = this;
  var tsId = timeseriesId;
  if (!tsId && this.tsId) {
    tsId = this.tsId;
  }
  var requestObject = this.requestContainer.getRequestParams();
  var params = this.getQueryFromRequestObject(requestObject, undefined, this.viewerId);
  webtsm.Api.timeseries.getData(this.viewerId, tsId, params).then(function(dataArray) {
    var store = $jscomp$this.valueEditor.getStore();
    if (store) {
      store.removeAll();
      if (Ext.isObject(dataArray)) {
        if ('errorMessage' in dataArray && dataArray.errorMessage) {
          var o = dataArray.errorMessage;
          if ('Message' in o && o.Message) {
            $jscomp$this.applyEmptyText(o['Message']);
          }
        } else {
          var data = $jscomp$this.handleData(dataArray);
          store.add(data);
        }
      } else {
        store.add(dataArray);
      }
    }
  }, function(reason) {
  });
}, editTimeseriesMeta:{}, handleData:function(item) {
  this.isTSM39x = true;
  var $jscomp$destructuring$var47 = item;
  var Unit = $jscomp$destructuring$var47.Unit;
  var TimeZone = $jscomp$destructuring$var47.TimeZone;
  var Interval = $jscomp$destructuring$var47.Interval;
  this.editTimeseriesMeta = {Unit:Unit, TimeZone:TimeZone, Interval:Interval};
  var valueData = item.Data || [];
  var diffMillis, canAddDate = false;
  if (valueData.length >= 2) {
    var first = valueData[0] || {};
    var second = valueData[1] || {};
    var d1 = new Date(first.From);
    var d2 = new Date(second.From);
    diffMillis = Math.abs(d2 - d1);
    canAddDate = true;
  }
  item = valueData.map(function(i, index, array) {
    if (array[index + 1]) {
      var next = array[index + 1];
      if (next.From) {
        var $jscomp$destructuring$var48 = next;
        var From = $jscomp$destructuring$var48.From;
        i.To = From;
      }
    }
    if (canAddDate && array.length - 1 === index) {
      var from = new Date(i.From);
      var millis = from.getTime() + diffMillis;
      i.To = (new Date(millis)).toISOString();
    }
    return i;
  });
  return item;
}, isTSM39x:false, prepareValues:function() {
  var data = this.valueEditor.getStoreModels(), version;
  if (webtsm.Api.versionEnabled(this.viewerId)) {
    version = this.down('webtsmVersionCombo').getValue();
  }
  if (this.isTSM39x) {
    var body = this.editTimeseriesMeta || {};
    body.Data = data.map(function(item) {
      delete item.To;
      return item;
    });
    data = body;
  }
  return {version:version, data:data};
}, prepareAndWriteDataOnTimeSeries:function() {
  var $jscomp$this = this;
  var $jscomp$destructuring$var49 = this.prepareValues();
  var data = $jscomp$destructuring$var49.data;
  var version = $jscomp$destructuring$var49.version;
  var auditLogData = {_moduleId:this.moduleId, ID:this.tsId, Version:version, Unit:null, Values:data};
  this.doAsyncAction(version, data).then(function(error) {
    auditLogData.error = error;
    $jscomp$this.writeAuditLogData(auditLogData);
    return error;
  }).then(function(error) {
    if (!error) {
      $jscomp$this.loadValues();
    }
  });
}, doAsyncAction:function(version, data) {
  var error = false;
  return webtsm.Api.updateTimeseriesValues(this.viewerId, version, this.tsId, data).then(function(response) {
  }, function(response, opts) {
    error = true;
  })["finally"](function() {
    return error;
  });
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.tseditor.ValuesGrid', {extend:'Ext.grid.Panel', alias:'widget.tsmValueEditorGrid', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component', 'webtsm.mixins.AuditLog'], viewConfig:{markDirty:false, emptyText:'Keine Daten geladen, bitte Zeitreihe wählen.', enableTextSelection:true, getRowClass:function(record, rowIndex, rowParams, store) {
  if (record && record.get('meta')) {
    return rowIndex & 1 ? 'webtsm-grid-odd' : 'webtsm-grid-even';
  }
  return 'webtsm-grid';
}}, viewModel:{data:{hideRolloutFields:true, rolloutFlag:undefined, rolloutValue:undefined}, formulas:{valueEnabled:function(get) {
  var rValue = get('rolloutValue');
  var enabled = false;
  if (rValue || Ext.isDefined(rValue) && rValue === 0) {
    enabled = true;
  }
  return enabled;
}, flagEnabled:function(get) {
  return !!get('rolloutFlag');
}}}, iconCls:webtsm.ConfigKeys.icons.edit, selModel:'cellmodel', header:false, plugins:{ptype:'cellediting', clicksToEdit:1}, tsId:undefined, features:[{ftype:'summary', dock:'bottom'}], listeners:{'edit':function(editor, e) {
  if ('record' in e && e.record) {
    var $jscomp$destructuring$var50 = e.record.data || {};
    var Value = $jscomp$destructuring$var50.Value;
    var Flag = $jscomp$destructuring$var50.Flag;
    if (Value && Flag === 19) {
      e.record.set('Flag', BpcCommon.Api.getSetting(e.grid.moduleId, 'flags_defaultEditing'));
      e.record.commit();
    }
  }
}}, getBaseDateColumn:function(dataIndex, flex) {
  dataIndex = dataIndex === void 0 ? '' : dataIndex;
  flex = flex === void 0 ? 2 : flex;
  return {xtype:'datecolumn', dataIndex:dataIndex, format:webtsm.Support.defaultDateFormat, flex:flex};
}, initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {fields:['From', 'To', 'Flag', 'Value'], data:[]});
  this.columns = [{xtype:'gridcolumn', dataIndex:'dummy', align:'right', width:60, text:webtsm.Support.getSpanForIconCls(webtsm.Support.getBpcIconCls('fa-sort-numeric-down'), 'black'), renderer:function(v, m, r, rowIndex) {
    return rowIndex + 1;
  }}, this.getBaseDateColumn('From'), this.getBaseDateColumn('To'), {dataIndex:'Flag', flex:4, renderer:function(v) {
    var flags = $jscomp$this.moduleInstance && $jscomp$this.moduleInstance.flags ? $jscomp$this.moduleInstance.flags : [];
    if (Ext.isDefined(v)) {
      Ext.Array.each(flags, function(flagItem) {
        if (flagItem.ID && flagItem.Name && flagItem.ID === v) {
          v = '\x3cspan style\x3d"display:inline-block;width:30px;text-align: right!important; margin-right: 15px;"\x3e' + v + '\x3c/span\x3e' + flagItem.Name;
          return false;
        }
      });
    }
    return v;
  }, editor:{xtype:'webtsmFlagCombo', moduleId:this.moduleId, allowBlank:false}, summaryRenderer:function() {
    return '\x3cb\x3eAggregation\x3c/b\x3e';
  }}, {dataIndex:'Value', flex:4, editor:{xtype:'numberfield', allowDecimals:true, allowBlank:false, decimalPrecision:BpcCommon.Api.getSetting(this.moduleId, 'editor_maxDecimals')}, summaryType:'sum'}, {xtype:'actioncolumn', width:25, items:[{iconCls:webtsm.ConfigKeys.icons.remove, tooltip:webtsm.Support.TR('REMOVE_ROW'), handler:function(grid, rI) {
    $jscomp$this.store.removeAt(rI);
  }}]}].map(function(c) {
    c.style = webtsm.Support.getDefaultGridStyle();
    if (c.dataIndex) {
      c.text = webtsm.Support.TR(c.dataIndex);
    }
    return c;
  });
  this.enableBaseButtons({submit:{iconCls:'fa-pen', tr:'WRITE_VALUES', ui:'primary'}, rollout:{iconCls:'fa-cog', tr:'ROLLOUT_VALUES_AND_FLAGS', ui:'primary'}, applyRolloutValues:{iconCls:'fa-check', tr:'APPLY_VALUES', ui:'secondary'}, setFlag:{iconCls:'fa-check', tr:'WRITE_VALUES', ui:'secondary'}, changedValues:{ui:'secondary'}}, {scale:'medium', iconAlign:'top'});
  this.applyRolloutBtn = this.createBaseButton('applyRolloutValues', {itemId:'valueApplyBtn', tooltip:'Wert für alle Einträge im Store setzen', bind:{disabled:'{!valueEnabled}', hidden:'{hideRolloutFields}'}, disabled:true, ui:'secondary', handler:function(btn) {
    var vm = $jscomp$this.getViewModel(), f = vm.get('rolloutValue');
    var defaultFlag = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'flags_defaultEditing');
    $jscomp$this.store.each(function(model) {
      model.set('Value', f);
      var flagValue = model.get('Flag');
      if (flagValue === 19) {
        model.set('Flag', defaultFlag);
      }
    });
    vm.set('rolloutValue', null);
  }});
  this.rolloutBtn = this.createBaseButton('rollout', {bind:{hidden:'{!hideRolloutFields}'}, handler:function(btn) {
    var vm = $jscomp$this.getViewModel();
    vm.set('hideRolloutFields', !vm.get('hideRolloutFields'));
  }});
  this.setFlagBtn = this.createBaseButton('setFlag', {tooltip:'Flag für alle Einträge im Store setzen', itemId:'flagApplyBtn', bind:{disabled:'{!flagEnabled}', hidden:'{hideRolloutFields}'}, handler:function(btn) {
    var vm = $jscomp$this.getViewModel(), f = vm.get('rolloutFlag');
    $jscomp$this.store.each(function(model) {
      model.set('Flag', f);
    });
    vm.set('rolloutFlag', null);
  }});
  this.changedValuesBtn = this.createBaseButton('changedValues', {xtype:'webtsmStoreFilterBtn', listeners:{toggle:function(container, button, pressed) {
    $jscomp$this.filterTsmValuesStore(button, !pressed);
  }}});
  this.reloadButton = this.createBaseButton('refresh', {handler:function() {
    $jscomp$this.editorMain.loadValues();
  }});
  this.submitButton = this.createBaseButton('submit', {handler:function() {
    $jscomp$this.editorMain.prepareAndWriteDataOnTimeSeries();
  }});
  this._addDocked([this.rolloutBtn, {xtype:'numberfield', fieldLabel:'Wert', emptyText:'Wert ausrollen', itemId:'webtsmRolloutValue', bind:{value:'{rolloutValue}', hidden:'{hideRolloutFields}'}, flex:1}, this.applyRolloutBtn, {xtype:'webtsmFlagCombo', fieldLabel:'Flag', moduleId:this.moduleId, emptyText:'Flag ausrollen', itemId:'webtsmRolloutFlag', allowBlank:true, bind:{value:'{rolloutFlag}', hidden:'{hideRolloutFields}'}, flex:1}, this.setFlagBtn, this._fill(), this.changedValuesBtn], 'top');
  this._addDocked([this.reloadButton, this._fill(), this.submitButton]);
  this.callParent(arguments);
}, getStoreModels:function() {
  return (this.store.getData().getRange() || []).map(function(r) {
    var data = r.getData() || {};
    var $jscomp$destructuring$var51 = data;
    var From = $jscomp$destructuring$var51.From;
    var To = $jscomp$destructuring$var51.To;
    var Value = $jscomp$destructuring$var51.Value;
    var Flag = $jscomp$destructuring$var51.Flag;
    From = webtsm.Support.formatDates(From);
    To = webtsm.Support.formatDates(To);
    return {From:From, To:To, Value:Value, Flag:Flag};
  });
}, applyEmptyText:function(text) {
  var tableView = this.down('tableview');
  if (Ext.isDefined(tableView)) {
    tableView.setEmptyText(text);
  }
}, removeAllFilters:function() {
  this.store.clearFilter();
  this.isFiltered = false;
  this.tsmFilterType = undefined;
}, isFiltered:false, tsmFilterType:undefined, filterTsmValuesStore:function(btn, kill) {
  try {
    var view = this;
    if (view.isFiltered && btn.tsmFilterAction !== view.tsmFilterType) {
      this.removeAllFilters();
    }
    if (kill) {
      this.removeAllFilters();
    } else {
      if ('tsmFilterAction' in btn && btn.tsmFilterAction) {
        var store = view.getStore(), keys = [], relevant = [], lastValueObj = [];
        relevant.push('Value');
        if (btn.tsmFilterAction === 'changed') {
          Ext.Array.each(relevant, function(key) {
            lastValueObj[key] = null;
          });
        }
        var changed = function(s, relevant, lastValueObj) {
          s.filterBy(function(record) {
            var filter = false;
            Ext.Array.each(relevant, function(key, index) {
              var value = record.get(key);
              if (value !== lastValueObj[key]) {
                filter = true;
              }
              lastValueObj[key] = value;
            });
            return filter;
          });
        };
        var empty = function(s, relevant, lastValueObj) {
          s.filterBy(function(record) {
            var filter = false;
            Ext.Array.each(relevant, function(key) {
              var value = record.get(key);
              if (value != 0) {
                filter = true;
              }
            });
            return filter;
          });
        };
        var filters = {changed:changed, empty:empty};
        filters[btn.tsmFilterAction](store, relevant, lastValueObj);
        view.isFiltered = true;
        view.tsmFilterType = btn.tsmFilterAction;
      }
    }
  } catch (e) {
    this.removeAllFilters();
  }
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.attributesmanager.AttributeEditor', {extend:'Ext.grid.Panel', alias:'widget.webtsmAttributeEditor', requires:['webtsm.ConfigKeys'], plugins:{ptype:'cellediting', clicksToEdit:1}, hideHeaders:false, viewConfig:{enableTextSelection:true}, moduleId:undefined, attributeValues:undefined, attributeId:undefined, attributeList:[], grid:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {fields:['date', 'key', 'value'], data:[]});
  this.viewConfig = {emptyText:'Keine Attribute / Eigenschaften gesetzt', enableTextSelection:true, dateDisplayFormat:BpcCommon.Api.getSetting(this.moduleId, 'attributes_keyFormat') || 'd.m.Y H:i:s'};
  this.attributeValueDateFormat = 'c';
  this.columns = [{dataIndex:'date', text:webtsm.Support.TR('ATTRIBUTE_KEY'), renderer:function(date) {
    if (date) {
      return date.toISOString();
    }
    return '';
  }, flex:1, editor:{field:{xtype:'datefield', format:this.attributeValueDateFormat}}}, {dataIndex:'value', text:webtsm.Support.TR('ATTRIBUTE_VALUE'), flex:1, editor:{field:{xtype:'textfield'}}}, {xtype:'actioncolumn', text:'OPTIONEN', width:75, items:[{iconCls:webtsm.Support.getBpcIconCls(webtsm.Support.keys.icons["delete"]), tooltip:'Attributwert entfernen', width:25, handler:function(tableView, rowIndex) {
    $jscomp$this.store.removeAt(rowIndex);
  }}]}];
  this.dateField = Ext.create({xtype:'datefield', itemId:'key', format:BpcCommon.Api.getSetting(this.moduleId, 'attributes_keyFormat'), altFormats:'C', emptyText:webtsm.Support.getTranslation('DATE'), moduleId:this.moduleId, value:BpcCommon.Api.getSetting(this.moduleId, 'attributes_keyDefaultDate'), restoreDefaultDate:function() {
    this.setValue(BpcCommon.Api.getSetting(this.moduleId, 'attributes_keyDefaultDate'));
  }});
  this.valueField = Ext.create({xtype:'textfield', emptyText:webtsm.Support.getTranslation('ATTRIBUTE_VALUE'), listeners:{change:function(c, newVal, oldVal) {
    var noValue = !Ext.isDefined(newVal) || Ext.isDefined(newVal) && newVal.length === 0;
    this.addBtn.setDisabled(noValue);
    this.submitBtn.setDisabled(!noValue);
  }.bind(this)}});
  this.addBtn = Ext.create({xtype:'button', disabled:true, iconCls:webtsm.ConfigKeys.icons.plus, handler:function(btn) {
    var date = $jscomp$this.dateField.getValue();
    $jscomp$this.store.add({key:date.toISOString(), value:$jscomp$this.valueField.getValue(), date:date});
    $jscomp$this.dateField.restoreDefaultDate();
    $jscomp$this.valueField.setValue('');
  }});
  this.submitBtn = Ext.create({xtype:'button', disabled:true, iconCls:webtsm.ConfigKeys.icons.check, text:'Werte übernehmen', handler:function() {
    var values = {};
    $jscomp$this.store.each(function(r) {
      var key = r.get('key');
      values[key] = r.get('value');
    });
    $jscomp$this.grid.updateAttributes([{AttributeID:$jscomp$this.attributeId, Values:values}]);
    var w = $jscomp$this.up('window');
    if (w) {
      w.close();
    }
  }});
  this.bbar = [this.dateField, this.valueField, this.addBtn, {xtype:'tbfill'}, this.submitBtn];
  this.callParent(arguments);
  this.initData(this.attributeValues || '');
}, initData:function(attributeValuesStr) {
  var attributeValuesObj = Ext.decode(attributeValuesStr, true) || {}, storeData = [];
  for (var key in attributeValuesObj) {
    if (attributeValuesObj[key]) {
      storeData.push({key:key, value:attributeValuesObj[key], date:Ext.Date.parse(key, this.attributeValueDateFormat)});
    }
  }
  storeData.length ? this.store.loadData(storeData) : this.store.removeAll();
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.attributesmanager.AttributesDataPanel', {extend:'Ext.panel.Panel', alias:'widget.webtsmAttributesDataPanel', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  this.attributePreviewPanel = Ext.create({xtype:'webtsmAttributesTabpanel', flex:1, itemId:'attributePreviewPanel', moduleId:this.moduleId, managerMain:this.managerMain});
  this.attributesGridSingle = Ext.create({xtype:'webtsmAttributesGridSingle', flex:1, hideHeaders:false, moduleId:this.moduleId, managerMain:this.managerMain});
  this.items = [this.attributePreviewPanel, {xtype:'splitter'}, this.attributesGridSingle];
  this.enableBaseButtons({addSingle:{iconCls:'fa-code-merge', tr:'ADD_ATTRIBUTES', ui:'primary'}}, {scale:'medium', iconAlign:'top'});
  this.refreshButton = this.createBaseButton('refresh', {handler:function() {
    $jscomp$this.updateAttributesOverview();
  }});
  this.addSingleBtn = this.createBaseButton('addSingle', {disabled:true, handler:function() {
    $jscomp$this.mergeAttributes();
  }});
  this._addDocked([this.refreshButton, this._fill(), this.addSingleBtn]);
  this.callParent(arguments);
  this.attributesGridSingle.store.on('datachanged', function(s) {
    var disabled = s.getCount() === 0 ? true : $jscomp$this.attributesGridSingle.validateStore() === false;
    $jscomp$this.addSingleBtn.setDisabled(disabled);
  });
}, getIds:function() {
  var mainAttributes = this.up('webtsmAttributesOverview'), bucketStore = mainAttributes.bucket.getStore();
  return bucketStore.getData().getRange();
}, getIdsAndAttributes:function(emptyAttributes) {
  var attributes = emptyAttributes ? [] : this.attributesGridSingle.getAttributeDefinitions();
  var ids = this.getIds();
  if (ids.length) {
    return ids.map(function(tsModel) {
      return {ID:tsModel.get('ID'), Attributes:attributes};
    });
  }
}, getExistingAttributesById:function(ids) {
  var $jscomp$this = this;
  ids = ids === void 0 ? [] : ids;
  return ids.map(function(id) {
    return webtsm.Api.attributes.get($jscomp$this.moduleId, id);
  });
}, mergeAttributes:function() {
  var $jscomp$this = this;
  var payload = this.getIdsAndAttributes() || [];
  if (payload && !payload.length) {
    webtsm.Support.notify('Payload empty, loaded without ts ?', false);
    return;
  }
  Promise.all(this.getExistingAttributesById(payload.map(function(item) {
    return item.ID;
  }))).then(function(responses) {
    responses.map(function(assignments, i) {
      payload[i].existing = assignments;
      payload[i].existingIds = assignments.map(function(item) {
        return item.AttributeID;
      });
      payload[i].processedIds = [];
    });
    var mergedPayload = [];
    payload.map(function(item) {
      var merged = {ID:item.ID, data:[]};
      item.Attributes.map(function(newAssignment) {
        var newValues = Ext.apply({}, newAssignment.Values);
        var match = item.existing.filter(function(item) {
          return item.AttributeID === newAssignment.AttributeID;
        });
        if (match.length) {
          newValues = Ext.applyIf(newValues, match[0].Values || {});
        }
        merged.data.push({AttributeID:newAssignment.AttributeID, Values:newValues});
        item.processedIds.push(newAssignment.AttributeID);
      });
      item.existing.map(function(obj) {
        if (item.processedIds.indexOf(obj.AttributeID) === -1) {
          merged.data.push(obj);
        }
      });
      mergedPayload.push(merged);
    });
    $jscomp$this.assignAttributes(mergedPayload);
  });
}, assignAttributes:function(payload) {
  var $jscomp$this = this;
  var assignRequests = payload.map(function(item) {
    return webtsm.Api.attributes.assignAttributesToTimeseries($jscomp$this.moduleId, item.ID, item.data);
  });
  Promise.all(assignRequests).then(function(responses) {
    $jscomp$this.attributesGridSingle.store.removeAll();
    $jscomp$this.updateAttributesOverview();
  });
}, updateAttributesOverview:function() {
  this.up('webtsmAttributesOverview').loadBucket();
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.attributesmanager.AttributesGridSingle', {extend:'Ext.grid.Panel', alias:'widget.webtsmAttributesGridSingle', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], viewConfig:{emptyText:'Keine Attribute / Eigenschaften gesetzt', enableTextSelection:true}, selModel:'cellmodel', tsId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = this.TR('ATTRIBUTES_ASSIGNMENT');
  this.columns = [{dataIndex:'ID', width:50}, {dataIndex:'ID', flex:3, renderer:function(value) {
    var matches = $jscomp$this.managerMain.attributeList.filter(function(i) {
      return i.ID === value;
    });
    return matches.length ? matches[0].Name : value;
  }}, {dataIndex:'ValuesCount', width:50}, {dataIndex:'Values', flex:3}, {dataIndex:'valid', width:80, renderer:function(value, metaData, record) {
    return $jscomp$this.validateJsonAttribute(record.get('Values'));
  }}, {xtype:'actioncolumn', width:150, items:[{iconCls:webtsm.ConfigKeys.icons.edit, tooltip:'Attribut bearbeiten', width:25, handler:function(tableView, rowIndex) {
    var record = tableView.getStore().getAt(rowIndex);
    webtsm.Support.openWindow('Attributewerte bearbeiten', webtsm.Support.getBpcIconCls('fa-archive'), undefined, undefined, 'webtsmAttributeEditor', {attributeValues:record.get('Values'), moduleId:$jscomp$this.moduleId, grid:$jscomp$this, attributeId:record.get('ID')});
  }}, {iconCls:webtsm.ConfigKeys.icons["delete"], tooltip:'Attribut aus der Auswahl entfernen', width:25, handler:function(tableView, rowIndex, colIndex) {
    $jscomp$this.store.removeAt(rowIndex);
  }}]}].map(function(c) {
    c.text = $jscomp$this.TR('GRID_ATTRIBUTES_' + (c.dataIndex || 'OPTIONS'));
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  });
  this.enableBaseButtons({addAttribute:{iconCls:'fa-plus', tr:'ADD_ATTRIBUTE', ui:'primary'}, removeAll:{iconCls:'fa-times', tr:'REMOVE_ATTRIBUTE_ASSIGNMENTS', ui:'primary'}});
  this.addBtn = this.createBaseButton('addAttribute', {handler:function() {
    Ext.create({xtype:'webtsmAttributesSelectWindow', moduleId:$jscomp$this.moduleId, targetGrid:$jscomp$this}).show();
  }});
  this.removeBtn = this.createBaseButton('removeAll', {disabled:true, handler:function() {
    $jscomp$this.store.removeAll();
  }});
  this._addDocked([this.addBtn, {xtype:'tbfill'}, this.removeBtn], 'top');
  this.store = Ext.create('Ext.data.Store', {fields:['ID', 'Name', 'Type', 'Values'], data:[], listeners:{datachanged:function(s) {
    $jscomp$this.removeBtn.setDisabled(s.getCount() === 0);
  }}});
  this.callParent(arguments);
  if (Ext.isDefined(this.tsId)) {
    this.loadData();
  }
}, validateJsonAttribute:function(string) {
  var json = string ? Ext.decode(string, true) : undefined;
  return !!(json && Ext.isObject(json) && !Ext.Object.isEmpty(json));
}, validateStore:function() {
  var $jscomp$this = this;
  var validations = [];
  this.store.each(function(r) {
    validations.push($jscomp$this.validateJsonAttribute(r.get('Values')));
  });
  validations = Ext.Array.unique(validations);
  return validations.length === 1 && validations[0] === true;
}, loadData:function(tsId) {
  var $jscomp$this = this;
  this.setLoading(true);
  webtsm.Api.attributes.get(this.moduleId, tsId || this.tsId).then(function(array) {
    array = (array || []).map(function(a) {
      return $jscomp$this.transformAttribute(a);
    });
    $jscomp$this.store.loadData(array);
    $jscomp$this.setLoading(false);
  });
}, addAttribute:function(payload) {
  var idsToAdd = payload.map(function(i) {
    return i.ID;
  });
  var storeIds = [];
  this.store.each(function(rec) {
    storeIds.push(rec.get('ID'));
  });
  var diff = Ext.Array.difference(idsToAdd, storeIds);
  if (diff.length) {
    this.store.add(payload.filter(function(item) {
      return diff.indexOf(item.ID) !== -1;
    }));
  } else {
    webtsm.Support.notify(webtsm.Support.getTranslation('ATTRIBUTE_EXISTS'), false);
  }
}, getAttributeDefinitions:function() {
  var attributes = [];
  this.store.each(function(r) {
    var values = r.get('Values');
    if (!Ext.isDefined(values) || Ext.isString(values) && values.length === 0) {
      webtsm.Support.notify('attributes payload reset', false);
      values = [];
    } else {
      values = JSON.parse(values);
    }
    attributes.push({AttributeID:r.get('ID'), Values:values});
  });
  return attributes;
}, updateAttributes:function(attributesArray) {
  var $jscomp$this = this;
  if (attributesArray.length) {
    var storeData = this.store.getData().getRange();
    attributesArray.map(function(attribute) {
      var $jscomp$destructuring$var52 = attribute;
      var AttributeID = $jscomp$destructuring$var52.AttributeID;
      storeData.map(function(record) {
        if (record.get('ID') === AttributeID) {
          record.set($jscomp$this.transformAttribute(attribute));
        }
      });
    });
  }
}, transformAttribute:function(attribute) {
  if (attribute.AttributeID) {
    attribute.ID = attribute.AttributeID;
  }
  if ('Values' in attribute) {
    var valuesKeys = Ext.Object.getKeys(attribute.Values);
    attribute.ValuesCount = valuesKeys.length;
    attribute.Values = JSON.stringify(attribute.Values);
  }
  return attribute;
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.attributesmanager.AttributesOverview', {extend:'Ext.panel.Panel', alias:'widget.webtsmAttributesOverview', requires:['webtsm.Support'], iconCls:webtsm.Support.getBpcIconCls('fa-archive'), title:webtsm.Support.getTranslation('WEBTSM_CHANGE_ATTRIBUTES', undefined, false), layout:{type:'hbox', align:'stretch'}, loadBucket:function() {
  var $jscomp$this = this;
  this.attributePreviewPanel.removeAll(true);
  var added = false;
  this.bucket.store.each(function(r) {
    $jscomp$this.attributePreviewPanel.addTs(r.get('ID'), r.get('Name'));
    added = true;
  });
  if (added) {
    this.attributePreviewPanel.setActiveTab(0);
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.bucket = Ext.create({xtype:'webtsmBucketGrid', insideAttributes:true, hideHeaders:false, moduleId:this.moduleId, bucketStore:this.managerMain.bucketStore, bbar:[], flex:1, listeners:{select:function(selModel, record) {
    var items = $jscomp$this.attributePreviewPanel.query('#ts' + record.get('ID'));
    if (items.length) {
      $jscomp$this.attributePreviewPanel.setActiveTab(items[0]);
    }
  }}});
  this.webtsmAttributesDataPanel = Ext.create({xtype:'webtsmAttributesDataPanel', flex:2, moduleId:this.moduleId, managerMain:this.managerMain});
  this.items = [this.bucket, {xtype:'splitter'}, this.webtsmAttributesDataPanel];
  this.callParent(arguments);
  this.attributePreviewPanel = this.webtsmAttributesDataPanel.attributePreviewPanel;
  this.bucket.store.on({remove:function(s, records) {
    if (!$jscomp$this.destroyed) {
      $jscomp$this.attributePreviewPanel.removeTabByTsId(records.length ? records[0].get('ID') : !s.getCount() ? undefined : undefined);
    }
  }, datachanged:function() {
    if (!$jscomp$this.destroyed) {
      $jscomp$this.loadBucket();
    }
  }});
  this.loadBucket();
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.attributesmanager.AttributesPreviewPanel', {extend:'Ext.grid.Panel', alias:'widget.webtsmAttributesPreviewGrid', requires:['webtsm.ConfigKeys'], scrollable:'y', viewConfig:{emptyText:'Keine Attribute vorhanden.', deferEmptyText:true, enableTextSelection:true}, timeseriesId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.plugins = [{ptype:'rowwidget', getHeaderConfig:function() {
    var me = this, lockable = me.grid.lockable && me.grid;
    return {width:me.headerWidth, ignoreExport:true, lockable:false, autoLock:true, sortable:false, resizable:false, draggable:false, style:webtsm.Support.getDefaultGridStyle(), hideable:false, menuDisabled:true, tdCls:Ext.baseCSSPrefix + 'grid-cell-special', innerCls:Ext.baseCSSPrefix + 'grid-cell-inner-row-expander', renderer:function() {
      return '\x3cdiv class\x3d"' + Ext.baseCSSPrefix + 'grid-row-expander" role\x3d"presentation" tabIndex\x3d"0"\x3e\x3c/div\x3e';
    }, processEvent:function(type, view, cell, rowIndex, cellIndex, e, record) {
      var isTouch = e.pointerType === 'touch', isExpanderClick = !!e.getTarget('.' + Ext.baseCSSPrefix + 'grid-row-expander');
      if (type === 'click' && isExpanderClick || type === 'keydown' && e.getKey() === e.SPACE) {
        if (isTouch) {
          cell.focus();
        }
        me.toggleRow(rowIndex, record, e);
        e.stopSelection = !me.selectRowOnExpand;
      } else if (e.type === 'mousedown' && !isTouch && isExpanderClick) {
        e.preventDefault();
      }
    }, isLocked:function() {
      return lockable && (lockable.lockedGrid.isVisible() || this.locked);
    }, editRenderer:function() {
      return '\x26#160;';
    }};
  }, widget:{xtype:'container', layout:'fit', items:[]}, onWidgetAttach:function(plugin, cmp, record) {
    cmp.removeAll();
    var g = {xtype:'grid', store:Ext.create('Ext.data.Store', {data:[]}), columns:[{dataIndex:'from', text:'VON'}, {dataIndex:'to', text:'BIS'}, {dataIndex:'value', text:'WERT'}].map(function(i) {
      i.flex = 1;
      return i;
    })};
    cmp.add(g);
    g.store.add(record.get('attributesData'));
  }}];
  this.itemId = 'ts' + this.timeseriesId;
  this.columns = [{text:'ATTRIBUTEID', dataIndex:'AttributeID'}, {text:'ATTRIBUTENAME', dataIndex:'AttributeID', renderer:function(value) {
    return $jscomp$this.managerMain.getNameById(value) || value;
  }}, {text:'WERTE', dataIndex:'Values', flex:1, renderer:function(v, m, r) {
    return r.get('tableData');
  }}, {xtype:'actioncolumn', width:40, items:[{iconCls:webtsm.Support.getBpcIconCls('fa-trash'), tooltip:'Attributzuweisung entfernen', handler:function(tv, rowIndex) {
    webtsm.Support.confirmDialog('Sie ändern die bisherige Attributzuweisung', 'Attributzuweisung übernehmen?').then(function(yes) {
      if (yes) {
        var rec = tv.store.getAt(rowIndex);
        $jscomp$this.deleteAssignments($jscomp$this.timeseriesId, rec.get('AttributeID'), rowIndex);
      }
    });
  }}]}].map(function(c) {
    c.style = webtsm.Support.getDefaultGridStyle();
    return c;
  });
  this.bbar = [{xtype:'tbfill'}, {text:'Aktualisieren', iconCls:webtsm.ConfigKeys.icons.refresh, handler:function() {
    $jscomp$this.loadAttributes();
  }}];
  this.callParent(arguments);
  this.loadAttributes();
}, deleteAssignments:function(tsId, attributeId, rowIndex) {
  var $jscomp$this = this;
  tsId = tsId || this.timeseriesId;
  webtsm.Api.attributes.deleteAssignment(this.moduleId, tsId, attributeId).then(function(response) {
    $jscomp$this.store.remove($jscomp$this.store.getAt(rowIndex));
  }, function(response) {
    var errorStore = Ext.create('Ext.data.Store', {data:[]});
    var item = {status:response.status};
    if (response.responseText) {
      var json = Ext.decode(response.responseText, true);
      if (json.Message) {
        item.message = json.Message;
      }
    }
    errorStore.add(item);
    Ext.create('Ext.window.Window', {title:'Achtung: Fehler', height:200, width:400, layout:'fit', items:[{xtype:'grid', store:errorStore, columns:[{dataIndex:'status'}, {dataIndex:'message', flex:1}]}]}).show();
  });
}, loadAttributes:function() {
  var $jscomp$this = this;
  if (this.timeseriesId) {
    this.setLoading('Attribute werden geladen');
    webtsm.Api.attributes.get(this.moduleId, this.timeseriesId).then(function(value) {
      if (!$jscomp$this.destroyed && $jscomp$this.store) {
        $jscomp$this.store.removeAll();
        value = value || [];
        value = value.map(function(item, i) {
          var Values = item.Values || {};
          var table = '', array = [];
          if (!Ext.isEmpty(Values)) {
            var dateApi = webtsm.Api.date;
            Ext.iterate(Values, function(isoDateString, attributeValue) {
              var dt = dateApi.stringToDate(isoDateString);
              array.push({isoDateString:isoDateString, date:dt, formatted:dateApi.dateToFormattedString(dt), value:attributeValue});
            });
            if (array.length) {
              array.sort(function(a, b) {
                return b.date - a.date;
              });
              table = '\x3ctable\x3e';
              Ext.Array.each(array, function(item, index, a) {
                table += '\x3ctr\x3e\x3ctd\x3e' + item.formatted + '\x3c/td\x3e\x3ctd\x3e' + (index === 0 ? ' - ' : a[index - 1].formatted) + '\x3c/b\x3e\x3c/td\x3e\x3ctd\x3e' + item.value + '\x3c/td\x3e\x3c/tr\x3e';
                item.from = item.formatted;
                item.to = index === 0 ? ' - ' : a[index - 1].formatted;
              });
              table += '\x3c/table\x3e';
            }
          }
          item.tableData = table;
          item.attributesData = array;
          return item;
        });
        $jscomp$this.store.add(value);
        $jscomp$this.setLoading(false);
      }
    });
  }
}});
Ext.define('webtsm.view.manager.timeseries.attributes.SelectWindow', {extend:'Ext.window.Window', alias:'widget.webtsmAttributesSelectWindow', mixins:['webtsm.mixins.Component'], layout:'fit', targetGrid:undefined, moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.applyWidthHeight(0.8, 0.7);
  this.iconCls = this.faIcon('fa-archive');
  this.title = this.TR('ATTRIBUTE_SELECTION');
  this.attributeGrid = Ext.create({xtype:'grid', header:false, store:webtsm.Support.createTsmApiStore(this.moduleId, '/attributes', true, true), selModel:{mode:'MULTI'}, columns:['ID', 'Name'].map(function(c) {
    return {dataIndex:c, text:c.toUpperCase(), flex:c === 'ID' ? 1 : 5};
  }), listeners:{rowdblclick:function(tv, record) {
    $jscomp$this.addToStore([record]);
  }}});
  this.items = [this.attributeGrid];
  this._addDocked([{xtype:'tbfill'}, {iconCls:webtsm.ConfigKeys.icons.close, text:this.TR('CLOSE'), scale:'medium', ui:'secondary', handler:function(btn) {
    $jscomp$this.close();
  }}, {iconCls:webtsm.ConfigKeys.icons.plus, text:this.TR('SELECTION_ADD'), scale:'medium', ui:'primary', handler:function(btn) {
    $jscomp$this.addToStore($jscomp$this.attributeGrid.getSelection());
  }}]);
  this.callParent(arguments);
  this.idsSelected = [];
  this.targetGrid.store.each(function(r) {
    $jscomp$this.idsSelected.push(r.get('ID'));
  });
  this.refreshFilters();
}, idsSelected:[], refreshFilters:function() {
  var $jscomp$this = this;
  this.attributeGrid.store.clearFilter();
  var filterCollection = this.attributeGrid.store.getFilters();
  var isSelected = function(r) {
    return $jscomp$this.idsSelected.indexOf(r.get('ID')) === -1;
  };
  filterCollection.add(isSelected);
}, addToStore:function(selection) {
  var $jscomp$this = this;
  this.targetGrid.addAttribute(selection.map(function(item) {
    var id = item.get('ID');
    $jscomp$this.idsSelected.push(id);
    return {ID:id, Name:item.get('Name'), Type:item.get('Type')};
  }));
  this.refreshFilters();
}});
Ext.define('webtsm.view.manager.timeseries.attributes.Tabpanel', {extend:'Ext.tab.Panel', alias:'widget.webtsmAttributesTabpanel', items:[{xtype:'panel', title:'Attributsübersicht', iconCls:webtsm.Support.getBpcIconCls('warning'), html:'Es wurden keine Zeitreihen ausgewählt.'}], addTs:function(id, name) {
  this.add({xtype:'webtsmAttributesPreviewGrid', moduleId:this.moduleId, managerMain:this.managerMain, timeseriesId:id, title:name, iconCls:webtsm.Support.getBpcIconCls('book')});
}, removeAllTabs:function() {
  this.removeAll(true);
  this.add({xtype:'panel', html:'Keine Zeitreihen im Bucket, bitte nehmen Sie erneut eine Auswahl über die Suche vor.', title:'Keine Daten'});
}, getCmpsPerId:function() {
  return this.query('webtsmAttributesPreviewGrid');
}, removeTabByTsId:function(id) {
  if (id) {
    var cmps = this.getCmpsPerId().filter(function(item) {
      return item.timeseriesId === id;
    });
    if (cmps.length) {
      this.remove(cmps[0]);
    }
    if (this.getCmpsPerId().length) {
      return;
    }
  }
  this.removeAllTabs();
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.definitions.DefinitionsDataPanel', {extend:'Ext.panel.Panel', alias:'widget.tsmDefinitionsDataPanel', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component', 'webtsm.mixins.AuditLog'], layout:{type:'vbox', align:'stretch'}, padding:'5 5 5 5', initComponent:function() {
  var $jscomp$this = this;
  this.definitionsPanel = Ext.create({xtype:'fieldset', title:this.TR('NO_TIMESERIES_SELECTED'), defaultType:'textfield', layout:{type:'vbox', align:'stretch'}, scrollable:'y', flex:2, items:[{xtype:'container', html:this.TR('PLEASE_SELECT_TIMESERIES')}], padding:'5 5 5 5'});
  this.attributesPanel = Ext.create({xtype:'webtsmAttributesGridSingle', flex:1, header:false, style:{border:'0px'}, moduleId:this.moduleId, managerMain:this.managerMain});
  this.attributesPanelWrapper = Ext.create({xtype:'fieldset', collapsible:true, title:this.TR('ATTRIBUTES'), layout:'fit', scrollable:'y', flex:1, items:this.attributesPanel, padding:'5 5 5 5'});
  this.items = [this.definitionsPanel, {xtype:'splitter'}, this.attributesPanelWrapper];
  this.enableBaseButtons();
  this.bpcBaseButton.scale = 'medium';
  this.bpcBaseButton.iconAlign = 'top';
  this.deleteButton = this.createBaseButton('delete', {handler:function(b) {
    webtsm.Support.deleteTimeseriesWithMessage($jscomp$this.moduleId, $jscomp$this.selectedTs, $jscomp$this);
  }});
  this.saveButton = this.createBaseButton('save', {handler:this.updateTimeseries.bind(this)});
  this.refreshButton = this.createBaseButton('refresh', {handler:function() {
    $jscomp$this.fetchTimeseries();
  }});
  this._addDocked([this.deleteButton, this.refreshButton, this._fill(), this.saveButton]);
  this.initAuditLog(webtsm.Support.logEventNames.editTimeSeries);
  this.callParent(arguments);
  this.store = {load:this.onDeleted.bind(this)};
}, onDeleted:function() {
  this.fetchTimeseries(this.selectedTs);
  this.deleteButton.setDisabled(true);
  this.saveButton.setDisabled(true);
}, updateMetaData:function(obj) {
  var $jscomp$this = this;
  obj = obj === void 0 ? {} : obj;
  var $jscomp$destructuring$var53 = obj;
  var ID = $jscomp$destructuring$var53.ID;
  var Name = $jscomp$destructuring$var53.Name;
  if (ID && Name) {
    this.definitionsPanel.setTitle('Metadaten: ' + obj.Name + ' - ( ' + obj.ID + ' )');
  }
  var visibleTimeseriesMetaDataFields = ['ID', 'Name', 'Description', 'Type', 'Interval', 'Unit', 'Table', 'ArchiveTable', 'Formula', 'TimeZone', 'StartOfYear', 'StartOfDay', 'PreserveDuplicatedValues', 'Aggregation', 'QuotationDefaultBehavior', 'Quotation', 'Audit', 'Compressed', 'ExchangeTimeSeries'];
  Ext.iterate(obj, function(k, v) {
    var typeMap = {ID:'numberfield', Name:'textfield', Description:'textarea', Type:'numberfield', Interval:'textarea', Unit:'textfield', Table:'textfield', ArchiveTable:'textfield', Formula:'textarea', TimeZone:'textfield', StartOfYear:'numberfield', StartOfDay:'numberfield', PreserveDuplicatedValues:'checkbox', Aggregation:'textfield', QuotationDefaultBehavior:'numberfield', Quotation:'checkbox', Audit:'checkbox', Compressed:'checkbox', ExchangeTimeSeries:'textarea'};
    var field = {fieldLabel:webtsm.Support.getTranslation('WEBTSM_TS_' + k), dtoKey:k, value:v, xtype:typeMap[k], hidden:visibleTimeseriesMetaDataFields.indexOf(k) === -1};
    if (['Formula', 'ExchangeTimeSeries', 'Interval'].indexOf(k) !== -1) {
      field.height = 100;
      field.isJSON = true;
      field.value = JSON.stringify(v, undefined, 4);
    }
    if (k === 'ID') {
      field.readOnly = true;
    }
    $jscomp$this.definitionsPanel.add(field);
  });
}, updateTimeseries:function() {
  var $jscomp$this = this;
  var tsObj = {};
  this.query('field').map(function(tf) {
    var v = tf.getValue();
    if (Ext.isDefined(v)) {
      if (tf.isJSON && tf.isJSON === true) {
        v = JSON.parse(v);
      }
      var k = tf.dtoKey;
      if (k === 'Aggregation') {
        v = v ? v.length === 0 ? null : v : null;
      }
      if (k === 'Table') {
        v = v ? v.length === 0 ? null : v : null;
      }
      if (k === 'ArchiveTable') {
        v = v ? v.length === 0 ? null : v : null;
      }
      if (k === 'TimeZone') {
        v = v ? v.length === 0 ? null : v : null;
      }
      tsObj[k] = v;
    }
  });
  var updateRequests = [webtsm.Api.updateTimeseries(this.moduleId, this.selectedTs, tsObj), webtsm.Api.attributes.assignAttributesToTimeseries(this.moduleId, this.selectedTs, this.attributesPanel.getAttributeDefinitions())];
  Promise.all(updateRequests).then(function() {
    $jscomp$this.writeAuditLogData({meta:tsObj});
    return $jscomp$this.fetchTimeseries($jscomp$this.selectedTs);
  });
}, selectedTs:undefined, fetchTimeseries:function(id) {
  var $jscomp$this = this;
  id = id || this.selectedTs;
  this.attributesPanel.store.removeAll();
  this.definitionsPanel.removeAll();
  return webtsm.Api.timeseries.getMeta(this.moduleId, id).then(function(response, opts) {
    $jscomp$this.selectedTs = id;
    $jscomp$this.updateMetaData(response);
    $jscomp$this.attributesPanel.loadData(id);
    return true;
  });
}});
Ext.define('webtsm.view.instanceTypes.client.tsmanager.definitions.DefinitionsOverview', {extend:'Ext.panel.Panel', alias:'widget.tsmDefinitionsOverview', iconCls:webtsm.Support.getBpcIconCls('fa-wrench'), title:webtsm.Support.getTranslation('WEBTSM_CHANGE_MASTERDATA', undefined, false), layout:{type:'hbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  this.bucket = Ext.create({xtype:'webtsmBucketGrid', hideHeaders:false, moduleId:this.moduleId, bucketStore:this.managerMain.bucketStore, flex:1, bbar:[], listeners:{select:function(selModel, r) {
    $jscomp$this.definitionsDataPanel.fetchTimeseries(r.get('ID'));
  }}});
  this.definitionsDataPanel = Ext.create({xtype:'tsmDefinitionsDataPanel', flex:3, moduleId:this.moduleId, bucket:this.bucket, managerMain:this.managerMain});
  this.items = [this.bucket, {xtype:'splitter'}, this.definitionsDataPanel];
  this.callParent(arguments);
  this.bucket.store.on({remove:function(s, records) {
  }, datachanged:function() {
    if (!$jscomp$this.destroyed) {
      $jscomp$this.loadBucket();
    }
  }});
  this.loadBucket();
}, loadBucket:function() {
  if (this.bucket.store.getCount()) {
    this.definitionsDataPanel.fetchTimeseries(this.bucket.store.getAt(0).get('ID'));
  }
}});
Ext.define('webtsm.view.instanceTypes.client.chart.Chart', {extend:'Ext.panel.Panel', alias:'widget.tsChart', requires:['webtsm.Support'], mixins:['webtsm.mixins.Component'], iconCls:webtsm.ConfigKeys.icons.chartArea, layout:'fit', chart:undefined, disabledTimeseriesInLegend:{}, hasModuleHeader:false, windowMode:false, pluginMode:false, initComponent:function() {
  var $jscomp$this = this;
  if (this.hasModuleHeader) {
    this.header = {items:[{xtype:'toolbar', items:[{iconCls:webtsm.ConfigKeys.icons.expand, handler:function() {
      webtsm.Support.openWindow($jscomp$this.getTitle(), undefined, undefined, undefined, 'tsChart', {chartConfig:$jscomp$this.chartConfig, moduleId:$jscomp$this.moduleId, windowMode:true, header:false});
    }, hidden:true, tooltip:this.TR('OPEN_IN_WINDOW')}, {iconCls:webtsm.ConfigKeys.icons.gears, tooltip:this.TR('HIDE_CONFIGURATION'), ui:'secondary', handler:function() {
      $jscomp$this.moduleInstance.requestPanel.setVisible(!$jscomp$this.moduleInstance.requestPanel.isVisible(true));
    }}]}]};
  }
  this.listeners = {beforedestroy:function(c) {
    $jscomp$this.destroyChart();
  }};
  if (this.windowMode || this.pluginMode) {
    this.listeners.afterrender = function() {
      Ext.Function.defer(function() {
        $jscomp$this.buildChart();
      }, 50);
    };
  }
  this.items = [{xtype:'container', layout:'center', items:[webtsm.Support.getEmptyInfoContainer('BRAND_NAME', this.iconCls, 'NO_DATA_LOADED')]}];
  this.title = this.TR('GRAPH');
  this.callParent(arguments);
}, createSeries:function(graphs) {
  var $jscomp$this = this;
  graphs = graphs === void 0 ? [] : graphs;
  return graphs.map(function(o) {
    var series = $jscomp$this.chart.series.push(new am4charts.LineSeries());
    series.dataFields.valueY = o.valueField;
    series.dataFields.dateX = 'date';
    series.tooltipText = '{' + o.valueField + '} ' + o.seriesTooltipTitle;
    series.strokeWidth = 2;
    series.minBulletDistance = 15;
    series.name = o.title;
    series.tooltip.background.strokeOpacity = 0;
    series.tooltip.pointerOrientation = 'horizontal';
    series.tooltip.label.minWidth = 30;
    series.tooltip.label.minHeight = 30;
    series.tooltip.label.textAlign = 'middle';
    series.tooltip.label.textValign = 'middle';
    series.stroke = am4core.color(o.lineColor);
    series.fill = series.stroke;
    return series;
  });
}, addScrollbarX:function(chart, series) {
  chart.scrollbarX = new am4charts.XYChartScrollbar();
  series.map(function(s) {
    chart.scrollbarX.series.push(s);
  });
  chart.scrollbarX.parent = chart.topAxesContainer;
}, addScrollbarY:function(chart, series) {
  chart.scrollbarY = new am4core.Scrollbar();
  chart.scrollbarY.parent = chart.leftAxesContainer;
  chart.scrollbarY.toBack();
}, destroyChart:function() {
  if (this.chart) {
    this.chart.dispose();
    delete this.chart;
  }
}, createChart:function(chartConfig) {
  var $jscomp$this = this;
  this.destroyChart();
  am4core.ready(function() {
    var chart = am4core.create($jscomp$this.id + '-body', am4charts.XYChart);
    chart.data = chartConfig.dataProvider;
    $jscomp$this.chart = chart;
    var dateAxis = chart.xAxes.push(new am4charts.DateAxis());
    var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
    var series = $jscomp$this.createSeries(chartConfig.graphs);
    chart.cursor = new am4charts.XYCursor();
    chart.cursor.behavior = 'panXY';
    chart.cursor.xAxis = dateAxis;
    chart.legend = new am4charts.Legend();
    chart.legend.useDefaultMarker = true;
    if (!$jscomp$this.pluginMode) {
      $jscomp$this.addScrollbarY(chart, series);
      $jscomp$this.addScrollbarX(chart, series);
    }
    dateAxis.keepSelection = true;
  });
}, clearChart:function() {
  if (this.chart) {
    this.chart.clear();
  }
}, buildChartData:function(data) {
  try {
    var chartDataObject = {};
    data.map(function(item) {
      if (item.metadata && item.metadata.ID && Ext.isArray(item.data)) {
        item.data.map(function(entry) {
          var timestampMillis = (new Date(entry.From)).getTime();
          if (!chartDataObject[timestampMillis]) {
            var valueObject = {};
            valueObject[item.metadata.ID + '_' + (item.metadata.Version || 'null')] = entry.Value;
            chartDataObject[timestampMillis] = valueObject;
          } else {
            chartDataObject[timestampMillis][item.metadata.ID + '_' + (item.metadata.Version || 'null')] = entry.Value;
          }
        });
      }
    });
    return Object.keys(chartDataObject).map(function(k) {
      return Ext.apply({}, chartDataObject[k], {date:new Date(parseInt(k))});
    });
  } catch (e) {
  }
}, resetData:function() {
  this.disabledTimeseriesInLegend = {};
}, createGraphsFromData:function(data) {
  data = data === void 0 ? [] : data;
  return data.map(function(ts) {
    var $jscomp$destructuring$var54 = ts.metadata || {};
    var Name = $jscomp$destructuring$var54.Name;
    var ID = $jscomp$destructuring$var54.ID;
    var Unit = $jscomp$destructuring$var54.Unit;
    var Version = $jscomp$destructuring$var54.Version;
    return {lineColor:ts.color || '#e3e3e3', title:Name, valueField:ID + '_' + (Version || 'null'), Unit:Unit || '', seriesTooltipTitle:(Unit || '') + ' ' + '( ' + Name + ' )'};
  });
}, buildChart:function(data) {
  try {
    var graphs = this.createGraphsFromData(data);
    if (this.windowMode) {
      this.createChart(this.chartConfig);
      return;
    }
    this.disabledTimeseriesInLegend = {};
    var chartData = this.buildChartData(data);
    if (data.length && graphs.length) {
      this.createChart({graphs:graphs, dataProvider:chartData});
    }
  } catch (e) {
  }
}});
Ext.define('webtsm.view.viewer.Main', {extend:'Ext.container.Container', alias:'widget.tsmMain', mixins:['webtsm.view.viewer.WebTsmViewerMixin'], requires:['webtsm.ConfigKeys'], layout:'border', bodyBorder:false, defaults:{split:true}, padding:0, margin:0, style:'background-color:white;', collapseState:undefined, moduleCfg:undefined, moduleId:undefined, grid:undefined, listeners:{'boxready':function(c) {
  var cssId = c.getId();
  if (cssId) {
    document.querySelector('#' + cssId).addEventListener('keypress', function(e) {
      var key = e.which || e.keyCode;
      if (key === 13) {
        var btn = c.down('#submitRequestBtn');
        if (btn) {
          btn.click();
        }
      }
    });
  }
}}, moduleConfigInvalid:true, getApiId:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'api_id');
}, initComponent:function() {
  var $jscomp$this = this;
  var apiId = this.getApiId();
  this.moduleConfigInvalid = apiId === null || !Ext.isDefined(apiId) || Ext.isString(apiId) && apiId.length === 0;
  if (this.moduleConfigInvalid) {
    this.items = [{xtype:'container', region:'center', html:'Viewer Einstellungen sind nicht korrekt. \x3cbr/\x3e\x3cbr/\x3eKeine Api Id zugewiesen'}];
  } else {
    this.selectGrid = Ext.create({xtype:'tsmSelectGrid', region:'west', collapsible:true, collapsed:true, flex:1, itemId:'webtsmSelector', iconCls:webtsm.Support.getBpcIconCls('fa-align-justify'), moduleId:this.moduleId, moduleInstance:this});
    this.requestPanel = Ext.create({xtype:'tsmSearch', region:'north', split:false, moduleId:this.moduleId, moduleInstance:this});
    this.tsGrid = Ext.create({xtype:'tsGrid', moduleId:this.moduleId, region:'west', moduleInstance:this, style:'border: 0px !important; border-right: 1px solid white!important;', flex:1, header:{items:[{xtype:'tsmGridHeader', moduleId:this.moduleId}]}});
    this.chartView = Ext.create({xtype:'tsChart', collapsible:false, region:'center', moduleId:this.moduleId, moduleInstance:this, hasModuleHeader:true});
    this.items = [this.selectGrid, {xtype:'container', flex:2, moduleId:this.moduleId, region:'center', layout:'border', style:'background-color:white;', items:[this.requestPanel, this.tsGrid, this.chartView]}];
  }
  this.bpcModuleHeader = Ext.createByAlias('widget.webtsmModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
  this.callParent(arguments);
  if (!this.moduleConfigInvalid) {
    this.bpcModuleHeader.applyApiConfig().then(function(configValid) {
      return webtsm.Support.loadLibraries();
    }).then(function(libsLoaded) {
      if (libsLoaded) {
        $jscomp$this.requestPanel.requestContainer.intervalCombo.getStore().load({callback:function(records, operation, success) {
          if (success) {
            $jscomp$this.loadViewer();
          }
        }});
      }
    });
  }
}, loadViewer:function() {
  this.setModuleInstanceDefaults();
  if (this.moduleCfg) {
    var keys = Ext.Object.getKeys(this.moduleCfg);
    if (keys.length) {
      this.updateInstance(this.moduleCfg).then(function(loadDataOrErrorMsg) {
      });
    } else {
      this.restoreViewerConfig();
    }
  }
}, webtsmStateId:'webtsmMainViewerView', getWebTsmStateKey:function(name, cmp) {
  if (!cmp) {
    cmp = this;
  }
  if (!name) {
    if ('webtsmStateId' in cmp && cmp.webtsmStateId) {
      name = cmp.webtsmStateId;
    }
  }
  if (name) {
    var keys = [];
    keys.push(name);
    keys.push(cmp.moduleId);
    return keys.join('-');
  }
  return null;
}, setDateValues:function(prefix, dateStringObj) {
  var dateObj = Ext.isDate(dateStringObj) ? dateStringObj : Ext.isString(dateStringObj) ? Ext.Date.parse(dateStringObj, 'c') : undefined;
  var p = {};
  if (dateObj && Ext.isDate(dateObj)) {
    p[prefix + 'Date'] = dateObj;
    p[prefix + 'Hour'] = dateObj.getHours();
    p[prefix + 'Minute'] = dateObj.getMinutes();
  }
  return p;
}, updateInstance:function(configObject) {
  var $jscomp$this = this;
  try {
    var me = this;
    return new Ext.Promise(function(resolve, reject) {
      if (Ext.isDefined(configObject)) {
        var keys = Ext.Object.getKeys(configObject);
        if (keys.length > 0) {
          if (keys.indexOf('column') !== -1 && keys.indexOf('record') !== -1 && configObject.column.dataIndex) {
            var bucket = webtsm.Support.getBucketPayloadFromRecord(configObject.record, configObject.column.dataIndex, configObject.column.webtsmStartDateStringField, configObject.column.webtsmEndDateStringField, configObject.column.delimiter, undefined, configObject.column.webtsmDateStringFormat);
            if (bucket) {
              configObject = bucket;
            }
          }
          var timeseries = Ext.isArray(configObject.tsIds) ? configObject.tsIds : [];
          timeseries = timeseries.concat(Ext.isArray(configObject.tsNames) ? configObject.tsNames : []);
          timeseries = timeseries.concat(Ext.isArray(configObject.timeseries) ? configObject.timeseries : []);
          if ('bucket' in configObject) {
            timeseries = timeseries.concat(configObject.bucket);
          }
          var p = {};
          if ('interval' in configObject) {
            p.interval = configObject.interval || BpcCommon.Api.getSetting($jscomp$this.moduleId, 'default_interval');
          }
          if ('aggregation' in configObject) {
            p.requestAggregation = configObject.aggregation || 4269;
          }
          if (configObject.start) {
            p = Ext.apply({}, p, me.setDateValues('start', configObject.start));
          }
          if (configObject.end) {
            p = Ext.apply({}, p, me.setDateValues('end', configObject.end));
          }
          $jscomp$this.requestPanel.setRequestParams(p);
          if (Ext.isArray(timeseries) && timeseries.length > 0) {
            webtsm.Support.loadBatchMetaData(timeseries, me.moduleId).then(function(results) {
              var storeData = [];
              for (var i = 0; i < results.length; i++) {
                storeData.push(webtsm.Support.handleMetaDataPromiseResponse(results[i], timeseries[i]));
              }
              $jscomp$this.addToSelectedStore(storeData, true, true);
              Ext.Function.defer(function() {
                resolve(true);
              }, 300);
            }, function() {
              resolve(webtsm.Support.getTranslation('WEBTSM_ERROR_FETCHING_METADATA'));
            });
          } else {
            resolve(false);
          }
        } else {
          resolve(webtsm.Support.getTranslation('WEBTSM_EMPTY_CONFIG'));
        }
      } else {
        resolve(webtsm.Support.getTranslation('WEBTSM_UNDEFINED_CONFIG'));
      }
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateInstance', dump:e, stack:true, level:'error'});
  }
}, getState:function() {
  var s = this.getRequestObject();
  webtsm.Support.bpc.removeReplaceStateFromUrl(s);
  return s;
}});
Ext.define('webtsm.view.config.TsmSearch', {extend:'Ext.container.Container', alias:'widget.tsmSearch', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], layout:{type:'hbox', align:'stretch'}, padding:'0 0 0 0', openBucketFromAdvancedSearch:function(bucketArray) {
  var $jscomp$this = this;
  webtsm.Support.loadBatchMetaData(bucketArray, this.moduleId).then(function(results) {
    var storeData = [];
    for (var i = 0; i < results.length; i++) {
      storeData.push(webtsm.Support.handleMetaDataPromiseResponse(results[i], bucketArray[i]));
    }
    $jscomp$this.moduleInstance.addToSelectedStore(storeData, true, true);
  }, function() {
  });
}, initComponent:function() {
  var $jscomp$this = this;
  var editEnabled = webtsm.Support.canEdit();
  this.emptyGridButton = Ext.create({xtype:'button', ui:'secondary', disabled:true, tooltip:this.TR('WEBTSM_REMOVE_SELECTED_TIMESERIES'), iconCls:this.faIcon(webtsm.Support.keys.icons["delete"]), handler:function(btn) {
    return $jscomp$this.resetSearch();
  }});
  this.jumpButton = Ext.create({xtype:'button', iconCls:this.faIcon('fa-external-link'), hidden:!editEnabled, ui:'secondary', disabled:true, maxWidth:45, menu:{plain:true, items:webtsm.Api.getManagerActions(webtsm.Support.getManagerInstanceForViewer(this.moduleId)).map(function(i) {
    i.handler = function(b) {
      if (b.actionKey) {
        this.selectedGrid.openManager(b.actionKey);
      } else {
        webtsm.Support.notify(webtsm.Support.getTranslation('ERROR'));
      }
    }.bind($jscomp$this);
    return i;
  })}});
  var buttons = [this.jumpButton, this.emptyGridButton];
  this.selectedGrid = Ext.create(Ext.apply({}, {xtype:'tsmSelectedGrid', editEnabled:editEnabled, moduleId:this.moduleId, flex:2, style:'border:0px', bbar:[{iconCls:webtsm.ConfigKeys.icons.search, tooltip:this.TR('WEBTSM_ADVANCED_TS_SEARCH'), ui:'secondary', searchWindow:undefined, handler:function(btn) {
    webtsm.Support.openWindow($jscomp$this.TR('WEBTSM_ADVANCED_TS_SEARCH'), webtsm.ConfigKeys.icons.edit, document.body.clientWidth * 0.8, document.body.clientHeight * 0.8, 'webtsmManagerMain', {moduleId:BpcCommon.Api.getSetting($jscomp$this.moduleId, 'webtsm_managerInstance'), hideEdit:true, readOnly:true, openedInViewer:true, baseCmp:$jscomp$this});
  }}, {xtype:'button', ui:'primary', text:this.TR('WEBTSM_USE_REQUEST'), defaultTsmText:this.TR('WEBTSM_USE_REQUEST'), defaultTsmIconCls:webtsm.ConfigKeys.icons.refresh, iconCls:webtsm.ConfigKeys.icons.refresh, requestInvalid:function(disable, text, icon) {
    this.setIconCls(disable ? webtsm.Support.getBpcIconCls('fa-exclamation-triangle') : this.defaultTsmIconCls);
    this.setText(disable ? text && text.length ? text : 'Request Parameters invalid' : this.defaultTsmText);
    this.setDisabled(disable);
  }, listeners:{click:function(btn, e, eOpts) {
    btn.disable();
    btn.setIconCls($jscomp$this.faIcon('fa-clock'));
    btn.setText($jscomp$this.TR('WEBTSM_REQ_SENT'));
    if ($jscomp$this.moduleInstance) {
      $jscomp$this.moduleInstance.getComponentConfig();
      $jscomp$this.moduleInstance.loadData(btn);
    }
  }}, itemId:'submitRequestBtn', flex:2}].concat(buttons)}));
  this.selectedGrid.store.on('datachanged', function(s) {
    var emptySelection = s.getCount() === 0;
    buttons.map(function(b) {
      return b.setDisabled(emptySelection);
    });
  });
  this.requestContainer = Ext.create(Ext.apply({}, {xtype:'webtsmRequestContainer', requestPanel:this, flex:2, moduleId:this.moduleId}));
  this.items = [this.selectedGrid, this.requestContainer];
  this.callParent(arguments);
}, setRequestParams:function(params) {
  this.requestContainer.setRequestParams(params);
}, getRequestParams:function() {
  return this.requestContainer.getRequestParams();
}, getInterval:function() {
  return this.requestContainer.intervalCombo.getValue();
}, resetSearch:function() {
  this.selectedGrid.resetGrid();
}, changeValueInSelection:function(val, key) {
  this.selectedGrid.changeValueForItems(val, key);
}});
Ext.define('webtsm.view.instanceTypes.client.grid.TsGrid', {extend:'Ext.grid.Panel', alias:'widget.tsGrid', controller:'tsGrid', mixins:['webtsm.mixins.Component'], requires:['webtsm.ConfigKeys'], features:[{ftype:'webtsmsummary', dock:'bottom'}], plugins:['clipboard'], title:'Daten', iconCls:webtsm.ConfigKeys.icons.timeseriesData, headerBorders:false, sortableColumns:false, metaMap:undefined, isFiltered:false, tsmFilterType:undefined, extraColumnWithFlags:false, renderFlagInValueColumn:false, flagColorSettings:{}, 
moduleId:undefined, handleCustomisations:function(arrayWithKeys, settingsObj) {
  var $jscomp$this = this;
  if (arrayWithKeys) {
    Ext.Array.each(arrayWithKeys, function(key) {
      if (settingsObj && key in settingsObj && Ext.isDefined(settingsObj[key] && settingsObj[key] === true)) {
        $jscomp$this[key] = settingsObj[key];
      }
    });
  }
}, setGridTitle:function() {
  this.setTitle(this.moduleInstance.getSelectionPeriodAsText());
}, flags:{}, flagsResponse:[], initComponent:function() {
  var $jscomp$this = this;
  this.viewConfig = {markDirty:false, trackOver:false, deferEmptyText:false, emptyText:this.TR('NO_TS_SELECTED_PLEASE_CHOOSE'), enableTextSelection:true, style:'border: 0px !important;', getRowClass:function(record, rowIndex, rowParams, store) {
    return record && record.get('meta') ? rowIndex & 1 ? 'webtsm-grid-odd' : 'webtsm-grid-even' : 'webtsm-grid';
  }};
  webtsm.Api.getFlags(this.moduleId).then(function(array) {
    if (Ext.isDefined(array) && array !== null && Ext.isArray(array) && array.length > 0) {
      $jscomp$this.flagsResponse = array;
      $jscomp$this.flags = webtsm.Support.convertArrayToObject(array);
    }
  });
  this.createTSMStore();
  var customSettings = BpcCommon.Api.getSetting(this.moduleId, 'custom_settings');
  if (customSettings) {
    this.handleCustomisations(['extraColumnWithFlags', 'renderFlagInValueColumn'], customSettings);
    if ('flags' in customSettings && Ext.isDefined(customSettings['flags']) && customSettings['flags'] !== null && Ext.isObject(customSettings['flags'])) {
      this.flagColorSettings = customSettings['flags'];
    }
  }
  this.listeners = {cellcontextmenu:function(tableView, td, cellIndex, record, tr, rowIndex, e, eOpts) {
    e.preventDefault();
    if (webtsm.Support.canEdit()) {
      Ext.create({xtype:'tsmTableContextMenu', gridReference:$jscomp$this, moduleId:$jscomp$this.moduleId, record:record, columnDataIndex:tableView.panel.headerCt.getHeaderAtIndex(cellIndex).dataIndex}).showAt(e.getXY());
    }
  }};
  this.callParent(arguments);
  var headerContainer = this.getHeaderContainer();
  headerContainer.setStyle(webtsm.Support.getDefaultGridStyle());
  if (this.windowMode !== true) {
    headerContainer.setStyle('border', '0px !important;');
  } else {
    try {
      if (this.config.gridConfig) {
        this.bootEnlargedGrid(this.config.gridConfig.data, this.config.gridConfig.columns);
      }
    } catch (e) {
    }
  }
}, createTSMStore:function() {
  this.store = Ext.create('Ext.data.Store', {getTSMStoreData:function() {
    var storeData = Ext.clone(this.getRange());
    return storeData.map(function(r) {
      var o = r.getData();
      if (o.id) {
        delete o.id;
      }
      return o;
    });
  }});
}, bootEnlargedGrid:function(data, columns) {
  this.store.loadData(data);
  this.reconfigure(this.store, columns);
}, getTSMColumnConfig:function() {
  return (Ext.clone(this.getColumns()) || []).filter(function(column, index) {
    return index !== 0 && column && column.initialConfig;
  }).map(function(c) {
    return c.initialConfig;
  });
}, metaDataVisible:false, metaKeys:['ID', 'Name', 'Description', 'Type', 'Interval', 'Unit', 'Table', 'ArchiveTable', 'Formula', 'TimeZone', 'StartOfYear', 'StartOfDay', 'PreserveDuplicatedValues', 'Quotation', 'Audit', 'Compressed', 'Version', 'ExchangeTimeSeries'], getNumberColumn:function() {
  var $jscomp$this = this;
  return {xtype:'gridcolumn', dataIndex:'dummy', align:'end', style:webtsm.Support.getDefaultGridStyle(), text:webtsm.Support.getTranslation('CURRENT_NUMBER', true), renderer:function(value, metaData, record, rowIndex) {
    var metaDataVisible = false;
    if ($jscomp$this) {
      if ($jscomp$this.metaDataVisible) {
        metaDataVisible = true;
      }
    }
    value = '';
    if (metaDataVisible) {
      if (record) {
        var metaKey = record.get('meta');
        if (metaKey) {
        } else {
          value = rowIndex - $jscomp$this.metaKeys.length + 1;
        }
      }
    } else {
      value = rowIndex + 1;
    }
    return value;
  }};
}, updateTimeseries:function(timeseriesDataArray) {
  var $jscomp$this = this;
  try {
    if (timeseriesDataArray) {
      if (this.showOnlyGrid) {
        try {
          var metaDataArray = timeseriesDataArray.map(function(data) {
            return data.metadata || {};
          });
          var metaStoreData = [];
          var columnDataIndexes = [];
          var metaColumns = metaDataArray.map(function(m, i, arr) {
            var k = m.ID ? String(m.ID) : 'notFound';
            columnDataIndexes.push(k);
            return {dataIndex:m.ID ? String(m.ID) : 'notFound', text:m.Name || '-1', style:webtsm.Support.getDefaultGridStyle(), renderer:function(v, m, r) {
              if (Ext.isArray(v)) {
                return v.length;
              } else {
                return Ext.isObject(v) ? JSON.stringify(v, undefined, 4) : v;
              }
            }};
          });
          var metaKeys = this.metaKeys.map(function(c) {
            return c;
          });
          metaKeys.push('Attributes');
          metaKeys.map(function(key, index) {
            var obj = {};
            columnDataIndexes.map(function(dataIndex, index, arr) {
              if (key !== 'Attributes') {
                var meta = metaDataArray[index] || {};
                obj[dataIndex] = Ext.isDefined(meta[key]) ? meta[key] : '-1';
              } else {
                obj[dataIndex] = [];
              }
              obj.key = key;
            });
            metaStoreData.push(obj);
          });
          this.metaGrid.store.removeAll();
          this.metaGrid.store.add(metaStoreData);
          this.metaGrid.reconfigure(this.metaGrid.store, [{dataIndex:'key', text:' ', align:'right', renderer:function(v) {
            return '\x3cb\x3e' + v + '\x3c/b\x3e';
          }, style:webtsm.Support.getDefaultGridStyle()}].concat(metaColumns));
          var attributePromises = columnDataIndexes.map(function(tsId) {
            return webtsm.Api.timeseries.getAttributes($jscomp$this.moduleId, tsId);
          });
          Promise.all(attributePromises).then(function(array) {
            array.map(function(attributeArray, index) {
              var tsId = columnDataIndexes[index];
              attributeArray = attributeArray || [];
              $jscomp$this.metaGrid.store.each(function(r) {
                if (r.get('key') === 'Attributes') {
                  r.set(tsId, attributeArray);
                }
              });
            });
          });
        } catch (e) {
        }
      }
      var storeData = [], columns = [this.getNumberColumn(), this.createRangeColumns({}, 'timestampFrom', webtsm.Support.getTranslation('FROM', true)), this.createRangeColumns({summaryRenderer:function() {
        return '\x3cspan class\x3d"webtsm-grid"\x3e\x3cb\x3eAggregation\x3c/b\x3e\x3c/span\x3e';
      }}, 'timestampTo', webtsm.Support.getTranslation('TO', true))], loadedTimeseriesData = {};
      var metaMap = {};
      Ext.Array.each(timeseriesDataArray, function(tsDataObject, index, array) {
        var col = null;
        if (Ext.isObject(tsDataObject.metadata) && 'errorMessage' in tsDataObject.metadata) {
          col = $jscomp$this.createValueColumn(tsDataObject.data, undefined, tsDataObject.metadata);
        } else {
          if ('ID' in tsDataObject.metadata && tsDataObject.metadata.ID) {
            var display = {};
            var displayData = Ext.clone(tsDataObject.metadata);
            Ext.iterate(displayData, function(k, v) {
              if (Ext.isDefined(v)) {
                if (Ext.isObject(v) || Ext.isArray(v)) {
                  v = JSON.stringify(v);
                } else if (!Ext.isString(v)) {
                  v = String(v);
                }
              } else {
                v = '-';
              }
              display[k] = v;
            });
            metaMap[tsDataObject.metadata.ID] = display;
          }
        }
        var metadata = $jscomp$this.xMetdata(tsDataObject.metadata, tsDataObject.requestParam);
        var getDataIndexFromMetaData = function(timeseries) {
          return timeseries.ID + '_' + timeseries.requestUnit + '_' + timeseries.Aggregation + '_' + timeseries.Version;
        };
        metadata.dataIndexValues = getDataIndexFromMetaData(metadata);
        metadata.dataIndexFlags = metadata.dataIndexValues + '_flag';
        var last = '', longestDecimal = BpcCommon.Api.getSetting($jscomp$this.moduleId, 'editor_maxDecimals');
        if (!longestDecimal) {
          longestDecimal = 2;
        }
        Ext.Array.each(tsDataObject.data, function(value, index, array) {
          var timestampMillis = (new Date(value.From)).getTime();
          if (loadedTimeseriesData[timestampMillis]) {
            loadedTimeseriesData[timestampMillis][metadata.dataIndexValues] = value.Value;
            loadedTimeseriesData[timestampMillis][metadata.dataIndexFlags] = value.Flag;
          } else {
            var valueMap = {};
            valueMap[metadata.dataIndexValues] = value.Value;
            valueMap['timestampTo'] = new Date(value.To);
            valueMap[metadata.dataIndexFlags] = value.Flag;
            loadedTimeseriesData[timestampMillis] = valueMap;
          }
          if (longestDecimal === 0) {
            var number = String(value.Value);
            if (number !== last) {
              var a = number.split('.');
              if (a.length === 2) {
                if (a[1].length > longestDecimal) {
                  longestDecimal = a[1].length;
                }
              } else {
                Ext.log({dump:array, msg:'not considered for rendering'});
              }
              last = number;
            }
          }
        });
        if (!col) {
          col = $jscomp$this.createValueColumn(metadata, undefined, undefined, longestDecimal);
          col.editTimeseriesMeta = (tsDataObject || {}).editTimeseriesMeta || null;
        }
        columns.push(col);
        if ($jscomp$this.extraColumnWithFlags === true) {
          col = $jscomp$this.createValueColumn(metadata, $jscomp$this.flagColorSettings);
          columns.push(col);
        }
      });
      Ext.iterate(loadedTimeseriesData, function(key, valueMap) {
        valueMap['timestampFrom'] = new Date(parseInt(key));
        storeData.push(valueMap);
      });
      this.store.loadData(storeData);
      this.metaMap = metaMap;
      this.reconfigure(this.store, columns);
    }
  } catch (e$13) {
  }
}, xMetdata:function(metadata, requestParameter) {
  var timeseries = metadata;
  if (!timeseries.Aggregation) {
    timeseries.Aggregation === 'null';
  }
  if (!timeseries.Unit) {
    timeseries.Unit === 'null';
  }
  if (!timeseries.Version) {
    timeseries.Version === 'null';
  }
  if ('unit' in requestParameter && requestParameter.unit) {
    timeseries.requestUnit = requestParameter.unit;
  } else {
    timeseries.requestUnit = timeseries.Unit;
  }
  if ('version' in requestParameter && requestParameter.version) {
    timeseries.Version = requestParameter.version;
  }
  return timeseries;
}, resetGrid:function() {
  if (this.store) {
    this.store.removeAll();
    this.store.clearFilter(true);
    this.reconfigure(this.store, []);
  }
}, createRangeColumns:function(individualConfig, dataIndex, text) {
  var format;
  try {
    format = this.moduleInstance.getDateFormat();
  } catch (e) {
    format = webtsm.Support.defaultDateFormat;
  }
  return Ext.apply({xtype:'gridcolumn', dataIndex:dataIndex, text:text, draggable:false, dateFormat:format, width:Ext.isDefined(format) && format.endsWith('s') ? 150 : 140, style:webtsm.Support.getDefaultGridStyle(), renderer:function(val, meta, record, rowIndex, colIndex) {
    if (!val) {
      val = '';
      if (colIndex === 2) {
        if (record) {
          var metaKey = record.get('meta');
          if (metaKey) {
            val = metaKey;
          }
        }
      }
    } else {
      if (val && Ext.isDate(val)) {
        val = Ext.Date.format(val, format || webtsm.Support.defaultDateFormat);
      }
    }
    val = '\x3cspan class\x3d"webtsm-grid"\x3e' + val + '\x3c/span\x3e';
    return val;
  }}, individualConfig);
}, createValueColumn:function(timeseries, flagColorSettings, faultyRequestO, longestDecimal) {
  var $jscomp$this = this;
  var format = '0,000.########';
  if (longestDecimal > 0) {
    format = '0,000.' + Ext.String.repeat('#', longestDecimal);
  }
  var tooltipObj = {Id:timeseries.ID, Name:timeseries.Name, Einheit:timeseries.Unit, Abfrageeinheit:timeseries.requestUnit, Version:timeseries.Version, Aggregation:timeseries.Aggregation};
  if (timeseries.Version === 'null') {
    tooltipObj.Version = 'Standard';
  }
  if (Ext.isDefined(faultyRequestO) && Ext.isObject(faultyRequestO)) {
    tooltipObj = faultyRequestO;
    timeseries.Name = '\x3ci class\x3d"fal fa-exclamation-triangle"\x3e\x3c/i\x3e' + ' ' + timeseries.Name;
  }
  var timeseriesDataIndex = timeseries.dataIndexValues;
  var timeseriesFlagDataIndex = timeseries.dataIndexFlags;
  var flagTranslations = this.flags;
  if (Ext.isDefined(flagColorSettings) && Ext.isObject(flagColorSettings)) {
    return Ext.apply({xtype:'gridcolumn', width:40, style:webtsm.Support.getDefaultGridStyle(), align:'end'}, {text:this.getColumnHeaderHtmlString(webtsm.Support.getBpcIconCls('fa-flag')), dataIndex:timeseriesFlagDataIndex, format:format, timeSeriesMeta:timeseries || {}, requestUnit:timeseries.requestUnit, tooltip:timeseries.Name + ' - Flag', renderer:function(value, metaData, record, rowIndex, colIndex, view) {
      var colorSettings = flagColorSettings;
      var color = null;
      var flags = flagTranslations;
      var qtip = null;
      if (Ext.isDefined(value)) {
        var o = {};
        o.Flag = value;
        if (value in flags) {
          o.FlagName = flags[value];
        }
        qtip = 'data-qtip\x3d"' + webtsm.Support.createHtmlTooltipFromObject(o) + '"';
      }
      var bgColor = null;
      if (Ext.isDefined(value)) {
        if (value in colorSettings && 'color' in colorSettings[value] && Ext.isDefined(colorSettings[value]['color'])) {
          color = colorSettings[value]['color'];
        }
        if (color != null) {
          metaData.tdStyle = 'color:' + color + ';';
        }
        if (value in colorSettings && 'bgColor' in colorSettings[value] && Ext.isDefined(colorSettings[value]['bgColor'])) {
          bgColor = colorSettings[value]['bgColor'];
        }
        if (bgColor != null) {
          metaData.tdAttr = 'bgcolor\x3d"' + bgColor + '"';
        } else {
          bgColor = 'transparent';
        }
        if (qtip != null) {
          metaData.tdAttr = qtip + 'bgcolor\x3d"' + bgColor + '";';
        }
      } else {
        if (record) {
          if (record.get('meta')) {
            value = '';
          } else {
            value = 'NaN';
          }
        }
      }
      return value;
    }});
  } else {
    var colors = {};
    if ('flagColorSettings' in this) {
      colors = this.flagColorSettings;
    }
    var renderFlagInValueColumn = this.renderFlagInValueColumn;
    var ID = timeseries.ID, gridSummary = 'sum';
    if ('requestUnit' in timeseries && timeseries.requestUnit) {
      var managerInstanceId = BpcCommon.Api.getSetting(this.moduleId, 'webtsm_managerInstance');
      if (managerInstanceId) {
        var jsonStringArray = BpcCommon.Api.getSetting(managerInstanceId, 'units_powerLike');
        if (jsonStringArray && jsonStringArray.indexOf(timeseries.requestUnit) !== -1) {
          gridSummary = 'tsm';
        }
      }
    }
    return Ext.apply({xtype:'gridcolumn', width:150, summaryType:gridSummary, align:'end', minWidth:30, style:webtsm.Support.getDefaultGridStyle()}, {text:timeseries.Name + ' ( ' + timeseries.requestUnit + ' )', timeSeriesMeta:timeseries || {}, requestUnit:timeseries.requestUnit, dataIndex:timeseriesDataIndex, _tsmName:tooltipObj.Name, _tsmVersion:tooltipObj.Version, _tsmUnit:timeseries.requestUnit, _tsmId:tooltipObj.Id, summaryRenderer:function(value, data, index, a, b, c) {
      var renderFlag = renderFlagInValueColumn;
      var longest = longestDecimal;
      value = Ext.util.Format.number(value, format);
      var array = value.split(',');
      if (array.length === 1) {
        value = array[0] + ',' + Ext.String.repeat('0', longest);
      } else if (array.length === 2) {
        value = array[0] + ',';
        if (array[1].length < longest) {
          var d = longest - array[1].length;
          value += array[1] + Ext.String.repeat('0', d);
        } else if (array[1].length === longest) {
          value = array[0] + ',' + array[1];
        }
      } else {
      }
      value = '\x3cspan class\x3d"webtsm-grid"\x3e\x3cb\x3e' + value + '\x3c/b\x3e\x3c/span\x3e';
      if (renderFlag) {
        value += '\x3cspan style\x3d"display: inline-block !important;width:25px;margin-left: 5px;"\x3e\x3c/span\x3e';
      }
      return value;
    }, height:32, renderer:function(value, metaData, record, rowIndex, colIndex, store, view) {
      var flagValue = record.get(timeseriesFlagDataIndex);
      var renderFlag = renderFlagInValueColumn;
      var flags = flagTranslations;
      var colorSettings = colors;
      if (Ext.isDefined(flagValue) && Ext.isDefined(value)) {
        var o = {};
        o.Wert = value;
        o.Flag = flagValue;
        if (flagValue in flags) {
          o.FlagName = flags[flagValue];
        }
        metaData.tdAttr = 'data-qtip\x3d' + webtsm.Support.createHtmlTooltipFromObject(o);
      }
      if (!Ext.isDefined(value)) {
        var metaKey = record.get('meta');
        if (metaKey) {
          if ($jscomp$this.metaMap) {
            value = $jscomp$this.metaMap[ID][metaKey];
          }
        } else {
          value = 'NaN';
        }
      } else {
        var longest = longestDecimal;
        value = Ext.util.Format.number(value, format);
        var array = value.split(',');
        if (array.length === 1) {
          value = array[0] + ',' + +Ext.String.repeat('0', longest);
        } else if (array.length === 2) {
          value = array[0] + ',';
          if (array[1].length < longest) {
            var d = longest - array[1].length;
            value += array[1] + Ext.String.repeat('0', d);
          } else if (array[1].length === longest) {
            value = array[0] + ',' + array[1];
          }
        } else {
        }
      }
      if (renderFlag === true) {
        if (Ext.isDefined(flagValue)) {
          var visualFlag = flagValue;
          if (flagValue in colorSettings && 'color' in colorSettings[flagValue] && Ext.isDefined(colorSettings[flagValue]['color'])) {
            visualFlag = '\x3cspan style\x3d"color:' + colorSettings[flagValue]['color'] + ';"\x3e' + flagValue + '\x3c/span\x3e';
          }
          value += '\x3cspan style\x3d"display: inline-block !important;width:25px;margin-left: 5px;"\x3e  ( ' + visualFlag + ' )\x3c/span\x3e';
        }
      }
      metaData.tdCls = 'webtsm-grid-cell';
      return value;
    }, tooltip:this.getTooltipContent(tooltipObj)});
  }
}, getColumnHeaderHtmlString:function(icon) {
  return '\x3cspan class\x3d"' + icon + '"\x3e\x3c/span\x3e\x26nbsp;';
}, getTooltipContent:function(metaDataObject) {
  try {
    var content = '\x3ctable\x3e';
    Ext.iterate(metaDataObject, function(key, value) {
      if (Ext.isObject(value)) {
        if ('Message' in value) {
          value = value.Message;
        }
      }
      content += '\x3ctr\x3e';
      content += '\x3ctd\x3e\x3cb\x3e' + key + ':\x3c/b\x3e\x3c/td\x3e';
      content += '\x3ctd\x3e' + value + '\x3c/td\x3e';
      content += '\x3c/tr\x3e';
    });
    content += '\x3c/table\x3e';
    return content;
  } catch (e) {
  }
}});
Ext.define('webtsm.view.instanceTypes.client.grid.TsGridController', {extend:'Ext.app.ViewController', alias:'controller.tsGrid', control:{'gridcolumn':{headerclick:'onHeaderClick'}}, metaDataVisible:false, metaKeys:['ID', 'Name', 'Description', 'Type', 'Interval', 'Unit', 'Table', 'ArchiveTable', 'Formula', 'TimeZone', 'StartOfYear', 'StartOfDay', 'PreserveDuplicatedValues', 'Quotation', 'Audit', 'Compressed', 'Version', 'ExchangeTimeSeries'], onHeaderClick:function(ct, column, e, t, eOpts) {
  var g = this.getView(), s = g.getStore();
  if (this.metaDataVisible) {
    s.removeAt(0, this.metaKeys.length);
    this.metaDataVisible = false;
  } else {
    var emptyMetaData = [];
    Ext.Array.each(this.metaKeys, function(key) {
      emptyMetaData.push({meta:key});
    });
    s.insert(0, emptyMetaData);
    this.metaDataVisible = true;
  }
  g.down('tableview').refresh();
}, flipFlagValue:function(keyInView) {
  var view = this.getView();
  view[keyInView] = !view[keyInView];
  var mainView = view.up('tsmMain');
  mainView.loadData();
}, removeAllFilters:function() {
  var view = this.getView(), s = view.getStore();
  s.clearFilter();
  view.isFiltered = false;
  view.tsmFilterType = undefined;
}, filterTsmValuesStore:function(btn, kill) {
  try {
    var view = this.getView();
    if (view.isFiltered && btn.tsmFilterAction !== view.tsmFilterType) {
      this.removeAllFilters();
    }
    if (kill) {
      this.removeAllFilters();
    } else {
      if ('tsmFilterAction' in btn && btn.tsmFilterAction) {
        var store = view.getStore(), keys = [], relevant = [], lastValueObj = [];
        if (store) {
          var storeModelArray = store.getData().getRange();
          if (storeModelArray) {
            var firstObject = storeModelArray[0].getData();
            keys = Ext.Object.getKeys(firstObject);
          }
        }
        Ext.Array.each(keys, function(key) {
          if (key !== 'id' && key !== 'timestampFrom' && key !== 'timestampTo' && !Ext.String.endsWith(key, '_flag')) {
            relevant.push(key);
          }
        });
        if (btn.tsmFilterAction === 'changed') {
          Ext.Array.each(relevant, function(key) {
            lastValueObj[key] = null;
          });
        }
        var changed = function(s, relevant, lastValueObj) {
          s.filterBy(function(record) {
            var filter = false;
            Ext.Array.each(relevant, function(key, index) {
              var value = record.get(key);
              if (value !== lastValueObj[key]) {
                filter = true;
              }
              lastValueObj[key] = value;
            });
            return filter;
          });
        };
        var empty = function(s, relevant, lastValueObj) {
          s.filterBy(function(record) {
            var filter = false;
            Ext.Array.each(relevant, function(key) {
              var value = record.get(key);
              if (value != 0) {
                filter = true;
              }
            });
            return filter;
          });
        };
        var filters = {changed:changed, empty:empty};
        filters[btn.tsmFilterAction](store, relevant, lastValueObj);
        view.isFiltered = true;
        view.tsmFilterType = btn.tsmFilterAction;
      }
    }
  } catch (e) {
    this.removeAllFilters();
  }
}, onExpandClick:function(btn) {
  try {
    var v = this.getView();
    webtsm.Support.openWindow(v.getTitle(), undefined, undefined, undefined, 'tsGrid', {config:{gridConfig:{data:v.getStore().getTSMStoreData(), columns:v.getTSMColumnConfig()}}, moduleId:v.moduleId, windowMode:true, header:false});
  } catch (e) {
  }
}});
Ext.define('webtsm.view.instanceTypes.client.grid.TsGridHeader', {extend:'Ext.toolbar.Toolbar', alias:'widget.tsmGridHeader', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], layout:{type:'hbox'}, initComponent:function() {
  this.defaults = {ui:'secondary', moduleId:this.moduleId};
  this.items = [{iconCls:webtsm.Support.getBpcIconCls('fa-flag'), disabled:true}, {xtype:'segmentedbutton', allowMultiple:true, items:[{tooltip:this.TR('TT_FLAGS_IN_VALUE_COLUMN'), webtsmAction:'renderFlagInValueColumn', iconCls:webtsm.Support.getBpcIconCls('fa-code'), ui:'secondary'}, {tooltip:this.TR('TT_FLAGS_IN_EXTRA_COLUMN'), webtsmAction:'extraColumnWithFlags', iconCls:webtsm.Support.getBpcIconCls('fa-columns'), ui:'secondary'}], listeners:{toggle:function(container, button, pressed) {
    button.up('tsGrid').getController().flipFlagValue(button.webtsmAction);
  }}}, {xtype:'tbspacer', width:10}, {xtype:'webtsmStoreFilterBtn', iconOnly:true, ui:'secondary', listeners:{toggle:function(container, button, pressed) {
    button.up('tsGrid').getController().filterTsmValuesStore(button, !pressed);
  }}}, {xtype:'tbspacer', width:10}, {iconCls:webtsm.ConfigKeys.icons.expand, handler:'onExpandClick', tooltip:this.TR('TT_OPEN_GRID_IN_WINDOW')}, {xtype:'tbspacer', width:10}, {iconCls:webtsm.ConfigKeys.icons.download, tooltip:this.TR('TT_HAKOM_TEMPLATE_EXPORT'), handler:function(btn) {
    if (Ext.isDefined(btn.exportUrl)) {
      var tsmMain = btn.up('tsmMain');
      var apiId = tsmMain.getApiId();
      var application = webtsm.Api.helper.getKeyFromApiConfig(apiId, 'application');
      tsmMain.getDataForExport().then(function(array) {
        var postO = {format:'hakom-tsm-xslx', data:array, application:application, request:tsmMain.getRequestObject()};
        webtsm.Api.getCreateRequestPromise(btn.exportUrl, postO).then(function(request) {
          var value = webtsm.Support.getResponseObject(request);
          if (value) {
            webtsm.Files.downloadFile(value);
            return;
          }
          webtsm.Support.notify('Fehler beim Parsen der Antwort des Dateidownloads.');
        }, function(reason) {
          BpcCommon.Api.showNotification('Fehler beim Download.');
        });
      });
    } else {
      BpcCommon.Api.showNotification('Export nicht möglich. Bitte Konfiguration in der ClientInstanz prüfen.');
    }
  }, initComponent:function() {
    var me = this;
    if (Ext.isDefined(me.moduleId)) {
      var enabled = BpcCommon.Api.getSetting(me.moduleId, 'function_externalExportEnabled');
      if (enabled === true) {
        var backendConnectionId = BpcCommon.Api.getSetting(me.moduleId, 'bpc_backendConnectionId');
        var path = BpcCommon.Api.getSetting(me.moduleId, 'function_externalExportPath');
        if (Ext.isDefined(backendConnectionId) && Ext.isDefined(path) && backendConnectionId !== null && path != null) {
          this.exportUrl = BpcCommon.Api.getBackendUrl(backendConnectionId) + path;
        } else {
        }
      } else {
        this.disabled = true;
      }
    } else {
      this.disabled = true;
    }
    me.callParent(arguments);
  }}, {xtype:'segmentedbutton', allowMultiple:false, hidden:true, items:[{tooltip:this.TR('HANDOVER_DATA_TO_WORKFLOW'), iconCls:webtsm.Support.getBpcIconCls('fa-code-branch'), ui:'secondary', handler:function(btn) {
    if (Ext.isDefined(btn.exportUrl)) {
      var tsmMain = btn.up('tsmMain');
      var tsmController = tsmMain.getController();
      tsmController.getDataAsArray().then(function(array) {
        var postO = {format:'custom-export', data:array, application:tsmMain.getApplication(), request:tsmMain.getRequestObject()};
        webtsm.Api.getCreateRequestPromise(btn.exportUrl, postO).then(function(request) {
          var value = webtsm.Support.getResponseObject(request);
          if (value) {
            webtsm.Files.downloadFile(value);
            return;
          }
          webtsm.Support.notify('Fehler beim Parsen der Antwort des Dateidownloads.');
        }, function(reason) {
          BpcCommon.Api.showNotification('Fehler beim Download.');
        });
      });
    } else {
      BpcCommon.Api.showNotification('Export nicht möglich. Bitte Konfiguration in der ClientInstanz prüfen.');
    }
  }, initComponent:function() {
    var me = this;
    var exportMain = me.up('segmentedbutton');
    if (Ext.isDefined(exportMain) && 'moduleId' in exportMain && Ext.isDefined(exportMain.moduleId)) {
      var enabled = BpcCommon.Api.getSetting(exportMain.moduleId, 'function_externalExportEnabled');
      if (Ext.isDefined(enabled) && enabled === true) {
        var backendConnectionId = BpcCommon.Api.getSetting(exportMain.moduleId, 'bpc_backendConnectionId');
        var path = BpcCommon.Api.getSetting(exportMain.moduleId, 'function_externalExportPath');
        if (Ext.isDefined(backendConnectionId) && Ext.isDefined(path) && backendConnectionId !== null && path != null) {
          var url = BpcCommon.Api.getBackendUrl(backendConnectionId) + path;
          this.exportUrl = url;
        } else {
          Ext.log({dump:backendConnectionId, msg:'backendConnection ID maybe null'});
          Ext.log({dump:path, msg:'path maybe null'});
        }
      } else {
        this.disabled = true;
      }
    } else {
      this.disabled = true;
    }
    me.callParent(arguments);
  }}]}];
  this.callParent(arguments);
}});
Ext.define('webtsm.view.tsmselector.TsSelectGrid', {extend:'Ext.grid.Panel', alias:'widget.tsmSelectGrid', requires:['webtsm.ConfigKeys'], mixins:['webtsm.mixins.Component'], viewConfig:{markDirty:false, enableTextSelection:true}, selModel:{mode:'MULTI'}, viewModel:{data:{lastUpdate:null, activeFilters:null}, formulas:{getActiveFilters:{get:function(get) {
  var fArray = get('activeFilters');
  if (fArray) {
    var divArray = fArray.map(function(value) {
      return '\x3cspan style\x3d"display: inline-block; background-color: #CFD8DC; color: #263238; padding: 5px;"\x3e' + value + '\x3c/span\x3e';
    });
    return divArray.join('\x26nbsp;');
  }
  return 'Keine';
}}}}, moduleInstance:undefined, tsmViewMode:'list', initComponent:function() {
  var $jscomp$this = this;
  var columnConfig = BpcCommon.Api.getSetting(this.moduleId, 'previewColumnConfig') || [{dataIndex:'Name', flex:1}, {dataIndex:'ID'}];
  this.columns = columnConfig.map(function(i) {
    i.style = webtsm.Support.getDefaultGridStyle();
    i.flex = i.flex ? i.flex : 1;
    i.text = webtsm.Support.TR('COL_' + i.dataIndex.toUpperCase());
    i.renderer = function(value, meta, r) {
      meta.tdAttr = webtsm.Support.getTooltipFromRecord(r);
      return value;
    };
    return i;
  });
  this.enableBaseButtons({viewMode:{iconCls:'fa-eye', tr:null, ui:'secondary'}, listMode:{iconCls:'fa-list-alt', tr:null, ui:'secondary'}, add:{iconCls:'fa-save', tr:'ADD', ui:'primary'}});
  this.viewModeBtn = this.createBaseButton('viewMode', {tooltip:'Ansichtsmodus', tsmViewMode:'viewer', handler:function(btn) {
    $jscomp$this.tsmViewMode = btn.tsmViewMode;
    $jscomp$this.listModeBtn.setDisabled(false);
    $jscomp$this.addToSelectionBtn.setDisabled(true);
    btn.setDisabled(true);
  }});
  this.listModeBtn = this.createBaseButton('listMode', {tooltip:'Listenmodus', disabled:true, tsmViewMode:'list', handler:function(btn) {
    $jscomp$this.tsmViewMode = btn.tsmViewMode;
    $jscomp$this.viewModeBtn.setDisabled(false);
    $jscomp$this.addToSelectionBtn.setDisabled(false);
    btn.setDisabled(true);
  }});
  this.addToSelectionBtn = this.createBaseButton('add', {tooltip:this.TR('ADD_TIME_SERIES_SELECTION'), handler:function() {
    $jscomp$this.addToSelectedGrid($jscomp$this.getSelection(), true);
  }});
  this._addDocked([this.viewModeBtn, this.listModeBtn, {xtype:'tsmInputQueryField', itemId:'cacheSearchField', flex:1, gridReference:this}, this.addToSelectionBtn], 'top');
  this.listeners = {selectionchange:function(selModel, selected, eOpts) {
    if ($jscomp$this.tsmViewMode === 'viewer') {
      $jscomp$this.addToSelectedGrid($jscomp$this.getSelection(), false);
      Ext.defer(function() {
        $jscomp$this.moduleInstance.loadData();
      }, 500);
    }
  }, rowdblclick:function(table, record, element, rowIndex, e, eOpts) {
    $jscomp$this.addToSelectedGrid([record], $jscomp$this.tsmViewMode === 'list');
  }, afterrender:function(c) {
    $jscomp$this.store.load();
  }};
  this.store = Ext.create('Ext.data.BufferedStore', {proxy:{type:'ajax', url:webtsm.Api.tsmBasePath + 'cache/' + this.moduleId, reader:{type:'json', rootProperty:'data', totalProperty:'total'}, extraParams:{instanceId:this.moduleId, includeOverallTotal:true}}, autoLoad:false, moduleInstance:this.moduleInstance, listeners:{prefetch:function(store, records, successful, operation, eOpts) {
    $jscomp$this.handleStoreLoad(store, records, successful, operation, eOpts);
  }}});
  this.callParent(arguments);
}, handleStoreLoad:function(store, records, successful, operation, eOpts) {
  var filtered = false, cacheTotalCount, totalCount;
  if (successful) {
    totalCount = store.getTotalCount();
    var jsObj = webtsm.Support.getResponseObject(operation.getResponse()) || {};
    if (jsObj) {
      cacheTotalCount = jsObj.cacheTotalCount;
      var gridVm = this.getViewModel();
      if ('baseFiltersApplied' in jsObj) {
        gridVm.set('activeFilters', jsObj.baseFiltersApplied);
      }
      if ('lastCacheRefresh' in jsObj && jsObj.lastCacheRefresh) {
        gridVm.set('lastUpdate', Ext.Date.format(Ext.Date.parse(jsObj.lastCacheRefresh, 'time'), webtsm.Support.defaultDateFormat));
      }
      filtered = cacheTotalCount !== totalCount;
    }
  }
  var key = successful ? !filtered && totalCount === 1 ? 'TIME_SERIES' : 'TIME_SERIES_PLURAL' : 'ERROR';
  var time_series_translation = webtsm.Support.TR(key);
  var title = successful ? filtered ? totalCount + ' ' + webtsm.Support.TR('OF') + ' ' + cacheTotalCount + ' ' + time_series_translation : totalCount + ' ' + time_series_translation : webtsm.Support.TR(key);
  this.setTitle(title);
}, addToSelectedGrid:function(arrayOfRecords, addToExisting) {
  this.moduleInstance.changeTimeseries(arrayOfRecords, addToExisting);
  this.getSelectionModel().deselectAll();
}});
